// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/api/apikeys/v2/apikeys.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fapi_2fapikeys_2fv2_2fapikeys_2eproto__INCLUDED
#define GRPC_google_2fapi_2fapikeys_2fv2_2fapikeys_2eproto__INCLUDED

#include "google/api/apikeys/v2/apikeys.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace api {
namespace apikeys {
namespace v2 {

// Manages the API keys associated with projects.
class ApiKeys final {
 public:
  static constexpr char const* service_full_name() {
    return "google.api.apikeys.v2.ApiKeys";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a new API key.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status CreateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateKeyRaw(context, request, cq));
    }
    // Lists the API keys owned by a project. The key string of the API key
    // isn't included in the response.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status ListKeys(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest& request, ::google::api::apikeys::v2::ListKeysResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::ListKeysResponse>> AsyncListKeys(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::ListKeysResponse>>(AsyncListKeysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::ListKeysResponse>> PrepareAsyncListKeys(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::ListKeysResponse>>(PrepareAsyncListKeysRaw(context, request, cq));
    }
    // Gets the metadata for an API key. The key string of the API key
    // isn't included in the response.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status GetKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest& request, ::google::api::apikeys::v2::Key* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::Key>> AsyncGetKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::Key>>(AsyncGetKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::Key>> PrepareAsyncGetKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::Key>>(PrepareAsyncGetKeyRaw(context, request, cq));
    }
    // Get the key string for an API key.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status GetKeyString(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest& request, ::google::api::apikeys::v2::GetKeyStringResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::GetKeyStringResponse>> AsyncGetKeyString(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::GetKeyStringResponse>>(AsyncGetKeyStringRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::GetKeyStringResponse>> PrepareAsyncGetKeyString(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::GetKeyStringResponse>>(PrepareAsyncGetKeyStringRaw(context, request, cq));
    }
    // Patches the modifiable fields of an API key.
    // The key string of the API key isn't included in the response.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status UpdateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateKeyRaw(context, request, cq));
    }
    // Deletes an API key. Deleted key can be retrieved within 30 days of
    // deletion. Afterward, key will be purged from the project.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status DeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteKeyRaw(context, request, cq));
    }
    // Undeletes an API key which was deleted within 30 days.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status UndeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUndeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUndeleteKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUndeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUndeleteKeyRaw(context, request, cq));
    }
    // Find the parent project and resource name of the API
    // key that matches the key string in the request. If the API key has been
    // purged, resource name will not be set.
    // The service account must have the `apikeys.keys.lookup` permission
    // on the parent project.
    virtual ::grpc::Status LookupKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest& request, ::google::api::apikeys::v2::LookupKeyResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::LookupKeyResponse>> AsyncLookupKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::LookupKeyResponse>>(AsyncLookupKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::LookupKeyResponse>> PrepareAsyncLookupKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::LookupKeyResponse>>(PrepareAsyncLookupKeyRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a new API key.
      //
      // NOTE: Key is a global resource; hence the only supported value for
      // location is `global`.
      virtual void CreateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the API keys owned by a project. The key string of the API key
      // isn't included in the response.
      //
      // NOTE: Key is a global resource; hence the only supported value for
      // location is `global`.
      virtual void ListKeys(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest* request, ::google::api::apikeys::v2::ListKeysResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListKeys(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest* request, ::google::api::apikeys::v2::ListKeysResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the metadata for an API key. The key string of the API key
      // isn't included in the response.
      //
      // NOTE: Key is a global resource; hence the only supported value for
      // location is `global`.
      virtual void GetKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest* request, ::google::api::apikeys::v2::Key* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest* request, ::google::api::apikeys::v2::Key* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Get the key string for an API key.
      //
      // NOTE: Key is a global resource; hence the only supported value for
      // location is `global`.
      virtual void GetKeyString(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest* request, ::google::api::apikeys::v2::GetKeyStringResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetKeyString(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest* request, ::google::api::apikeys::v2::GetKeyStringResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Patches the modifiable fields of an API key.
      // The key string of the API key isn't included in the response.
      //
      // NOTE: Key is a global resource; hence the only supported value for
      // location is `global`.
      virtual void UpdateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an API key. Deleted key can be retrieved within 30 days of
      // deletion. Afterward, key will be purged from the project.
      //
      // NOTE: Key is a global resource; hence the only supported value for
      // location is `global`.
      virtual void DeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Undeletes an API key which was deleted within 30 days.
      //
      // NOTE: Key is a global resource; hence the only supported value for
      // location is `global`.
      virtual void UndeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UndeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Find the parent project and resource name of the API
      // key that matches the key string in the request. If the API key has been
      // purged, resource name will not be set.
      // The service account must have the `apikeys.keys.lookup` permission
      // on the parent project.
      virtual void LookupKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest* request, ::google::api::apikeys::v2::LookupKeyResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void LookupKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest* request, ::google::api::apikeys::v2::LookupKeyResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::ListKeysResponse>* AsyncListKeysRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::ListKeysResponse>* PrepareAsyncListKeysRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::Key>* AsyncGetKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::Key>* PrepareAsyncGetKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::GetKeyStringResponse>* AsyncGetKeyStringRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::GetKeyStringResponse>* PrepareAsyncGetKeyStringRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUndeleteKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUndeleteKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::LookupKeyResponse>* AsyncLookupKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::apikeys::v2::LookupKeyResponse>* PrepareAsyncLookupKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateKeyRaw(context, request, cq));
    }
    ::grpc::Status ListKeys(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest& request, ::google::api::apikeys::v2::ListKeysResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::ListKeysResponse>> AsyncListKeys(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::ListKeysResponse>>(AsyncListKeysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::ListKeysResponse>> PrepareAsyncListKeys(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::ListKeysResponse>>(PrepareAsyncListKeysRaw(context, request, cq));
    }
    ::grpc::Status GetKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest& request, ::google::api::apikeys::v2::Key* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::Key>> AsyncGetKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::Key>>(AsyncGetKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::Key>> PrepareAsyncGetKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::Key>>(PrepareAsyncGetKeyRaw(context, request, cq));
    }
    ::grpc::Status GetKeyString(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest& request, ::google::api::apikeys::v2::GetKeyStringResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::GetKeyStringResponse>> AsyncGetKeyString(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::GetKeyStringResponse>>(AsyncGetKeyStringRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::GetKeyStringResponse>> PrepareAsyncGetKeyString(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::GetKeyStringResponse>>(PrepareAsyncGetKeyStringRaw(context, request, cq));
    }
    ::grpc::Status UpdateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateKeyRaw(context, request, cq));
    }
    ::grpc::Status DeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteKeyRaw(context, request, cq));
    }
    ::grpc::Status UndeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUndeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUndeleteKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUndeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUndeleteKeyRaw(context, request, cq));
    }
    ::grpc::Status LookupKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest& request, ::google::api::apikeys::v2::LookupKeyResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::LookupKeyResponse>> AsyncLookupKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::LookupKeyResponse>>(AsyncLookupKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::LookupKeyResponse>> PrepareAsyncLookupKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::LookupKeyResponse>>(PrepareAsyncLookupKeyRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListKeys(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest* request, ::google::api::apikeys::v2::ListKeysResponse* response, std::function<void(::grpc::Status)>) override;
      void ListKeys(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest* request, ::google::api::apikeys::v2::ListKeysResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest* request, ::google::api::apikeys::v2::Key* response, std::function<void(::grpc::Status)>) override;
      void GetKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest* request, ::google::api::apikeys::v2::Key* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetKeyString(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest* request, ::google::api::apikeys::v2::GetKeyStringResponse* response, std::function<void(::grpc::Status)>) override;
      void GetKeyString(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest* request, ::google::api::apikeys::v2::GetKeyStringResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UndeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UndeleteKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void LookupKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest* request, ::google::api::apikeys::v2::LookupKeyResponse* response, std::function<void(::grpc::Status)>) override;
      void LookupKey(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest* request, ::google::api::apikeys::v2::LookupKeyResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::CreateKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::ListKeysResponse>* AsyncListKeysRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::ListKeysResponse>* PrepareAsyncListKeysRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::ListKeysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::Key>* AsyncGetKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::Key>* PrepareAsyncGetKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::GetKeyStringResponse>* AsyncGetKeyStringRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::GetKeyStringResponse>* PrepareAsyncGetKeyStringRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUndeleteKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUndeleteKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::LookupKeyResponse>* AsyncLookupKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::apikeys::v2::LookupKeyResponse>* PrepareAsyncLookupKeyRaw(::grpc::ClientContext* context, const ::google::api::apikeys::v2::LookupKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateKey_;
    const ::grpc::internal::RpcMethod rpcmethod_ListKeys_;
    const ::grpc::internal::RpcMethod rpcmethod_GetKey_;
    const ::grpc::internal::RpcMethod rpcmethod_GetKeyString_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateKey_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteKey_;
    const ::grpc::internal::RpcMethod rpcmethod_UndeleteKey_;
    const ::grpc::internal::RpcMethod rpcmethod_LookupKey_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a new API key.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status CreateKey(::grpc::ServerContext* context, const ::google::api::apikeys::v2::CreateKeyRequest* request, ::google::longrunning::Operation* response);
    // Lists the API keys owned by a project. The key string of the API key
    // isn't included in the response.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status ListKeys(::grpc::ServerContext* context, const ::google::api::apikeys::v2::ListKeysRequest* request, ::google::api::apikeys::v2::ListKeysResponse* response);
    // Gets the metadata for an API key. The key string of the API key
    // isn't included in the response.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status GetKey(::grpc::ServerContext* context, const ::google::api::apikeys::v2::GetKeyRequest* request, ::google::api::apikeys::v2::Key* response);
    // Get the key string for an API key.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status GetKeyString(::grpc::ServerContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest* request, ::google::api::apikeys::v2::GetKeyStringResponse* response);
    // Patches the modifiable fields of an API key.
    // The key string of the API key isn't included in the response.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status UpdateKey(::grpc::ServerContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest* request, ::google::longrunning::Operation* response);
    // Deletes an API key. Deleted key can be retrieved within 30 days of
    // deletion. Afterward, key will be purged from the project.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status DeleteKey(::grpc::ServerContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest* request, ::google::longrunning::Operation* response);
    // Undeletes an API key which was deleted within 30 days.
    //
    // NOTE: Key is a global resource; hence the only supported value for
    // location is `global`.
    virtual ::grpc::Status UndeleteKey(::grpc::ServerContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest* request, ::google::longrunning::Operation* response);
    // Find the parent project and resource name of the API
    // key that matches the key string in the request. If the API key has been
    // purged, resource name will not be set.
    // The service account must have the `apikeys.keys.lookup` permission
    // on the parent project.
    virtual ::grpc::Status LookupKey(::grpc::ServerContext* context, const ::google::api::apikeys::v2::LookupKeyRequest* request, ::google::api::apikeys::v2::LookupKeyResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateKey() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::CreateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateKey(::grpc::ServerContext* context, ::google::api::apikeys::v2::CreateKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListKeys() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeys(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::ListKeysRequest* /*request*/, ::google::api::apikeys::v2::ListKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListKeys(::grpc::ServerContext* context, ::google::api::apikeys::v2::ListKeysRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::apikeys::v2::ListKeysResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetKey() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyRequest* /*request*/, ::google::api::apikeys::v2::Key* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetKey(::grpc::ServerContext* context, ::google::api::apikeys::v2::GetKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::apikeys::v2::Key>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetKeyString : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetKeyString() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetKeyString() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyString(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyStringRequest* /*request*/, ::google::api::apikeys::v2::GetKeyStringResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetKeyString(::grpc::ServerContext* context, ::google::api::apikeys::v2::GetKeyStringRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::apikeys::v2::GetKeyStringResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateKey() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::UpdateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateKey(::grpc::ServerContext* context, ::google::api::apikeys::v2::UpdateKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteKey() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_DeleteKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::DeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteKey(::grpc::ServerContext* context, ::google::api::apikeys::v2::DeleteKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UndeleteKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UndeleteKey() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_UndeleteKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::UndeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeleteKey(::grpc::ServerContext* context, ::google::api::apikeys::v2::UndeleteKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_LookupKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_LookupKey() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_LookupKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::LookupKeyRequest* /*request*/, ::google::api::apikeys::v2::LookupKeyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestLookupKey(::grpc::ServerContext* context, ::google::api::apikeys::v2::LookupKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::apikeys::v2::LookupKeyResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateKey<WithAsyncMethod_ListKeys<WithAsyncMethod_GetKey<WithAsyncMethod_GetKeyString<WithAsyncMethod_UpdateKey<WithAsyncMethod_DeleteKey<WithAsyncMethod_UndeleteKey<WithAsyncMethod_LookupKey<Service > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateKey() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::CreateKeyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::apikeys::v2::CreateKeyRequest* request, ::google::longrunning::Operation* response) { return this->CreateKey(context, request, response); }));}
    void SetMessageAllocatorFor_CreateKey(
        ::grpc::MessageAllocator< ::google::api::apikeys::v2::CreateKeyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::CreateKeyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::CreateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::apikeys::v2::CreateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListKeys() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::ListKeysRequest, ::google::api::apikeys::v2::ListKeysResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::apikeys::v2::ListKeysRequest* request, ::google::api::apikeys::v2::ListKeysResponse* response) { return this->ListKeys(context, request, response); }));}
    void SetMessageAllocatorFor_ListKeys(
        ::grpc::MessageAllocator< ::google::api::apikeys::v2::ListKeysRequest, ::google::api::apikeys::v2::ListKeysResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::ListKeysRequest, ::google::api::apikeys::v2::ListKeysResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeys(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::ListKeysRequest* /*request*/, ::google::api::apikeys::v2::ListKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListKeys(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::apikeys::v2::ListKeysRequest* /*request*/, ::google::api::apikeys::v2::ListKeysResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetKey() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::GetKeyRequest, ::google::api::apikeys::v2::Key>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::apikeys::v2::GetKeyRequest* request, ::google::api::apikeys::v2::Key* response) { return this->GetKey(context, request, response); }));}
    void SetMessageAllocatorFor_GetKey(
        ::grpc::MessageAllocator< ::google::api::apikeys::v2::GetKeyRequest, ::google::api::apikeys::v2::Key>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::GetKeyRequest, ::google::api::apikeys::v2::Key>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyRequest* /*request*/, ::google::api::apikeys::v2::Key* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyRequest* /*request*/, ::google::api::apikeys::v2::Key* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetKeyString : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetKeyString() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::GetKeyStringRequest, ::google::api::apikeys::v2::GetKeyStringResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::apikeys::v2::GetKeyStringRequest* request, ::google::api::apikeys::v2::GetKeyStringResponse* response) { return this->GetKeyString(context, request, response); }));}
    void SetMessageAllocatorFor_GetKeyString(
        ::grpc::MessageAllocator< ::google::api::apikeys::v2::GetKeyStringRequest, ::google::api::apikeys::v2::GetKeyStringResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::GetKeyStringRequest, ::google::api::apikeys::v2::GetKeyStringResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetKeyString() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyString(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyStringRequest* /*request*/, ::google::api::apikeys::v2::GetKeyStringResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetKeyString(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyStringRequest* /*request*/, ::google::api::apikeys::v2::GetKeyStringResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateKey() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::UpdateKeyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::apikeys::v2::UpdateKeyRequest* request, ::google::longrunning::Operation* response) { return this->UpdateKey(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateKey(
        ::grpc::MessageAllocator< ::google::api::apikeys::v2::UpdateKeyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::UpdateKeyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::UpdateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::apikeys::v2::UpdateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteKey() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::DeleteKeyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::apikeys::v2::DeleteKeyRequest* request, ::google::longrunning::Operation* response) { return this->DeleteKey(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteKey(
        ::grpc::MessageAllocator< ::google::api::apikeys::v2::DeleteKeyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::DeleteKeyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::DeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::apikeys::v2::DeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UndeleteKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UndeleteKey() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::UndeleteKeyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::apikeys::v2::UndeleteKeyRequest* request, ::google::longrunning::Operation* response) { return this->UndeleteKey(context, request, response); }));}
    void SetMessageAllocatorFor_UndeleteKey(
        ::grpc::MessageAllocator< ::google::api::apikeys::v2::UndeleteKeyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::UndeleteKeyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UndeleteKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::UndeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeleteKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::apikeys::v2::UndeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_LookupKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_LookupKey() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::LookupKeyRequest, ::google::api::apikeys::v2::LookupKeyResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::api::apikeys::v2::LookupKeyRequest* request, ::google::api::apikeys::v2::LookupKeyResponse* response) { return this->LookupKey(context, request, response); }));}
    void SetMessageAllocatorFor_LookupKey(
        ::grpc::MessageAllocator< ::google::api::apikeys::v2::LookupKeyRequest, ::google::api::apikeys::v2::LookupKeyResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::api::apikeys::v2::LookupKeyRequest, ::google::api::apikeys::v2::LookupKeyResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_LookupKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::LookupKeyRequest* /*request*/, ::google::api::apikeys::v2::LookupKeyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* LookupKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::api::apikeys::v2::LookupKeyRequest* /*request*/, ::google::api::apikeys::v2::LookupKeyResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateKey<WithCallbackMethod_ListKeys<WithCallbackMethod_GetKey<WithCallbackMethod_GetKeyString<WithCallbackMethod_UpdateKey<WithCallbackMethod_DeleteKey<WithCallbackMethod_UndeleteKey<WithCallbackMethod_LookupKey<Service > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateKey() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::CreateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListKeys() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeys(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::ListKeysRequest* /*request*/, ::google::api::apikeys::v2::ListKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetKey() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyRequest* /*request*/, ::google::api::apikeys::v2::Key* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetKeyString : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetKeyString() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetKeyString() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyString(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyStringRequest* /*request*/, ::google::api::apikeys::v2::GetKeyStringResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateKey() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::UpdateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteKey() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_DeleteKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::DeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UndeleteKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UndeleteKey() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_UndeleteKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::UndeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_LookupKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_LookupKey() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_LookupKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::LookupKeyRequest* /*request*/, ::google::api::apikeys::v2::LookupKeyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateKey() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::CreateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListKeys() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeys(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::ListKeysRequest* /*request*/, ::google::api::apikeys::v2::ListKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListKeys(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetKey() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyRequest* /*request*/, ::google::api::apikeys::v2::Key* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetKeyString : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetKeyString() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetKeyString() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyString(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyStringRequest* /*request*/, ::google::api::apikeys::v2::GetKeyStringResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetKeyString(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateKey() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::UpdateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteKey() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_DeleteKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::DeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UndeleteKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UndeleteKey() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_UndeleteKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::UndeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeleteKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_LookupKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_LookupKey() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_LookupKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::LookupKeyRequest* /*request*/, ::google::api::apikeys::v2::LookupKeyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestLookupKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateKey() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::CreateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListKeys() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListKeys(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListKeys(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::ListKeysRequest* /*request*/, ::google::api::apikeys::v2::ListKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListKeys(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetKey() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyRequest* /*request*/, ::google::api::apikeys::v2::Key* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetKeyString : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetKeyString() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetKeyString(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetKeyString() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetKeyString(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyStringRequest* /*request*/, ::google::api::apikeys::v2::GetKeyStringResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetKeyString(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateKey() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::UpdateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteKey() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::DeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UndeleteKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UndeleteKey() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UndeleteKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_UndeleteKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeleteKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::UndeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeleteKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_LookupKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_LookupKey() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->LookupKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_LookupKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::LookupKeyRequest* /*request*/, ::google::api::apikeys::v2::LookupKeyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* LookupKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateKey() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::apikeys::v2::CreateKeyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::apikeys::v2::CreateKeyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::CreateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::apikeys::v2::CreateKeyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListKeys() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::apikeys::v2::ListKeysRequest, ::google::api::apikeys::v2::ListKeysResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::apikeys::v2::ListKeysRequest, ::google::api::apikeys::v2::ListKeysResponse>* streamer) {
                       return this->StreamedListKeys(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListKeys(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::ListKeysRequest* /*request*/, ::google::api::apikeys::v2::ListKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListKeys(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::apikeys::v2::ListKeysRequest,::google::api::apikeys::v2::ListKeysResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetKey() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::apikeys::v2::GetKeyRequest, ::google::api::apikeys::v2::Key>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::apikeys::v2::GetKeyRequest, ::google::api::apikeys::v2::Key>* streamer) {
                       return this->StreamedGetKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyRequest* /*request*/, ::google::api::apikeys::v2::Key* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::apikeys::v2::GetKeyRequest,::google::api::apikeys::v2::Key>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetKeyString : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetKeyString() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::apikeys::v2::GetKeyStringRequest, ::google::api::apikeys::v2::GetKeyStringResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::apikeys::v2::GetKeyStringRequest, ::google::api::apikeys::v2::GetKeyStringResponse>* streamer) {
                       return this->StreamedGetKeyString(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetKeyString() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetKeyString(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::GetKeyStringRequest* /*request*/, ::google::api::apikeys::v2::GetKeyStringResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetKeyString(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::apikeys::v2::GetKeyStringRequest,::google::api::apikeys::v2::GetKeyStringResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateKey() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::apikeys::v2::UpdateKeyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::apikeys::v2::UpdateKeyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::UpdateKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::apikeys::v2::UpdateKeyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteKey() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::apikeys::v2::DeleteKeyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::apikeys::v2::DeleteKeyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::DeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::apikeys::v2::DeleteKeyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UndeleteKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UndeleteKey() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::apikeys::v2::UndeleteKeyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::apikeys::v2::UndeleteKeyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUndeleteKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UndeleteKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UndeleteKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::UndeleteKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUndeleteKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::apikeys::v2::UndeleteKeyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_LookupKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_LookupKey() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::api::apikeys::v2::LookupKeyRequest, ::google::api::apikeys::v2::LookupKeyResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::api::apikeys::v2::LookupKeyRequest, ::google::api::apikeys::v2::LookupKeyResponse>* streamer) {
                       return this->StreamedLookupKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_LookupKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status LookupKey(::grpc::ServerContext* /*context*/, const ::google::api::apikeys::v2::LookupKeyRequest* /*request*/, ::google::api::apikeys::v2::LookupKeyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedLookupKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::api::apikeys::v2::LookupKeyRequest,::google::api::apikeys::v2::LookupKeyResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateKey<WithStreamedUnaryMethod_ListKeys<WithStreamedUnaryMethod_GetKey<WithStreamedUnaryMethod_GetKeyString<WithStreamedUnaryMethod_UpdateKey<WithStreamedUnaryMethod_DeleteKey<WithStreamedUnaryMethod_UndeleteKey<WithStreamedUnaryMethod_LookupKey<Service > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateKey<WithStreamedUnaryMethod_ListKeys<WithStreamedUnaryMethod_GetKey<WithStreamedUnaryMethod_GetKeyString<WithStreamedUnaryMethod_UpdateKey<WithStreamedUnaryMethod_DeleteKey<WithStreamedUnaryMethod_UndeleteKey<WithStreamedUnaryMethod_LookupKey<Service > > > > > > > > StreamedService;
};

}  // namespace v2
}  // namespace apikeys
}  // namespace api
}  // namespace google


#endif  // GRPC_google_2fapi_2fapikeys_2fv2_2fapikeys_2eproto__INCLUDED
