// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/dataset_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_INTERNAL_DATASET_TRACING_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_INTERNAL_DATASET_TRACING_CONNECTION_H

#include "google/cloud/aiplatform/v1/dataset_connection.h"
#include "google/cloud/version.h"
#include <memory>

namespace google {
namespace cloud {
namespace aiplatform_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

class DatasetServiceTracingConnection
    : public aiplatform_v1::DatasetServiceConnection {
 public:
  ~DatasetServiceTracingConnection() override = default;

  explicit DatasetServiceTracingConnection(
      std::shared_ptr<aiplatform_v1::DatasetServiceConnection> child);

  Options options() override { return child_->options(); }

  future<StatusOr<google::cloud::aiplatform::v1::Dataset>> CreateDataset(
      google::cloud::aiplatform::v1::CreateDatasetRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> CreateDataset(
      ExperimentalTag, NoAwaitTag,
      google::cloud::aiplatform::v1::CreateDatasetRequest const& request)
      override;

  future<StatusOr<google::cloud::aiplatform::v1::Dataset>> CreateDataset(
      ExperimentalTag,
      google::longrunning::Operation const& operation) override;

  StatusOr<google::cloud::aiplatform::v1::Dataset> GetDataset(
      google::cloud::aiplatform::v1::GetDatasetRequest const& request) override;

  StatusOr<google::cloud::aiplatform::v1::Dataset> UpdateDataset(
      google::cloud::aiplatform::v1::UpdateDatasetRequest const& request)
      override;

  StreamRange<google::cloud::aiplatform::v1::Dataset> ListDatasets(
      google::cloud::aiplatform::v1::ListDatasetsRequest request) override;

  future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>
  DeleteDataset(google::cloud::aiplatform::v1::DeleteDatasetRequest const&
                    request) override;

  StatusOr<google::longrunning::Operation> DeleteDataset(
      ExperimentalTag, NoAwaitTag,
      google::cloud::aiplatform::v1::DeleteDatasetRequest const& request)
      override;

  future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>
  DeleteDataset(ExperimentalTag,
                google::longrunning::Operation const& operation) override;

  future<StatusOr<google::cloud::aiplatform::v1::ImportDataResponse>>
  ImportData(
      google::cloud::aiplatform::v1::ImportDataRequest const& request) override;

  StatusOr<google::longrunning::Operation> ImportData(
      ExperimentalTag, NoAwaitTag,
      google::cloud::aiplatform::v1::ImportDataRequest const& request) override;

  future<StatusOr<google::cloud::aiplatform::v1::ImportDataResponse>>
  ImportData(ExperimentalTag,
             google::longrunning::Operation const& operation) override;

  future<StatusOr<google::cloud::aiplatform::v1::ExportDataResponse>>
  ExportData(
      google::cloud::aiplatform::v1::ExportDataRequest const& request) override;

  StatusOr<google::longrunning::Operation> ExportData(
      ExperimentalTag, NoAwaitTag,
      google::cloud::aiplatform::v1::ExportDataRequest const& request) override;

  future<StatusOr<google::cloud::aiplatform::v1::ExportDataResponse>>
  ExportData(ExperimentalTag,
             google::longrunning::Operation const& operation) override;

  future<StatusOr<google::cloud::aiplatform::v1::DatasetVersion>>
  CreateDatasetVersion(
      google::cloud::aiplatform::v1::CreateDatasetVersionRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> CreateDatasetVersion(
      ExperimentalTag, NoAwaitTag,
      google::cloud::aiplatform::v1::CreateDatasetVersionRequest const& request)
      override;

  future<StatusOr<google::cloud::aiplatform::v1::DatasetVersion>>
  CreateDatasetVersion(
      ExperimentalTag,
      google::longrunning::Operation const& operation) override;

  StatusOr<google::cloud::aiplatform::v1::DatasetVersion> UpdateDatasetVersion(
      google::cloud::aiplatform::v1::UpdateDatasetVersionRequest const& request)
      override;

  future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>
  DeleteDatasetVersion(
      google::cloud::aiplatform::v1::DeleteDatasetVersionRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> DeleteDatasetVersion(
      ExperimentalTag, NoAwaitTag,
      google::cloud::aiplatform::v1::DeleteDatasetVersionRequest const& request)
      override;

  future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>
  DeleteDatasetVersion(
      ExperimentalTag,
      google::longrunning::Operation const& operation) override;

  StatusOr<google::cloud::aiplatform::v1::DatasetVersion> GetDatasetVersion(
      google::cloud::aiplatform::v1::GetDatasetVersionRequest const& request)
      override;

  StreamRange<google::cloud::aiplatform::v1::DatasetVersion>
  ListDatasetVersions(google::cloud::aiplatform::v1::ListDatasetVersionsRequest
                          request) override;

  future<StatusOr<google::cloud::aiplatform::v1::DatasetVersion>>
  RestoreDatasetVersion(
      google::cloud::aiplatform::v1::RestoreDatasetVersionRequest const&
          request) override;

  StatusOr<google::longrunning::Operation> RestoreDatasetVersion(
      ExperimentalTag, NoAwaitTag,
      google::cloud::aiplatform::v1::RestoreDatasetVersionRequest const&
          request) override;

  future<StatusOr<google::cloud::aiplatform::v1::DatasetVersion>>
  RestoreDatasetVersion(
      ExperimentalTag,
      google::longrunning::Operation const& operation) override;

  StreamRange<google::cloud::aiplatform::v1::DataItem> ListDataItems(
      google::cloud::aiplatform::v1::ListDataItemsRequest request) override;

  StreamRange<google::cloud::aiplatform::v1::DataItemView> SearchDataItems(
      google::cloud::aiplatform::v1::SearchDataItemsRequest request) override;

  StreamRange<google::cloud::aiplatform::v1::SavedQuery> ListSavedQueries(
      google::cloud::aiplatform::v1::ListSavedQueriesRequest request) override;

  future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>
  DeleteSavedQuery(google::cloud::aiplatform::v1::DeleteSavedQueryRequest const&
                       request) override;

  StatusOr<google::longrunning::Operation> DeleteSavedQuery(
      ExperimentalTag, NoAwaitTag,
      google::cloud::aiplatform::v1::DeleteSavedQueryRequest const& request)
      override;

  future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>
  DeleteSavedQuery(ExperimentalTag,
                   google::longrunning::Operation const& operation) override;

  StatusOr<google::cloud::aiplatform::v1::AnnotationSpec> GetAnnotationSpec(
      google::cloud::aiplatform::v1::GetAnnotationSpecRequest const& request)
      override;

  StreamRange<google::cloud::aiplatform::v1::Annotation> ListAnnotations(
      google::cloud::aiplatform::v1::ListAnnotationsRequest request) override;

 private:
  std::shared_ptr<aiplatform_v1::DatasetServiceConnection> child_;
};

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

/**
 * Conditionally applies the tracing decorator to the given connection.
 *
 * The connection is only decorated if tracing is enabled (as determined by the
 * connection's options).
 */
std::shared_ptr<aiplatform_v1::DatasetServiceConnection>
MakeDatasetServiceTracingConnection(
    std::shared_ptr<aiplatform_v1::DatasetServiceConnection> conn);

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_INTERNAL_DATASET_TRACING_CONNECTION_H
