// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/notebook_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_MOCKS_MOCK_NOTEBOOK_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_MOCKS_MOCK_NOTEBOOK_CONNECTION_H

#include "google/cloud/aiplatform/v1/notebook_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace aiplatform_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `NotebookServiceConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `NotebookServiceClient`. To do so,
 * construct an object of type `NotebookServiceClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockNotebookServiceConnection
    : public aiplatform_v1::NotebookServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateNotebookRuntimeTemplate)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateNotebookRuntimeTemplate(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::aiplatform::v1::NotebookRuntimeTemplate>>,
      CreateNotebookRuntimeTemplate,
      (google::cloud::aiplatform::v1::
           CreateNotebookRuntimeTemplateRequest const& request),
      (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>,
              CreateNotebookRuntimeTemplate,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::aiplatform::v1::
                   CreateNotebookRuntimeTemplateRequest const& request),
              (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::aiplatform::v1::NotebookRuntimeTemplate>>,
      CreateNotebookRuntimeTemplate,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::aiplatform::v1::NotebookRuntimeTemplate>,
      GetNotebookRuntimeTemplate,
      (google::cloud::aiplatform::v1::GetNotebookRuntimeTemplateRequest const&
           request),
      (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::aiplatform::v1::NotebookRuntimeTemplate>),
      ListNotebookRuntimeTemplates,
      (google::cloud::aiplatform::v1::ListNotebookRuntimeTemplatesRequest
           request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteNotebookRuntimeTemplate)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteNotebookRuntimeTemplate(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>,
      DeleteNotebookRuntimeTemplate,
      (google::cloud::aiplatform::v1::
           DeleteNotebookRuntimeTemplateRequest const& request),
      (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>,
              DeleteNotebookRuntimeTemplate,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::aiplatform::v1::
                   DeleteNotebookRuntimeTemplateRequest const& request),
              (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>,
      DeleteNotebookRuntimeTemplate,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  MOCK_METHOD(StatusOr<google::cloud::aiplatform::v1::NotebookRuntimeTemplate>,
              UpdateNotebookRuntimeTemplate,
              (google::cloud::aiplatform::v1::
                   UpdateNotebookRuntimeTemplateRequest const& request),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, AssignNotebookRuntime)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, AssignNotebookRuntime(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::aiplatform::v1::NotebookRuntime>>,
      AssignNotebookRuntime,
      (google::cloud::aiplatform::v1::AssignNotebookRuntimeRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, AssignNotebookRuntime,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::aiplatform::v1::AssignNotebookRuntimeRequest const&
           request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::aiplatform::v1::NotebookRuntime>>,
              AssignNotebookRuntime,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::aiplatform::v1::NotebookRuntime>,
      GetNotebookRuntime,
      (google::cloud::aiplatform::v1::GetNotebookRuntimeRequest const& request),
      (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::aiplatform::v1::NotebookRuntime>),
      ListNotebookRuntimes,
      (google::cloud::aiplatform::v1::ListNotebookRuntimesRequest request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteNotebookRuntime)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteNotebookRuntime(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>,
      DeleteNotebookRuntime,
      (google::cloud::aiplatform::v1::DeleteNotebookRuntimeRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, DeleteNotebookRuntime,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::aiplatform::v1::DeleteNotebookRuntimeRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>,
      DeleteNotebookRuntime,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpgradeNotebookRuntime)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpgradeNotebookRuntime(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<
          google::cloud::aiplatform::v1::UpgradeNotebookRuntimeResponse>>,
      UpgradeNotebookRuntime,
      (google::cloud::aiplatform::v1::UpgradeNotebookRuntimeRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, UpgradeNotebookRuntime,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::aiplatform::v1::UpgradeNotebookRuntimeRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<
          google::cloud::aiplatform::v1::UpgradeNotebookRuntimeResponse>>,
      UpgradeNotebookRuntime,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, StartNotebookRuntime)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, StartNotebookRuntime(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<
                  google::cloud::aiplatform::v1::StartNotebookRuntimeResponse>>,
              StartNotebookRuntime,
              (google::cloud::aiplatform::v1::StartNotebookRuntimeRequest const&
                   request),
              (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, StartNotebookRuntime,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::aiplatform::v1::StartNotebookRuntimeRequest const&
                   request),
              (override));

  MOCK_METHOD(future<StatusOr<
                  google::cloud::aiplatform::v1::StartNotebookRuntimeResponse>>,
              StartNotebookRuntime,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_MOCKS_MOCK_NOTEBOOK_CONNECTION_H
