// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/prediction_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_MOCKS_MOCK_PREDICTION_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_MOCKS_MOCK_PREDICTION_CONNECTION_H

#include "google/cloud/aiplatform/v1/prediction_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace aiplatform_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `PredictionServiceConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `PredictionServiceClient`. To do so,
 * construct an object of type `PredictionServiceClient` with an instance of
 * this class. Then use the Google Test framework functions to program the
 * behavior of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockPredictionServiceConnection
    : public aiplatform_v1::PredictionServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(StatusOr<google::cloud::aiplatform::v1::PredictResponse>, Predict,
              (google::cloud::aiplatform::v1::PredictRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::api::HttpBody>, RawPredict,
              (google::cloud::aiplatform::v1::RawPredictRequest const& request),
              (override));

  MOCK_METHOD(
      StreamRange<google::api::HttpBody>, StreamRawPredict,
      (google::cloud::aiplatform::v1::StreamRawPredictRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::aiplatform::v1::DirectPredictResponse>,
      DirectPredict,
      (google::cloud::aiplatform::v1::DirectPredictRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::aiplatform::v1::DirectRawPredictResponse>,
      DirectRawPredict,
      (google::cloud::aiplatform::v1::DirectRawPredictRequest const& request),
      (override));

  MOCK_METHOD(
      (std::unique_ptr<::google::cloud::AsyncStreamingReadWriteRpc<
           google::cloud::aiplatform::v1::StreamDirectPredictRequest,
           google::cloud::aiplatform::v1::StreamDirectPredictResponse>>),
      AsyncStreamDirectPredict, (), (override));

  MOCK_METHOD(
      (std::unique_ptr<::google::cloud::AsyncStreamingReadWriteRpc<
           google::cloud::aiplatform::v1::StreamDirectRawPredictRequest,
           google::cloud::aiplatform::v1::StreamDirectRawPredictResponse>>),
      AsyncStreamDirectRawPredict, (), (override));

  MOCK_METHOD((std::unique_ptr<::google::cloud::AsyncStreamingReadWriteRpc<
                   google::cloud::aiplatform::v1::StreamingPredictRequest,
                   google::cloud::aiplatform::v1::StreamingPredictResponse>>),
              AsyncStreamingPredict, (), (override));

  MOCK_METHOD(
      StreamRange<google::cloud::aiplatform::v1::StreamingPredictResponse>,
      ServerStreamingPredict,
      (google::cloud::aiplatform::v1::StreamingPredictRequest const& request),
      (override));

  MOCK_METHOD(
      (std::unique_ptr<::google::cloud::AsyncStreamingReadWriteRpc<
           google::cloud::aiplatform::v1::StreamingRawPredictRequest,
           google::cloud::aiplatform::v1::StreamingRawPredictResponse>>),
      AsyncStreamingRawPredict, (), (override));

  MOCK_METHOD(StatusOr<google::cloud::aiplatform::v1::ExplainResponse>, Explain,
              (google::cloud::aiplatform::v1::ExplainRequest const& request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::aiplatform::v1::GenerateContentResponse>,
      GenerateContent,
      (google::cloud::aiplatform::v1::GenerateContentRequest const& request),
      (override));

  MOCK_METHOD(
      StreamRange<google::cloud::aiplatform::v1::GenerateContentResponse>,
      StreamGenerateContent,
      (google::cloud::aiplatform::v1::GenerateContentRequest const& request),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_MOCKS_MOCK_PREDICTION_CONNECTION_H
