// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/aiplatform/v1/specialist_pool_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_MOCKS_MOCK_SPECIALIST_POOL_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_MOCKS_MOCK_SPECIALIST_POOL_CONNECTION_H

#include "google/cloud/aiplatform/v1/specialist_pool_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace aiplatform_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `SpecialistPoolServiceConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `SpecialistPoolServiceClient`. To do
 * so, construct an object of type `SpecialistPoolServiceClient` with an
 * instance of this class. Then use the Google Test framework functions to
 * program the behavior of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockSpecialistPoolServiceConnection
    : public aiplatform_v1::SpecialistPoolServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateSpecialistPool)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateSpecialistPool(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::aiplatform::v1::SpecialistPool>>,
              CreateSpecialistPool,
              (google::cloud::aiplatform::v1::CreateSpecialistPoolRequest const&
                   request),
              (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, CreateSpecialistPool,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::aiplatform::v1::CreateSpecialistPoolRequest const&
                   request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::aiplatform::v1::SpecialistPool>>,
              CreateSpecialistPool,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::aiplatform::v1::SpecialistPool>,
      GetSpecialistPool,
      (google::cloud::aiplatform::v1::GetSpecialistPoolRequest const& request),
      (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::aiplatform::v1::SpecialistPool>),
      ListSpecialistPools,
      (google::cloud::aiplatform::v1::ListSpecialistPoolsRequest request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteSpecialistPool)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteSpecialistPool(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>,
      DeleteSpecialistPool,
      (google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest const&
           request),
      (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, DeleteSpecialistPool,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::aiplatform::v1::DeleteSpecialistPoolRequest const&
                   request),
              (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::aiplatform::v1::DeleteOperationMetadata>>,
      DeleteSpecialistPool,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateSpecialistPool)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateSpecialistPool(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::aiplatform::v1::SpecialistPool>>,
              UpdateSpecialistPool,
              (google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest const&
                   request),
              (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, UpdateSpecialistPool,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::aiplatform::v1::UpdateSpecialistPoolRequest const&
                   request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::aiplatform::v1::SpecialistPool>>,
              UpdateSpecialistPool,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace aiplatform_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_AIPLATFORM_V1_MOCKS_MOCK_SPECIALIST_POOL_CONNECTION_H
