// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/apphub/v1/apphub_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_APPHUB_V1_MOCKS_MOCK_APP_HUB_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_APPHUB_V1_MOCKS_MOCK_APP_HUB_CONNECTION_H

#include "google/cloud/apphub/v1/app_hub_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace apphub_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `AppHubConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `AppHubClient`. To do so,
 * construct an object of type `AppHubClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockAppHubConnection : public apphub_v1::AppHubConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(
      StatusOr<
          google::cloud::apphub::v1::LookupServiceProjectAttachmentResponse>,
      LookupServiceProjectAttachment,
      (google::cloud::apphub::v1::LookupServiceProjectAttachmentRequest const&
           request),
      (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::apphub::v1::ServiceProjectAttachment>),
      ListServiceProjectAttachments,
      (google::cloud::apphub::v1::ListServiceProjectAttachmentsRequest request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateServiceProjectAttachment)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateServiceProjectAttachment(::testing::_))`
  /// instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::apphub::v1::ServiceProjectAttachment>>,
      CreateServiceProjectAttachment,
      (google::cloud::apphub::v1::CreateServiceProjectAttachmentRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, CreateServiceProjectAttachment,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::apphub::v1::CreateServiceProjectAttachmentRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::apphub::v1::ServiceProjectAttachment>>,
      CreateServiceProjectAttachment,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::apphub::v1::ServiceProjectAttachment>,
      GetServiceProjectAttachment,
      (google::cloud::apphub::v1::GetServiceProjectAttachmentRequest const&
           request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteServiceProjectAttachment)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteServiceProjectAttachment(::testing::_))`
  /// instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::apphub::v1::OperationMetadata>>,
      DeleteServiceProjectAttachment,
      (google::cloud::apphub::v1::DeleteServiceProjectAttachmentRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, DeleteServiceProjectAttachment,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::apphub::v1::DeleteServiceProjectAttachmentRequest const&
           request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::OperationMetadata>>,
              DeleteServiceProjectAttachment,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD(
      StatusOr<
          google::cloud::apphub::v1::DetachServiceProjectAttachmentResponse>,
      DetachServiceProjectAttachment,
      (google::cloud::apphub::v1::DetachServiceProjectAttachmentRequest const&
           request),
      (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::apphub::v1::DiscoveredService>),
      ListDiscoveredServices,
      (google::cloud::apphub::v1::ListDiscoveredServicesRequest request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::apphub::v1::DiscoveredService>,
      GetDiscoveredService,
      (google::cloud::apphub::v1::GetDiscoveredServiceRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::apphub::v1::LookupDiscoveredServiceResponse>,
      LookupDiscoveredService,
      (google::cloud::apphub::v1::LookupDiscoveredServiceRequest const&
           request),
      (override));

  MOCK_METHOD((StreamRange<google::cloud::apphub::v1::Service>), ListServices,
              (google::cloud::apphub::v1::ListServicesRequest request),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateService)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateService(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::Service>>,
              CreateService,
              (google::cloud::apphub::v1::CreateServiceRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, CreateService,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::apphub::v1::CreateServiceRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::Service>>,
              CreateService,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::apphub::v1::Service>, GetService,
              (google::cloud::apphub::v1::GetServiceRequest const& request),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateService)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateService(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::Service>>,
              UpdateService,
              (google::cloud::apphub::v1::UpdateServiceRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, UpdateService,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::apphub::v1::UpdateServiceRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::Service>>,
              UpdateService,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteService)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteService(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::OperationMetadata>>,
              DeleteService,
              (google::cloud::apphub::v1::DeleteServiceRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, DeleteService,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::apphub::v1::DeleteServiceRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::OperationMetadata>>,
              DeleteService,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::apphub::v1::DiscoveredWorkload>),
      ListDiscoveredWorkloads,
      (google::cloud::apphub::v1::ListDiscoveredWorkloadsRequest request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::apphub::v1::DiscoveredWorkload>,
      GetDiscoveredWorkload,
      (google::cloud::apphub::v1::GetDiscoveredWorkloadRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::apphub::v1::LookupDiscoveredWorkloadResponse>,
      LookupDiscoveredWorkload,
      (google::cloud::apphub::v1::LookupDiscoveredWorkloadRequest const&
           request),
      (override));

  MOCK_METHOD((StreamRange<google::cloud::apphub::v1::Workload>), ListWorkloads,
              (google::cloud::apphub::v1::ListWorkloadsRequest request),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateWorkload)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateWorkload(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::Workload>>,
              CreateWorkload,
              (google::cloud::apphub::v1::CreateWorkloadRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, CreateWorkload,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::apphub::v1::CreateWorkloadRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::Workload>>,
              CreateWorkload,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::apphub::v1::Workload>, GetWorkload,
              (google::cloud::apphub::v1::GetWorkloadRequest const& request),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateWorkload)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateWorkload(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::Workload>>,
              UpdateWorkload,
              (google::cloud::apphub::v1::UpdateWorkloadRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, UpdateWorkload,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::apphub::v1::UpdateWorkloadRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::Workload>>,
              UpdateWorkload,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteWorkload)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteWorkload(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::OperationMetadata>>,
              DeleteWorkload,
              (google::cloud::apphub::v1::DeleteWorkloadRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, DeleteWorkload,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::apphub::v1::DeleteWorkloadRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::OperationMetadata>>,
              DeleteWorkload,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD((StreamRange<google::cloud::apphub::v1::Application>),
              ListApplications,
              (google::cloud::apphub::v1::ListApplicationsRequest request),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateApplication)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateApplication(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::apphub::v1::Application>>,
      CreateApplication,
      (google::cloud::apphub::v1::CreateApplicationRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, CreateApplication,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::apphub::v1::CreateApplicationRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::Application>>,
              CreateApplication,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::apphub::v1::Application>, GetApplication,
              (google::cloud::apphub::v1::GetApplicationRequest const& request),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateApplication)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateApplication(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::apphub::v1::Application>>,
      UpdateApplication,
      (google::cloud::apphub::v1::UpdateApplicationRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, UpdateApplication,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::apphub::v1::UpdateApplicationRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::Application>>,
              UpdateApplication,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteApplication)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteApplication(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::apphub::v1::OperationMetadata>>,
      DeleteApplication,
      (google::cloud::apphub::v1::DeleteApplicationRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, DeleteApplication,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::apphub::v1::DeleteApplicationRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::apphub::v1::OperationMetadata>>,
              DeleteApplication,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace apphub_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_APPHUB_V1_MOCKS_MOCK_APP_HUB_CONNECTION_H
