// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/assuredworkloads/v1/assuredworkloads.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fassuredworkloads_2fv1_2fassuredworkloads_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fassuredworkloads_2fv1_2fassuredworkloads_2eproto__INCLUDED

#include "google/cloud/assuredworkloads/v1/assuredworkloads.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace assuredworkloads {
namespace v1 {

// Service to manage AssuredWorkloads.
class AssuredWorkloadsService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.assuredworkloads.v1.AssuredWorkloadsService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates Assured Workload.
    virtual ::grpc::Status CreateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateWorkloadRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateWorkloadRaw(context, request, cq));
    }
    // Updates an existing workload.
    // Currently allows updating of workload display_name and labels.
    // For force updates don't set etag field in the Workload.
    // Only one update operation per workload can be in progress.
    virtual ::grpc::Status UpdateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest& request, ::google::cloud::assuredworkloads::v1::Workload* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Workload>> AsyncUpdateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Workload>>(AsyncUpdateWorkloadRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Workload>> PrepareAsyncUpdateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Workload>>(PrepareAsyncUpdateWorkloadRaw(context, request, cq));
    }
    // Restrict the list of resources allowed in the Workload environment.
    // The current list of allowed products can be found at
    // https://cloud.google.com/assured-workloads/docs/supported-products
    // In addition to assuredworkloads.workload.update permission, the user should
    // also have orgpolicy.policy.set permission on the folder resource
    // to use this functionality.
    virtual ::grpc::Status RestrictAllowedResources(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest& request, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>> AsyncRestrictAllowedResources(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>>(AsyncRestrictAllowedResourcesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>> PrepareAsyncRestrictAllowedResources(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>>(PrepareAsyncRestrictAllowedResourcesRaw(context, request, cq));
    }
    // Deletes the workload. Make sure that workload's direct children are already
    // in a deleted state, otherwise the request will fail with a
    // FAILED_PRECONDITION error.
    virtual ::grpc::Status DeleteWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteWorkloadRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteWorkloadRaw(context, request, cq));
    }
    // Gets Assured Workload associated with a CRM Node
    virtual ::grpc::Status GetWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest& request, ::google::cloud::assuredworkloads::v1::Workload* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Workload>> AsyncGetWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Workload>>(AsyncGetWorkloadRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Workload>> PrepareAsyncGetWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Workload>>(PrepareAsyncGetWorkloadRaw(context, request, cq));
    }
    // Lists Assured Workloads under a CRM Node.
    virtual ::grpc::Status ListWorkloads(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest& request, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>> AsyncListWorkloads(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>>(AsyncListWorkloadsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>> PrepareAsyncListWorkloads(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>>(PrepareAsyncListWorkloadsRaw(context, request, cq));
    }
    // Lists the Violations in the AssuredWorkload Environment.
    // Callers may also choose to read across multiple Workloads as per
    // [AIP-159](https://google.aip.dev/159) by using '-' (the hyphen or dash
    // character) as a wildcard character instead of workload-id in the parent.
    // Format `organizations/{org_id}/locations/{location}/workloads/-`
    virtual ::grpc::Status ListViolations(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest& request, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::ListViolationsResponse>> AsyncListViolations(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::ListViolationsResponse>>(AsyncListViolationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::ListViolationsResponse>> PrepareAsyncListViolations(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::ListViolationsResponse>>(PrepareAsyncListViolationsRaw(context, request, cq));
    }
    // Retrieves Assured Workload Violation based on ID.
    virtual ::grpc::Status GetViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest& request, ::google::cloud::assuredworkloads::v1::Violation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Violation>> AsyncGetViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Violation>>(AsyncGetViolationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Violation>> PrepareAsyncGetViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Violation>>(PrepareAsyncGetViolationRaw(context, request, cq));
    }
    // Acknowledges an existing violation. By acknowledging a violation, users
    // acknowledge the existence of a compliance violation in their workload and
    // decide to ignore it due to a valid business justification. Acknowledgement
    // is a permanent operation and it cannot be reverted.
    virtual ::grpc::Status AcknowledgeViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest& request, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>> AsyncAcknowledgeViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>>(AsyncAcknowledgeViolationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>> PrepareAsyncAcknowledgeViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>>(PrepareAsyncAcknowledgeViolationRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates Assured Workload.
      virtual void CreateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an existing workload.
      // Currently allows updating of workload display_name and labels.
      // For force updates don't set etag field in the Workload.
      // Only one update operation per workload can be in progress.
      virtual void UpdateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* request, ::google::cloud::assuredworkloads::v1::Workload* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* request, ::google::cloud::assuredworkloads::v1::Workload* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Restrict the list of resources allowed in the Workload environment.
      // The current list of allowed products can be found at
      // https://cloud.google.com/assured-workloads/docs/supported-products
      // In addition to assuredworkloads.workload.update permission, the user should
      // also have orgpolicy.policy.set permission on the folder resource
      // to use this functionality.
      virtual void RestrictAllowedResources(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* request, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RestrictAllowedResources(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* request, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the workload. Make sure that workload's direct children are already
      // in a deleted state, otherwise the request will fail with a
      // FAILED_PRECONDITION error.
      virtual void DeleteWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets Assured Workload associated with a CRM Node
      virtual void GetWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* request, ::google::cloud::assuredworkloads::v1::Workload* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* request, ::google::cloud::assuredworkloads::v1::Workload* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Assured Workloads under a CRM Node.
      virtual void ListWorkloads(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* request, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListWorkloads(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* request, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the Violations in the AssuredWorkload Environment.
      // Callers may also choose to read across multiple Workloads as per
      // [AIP-159](https://google.aip.dev/159) by using '-' (the hyphen or dash
      // character) as a wildcard character instead of workload-id in the parent.
      // Format `organizations/{org_id}/locations/{location}/workloads/-`
      virtual void ListViolations(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest* request, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListViolations(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest* request, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves Assured Workload Violation based on ID.
      virtual void GetViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest* request, ::google::cloud::assuredworkloads::v1::Violation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest* request, ::google::cloud::assuredworkloads::v1::Violation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Acknowledges an existing violation. By acknowledging a violation, users
      // acknowledge the existence of a compliance violation in their workload and
      // decide to ignore it due to a valid business justification. Acknowledgement
      // is a permanent operation and it cannot be reverted.
      virtual void AcknowledgeViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* request, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AcknowledgeViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* request, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Workload>* AsyncUpdateWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Workload>* PrepareAsyncUpdateWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>* AsyncRestrictAllowedResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>* PrepareAsyncRestrictAllowedResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Workload>* AsyncGetWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Workload>* PrepareAsyncGetWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>* AsyncListWorkloadsRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>* PrepareAsyncListWorkloadsRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::ListViolationsResponse>* AsyncListViolationsRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::ListViolationsResponse>* PrepareAsyncListViolationsRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Violation>* AsyncGetViolationRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::Violation>* PrepareAsyncGetViolationRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>* AsyncAcknowledgeViolationRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>* PrepareAsyncAcknowledgeViolationRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateWorkloadRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateWorkloadRaw(context, request, cq));
    }
    ::grpc::Status UpdateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest& request, ::google::cloud::assuredworkloads::v1::Workload* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Workload>> AsyncUpdateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Workload>>(AsyncUpdateWorkloadRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Workload>> PrepareAsyncUpdateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Workload>>(PrepareAsyncUpdateWorkloadRaw(context, request, cq));
    }
    ::grpc::Status RestrictAllowedResources(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest& request, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>> AsyncRestrictAllowedResources(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>>(AsyncRestrictAllowedResourcesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>> PrepareAsyncRestrictAllowedResources(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>>(PrepareAsyncRestrictAllowedResourcesRaw(context, request, cq));
    }
    ::grpc::Status DeleteWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteWorkloadRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteWorkloadRaw(context, request, cq));
    }
    ::grpc::Status GetWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest& request, ::google::cloud::assuredworkloads::v1::Workload* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Workload>> AsyncGetWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Workload>>(AsyncGetWorkloadRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Workload>> PrepareAsyncGetWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Workload>>(PrepareAsyncGetWorkloadRaw(context, request, cq));
    }
    ::grpc::Status ListWorkloads(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest& request, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>> AsyncListWorkloads(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>>(AsyncListWorkloadsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>> PrepareAsyncListWorkloads(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>>(PrepareAsyncListWorkloadsRaw(context, request, cq));
    }
    ::grpc::Status ListViolations(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest& request, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::ListViolationsResponse>> AsyncListViolations(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::ListViolationsResponse>>(AsyncListViolationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::ListViolationsResponse>> PrepareAsyncListViolations(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::ListViolationsResponse>>(PrepareAsyncListViolationsRaw(context, request, cq));
    }
    ::grpc::Status GetViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest& request, ::google::cloud::assuredworkloads::v1::Violation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Violation>> AsyncGetViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Violation>>(AsyncGetViolationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Violation>> PrepareAsyncGetViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Violation>>(PrepareAsyncGetViolationRaw(context, request, cq));
    }
    ::grpc::Status AcknowledgeViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest& request, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>> AsyncAcknowledgeViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>>(AsyncAcknowledgeViolationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>> PrepareAsyncAcknowledgeViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>>(PrepareAsyncAcknowledgeViolationRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* request, ::google::cloud::assuredworkloads::v1::Workload* response, std::function<void(::grpc::Status)>) override;
      void UpdateWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* request, ::google::cloud::assuredworkloads::v1::Workload* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RestrictAllowedResources(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* request, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* response, std::function<void(::grpc::Status)>) override;
      void RestrictAllowedResources(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* request, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* request, ::google::cloud::assuredworkloads::v1::Workload* response, std::function<void(::grpc::Status)>) override;
      void GetWorkload(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* request, ::google::cloud::assuredworkloads::v1::Workload* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListWorkloads(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* request, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListWorkloads(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* request, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListViolations(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest* request, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListViolations(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest* request, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest* request, ::google::cloud::assuredworkloads::v1::Violation* response, std::function<void(::grpc::Status)>) override;
      void GetViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest* request, ::google::cloud::assuredworkloads::v1::Violation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AcknowledgeViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* request, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* response, std::function<void(::grpc::Status)>) override;
      void AcknowledgeViolation(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* request, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Workload>* AsyncUpdateWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Workload>* PrepareAsyncUpdateWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>* AsyncRestrictAllowedResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>* PrepareAsyncRestrictAllowedResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Workload>* AsyncGetWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Workload>* PrepareAsyncGetWorkloadRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>* AsyncListWorkloadsRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>* PrepareAsyncListWorkloadsRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::ListViolationsResponse>* AsyncListViolationsRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::ListViolationsResponse>* PrepareAsyncListViolationsRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Violation>* AsyncGetViolationRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::Violation>* PrepareAsyncGetViolationRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>* AsyncAcknowledgeViolationRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>* PrepareAsyncAcknowledgeViolationRaw(::grpc::ClientContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateWorkload_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateWorkload_;
    const ::grpc::internal::RpcMethod rpcmethod_RestrictAllowedResources_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteWorkload_;
    const ::grpc::internal::RpcMethod rpcmethod_GetWorkload_;
    const ::grpc::internal::RpcMethod rpcmethod_ListWorkloads_;
    const ::grpc::internal::RpcMethod rpcmethod_ListViolations_;
    const ::grpc::internal::RpcMethod rpcmethod_GetViolation_;
    const ::grpc::internal::RpcMethod rpcmethod_AcknowledgeViolation_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates Assured Workload.
    virtual ::grpc::Status CreateWorkload(::grpc::ServerContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* request, ::google::longrunning::Operation* response);
    // Updates an existing workload.
    // Currently allows updating of workload display_name and labels.
    // For force updates don't set etag field in the Workload.
    // Only one update operation per workload can be in progress.
    virtual ::grpc::Status UpdateWorkload(::grpc::ServerContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* request, ::google::cloud::assuredworkloads::v1::Workload* response);
    // Restrict the list of resources allowed in the Workload environment.
    // The current list of allowed products can be found at
    // https://cloud.google.com/assured-workloads/docs/supported-products
    // In addition to assuredworkloads.workload.update permission, the user should
    // also have orgpolicy.policy.set permission on the folder resource
    // to use this functionality.
    virtual ::grpc::Status RestrictAllowedResources(::grpc::ServerContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* request, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* response);
    // Deletes the workload. Make sure that workload's direct children are already
    // in a deleted state, otherwise the request will fail with a
    // FAILED_PRECONDITION error.
    virtual ::grpc::Status DeleteWorkload(::grpc::ServerContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* request, ::google::protobuf::Empty* response);
    // Gets Assured Workload associated with a CRM Node
    virtual ::grpc::Status GetWorkload(::grpc::ServerContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* request, ::google::cloud::assuredworkloads::v1::Workload* response);
    // Lists Assured Workloads under a CRM Node.
    virtual ::grpc::Status ListWorkloads(::grpc::ServerContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* request, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* response);
    // Lists the Violations in the AssuredWorkload Environment.
    // Callers may also choose to read across multiple Workloads as per
    // [AIP-159](https://google.aip.dev/159) by using '-' (the hyphen or dash
    // character) as a wildcard character instead of workload-id in the parent.
    // Format `organizations/{org_id}/locations/{location}/workloads/-`
    virtual ::grpc::Status ListViolations(::grpc::ServerContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest* request, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* response);
    // Retrieves Assured Workload Violation based on ID.
    virtual ::grpc::Status GetViolation(::grpc::ServerContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest* request, ::google::cloud::assuredworkloads::v1::Violation* response);
    // Acknowledges an existing violation. By acknowledging a violation, users
    // acknowledge the existence of a compliance violation in their workload and
    // decide to ignore it due to a valid business justification. Acknowledgement
    // is a permanent operation and it cannot be reverted.
    virtual ::grpc::Status AcknowledgeViolation(::grpc::ServerContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* request, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateWorkload() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateWorkload(::grpc::ServerContext* context, ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateWorkload() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_UpdateWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateWorkload(::grpc::ServerContext* context, ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::assuredworkloads::v1::Workload>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RestrictAllowedResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RestrictAllowedResources() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_RestrictAllowedResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestrictAllowedResources(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* /*request*/, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestrictAllowedResources(::grpc::ServerContext* context, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteWorkload() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteWorkload(::grpc::ServerContext* context, ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetWorkload() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_GetWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetWorkload(::grpc::ServerContext* context, ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::assuredworkloads::v1::Workload>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListWorkloads : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListWorkloads() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListWorkloads() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkloads(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListWorkloads(::grpc::ServerContext* context, ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListViolations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListViolations() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ListViolations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListViolations(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListViolations(::grpc::ServerContext* context, ::google::cloud::assuredworkloads::v1::ListViolationsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::assuredworkloads::v1::ListViolationsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetViolation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetViolation() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetViolation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetViolation(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Violation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetViolation(::grpc::ServerContext* context, ::google::cloud::assuredworkloads::v1::GetViolationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::assuredworkloads::v1::Violation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AcknowledgeViolation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AcknowledgeViolation() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_AcknowledgeViolation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcknowledgeViolation(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAcknowledgeViolation(::grpc::ServerContext* context, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateWorkload<WithAsyncMethod_UpdateWorkload<WithAsyncMethod_RestrictAllowedResources<WithAsyncMethod_DeleteWorkload<WithAsyncMethod_GetWorkload<WithAsyncMethod_ListWorkloads<WithAsyncMethod_ListViolations<WithAsyncMethod_GetViolation<WithAsyncMethod_AcknowledgeViolation<Service > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateWorkload() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* request, ::google::longrunning::Operation* response) { return this->CreateWorkload(context, request, response); }));}
    void SetMessageAllocatorFor_CreateWorkload(
        ::grpc::MessageAllocator< ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateWorkload(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateWorkload() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest, ::google::cloud::assuredworkloads::v1::Workload>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* request, ::google::cloud::assuredworkloads::v1::Workload* response) { return this->UpdateWorkload(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateWorkload(
        ::grpc::MessageAllocator< ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest, ::google::cloud::assuredworkloads::v1::Workload>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest, ::google::cloud::assuredworkloads::v1::Workload>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateWorkload(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RestrictAllowedResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RestrictAllowedResources() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* request, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* response) { return this->RestrictAllowedResources(context, request, response); }));}
    void SetMessageAllocatorFor_RestrictAllowedResources(
        ::grpc::MessageAllocator< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RestrictAllowedResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestrictAllowedResources(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* /*request*/, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RestrictAllowedResources(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* /*request*/, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteWorkload() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* request, ::google::protobuf::Empty* response) { return this->DeleteWorkload(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteWorkload(
        ::grpc::MessageAllocator< ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteWorkload(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetWorkload() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::GetWorkloadRequest, ::google::cloud::assuredworkloads::v1::Workload>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* request, ::google::cloud::assuredworkloads::v1::Workload* response) { return this->GetWorkload(context, request, response); }));}
    void SetMessageAllocatorFor_GetWorkload(
        ::grpc::MessageAllocator< ::google::cloud::assuredworkloads::v1::GetWorkloadRequest, ::google::cloud::assuredworkloads::v1::Workload>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::GetWorkloadRequest, ::google::cloud::assuredworkloads::v1::Workload>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetWorkload(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListWorkloads : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListWorkloads() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* request, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* response) { return this->ListWorkloads(context, request, response); }));}
    void SetMessageAllocatorFor_ListWorkloads(
        ::grpc::MessageAllocator< ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListWorkloads() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkloads(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListWorkloads(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListViolations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListViolations() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::ListViolationsRequest, ::google::cloud::assuredworkloads::v1::ListViolationsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest* request, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* response) { return this->ListViolations(context, request, response); }));}
    void SetMessageAllocatorFor_ListViolations(
        ::grpc::MessageAllocator< ::google::cloud::assuredworkloads::v1::ListViolationsRequest, ::google::cloud::assuredworkloads::v1::ListViolationsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::ListViolationsRequest, ::google::cloud::assuredworkloads::v1::ListViolationsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListViolations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListViolations(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListViolations(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetViolation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetViolation() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::GetViolationRequest, ::google::cloud::assuredworkloads::v1::Violation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::assuredworkloads::v1::GetViolationRequest* request, ::google::cloud::assuredworkloads::v1::Violation* response) { return this->GetViolation(context, request, response); }));}
    void SetMessageAllocatorFor_GetViolation(
        ::grpc::MessageAllocator< ::google::cloud::assuredworkloads::v1::GetViolationRequest, ::google::cloud::assuredworkloads::v1::Violation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::GetViolationRequest, ::google::cloud::assuredworkloads::v1::Violation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetViolation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetViolation(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Violation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetViolation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Violation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AcknowledgeViolation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AcknowledgeViolation() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* request, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* response) { return this->AcknowledgeViolation(context, request, response); }));}
    void SetMessageAllocatorFor_AcknowledgeViolation(
        ::grpc::MessageAllocator< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AcknowledgeViolation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcknowledgeViolation(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AcknowledgeViolation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateWorkload<WithCallbackMethod_UpdateWorkload<WithCallbackMethod_RestrictAllowedResources<WithCallbackMethod_DeleteWorkload<WithCallbackMethod_GetWorkload<WithCallbackMethod_ListWorkloads<WithCallbackMethod_ListViolations<WithCallbackMethod_GetViolation<WithCallbackMethod_AcknowledgeViolation<Service > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateWorkload() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateWorkload() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_UpdateWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RestrictAllowedResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RestrictAllowedResources() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_RestrictAllowedResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestrictAllowedResources(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* /*request*/, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteWorkload() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetWorkload() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_GetWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListWorkloads : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListWorkloads() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListWorkloads() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkloads(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListViolations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListViolations() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ListViolations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListViolations(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetViolation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetViolation() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetViolation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetViolation(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Violation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AcknowledgeViolation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AcknowledgeViolation() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_AcknowledgeViolation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcknowledgeViolation(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateWorkload() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateWorkload(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateWorkload() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_UpdateWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateWorkload(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RestrictAllowedResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RestrictAllowedResources() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_RestrictAllowedResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestrictAllowedResources(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* /*request*/, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestrictAllowedResources(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteWorkload() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteWorkload(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetWorkload() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_GetWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetWorkload(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListWorkloads : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListWorkloads() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListWorkloads() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkloads(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListWorkloads(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListViolations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListViolations() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ListViolations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListViolations(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListViolations(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetViolation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetViolation() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetViolation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetViolation(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Violation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetViolation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AcknowledgeViolation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AcknowledgeViolation() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_AcknowledgeViolation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcknowledgeViolation(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAcknowledgeViolation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateWorkload() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateWorkload(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateWorkload(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateWorkload() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateWorkload(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateWorkload(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RestrictAllowedResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RestrictAllowedResources() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RestrictAllowedResources(context, request, response); }));
    }
    ~WithRawCallbackMethod_RestrictAllowedResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestrictAllowedResources(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* /*request*/, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RestrictAllowedResources(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteWorkload() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteWorkload(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteWorkload(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetWorkload() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetWorkload(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetWorkload(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListWorkloads : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListWorkloads() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListWorkloads(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListWorkloads() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkloads(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListWorkloads(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListViolations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListViolations() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListViolations(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListViolations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListViolations(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListViolations(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetViolation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetViolation() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetViolation(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetViolation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetViolation(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Violation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetViolation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AcknowledgeViolation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AcknowledgeViolation() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AcknowledgeViolation(context, request, response); }));
    }
    ~WithRawCallbackMethod_AcknowledgeViolation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcknowledgeViolation(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AcknowledgeViolation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateWorkload() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateWorkload(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateWorkload(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::assuredworkloads::v1::CreateWorkloadRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateWorkload() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest, ::google::cloud::assuredworkloads::v1::Workload>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest, ::google::cloud::assuredworkloads::v1::Workload>* streamer) {
                       return this->StreamedUpdateWorkload(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateWorkload(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::assuredworkloads::v1::UpdateWorkloadRequest,::google::cloud::assuredworkloads::v1::Workload>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RestrictAllowedResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RestrictAllowedResources() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>* streamer) {
                       return this->StreamedRestrictAllowedResources(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RestrictAllowedResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RestrictAllowedResources(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest* /*request*/, ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRestrictAllowedResources(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesRequest,::google::cloud::assuredworkloads::v1::RestrictAllowedResourcesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteWorkload() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteWorkload(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteWorkload(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::assuredworkloads::v1::DeleteWorkloadRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetWorkload : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetWorkload() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::assuredworkloads::v1::GetWorkloadRequest, ::google::cloud::assuredworkloads::v1::Workload>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::assuredworkloads::v1::GetWorkloadRequest, ::google::cloud::assuredworkloads::v1::Workload>* streamer) {
                       return this->StreamedGetWorkload(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetWorkload() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetWorkload(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetWorkloadRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Workload* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetWorkload(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::assuredworkloads::v1::GetWorkloadRequest,::google::cloud::assuredworkloads::v1::Workload>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListWorkloads : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListWorkloads() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>* streamer) {
                       return this->StreamedListWorkloads(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListWorkloads() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListWorkloads(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListWorkloadsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListWorkloads(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::assuredworkloads::v1::ListWorkloadsRequest,::google::cloud::assuredworkloads::v1::ListWorkloadsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListViolations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListViolations() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::assuredworkloads::v1::ListViolationsRequest, ::google::cloud::assuredworkloads::v1::ListViolationsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::assuredworkloads::v1::ListViolationsRequest, ::google::cloud::assuredworkloads::v1::ListViolationsResponse>* streamer) {
                       return this->StreamedListViolations(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListViolations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListViolations(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::ListViolationsRequest* /*request*/, ::google::cloud::assuredworkloads::v1::ListViolationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListViolations(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::assuredworkloads::v1::ListViolationsRequest,::google::cloud::assuredworkloads::v1::ListViolationsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetViolation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetViolation() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::assuredworkloads::v1::GetViolationRequest, ::google::cloud::assuredworkloads::v1::Violation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::assuredworkloads::v1::GetViolationRequest, ::google::cloud::assuredworkloads::v1::Violation>* streamer) {
                       return this->StreamedGetViolation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetViolation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetViolation(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::GetViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::Violation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetViolation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::assuredworkloads::v1::GetViolationRequest,::google::cloud::assuredworkloads::v1::Violation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AcknowledgeViolation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AcknowledgeViolation() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>* streamer) {
                       return this->StreamedAcknowledgeViolation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AcknowledgeViolation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AcknowledgeViolation(::grpc::ServerContext* /*context*/, const ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest* /*request*/, ::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAcknowledgeViolation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::assuredworkloads::v1::AcknowledgeViolationRequest,::google::cloud::assuredworkloads::v1::AcknowledgeViolationResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateWorkload<WithStreamedUnaryMethod_UpdateWorkload<WithStreamedUnaryMethod_RestrictAllowedResources<WithStreamedUnaryMethod_DeleteWorkload<WithStreamedUnaryMethod_GetWorkload<WithStreamedUnaryMethod_ListWorkloads<WithStreamedUnaryMethod_ListViolations<WithStreamedUnaryMethod_GetViolation<WithStreamedUnaryMethod_AcknowledgeViolation<Service > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateWorkload<WithStreamedUnaryMethod_UpdateWorkload<WithStreamedUnaryMethod_RestrictAllowedResources<WithStreamedUnaryMethod_DeleteWorkload<WithStreamedUnaryMethod_GetWorkload<WithStreamedUnaryMethod_ListWorkloads<WithStreamedUnaryMethod_ListViolations<WithStreamedUnaryMethod_GetViolation<WithStreamedUnaryMethod_AcknowledgeViolation<Service > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace assuredworkloads
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fassuredworkloads_2fv1_2fassuredworkloads_2eproto__INCLUDED
