// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/beyondcorp/appconnections/v1/app_connections_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BEYONDCORP_APPCONNECTIONS_V1_MOCKS_MOCK_APP_CONNECTIONS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BEYONDCORP_APPCONNECTIONS_V1_MOCKS_MOCK_APP_CONNECTIONS_CONNECTION_H

#include "google/cloud/beyondcorp/appconnections/v1/app_connections_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace beyondcorp_appconnections_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `AppConnectionsServiceConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `AppConnectionsServiceClient`. To do
 * so, construct an object of type `AppConnectionsServiceClient` with an
 * instance of this class. Then use the Google Test framework functions to
 * program the behavior of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockAppConnectionsServiceConnection
    : public beyondcorp_appconnections_v1::AppConnectionsServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(
      (StreamRange<
          google::cloud::beyondcorp::appconnections::v1::AppConnection>),
      ListAppConnections,
      (google::cloud::beyondcorp::appconnections::v1::ListAppConnectionsRequest
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::beyondcorp::appconnections::v1::AppConnection>,
      GetAppConnection,
      (google::cloud::beyondcorp::appconnections::v1::
           GetAppConnectionRequest const& request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateAppConnection)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateAppConnection(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<
          google::cloud::beyondcorp::appconnections::v1::AppConnection>>,
      CreateAppConnection,
      (google::cloud::beyondcorp::appconnections::v1::
           CreateAppConnectionRequest const& request),
      (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, CreateAppConnection,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::beyondcorp::appconnections::v1::
                   CreateAppConnectionRequest const& request),
              (override));

  MOCK_METHOD(
      future<StatusOr<
          google::cloud::beyondcorp::appconnections::v1::AppConnection>>,
      CreateAppConnection,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateAppConnection)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateAppConnection(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<
          google::cloud::beyondcorp::appconnections::v1::AppConnection>>,
      UpdateAppConnection,
      (google::cloud::beyondcorp::appconnections::v1::
           UpdateAppConnectionRequest const& request),
      (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, UpdateAppConnection,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::beyondcorp::appconnections::v1::
                   UpdateAppConnectionRequest const& request),
              (override));

  MOCK_METHOD(
      future<StatusOr<
          google::cloud::beyondcorp::appconnections::v1::AppConnection>>,
      UpdateAppConnection,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteAppConnection)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteAppConnection(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::beyondcorp::appconnections::v1::
                                  AppConnectionOperationMetadata>>,
              DeleteAppConnection,
              (google::cloud::beyondcorp::appconnections::v1::
                   DeleteAppConnectionRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, DeleteAppConnection,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::beyondcorp::appconnections::v1::
                   DeleteAppConnectionRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::beyondcorp::appconnections::v1::
                                  AppConnectionOperationMetadata>>,
              DeleteAppConnection,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::beyondcorp::appconnections::v1::
                       ResolveAppConnectionsResponse::AppConnectionDetails>),
      ResolveAppConnections,
      (google::cloud::beyondcorp::appconnections::v1::
           ResolveAppConnectionsRequest request),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace beyondcorp_appconnections_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_BEYONDCORP_APPCONNECTIONS_V1_MOCKS_MOCK_APP_CONNECTIONS_CONNECTION_H
