// Copyright 2018 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Interface name: "google.bigtable.admin.v2.BigtableInstanceAdmin"
// Define the defaults using a pre-processor macro, this allows
// the application developers to change the defaults for their
// application by compiling with different values.

#ifndef GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_INITIAL_DELAY
#define GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_INITIAL_DELAY \
  std::chrono::milliseconds(5)
#endif  // GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_INITIAL_DELAY

#ifndef GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_MAXIMUM_DELAY
#define GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_MAXIMUM_DELAY \
  std::chrono::milliseconds(60000)
#endif  // GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_MAXIMUM_DELAY

#ifndef GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_MAXIMUM_RETRY_PERIOD
#define GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_MAXIMUM_RETRY_PERIOD \
  std::chrono::milliseconds(600000)
#endif  // GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_MAXIMUM_RETRY_PERIOD

RPCPolicyParameters const kBigtableInstanceAdminLimits = {
    GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_INITIAL_DELAY,
    GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_MAXIMUM_DELAY,
    GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_MAXIMUM_RETRY_PERIOD,
};

// Interface name: "google.bigtable.admin.v2.BigtableTableAdmin"
// Define the defaults using a pre-processor macro, this allows
// the application developers to change the defaults for their
// application by compiling with different values.

#ifndef GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_INITIAL_DELAY
#define GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_INITIAL_DELAY \
  std::chrono::milliseconds(100)
#endif  // GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_INITIAL_DELAY

#ifndef GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_MAXIMUM_DELAY
#define GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_MAXIMUM_DELAY \
  std::chrono::milliseconds(60000)
#endif  // GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_MAXIMUM_DELAY

#ifndef GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_MAXIMUM_RETRY_PERIOD
#define GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_MAXIMUM_RETRY_PERIOD \
  std::chrono::milliseconds(600000)
#endif  // GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_MAXIMUM_RETRY_PERIOD

RPCPolicyParameters const kBigtableTableAdminLimits = {
    GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_INITIAL_DELAY,
    GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_MAXIMUM_DELAY,
    GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_MAXIMUM_RETRY_PERIOD,
};

// Interface name: "google.bigtable.v2.Bigtable"
// Define the defaults using a pre-processor macro, this allows
// the application developers to change the defaults for their
// application by compiling with different values.

#ifndef GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_INITIAL_DELAY
#define GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_INITIAL_DELAY \
  std::chrono::milliseconds(100)
#endif  // GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_INITIAL_DELAY

#ifndef GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_MAXIMUM_DELAY
#define GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_MAXIMUM_DELAY \
  std::chrono::milliseconds(60000)
#endif  // GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_MAXIMUM_DELAY

#ifndef GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_MAXIMUM_RETRY_PERIOD
#define GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_MAXIMUM_RETRY_PERIOD \
  std::chrono::milliseconds(600000)
#endif  // GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_MAXIMUM_RETRY_PERIOD

RPCPolicyParameters const kBigtableLimits = {
    GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_INITIAL_DELAY,
    GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_MAXIMUM_DELAY,
    GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_MAXIMUM_RETRY_PERIOD,
};

#undef GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_INITIAL_DELAY
#undef GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_MAXIMUM_DELAY
#undef GOOGLE_CLOUD_CPP_BIGTABLEINSTANCEADMIN_DEFAULT_MAXIMUM_RETRY_PERIOD
#undef GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_INITIAL_DELAY
#undef GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_MAXIMUM_DELAY
#undef GOOGLE_CLOUD_CPP_BIGTABLETABLEADMIN_DEFAULT_MAXIMUM_RETRY_PERIOD
#undef GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_INITIAL_DELAY
#undef GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_MAXIMUM_DELAY
#undef GOOGLE_CLOUD_CPP_BIGTABLE_DEFAULT_MAXIMUM_RETRY_PERIOD
