// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/addresses/v1/addresses.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_ADDRESSES_V1_INTERNAL_ADDRESSES_REST_CONNECTION_IMPL_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_ADDRESSES_V1_INTERNAL_ADDRESSES_REST_CONNECTION_IMPL_H

#include "google/cloud/compute/addresses/v1/addresses_connection.h"
#include "google/cloud/compute/addresses/v1/addresses_connection_idempotency_policy.h"
#include "google/cloud/compute/addresses/v1/addresses_options.h"
#include "google/cloud/compute/addresses/v1/internal/addresses_rest_stub.h"
#include "google/cloud/compute/addresses/v1/internal/addresses_retry_traits.h"
#include "google/cloud/background_threads.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/region_operations/v1/region_operations.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_addresses_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class AddressesRestConnectionImpl
    : public compute_addresses_v1::AddressesConnection {
 public:
  ~AddressesRestConnectionImpl() override = default;

  AddressesRestConnectionImpl(
      std::unique_ptr<google::cloud::BackgroundThreads> background,
      std::shared_ptr<compute_addresses_v1_internal::AddressesRestStub> stub,
      Options options);

  Options options() override { return options_; }

  StreamRange<std::pair<std::string,
                        google::cloud::cpp::compute::v1::AddressesScopedList>>
  AggregatedListAddresses(
      google::cloud::cpp::compute::addresses::v1::AggregatedListAddressesRequest
          request) override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>> DeleteAddress(
      google::cloud::cpp::compute::addresses::v1::DeleteAddressRequest const&
          request) override;

  StatusOr<google::cloud::cpp::compute::v1::Operation> DeleteAddress(
      ExperimentalTag, NoAwaitTag,
      google::cloud::cpp::compute::addresses::v1::DeleteAddressRequest const&
          request) override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>> DeleteAddress(
      ExperimentalTag,
      google::cloud::cpp::compute::v1::Operation const& operation) override;

  StatusOr<google::cloud::cpp::compute::v1::Address> GetAddress(
      google::cloud::cpp::compute::addresses::v1::GetAddressRequest const&
          request) override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>> InsertAddress(
      google::cloud::cpp::compute::addresses::v1::InsertAddressRequest const&
          request) override;

  StatusOr<google::cloud::cpp::compute::v1::Operation> InsertAddress(
      ExperimentalTag, NoAwaitTag,
      google::cloud::cpp::compute::addresses::v1::InsertAddressRequest const&
          request) override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>> InsertAddress(
      ExperimentalTag,
      google::cloud::cpp::compute::v1::Operation const& operation) override;

  StreamRange<google::cloud::cpp::compute::v1::Address> ListAddresses(
      google::cloud::cpp::compute::addresses::v1::ListAddressesRequest request)
      override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>> Move(
      google::cloud::cpp::compute::addresses::v1::MoveRequest const& request)
      override;

  StatusOr<google::cloud::cpp::compute::v1::Operation> Move(
      ExperimentalTag, NoAwaitTag,
      google::cloud::cpp::compute::addresses::v1::MoveRequest const& request)
      override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>> Move(
      ExperimentalTag,
      google::cloud::cpp::compute::v1::Operation const& operation) override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>> SetLabels(
      google::cloud::cpp::compute::addresses::v1::SetLabelsRequest const&
          request) override;

  StatusOr<google::cloud::cpp::compute::v1::Operation> SetLabels(
      ExperimentalTag, NoAwaitTag,
      google::cloud::cpp::compute::addresses::v1::SetLabelsRequest const&
          request) override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>> SetLabels(
      ExperimentalTag,
      google::cloud::cpp::compute::v1::Operation const& operation) override;

 private:
  static std::unique_ptr<compute_addresses_v1::AddressesRetryPolicy>
  retry_policy(Options const& options) {
    return options.get<compute_addresses_v1::AddressesRetryPolicyOption>()
        ->clone();
  }

  static std::unique_ptr<BackoffPolicy> backoff_policy(Options const& options) {
    return options.get<compute_addresses_v1::AddressesBackoffPolicyOption>()
        ->clone();
  }

  static std::unique_ptr<
      compute_addresses_v1::AddressesConnectionIdempotencyPolicy>
  idempotency_policy(Options const& options) {
    return options
        .get<compute_addresses_v1::AddressesConnectionIdempotencyPolicyOption>()
        ->clone();
  }

  static std::unique_ptr<PollingPolicy> polling_policy(Options const& options) {
    return options.get<compute_addresses_v1::AddressesPollingPolicyOption>()
        ->clone();
  }

  std::unique_ptr<google::cloud::BackgroundThreads> background_;
  std::shared_ptr<compute_addresses_v1_internal::AddressesRestStub> stub_;
  Options options_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_addresses_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_ADDRESSES_V1_INTERNAL_ADDRESSES_REST_CONNECTION_IMPL_H
