// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/packet_mirrorings/v1/packet_mirrorings.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_PACKET_MIRRORINGS_V1_MOCKS_MOCK_PACKET_MIRRORINGS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_PACKET_MIRRORINGS_V1_MOCKS_MOCK_PACKET_MIRRORINGS_CONNECTION_H

#include "google/cloud/compute/packet_mirrorings/v1/packet_mirrorings_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace compute_packet_mirrorings_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `PacketMirroringsConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `PacketMirroringsClient`. To do so,
 * construct an object of type `PacketMirroringsClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockPacketMirroringsConnection
    : public compute_packet_mirrorings_v1::PacketMirroringsConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(
      (StreamRange<std::pair<std::string, google::cloud::cpp::compute::v1::
                                              PacketMirroringsScopedList>>),
      AggregatedListPacketMirrorings,
      (google::cloud::cpp::compute::packet_mirrorings::v1::
           AggregatedListPacketMirroringsRequest request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeletePacketMirroring)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeletePacketMirroring(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              DeletePacketMirroring,
              (google::cloud::cpp::compute::packet_mirrorings::v1::
                   DeletePacketMirroringRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::Operation>,
              DeletePacketMirroring,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::cpp::compute::packet_mirrorings::v1::
                   DeletePacketMirroringRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              DeletePacketMirroring,
              (ExperimentalTag,
               google::cloud::cpp::compute::v1::Operation const& operation),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::PacketMirroring>,
              GetPacketMirroring,
              (google::cloud::cpp::compute::packet_mirrorings::v1::
                   GetPacketMirroringRequest const& request),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, InsertPacketMirroring)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, InsertPacketMirroring(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              InsertPacketMirroring,
              (google::cloud::cpp::compute::packet_mirrorings::v1::
                   InsertPacketMirroringRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::Operation>,
              InsertPacketMirroring,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::cpp::compute::packet_mirrorings::v1::
                   InsertPacketMirroringRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              InsertPacketMirroring,
              (ExperimentalTag,
               google::cloud::cpp::compute::v1::Operation const& operation),
              (override));

  MOCK_METHOD((StreamRange<google::cloud::cpp::compute::v1::PacketMirroring>),
              ListPacketMirrorings,
              (google::cloud::cpp::compute::packet_mirrorings::v1::
                   ListPacketMirroringsRequest request),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, PatchPacketMirroring)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, PatchPacketMirroring(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              PatchPacketMirroring,
              (google::cloud::cpp::compute::packet_mirrorings::v1::
                   PatchPacketMirroringRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::Operation>,
              PatchPacketMirroring,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::cpp::compute::packet_mirrorings::v1::
                   PatchPacketMirroringRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              PatchPacketMirroring,
              (ExperimentalTag,
               google::cloud::cpp::compute::v1::Operation const& operation),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::cpp::compute::v1::TestPermissionsResponse>,
      TestIamPermissions,
      (google::cloud::cpp::compute::packet_mirrorings::v1::
           TestIamPermissionsRequest const& request),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_packet_mirrorings_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_PACKET_MIRRORINGS_V1_MOCKS_MOCK_PACKET_MIRRORINGS_CONNECTION_H
