// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/region_health_check_services/v1/region_health_check_services.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_HEALTH_CHECK_SERVICES_V1_MOCKS_MOCK_REGION_HEALTH_CHECK_SERVICES_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_HEALTH_CHECK_SERVICES_V1_MOCKS_MOCK_REGION_HEALTH_CHECK_SERVICES_CONNECTION_H

#include "google/cloud/compute/region_health_check_services/v1/region_health_check_services_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace compute_region_health_check_services_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `RegionHealthCheckServicesConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `RegionHealthCheckServicesClient`.
 * To do so, construct an object of type `RegionHealthCheckServicesClient` with
 * an instance of this class. Then use the Google Test framework functions to
 * program the behavior of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockRegionHealthCheckServicesConnection
    : public compute_region_health_check_services_v1::
          RegionHealthCheckServicesConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteHealthCheckService)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteHealthCheckService(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              DeleteHealthCheckService,
              (google::cloud::cpp::compute::region_health_check_services::v1::
                   DeleteHealthCheckServiceRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::Operation>,
              DeleteHealthCheckService,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::cpp::compute::region_health_check_services::v1::
                   DeleteHealthCheckServiceRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              DeleteHealthCheckService,
              (ExperimentalTag,
               google::cloud::cpp::compute::v1::Operation const& operation),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::HealthCheckService>,
              GetHealthCheckService,
              (google::cloud::cpp::compute::region_health_check_services::v1::
                   GetHealthCheckServiceRequest const& request),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, InsertHealthCheckService)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, InsertHealthCheckService(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              InsertHealthCheckService,
              (google::cloud::cpp::compute::region_health_check_services::v1::
                   InsertHealthCheckServiceRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::Operation>,
              InsertHealthCheckService,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::cpp::compute::region_health_check_services::v1::
                   InsertHealthCheckServiceRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              InsertHealthCheckService,
              (ExperimentalTag,
               google::cloud::cpp::compute::v1::Operation const& operation),
              (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::cpp::compute::v1::HealthCheckService>),
      ListRegionHealthCheckServices,
      (google::cloud::cpp::compute::region_health_check_services::v1::
           ListRegionHealthCheckServicesRequest request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, PatchHealthCheckService)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, PatchHealthCheckService(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              PatchHealthCheckService,
              (google::cloud::cpp::compute::region_health_check_services::v1::
                   PatchHealthCheckServiceRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::Operation>,
              PatchHealthCheckService,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::cpp::compute::region_health_check_services::v1::
                   PatchHealthCheckServiceRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              PatchHealthCheckService,
              (ExperimentalTag,
               google::cloud::cpp::compute::v1::Operation const& operation),
              (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_region_health_check_services_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_HEALTH_CHECK_SERVICES_V1_MOCKS_MOCK_REGION_HEALTH_CHECK_SERVICES_CONNECTION_H
