// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/region_health_checks/v1/region_health_checks.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_HEALTH_CHECKS_V1_INTERNAL_REGION_HEALTH_CHECKS_REST_CONNECTION_IMPL_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_HEALTH_CHECKS_V1_INTERNAL_REGION_HEALTH_CHECKS_REST_CONNECTION_IMPL_H

#include "google/cloud/compute/region_health_checks/v1/internal/region_health_checks_rest_stub.h"
#include "google/cloud/compute/region_health_checks/v1/internal/region_health_checks_retry_traits.h"
#include "google/cloud/compute/region_health_checks/v1/region_health_checks_connection.h"
#include "google/cloud/compute/region_health_checks/v1/region_health_checks_connection_idempotency_policy.h"
#include "google/cloud/compute/region_health_checks/v1/region_health_checks_options.h"
#include "google/cloud/background_threads.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/region_operations/v1/region_operations.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_region_health_checks_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class RegionHealthChecksRestConnectionImpl
    : public compute_region_health_checks_v1::RegionHealthChecksConnection {
 public:
  ~RegionHealthChecksRestConnectionImpl() override = default;

  RegionHealthChecksRestConnectionImpl(
      std::unique_ptr<google::cloud::BackgroundThreads> background,
      std::shared_ptr<
          compute_region_health_checks_v1_internal::RegionHealthChecksRestStub>
          stub,
      Options options);

  Options options() override { return options_; }

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteHealthCheck(google::cloud::cpp::compute::region_health_checks::v1::
                        DeleteHealthCheckRequest const& request) override;

  StatusOr<google::cloud::cpp::compute::v1::Operation> DeleteHealthCheck(
      ExperimentalTag, NoAwaitTag,
      google::cloud::cpp::compute::region_health_checks::v1::
          DeleteHealthCheckRequest const& request) override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  DeleteHealthCheck(
      ExperimentalTag,
      google::cloud::cpp::compute::v1::Operation const& operation) override;

  StatusOr<google::cloud::cpp::compute::v1::HealthCheck> GetHealthCheck(
      google::cloud::cpp::compute::region_health_checks::v1::
          GetHealthCheckRequest const& request) override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertHealthCheck(google::cloud::cpp::compute::region_health_checks::v1::
                        InsertHealthCheckRequest const& request) override;

  StatusOr<google::cloud::cpp::compute::v1::Operation> InsertHealthCheck(
      ExperimentalTag, NoAwaitTag,
      google::cloud::cpp::compute::region_health_checks::v1::
          InsertHealthCheckRequest const& request) override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  InsertHealthCheck(
      ExperimentalTag,
      google::cloud::cpp::compute::v1::Operation const& operation) override;

  StreamRange<google::cloud::cpp::compute::v1::HealthCheck>
  ListRegionHealthChecks(google::cloud::cpp::compute::region_health_checks::v1::
                             ListRegionHealthChecksRequest request) override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>> PatchHealthCheck(
      google::cloud::cpp::compute::region_health_checks::v1::
          PatchHealthCheckRequest const& request) override;

  StatusOr<google::cloud::cpp::compute::v1::Operation> PatchHealthCheck(
      ExperimentalTag, NoAwaitTag,
      google::cloud::cpp::compute::region_health_checks::v1::
          PatchHealthCheckRequest const& request) override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>> PatchHealthCheck(
      ExperimentalTag,
      google::cloud::cpp::compute::v1::Operation const& operation) override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  UpdateHealthCheck(google::cloud::cpp::compute::region_health_checks::v1::
                        UpdateHealthCheckRequest const& request) override;

  StatusOr<google::cloud::cpp::compute::v1::Operation> UpdateHealthCheck(
      ExperimentalTag, NoAwaitTag,
      google::cloud::cpp::compute::region_health_checks::v1::
          UpdateHealthCheckRequest const& request) override;

  future<StatusOr<google::cloud::cpp::compute::v1::Operation>>
  UpdateHealthCheck(
      ExperimentalTag,
      google::cloud::cpp::compute::v1::Operation const& operation) override;

 private:
  static std::unique_ptr<
      compute_region_health_checks_v1::RegionHealthChecksRetryPolicy>
  retry_policy(Options const& options) {
    return options
        .get<compute_region_health_checks_v1::
                 RegionHealthChecksRetryPolicyOption>()
        ->clone();
  }

  static std::unique_ptr<BackoffPolicy> backoff_policy(Options const& options) {
    return options
        .get<compute_region_health_checks_v1::
                 RegionHealthChecksBackoffPolicyOption>()
        ->clone();
  }

  static std::unique_ptr<compute_region_health_checks_v1::
                             RegionHealthChecksConnectionIdempotencyPolicy>
  idempotency_policy(Options const& options) {
    return options
        .get<compute_region_health_checks_v1::
                 RegionHealthChecksConnectionIdempotencyPolicyOption>()
        ->clone();
  }

  static std::unique_ptr<PollingPolicy> polling_policy(Options const& options) {
    return options
        .get<compute_region_health_checks_v1::
                 RegionHealthChecksPollingPolicyOption>()
        ->clone();
  }

  std::unique_ptr<google::cloud::BackgroundThreads> background_;
  std::shared_ptr<
      compute_region_health_checks_v1_internal::RegionHealthChecksRestStub>
      stub_;
  Options options_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_region_health_checks_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_HEALTH_CHECKS_V1_INTERNAL_REGION_HEALTH_CHECKS_REST_CONNECTION_IMPL_H
