// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/compute/region_health_checks/v1/region_health_checks.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_HEALTH_CHECKS_V1_MOCKS_MOCK_REGION_HEALTH_CHECKS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_HEALTH_CHECKS_V1_MOCKS_MOCK_REGION_HEALTH_CHECKS_CONNECTION_H

#include "google/cloud/compute/region_health_checks/v1/region_health_checks_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace compute_region_health_checks_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `RegionHealthChecksConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `RegionHealthChecksClient`. To do
 * so, construct an object of type `RegionHealthChecksClient` with an instance
 * of this class. Then use the Google Test framework functions to program the
 * behavior of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockRegionHealthChecksConnection
    : public compute_region_health_checks_v1::RegionHealthChecksConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteHealthCheck)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteHealthCheck(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              DeleteHealthCheck,
              (google::cloud::cpp::compute::region_health_checks::v1::
                   DeleteHealthCheckRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::Operation>,
              DeleteHealthCheck,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::cpp::compute::region_health_checks::v1::
                   DeleteHealthCheckRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              DeleteHealthCheck,
              (ExperimentalTag,
               google::cloud::cpp::compute::v1::Operation const& operation),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::HealthCheck>,
              GetHealthCheck,
              (google::cloud::cpp::compute::region_health_checks::v1::
                   GetHealthCheckRequest const& request),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, InsertHealthCheck)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, InsertHealthCheck(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              InsertHealthCheck,
              (google::cloud::cpp::compute::region_health_checks::v1::
                   InsertHealthCheckRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::Operation>,
              InsertHealthCheck,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::cpp::compute::region_health_checks::v1::
                   InsertHealthCheckRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              InsertHealthCheck,
              (ExperimentalTag,
               google::cloud::cpp::compute::v1::Operation const& operation),
              (override));

  MOCK_METHOD((StreamRange<google::cloud::cpp::compute::v1::HealthCheck>),
              ListRegionHealthChecks,
              (google::cloud::cpp::compute::region_health_checks::v1::
                   ListRegionHealthChecksRequest request),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, PatchHealthCheck)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, PatchHealthCheck(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              PatchHealthCheck,
              (google::cloud::cpp::compute::region_health_checks::v1::
                   PatchHealthCheckRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::Operation>,
              PatchHealthCheck,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::cpp::compute::region_health_checks::v1::
                   PatchHealthCheckRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              PatchHealthCheck,
              (ExperimentalTag,
               google::cloud::cpp::compute::v1::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateHealthCheck)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateHealthCheck(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              UpdateHealthCheck,
              (google::cloud::cpp::compute::region_health_checks::v1::
                   UpdateHealthCheckRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::cpp::compute::v1::Operation>,
              UpdateHealthCheck,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::cpp::compute::region_health_checks::v1::
                   UpdateHealthCheckRequest const& request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::cpp::compute::v1::Operation>>,
              UpdateHealthCheck,
              (ExperimentalTag,
               google::cloud::cpp::compute::v1::Operation const& operation),
              (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_region_health_checks_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_REGION_HEALTH_CHECKS_V1_MOCKS_MOCK_REGION_HEALTH_CHECKS_CONNECTION_H
