// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/datafusion/v1/datafusion.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DATAFUSION_V1_INTERNAL_DATA_FUSION_TRACING_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DATAFUSION_V1_INTERNAL_DATA_FUSION_TRACING_CONNECTION_H

#include "google/cloud/datafusion/v1/data_fusion_connection.h"
#include "google/cloud/version.h"
#include <memory>

namespace google {
namespace cloud {
namespace datafusion_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

class DataFusionTracingConnection : public datafusion_v1::DataFusionConnection {
 public:
  ~DataFusionTracingConnection() override = default;

  explicit DataFusionTracingConnection(
      std::shared_ptr<datafusion_v1::DataFusionConnection> child);

  Options options() override { return child_->options(); }

  StreamRange<google::cloud::datafusion::v1::Version> ListAvailableVersions(
      google::cloud::datafusion::v1::ListAvailableVersionsRequest request)
      override;

  StreamRange<google::cloud::datafusion::v1::Instance> ListInstances(
      google::cloud::datafusion::v1::ListInstancesRequest request) override;

  StatusOr<google::cloud::datafusion::v1::Instance> GetInstance(
      google::cloud::datafusion::v1::GetInstanceRequest const& request)
      override;

  future<StatusOr<google::cloud::datafusion::v1::Instance>> CreateInstance(
      google::cloud::datafusion::v1::CreateInstanceRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> CreateInstance(
      ExperimentalTag, NoAwaitTag,
      google::cloud::datafusion::v1::CreateInstanceRequest const& request)
      override;

  future<StatusOr<google::cloud::datafusion::v1::Instance>> CreateInstance(
      ExperimentalTag,
      google::longrunning::Operation const& operation) override;

  future<StatusOr<google::cloud::datafusion::v1::OperationMetadata>>
  DeleteInstance(google::cloud::datafusion::v1::DeleteInstanceRequest const&
                     request) override;

  StatusOr<google::longrunning::Operation> DeleteInstance(
      ExperimentalTag, NoAwaitTag,
      google::cloud::datafusion::v1::DeleteInstanceRequest const& request)
      override;

  future<StatusOr<google::cloud::datafusion::v1::OperationMetadata>>
  DeleteInstance(ExperimentalTag,
                 google::longrunning::Operation const& operation) override;

  future<StatusOr<google::cloud::datafusion::v1::Instance>> UpdateInstance(
      google::cloud::datafusion::v1::UpdateInstanceRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> UpdateInstance(
      ExperimentalTag, NoAwaitTag,
      google::cloud::datafusion::v1::UpdateInstanceRequest const& request)
      override;

  future<StatusOr<google::cloud::datafusion::v1::Instance>> UpdateInstance(
      ExperimentalTag,
      google::longrunning::Operation const& operation) override;

  future<StatusOr<google::cloud::datafusion::v1::Instance>> RestartInstance(
      google::cloud::datafusion::v1::RestartInstanceRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> RestartInstance(
      ExperimentalTag, NoAwaitTag,
      google::cloud::datafusion::v1::RestartInstanceRequest const& request)
      override;

  future<StatusOr<google::cloud::datafusion::v1::Instance>> RestartInstance(
      ExperimentalTag,
      google::longrunning::Operation const& operation) override;

 private:
  std::shared_ptr<datafusion_v1::DataFusionConnection> child_;
};

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

/**
 * Conditionally applies the tracing decorator to the given connection.
 *
 * The connection is only decorated if tracing is enabled (as determined by the
 * connection's options).
 */
std::shared_ptr<datafusion_v1::DataFusionConnection>
MakeDataFusionTracingConnection(
    std::shared_ptr<datafusion_v1::DataFusionConnection> conn);

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace datafusion_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DATAFUSION_V1_INTERNAL_DATA_FUSION_TRACING_CONNECTION_H
