// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/cx/v3/agent.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_CX_MOCKS_MOCK_AGENTS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_CX_MOCKS_MOCK_AGENTS_CONNECTION_H

#include "google/cloud/dialogflow_cx/agents_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace dialogflow_cx_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `AgentsConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `AgentsClient`. To do so,
 * construct an object of type `AgentsClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockAgentsConnection : public dialogflow_cx::AgentsConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD((StreamRange<google::cloud::dialogflow::cx::v3::Agent>),
              ListAgents,
              (google::cloud::dialogflow::cx::v3::ListAgentsRequest request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::dialogflow::cx::v3::Agent>, GetAgent,
      (google::cloud::dialogflow::cx::v3::GetAgentRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::dialogflow::cx::v3::Agent>, CreateAgent,
      (google::cloud::dialogflow::cx::v3::CreateAgentRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::dialogflow::cx::v3::Agent>, UpdateAgent,
      (google::cloud::dialogflow::cx::v3::UpdateAgentRequest const& request),
      (override));

  MOCK_METHOD(
      Status, DeleteAgent,
      (google::cloud::dialogflow::cx::v3::DeleteAgentRequest const& request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, ExportAgent)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, ExportAgent(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::dialogflow::cx::v3::ExportAgentResponse>>,
      ExportAgent,
      (google::cloud::dialogflow::cx::v3::ExportAgentRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, ExportAgent,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::dialogflow::cx::v3::ExportAgentRequest const& request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::dialogflow::cx::v3::ExportAgentResponse>>,
      ExportAgent,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, RestoreAgent)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, RestoreAgent(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::protobuf::Struct>>, RestoreAgent,
      (google::cloud::dialogflow::cx::v3::RestoreAgentRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, RestoreAgent,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::dialogflow::cx::v3::RestoreAgentRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::protobuf::Struct>>, RestoreAgent,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::dialogflow::cx::v3::AgentValidationResult>,
      ValidateAgent,
      (google::cloud::dialogflow::cx::v3::ValidateAgentRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::dialogflow::cx::v3::AgentValidationResult>,
      GetAgentValidationResult,
      (google::cloud::dialogflow::cx::v3::GetAgentValidationResultRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::dialogflow::cx::v3::GenerativeSettings>,
      GetGenerativeSettings,
      (google::cloud::dialogflow::cx::v3::GetGenerativeSettingsRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::dialogflow::cx::v3::GenerativeSettings>,
      UpdateGenerativeSettings,
      (google::cloud::dialogflow::cx::v3::UpdateGenerativeSettingsRequest const&
           request),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_cx_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_CX_MOCKS_MOCK_AGENTS_CONNECTION_H
