// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/discoveryengine/v1/engine_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_ENGINE_AUTH_DECORATOR_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_ENGINE_AUTH_DECORATOR_H

#include "google/cloud/discoveryengine/v1/internal/engine_stub.h"
#include "google/cloud/internal/unified_grpc_credentials.h"
#include "google/cloud/version.h"
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>
#include <set>
#include <string>

namespace google {
namespace cloud {
namespace discoveryengine_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class EngineServiceAuth : public EngineServiceStub {
 public:
  ~EngineServiceAuth() override = default;
  EngineServiceAuth(
      std::shared_ptr<google::cloud::internal::GrpcAuthenticationStrategy> auth,
      std::shared_ptr<EngineServiceStub> child);

  future<StatusOr<google::longrunning::Operation>> AsyncCreateEngine(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::discoveryengine::v1::CreateEngineRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> CreateEngine(
      grpc::ClientContext& context, Options options,
      google::cloud::discoveryengine::v1::CreateEngineRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>> AsyncDeleteEngine(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::cloud::discoveryengine::v1::DeleteEngineRequest const& request)
      override;

  StatusOr<google::longrunning::Operation> DeleteEngine(
      grpc::ClientContext& context, Options options,
      google::cloud::discoveryengine::v1::DeleteEngineRequest const& request)
      override;

  StatusOr<google::cloud::discoveryengine::v1::Engine> UpdateEngine(
      grpc::ClientContext& context, Options const& options,
      google::cloud::discoveryengine::v1::UpdateEngineRequest const& request)
      override;

  StatusOr<google::cloud::discoveryengine::v1::Engine> GetEngine(
      grpc::ClientContext& context, Options const& options,
      google::cloud::discoveryengine::v1::GetEngineRequest const& request)
      override;

  StatusOr<google::cloud::discoveryengine::v1::ListEnginesResponse> ListEngines(
      grpc::ClientContext& context, Options const& options,
      google::cloud::discoveryengine::v1::ListEnginesRequest const& request)
      override;

  future<StatusOr<google::longrunning::Operation>> AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::GetOperationRequest const& request) override;

  future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::internal::ImmutableOptions options,
      google::longrunning::CancelOperationRequest const& request) override;

 private:
  std::shared_ptr<google::cloud::internal::GrpcAuthenticationStrategy> auth_;
  std::shared_ptr<EngineServiceStub> child_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace discoveryengine_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_ENGINE_AUTH_DECORATOR_H
