// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/functions/v1/functions.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2ffunctions_2fv1_2ffunctions_2eproto__INCLUDED
#define GRPC_google_2fcloud_2ffunctions_2fv1_2ffunctions_2eproto__INCLUDED

#include "google/cloud/functions/v1/functions.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace functions {
namespace v1 {

// A service that application uses to manipulate triggers and functions.
class CloudFunctionsService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.functions.v1.CloudFunctionsService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Returns a list of functions that belong to the requested project.
    virtual ::grpc::Status ListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest& request, ::google::cloud::functions::v1::ListFunctionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::ListFunctionsResponse>> AsyncListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::ListFunctionsResponse>>(AsyncListFunctionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::ListFunctionsResponse>> PrepareAsyncListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::ListFunctionsResponse>>(PrepareAsyncListFunctionsRaw(context, request, cq));
    }
    // Returns a function with the given name from the requested project.
    virtual ::grpc::Status GetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest& request, ::google::cloud::functions::v1::CloudFunction* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::CloudFunction>> AsyncGetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::CloudFunction>>(AsyncGetFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::CloudFunction>> PrepareAsyncGetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::CloudFunction>>(PrepareAsyncGetFunctionRaw(context, request, cq));
    }
    // Creates a new function. If a function with the given name already exists in
    // the specified project, the long running operation will return
    // `ALREADY_EXISTS` error.
    virtual ::grpc::Status CreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateFunctionRaw(context, request, cq));
    }
    // Updates existing function.
    virtual ::grpc::Status UpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateFunctionRaw(context, request, cq));
    }
    // Deletes a function with the given name from the specified project. If the
    // given function is used by some trigger, the trigger will be updated to
    // remove this function.
    virtual ::grpc::Status DeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteFunctionRaw(context, request, cq));
    }
    // Synchronously invokes a deployed Cloud Function. To be used for testing
    // purposes as very limited traffic is allowed. For more information on
    // the actual limits, refer to
    // [Rate Limits](https://cloud.google.com/functions/quotas#rate_limits).
    virtual ::grpc::Status CallFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest& request, ::google::cloud::functions::v1::CallFunctionResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::CallFunctionResponse>> AsyncCallFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::CallFunctionResponse>>(AsyncCallFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::CallFunctionResponse>> PrepareAsyncCallFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::CallFunctionResponse>>(PrepareAsyncCallFunctionRaw(context, request, cq));
    }
    // Returns a signed URL for uploading a function source code.
    // For more information about the signed URL usage see:
    // https://cloud.google.com/storage/docs/access-control/signed-urls.
    // Once the function source code upload is complete, the used signed
    // URL should be provided in CreateFunction or UpdateFunction request
    // as a reference to the function source code.
    //
    // When uploading source code to the generated signed URL, please follow
    // these restrictions:
    //
    // * Source file type should be a zip file.
    // * Source file size should not exceed 100MB limit.
    // * No credentials should be attached - the signed URLs provide access to the
    //   target bucket using internal service identity; if credentials were
    //   attached, the identity from the credentials would be used, but that
    //   identity does not have permissions to upload files to the URL.
    //
    // When making a HTTP PUT request, these two headers need to be specified:
    //
    // * `content-type: application/zip`
    // * `x-goog-content-length-range: 0,104857600`
    //
    // And this header SHOULD NOT be specified:
    //
    // * `Authorization: Bearer YOUR_TOKEN`
    virtual ::grpc::Status GenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest& request, ::google::cloud::functions::v1::GenerateUploadUrlResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::GenerateUploadUrlResponse>> AsyncGenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::GenerateUploadUrlResponse>>(AsyncGenerateUploadUrlRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::GenerateUploadUrlResponse>> PrepareAsyncGenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::GenerateUploadUrlResponse>>(PrepareAsyncGenerateUploadUrlRaw(context, request, cq));
    }
    // Returns a signed URL for downloading deployed function source code.
    // The URL is only valid for a limited period and should be used within
    // minutes after generation.
    // For more information about the signed URL usage see:
    // https://cloud.google.com/storage/docs/access-control/signed-urls
    virtual ::grpc::Status GenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest& request, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::GenerateDownloadUrlResponse>> AsyncGenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::GenerateDownloadUrlResponse>>(AsyncGenerateDownloadUrlRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::GenerateDownloadUrlResponse>> PrepareAsyncGenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::GenerateDownloadUrlResponse>>(PrepareAsyncGenerateDownloadUrlRaw(context, request, cq));
    }
    // Sets the IAM access control policy on the specified function.
    // Replaces any existing policy.
    virtual ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    // Gets the IAM access control policy for a function.
    // Returns an empty policy if the function exists and does not have a policy
    // set.
    virtual ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    // Tests the specified permissions against the IAM access control policy
    // for a function.
    // If the function does not exist, this will return an empty set of
    // permissions, not a NOT_FOUND error.
    virtual ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Returns a list of functions that belong to the requested project.
      virtual void ListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest* request, ::google::cloud::functions::v1::ListFunctionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest* request, ::google::cloud::functions::v1::ListFunctionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a function with the given name from the requested project.
      virtual void GetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest* request, ::google::cloud::functions::v1::CloudFunction* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest* request, ::google::cloud::functions::v1::CloudFunction* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new function. If a function with the given name already exists in
      // the specified project, the long running operation will return
      // `ALREADY_EXISTS` error.
      virtual void CreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates existing function.
      virtual void UpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a function with the given name from the specified project. If the
      // given function is used by some trigger, the trigger will be updated to
      // remove this function.
      virtual void DeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Synchronously invokes a deployed Cloud Function. To be used for testing
      // purposes as very limited traffic is allowed. For more information on
      // the actual limits, refer to
      // [Rate Limits](https://cloud.google.com/functions/quotas#rate_limits).
      virtual void CallFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest* request, ::google::cloud::functions::v1::CallFunctionResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CallFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest* request, ::google::cloud::functions::v1::CallFunctionResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a signed URL for uploading a function source code.
      // For more information about the signed URL usage see:
      // https://cloud.google.com/storage/docs/access-control/signed-urls.
      // Once the function source code upload is complete, the used signed
      // URL should be provided in CreateFunction or UpdateFunction request
      // as a reference to the function source code.
      //
      // When uploading source code to the generated signed URL, please follow
      // these restrictions:
      //
      // * Source file type should be a zip file.
      // * Source file size should not exceed 100MB limit.
      // * No credentials should be attached - the signed URLs provide access to the
      //   target bucket using internal service identity; if credentials were
      //   attached, the identity from the credentials would be used, but that
      //   identity does not have permissions to upload files to the URL.
      //
      // When making a HTTP PUT request, these two headers need to be specified:
      //
      // * `content-type: application/zip`
      // * `x-goog-content-length-range: 0,104857600`
      //
      // And this header SHOULD NOT be specified:
      //
      // * `Authorization: Bearer YOUR_TOKEN`
      virtual void GenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest* request, ::google::cloud::functions::v1::GenerateUploadUrlResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest* request, ::google::cloud::functions::v1::GenerateUploadUrlResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a signed URL for downloading deployed function source code.
      // The URL is only valid for a limited period and should be used within
      // minutes after generation.
      // For more information about the signed URL usage see:
      // https://cloud.google.com/storage/docs/access-control/signed-urls
      virtual void GenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest* request, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest* request, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Sets the IAM access control policy on the specified function.
      // Replaces any existing policy.
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the IAM access control policy for a function.
      // Returns an empty policy if the function exists and does not have a policy
      // set.
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Tests the specified permissions against the IAM access control policy
      // for a function.
      // If the function does not exist, this will return an empty set of
      // permissions, not a NOT_FOUND error.
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::ListFunctionsResponse>* AsyncListFunctionsRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::ListFunctionsResponse>* PrepareAsyncListFunctionsRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::CloudFunction>* AsyncGetFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::CloudFunction>* PrepareAsyncGetFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::CallFunctionResponse>* AsyncCallFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::CallFunctionResponse>* PrepareAsyncCallFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::GenerateUploadUrlResponse>* AsyncGenerateUploadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::GenerateUploadUrlResponse>* PrepareAsyncGenerateUploadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::GenerateDownloadUrlResponse>* AsyncGenerateDownloadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::functions::v1::GenerateDownloadUrlResponse>* PrepareAsyncGenerateDownloadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest& request, ::google::cloud::functions::v1::ListFunctionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::ListFunctionsResponse>> AsyncListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::ListFunctionsResponse>>(AsyncListFunctionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::ListFunctionsResponse>> PrepareAsyncListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::ListFunctionsResponse>>(PrepareAsyncListFunctionsRaw(context, request, cq));
    }
    ::grpc::Status GetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest& request, ::google::cloud::functions::v1::CloudFunction* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::CloudFunction>> AsyncGetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::CloudFunction>>(AsyncGetFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::CloudFunction>> PrepareAsyncGetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::CloudFunction>>(PrepareAsyncGetFunctionRaw(context, request, cq));
    }
    ::grpc::Status CreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateFunctionRaw(context, request, cq));
    }
    ::grpc::Status UpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateFunctionRaw(context, request, cq));
    }
    ::grpc::Status DeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteFunctionRaw(context, request, cq));
    }
    ::grpc::Status CallFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest& request, ::google::cloud::functions::v1::CallFunctionResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::CallFunctionResponse>> AsyncCallFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::CallFunctionResponse>>(AsyncCallFunctionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::CallFunctionResponse>> PrepareAsyncCallFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::CallFunctionResponse>>(PrepareAsyncCallFunctionRaw(context, request, cq));
    }
    ::grpc::Status GenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest& request, ::google::cloud::functions::v1::GenerateUploadUrlResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::GenerateUploadUrlResponse>> AsyncGenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::GenerateUploadUrlResponse>>(AsyncGenerateUploadUrlRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::GenerateUploadUrlResponse>> PrepareAsyncGenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::GenerateUploadUrlResponse>>(PrepareAsyncGenerateUploadUrlRaw(context, request, cq));
    }
    ::grpc::Status GenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest& request, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::GenerateDownloadUrlResponse>> AsyncGenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::GenerateDownloadUrlResponse>>(AsyncGenerateDownloadUrlRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::GenerateDownloadUrlResponse>> PrepareAsyncGenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::GenerateDownloadUrlResponse>>(PrepareAsyncGenerateDownloadUrlRaw(context, request, cq));
    }
    ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest* request, ::google::cloud::functions::v1::ListFunctionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListFunctions(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest* request, ::google::cloud::functions::v1::ListFunctionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest* request, ::google::cloud::functions::v1::CloudFunction* response, std::function<void(::grpc::Status)>) override;
      void GetFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest* request, ::google::cloud::functions::v1::CloudFunction* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CallFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest* request, ::google::cloud::functions::v1::CallFunctionResponse* response, std::function<void(::grpc::Status)>) override;
      void CallFunction(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest* request, ::google::cloud::functions::v1::CallFunctionResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest* request, ::google::cloud::functions::v1::GenerateUploadUrlResponse* response, std::function<void(::grpc::Status)>) override;
      void GenerateUploadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest* request, ::google::cloud::functions::v1::GenerateUploadUrlResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest* request, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* response, std::function<void(::grpc::Status)>) override;
      void GenerateDownloadUrl(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest* request, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::ListFunctionsResponse>* AsyncListFunctionsRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::ListFunctionsResponse>* PrepareAsyncListFunctionsRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::CloudFunction>* AsyncGetFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::CloudFunction>* PrepareAsyncGetFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GetFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::CallFunctionResponse>* AsyncCallFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::CallFunctionResponse>* PrepareAsyncCallFunctionRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::CallFunctionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::GenerateUploadUrlResponse>* AsyncGenerateUploadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::GenerateUploadUrlResponse>* PrepareAsyncGenerateUploadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::GenerateDownloadUrlResponse>* AsyncGenerateDownloadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::functions::v1::GenerateDownloadUrlResponse>* PrepareAsyncGenerateDownloadUrlRaw(::grpc::ClientContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListFunctions_;
    const ::grpc::internal::RpcMethod rpcmethod_GetFunction_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateFunction_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateFunction_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteFunction_;
    const ::grpc::internal::RpcMethod rpcmethod_CallFunction_;
    const ::grpc::internal::RpcMethod rpcmethod_GenerateUploadUrl_;
    const ::grpc::internal::RpcMethod rpcmethod_GenerateDownloadUrl_;
    const ::grpc::internal::RpcMethod rpcmethod_SetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_TestIamPermissions_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Returns a list of functions that belong to the requested project.
    virtual ::grpc::Status ListFunctions(::grpc::ServerContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest* request, ::google::cloud::functions::v1::ListFunctionsResponse* response);
    // Returns a function with the given name from the requested project.
    virtual ::grpc::Status GetFunction(::grpc::ServerContext* context, const ::google::cloud::functions::v1::GetFunctionRequest* request, ::google::cloud::functions::v1::CloudFunction* response);
    // Creates a new function. If a function with the given name already exists in
    // the specified project, the long running operation will return
    // `ALREADY_EXISTS` error.
    virtual ::grpc::Status CreateFunction(::grpc::ServerContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest* request, ::google::longrunning::Operation* response);
    // Updates existing function.
    virtual ::grpc::Status UpdateFunction(::grpc::ServerContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest* request, ::google::longrunning::Operation* response);
    // Deletes a function with the given name from the specified project. If the
    // given function is used by some trigger, the trigger will be updated to
    // remove this function.
    virtual ::grpc::Status DeleteFunction(::grpc::ServerContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest* request, ::google::longrunning::Operation* response);
    // Synchronously invokes a deployed Cloud Function. To be used for testing
    // purposes as very limited traffic is allowed. For more information on
    // the actual limits, refer to
    // [Rate Limits](https://cloud.google.com/functions/quotas#rate_limits).
    virtual ::grpc::Status CallFunction(::grpc::ServerContext* context, const ::google::cloud::functions::v1::CallFunctionRequest* request, ::google::cloud::functions::v1::CallFunctionResponse* response);
    // Returns a signed URL for uploading a function source code.
    // For more information about the signed URL usage see:
    // https://cloud.google.com/storage/docs/access-control/signed-urls.
    // Once the function source code upload is complete, the used signed
    // URL should be provided in CreateFunction or UpdateFunction request
    // as a reference to the function source code.
    //
    // When uploading source code to the generated signed URL, please follow
    // these restrictions:
    //
    // * Source file type should be a zip file.
    // * Source file size should not exceed 100MB limit.
    // * No credentials should be attached - the signed URLs provide access to the
    //   target bucket using internal service identity; if credentials were
    //   attached, the identity from the credentials would be used, but that
    //   identity does not have permissions to upload files to the URL.
    //
    // When making a HTTP PUT request, these two headers need to be specified:
    //
    // * `content-type: application/zip`
    // * `x-goog-content-length-range: 0,104857600`
    //
    // And this header SHOULD NOT be specified:
    //
    // * `Authorization: Bearer YOUR_TOKEN`
    virtual ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest* request, ::google::cloud::functions::v1::GenerateUploadUrlResponse* response);
    // Returns a signed URL for downloading deployed function source code.
    // The URL is only valid for a limited period and should be used within
    // minutes after generation.
    // For more information about the signed URL usage see:
    // https://cloud.google.com/storage/docs/access-control/signed-urls
    virtual ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest* request, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* response);
    // Sets the IAM access control policy on the specified function.
    // Replaces any existing policy.
    virtual ::grpc::Status SetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Gets the IAM access control policy for a function.
    // Returns an empty policy if the function exists and does not have a policy
    // set.
    virtual ::grpc::Status GetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Tests the specified permissions against the IAM access control policy
    // for a function.
    // If the function does not exist, this will return an empty set of
    // permissions, not a NOT_FOUND error.
    virtual ::grpc::Status TestIamPermissions(::grpc::ServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListFunctions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListFunctions() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListFunctions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFunctions(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v1::ListFunctionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFunctions(::grpc::ServerContext* context, ::google::cloud::functions::v1::ListFunctionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::functions::v1::ListFunctionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetFunction() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GetFunctionRequest* /*request*/, ::google::cloud::functions::v1::CloudFunction* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFunction(::grpc::ServerContext* context, ::google::cloud::functions::v1::GetFunctionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::functions::v1::CloudFunction>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateFunction() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateFunction(::grpc::ServerContext* context, ::google::cloud::functions::v1::CreateFunctionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateFunction() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFunction(::grpc::ServerContext* context, ::google::cloud::functions::v1::UpdateFunctionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteFunction() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFunction(::grpc::ServerContext* context, ::google::cloud::functions::v1::DeleteFunctionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CallFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CallFunction() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_CallFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CallFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::CallFunctionRequest* /*request*/, ::google::cloud::functions::v1::CallFunctionResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCallFunction(::grpc::ServerContext* context, ::google::cloud::functions::v1::CallFunctionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::functions::v1::CallFunctionResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GenerateUploadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GenerateUploadUrl() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GenerateUploadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateUploadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateUploadUrl(::grpc::ServerContext* context, ::google::cloud::functions::v1::GenerateUploadUrlRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::functions::v1::GenerateUploadUrlResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GenerateDownloadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GenerateDownloadUrl() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GenerateDownloadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateDownloadUrl(::grpc::ServerContext* context, ::google::cloud::functions::v1::GenerateDownloadUrlRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::functions::v1::GenerateDownloadUrlResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::SetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::GetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::google::iam::v1::TestIamPermissionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::TestIamPermissionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListFunctions<WithAsyncMethod_GetFunction<WithAsyncMethod_CreateFunction<WithAsyncMethod_UpdateFunction<WithAsyncMethod_DeleteFunction<WithAsyncMethod_CallFunction<WithAsyncMethod_GenerateUploadUrl<WithAsyncMethod_GenerateDownloadUrl<WithAsyncMethod_SetIamPolicy<WithAsyncMethod_GetIamPolicy<WithAsyncMethod_TestIamPermissions<Service > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListFunctions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListFunctions() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::ListFunctionsRequest, ::google::cloud::functions::v1::ListFunctionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v1::ListFunctionsRequest* request, ::google::cloud::functions::v1::ListFunctionsResponse* response) { return this->ListFunctions(context, request, response); }));}
    void SetMessageAllocatorFor_ListFunctions(
        ::grpc::MessageAllocator< ::google::cloud::functions::v1::ListFunctionsRequest, ::google::cloud::functions::v1::ListFunctionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::ListFunctionsRequest, ::google::cloud::functions::v1::ListFunctionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListFunctions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFunctions(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v1::ListFunctionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFunctions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v1::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v1::ListFunctionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetFunction() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::GetFunctionRequest, ::google::cloud::functions::v1::CloudFunction>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v1::GetFunctionRequest* request, ::google::cloud::functions::v1::CloudFunction* response) { return this->GetFunction(context, request, response); }));}
    void SetMessageAllocatorFor_GetFunction(
        ::grpc::MessageAllocator< ::google::cloud::functions::v1::GetFunctionRequest, ::google::cloud::functions::v1::CloudFunction>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::GetFunctionRequest, ::google::cloud::functions::v1::CloudFunction>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GetFunctionRequest* /*request*/, ::google::cloud::functions::v1::CloudFunction* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v1::GetFunctionRequest* /*request*/, ::google::cloud::functions::v1::CloudFunction* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateFunction() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::CreateFunctionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v1::CreateFunctionRequest* request, ::google::longrunning::Operation* response) { return this->CreateFunction(context, request, response); }));}
    void SetMessageAllocatorFor_CreateFunction(
        ::grpc::MessageAllocator< ::google::cloud::functions::v1::CreateFunctionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::CreateFunctionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v1::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateFunction() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::UpdateFunctionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v1::UpdateFunctionRequest* request, ::google::longrunning::Operation* response) { return this->UpdateFunction(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateFunction(
        ::grpc::MessageAllocator< ::google::cloud::functions::v1::UpdateFunctionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::UpdateFunctionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v1::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteFunction() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::DeleteFunctionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v1::DeleteFunctionRequest* request, ::google::longrunning::Operation* response) { return this->DeleteFunction(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteFunction(
        ::grpc::MessageAllocator< ::google::cloud::functions::v1::DeleteFunctionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::DeleteFunctionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v1::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CallFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CallFunction() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::CallFunctionRequest, ::google::cloud::functions::v1::CallFunctionResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v1::CallFunctionRequest* request, ::google::cloud::functions::v1::CallFunctionResponse* response) { return this->CallFunction(context, request, response); }));}
    void SetMessageAllocatorFor_CallFunction(
        ::grpc::MessageAllocator< ::google::cloud::functions::v1::CallFunctionRequest, ::google::cloud::functions::v1::CallFunctionResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::CallFunctionRequest, ::google::cloud::functions::v1::CallFunctionResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CallFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CallFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::CallFunctionRequest* /*request*/, ::google::cloud::functions::v1::CallFunctionResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CallFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v1::CallFunctionRequest* /*request*/, ::google::cloud::functions::v1::CallFunctionResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GenerateUploadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GenerateUploadUrl() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::GenerateUploadUrlRequest, ::google::cloud::functions::v1::GenerateUploadUrlResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v1::GenerateUploadUrlRequest* request, ::google::cloud::functions::v1::GenerateUploadUrlResponse* response) { return this->GenerateUploadUrl(context, request, response); }));}
    void SetMessageAllocatorFor_GenerateUploadUrl(
        ::grpc::MessageAllocator< ::google::cloud::functions::v1::GenerateUploadUrlRequest, ::google::cloud::functions::v1::GenerateUploadUrlResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::GenerateUploadUrlRequest, ::google::cloud::functions::v1::GenerateUploadUrlResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GenerateUploadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateUploadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateUploadUrl(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateUploadUrlResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GenerateDownloadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GenerateDownloadUrl() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::GenerateDownloadUrlRequest, ::google::cloud::functions::v1::GenerateDownloadUrlResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest* request, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* response) { return this->GenerateDownloadUrl(context, request, response); }));}
    void SetMessageAllocatorFor_GenerateDownloadUrl(
        ::grpc::MessageAllocator< ::google::cloud::functions::v1::GenerateDownloadUrlRequest, ::google::cloud::functions::v1::GenerateDownloadUrlResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::functions::v1::GenerateDownloadUrlRequest, ::google::cloud::functions::v1::GenerateDownloadUrlResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GenerateDownloadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateDownloadUrl(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->SetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_SetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->GetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response) { return this->TestIamPermissions(context, request, response); }));}
    void SetMessageAllocatorFor_TestIamPermissions(
        ::grpc::MessageAllocator< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListFunctions<WithCallbackMethod_GetFunction<WithCallbackMethod_CreateFunction<WithCallbackMethod_UpdateFunction<WithCallbackMethod_DeleteFunction<WithCallbackMethod_CallFunction<WithCallbackMethod_GenerateUploadUrl<WithCallbackMethod_GenerateDownloadUrl<WithCallbackMethod_SetIamPolicy<WithCallbackMethod_GetIamPolicy<WithCallbackMethod_TestIamPermissions<Service > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListFunctions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListFunctions() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListFunctions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFunctions(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v1::ListFunctionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetFunction() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GetFunctionRequest* /*request*/, ::google::cloud::functions::v1::CloudFunction* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateFunction() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateFunction() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteFunction() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CallFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CallFunction() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_CallFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CallFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::CallFunctionRequest* /*request*/, ::google::cloud::functions::v1::CallFunctionResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GenerateUploadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GenerateUploadUrl() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GenerateUploadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateUploadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GenerateDownloadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GenerateDownloadUrl() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GenerateDownloadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListFunctions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListFunctions() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListFunctions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFunctions(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v1::ListFunctionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFunctions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetFunction() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GetFunctionRequest* /*request*/, ::google::cloud::functions::v1::CloudFunction* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFunction(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateFunction() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateFunction(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateFunction() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFunction(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteFunction() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFunction(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CallFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CallFunction() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_CallFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CallFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::CallFunctionRequest* /*request*/, ::google::cloud::functions::v1::CallFunctionResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCallFunction(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GenerateUploadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GenerateUploadUrl() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GenerateUploadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateUploadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateUploadUrl(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GenerateDownloadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GenerateDownloadUrl() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GenerateDownloadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateDownloadUrl(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListFunctions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListFunctions() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListFunctions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListFunctions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFunctions(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v1::ListFunctionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFunctions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetFunction() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetFunction(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GetFunctionRequest* /*request*/, ::google::cloud::functions::v1::CloudFunction* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateFunction() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateFunction(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateFunction() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateFunction(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteFunction() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteFunction(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CallFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CallFunction() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CallFunction(context, request, response); }));
    }
    ~WithRawCallbackMethod_CallFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CallFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::CallFunctionRequest* /*request*/, ::google::cloud::functions::v1::CallFunctionResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CallFunction(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GenerateUploadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GenerateUploadUrl() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GenerateUploadUrl(context, request, response); }));
    }
    ~WithRawCallbackMethod_GenerateUploadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateUploadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateUploadUrl(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GenerateDownloadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GenerateDownloadUrl() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GenerateDownloadUrl(context, request, response); }));
    }
    ~WithRawCallbackMethod_GenerateDownloadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateDownloadUrl(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TestIamPermissions(context, request, response); }));
    }
    ~WithRawCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListFunctions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListFunctions() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v1::ListFunctionsRequest, ::google::cloud::functions::v1::ListFunctionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v1::ListFunctionsRequest, ::google::cloud::functions::v1::ListFunctionsResponse>* streamer) {
                       return this->StreamedListFunctions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListFunctions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListFunctions(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::ListFunctionsRequest* /*request*/, ::google::cloud::functions::v1::ListFunctionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListFunctions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v1::ListFunctionsRequest,::google::cloud::functions::v1::ListFunctionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetFunction() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v1::GetFunctionRequest, ::google::cloud::functions::v1::CloudFunction>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v1::GetFunctionRequest, ::google::cloud::functions::v1::CloudFunction>* streamer) {
                       return this->StreamedGetFunction(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GetFunctionRequest* /*request*/, ::google::cloud::functions::v1::CloudFunction* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetFunction(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v1::GetFunctionRequest,::google::cloud::functions::v1::CloudFunction>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateFunction() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v1::CreateFunctionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v1::CreateFunctionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateFunction(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::CreateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateFunction(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v1::CreateFunctionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateFunction() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v1::UpdateFunctionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v1::UpdateFunctionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateFunction(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::UpdateFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateFunction(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v1::UpdateFunctionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteFunction() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v1::DeleteFunctionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v1::DeleteFunctionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteFunction(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::DeleteFunctionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteFunction(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v1::DeleteFunctionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CallFunction : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CallFunction() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v1::CallFunctionRequest, ::google::cloud::functions::v1::CallFunctionResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v1::CallFunctionRequest, ::google::cloud::functions::v1::CallFunctionResponse>* streamer) {
                       return this->StreamedCallFunction(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CallFunction() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CallFunction(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::CallFunctionRequest* /*request*/, ::google::cloud::functions::v1::CallFunctionResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCallFunction(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v1::CallFunctionRequest,::google::cloud::functions::v1::CallFunctionResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GenerateUploadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GenerateUploadUrl() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v1::GenerateUploadUrlRequest, ::google::cloud::functions::v1::GenerateUploadUrlResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v1::GenerateUploadUrlRequest, ::google::cloud::functions::v1::GenerateUploadUrlResponse>* streamer) {
                       return this->StreamedGenerateUploadUrl(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GenerateUploadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GenerateUploadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateUploadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateUploadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGenerateUploadUrl(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v1::GenerateUploadUrlRequest,::google::cloud::functions::v1::GenerateUploadUrlResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GenerateDownloadUrl : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GenerateDownloadUrl() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::functions::v1::GenerateDownloadUrlRequest, ::google::cloud::functions::v1::GenerateDownloadUrlResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::functions::v1::GenerateDownloadUrlRequest, ::google::cloud::functions::v1::GenerateDownloadUrlResponse>* streamer) {
                       return this->StreamedGenerateDownloadUrl(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GenerateDownloadUrl() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GenerateDownloadUrl(::grpc::ServerContext* /*context*/, const ::google::cloud::functions::v1::GenerateDownloadUrlRequest* /*request*/, ::google::cloud::functions::v1::GenerateDownloadUrlResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGenerateDownloadUrl(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::functions::v1::GenerateDownloadUrlRequest,::google::cloud::functions::v1::GenerateDownloadUrlResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedSetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::SetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedGetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::GetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* streamer) {
                       return this->StreamedTestIamPermissions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTestIamPermissions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::TestIamPermissionsRequest,::google::iam::v1::TestIamPermissionsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListFunctions<WithStreamedUnaryMethod_GetFunction<WithStreamedUnaryMethod_CreateFunction<WithStreamedUnaryMethod_UpdateFunction<WithStreamedUnaryMethod_DeleteFunction<WithStreamedUnaryMethod_CallFunction<WithStreamedUnaryMethod_GenerateUploadUrl<WithStreamedUnaryMethod_GenerateDownloadUrl<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<Service > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListFunctions<WithStreamedUnaryMethod_GetFunction<WithStreamedUnaryMethod_CreateFunction<WithStreamedUnaryMethod_UpdateFunction<WithStreamedUnaryMethod_DeleteFunction<WithStreamedUnaryMethod_CallFunction<WithStreamedUnaryMethod_GenerateUploadUrl<WithStreamedUnaryMethod_GenerateDownloadUrl<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<Service > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace functions
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2ffunctions_2fv1_2ffunctions_2eproto__INCLUDED
