// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/kms/v1/autokey_admin.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fkms_2fv1_2fautokey_5fadmin_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fkms_2fv1_2fautokey_5fadmin_2eproto__INCLUDED

#include "google/cloud/kms/v1/autokey_admin.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace kms {
namespace v1 {

// Provides interfaces for managing Cloud KMS Autokey folder-level
// configurations. A configuration is inherited by all descendent projects. A
// configuration at one folder overrides any other configurations in its
// ancestry. Setting a configuration on a folder is a prerequisite for Cloud KMS
// Autokey, so that users working in a descendant project can request
// provisioned [CryptoKeys][google.cloud.kms.v1.CryptoKey], ready for Customer
// Managed Encryption Key (CMEK) use, on-demand.
class AutokeyAdmin final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.kms.v1.AutokeyAdmin";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Updates the [AutokeyConfig][google.cloud.kms.v1.AutokeyConfig] for a
    // folder. The caller must have both `cloudkms.autokeyConfigs.update`
    // permission on the parent folder and `cloudkms.cryptoKeys.setIamPolicy`
    // permission on the provided key project. A
    // [KeyHandle][google.cloud.kms.v1.KeyHandle] creation in the folder's
    // descendant projects will use this configuration to determine where to
    // create the resulting [CryptoKey][google.cloud.kms.v1.CryptoKey].
    virtual ::grpc::Status UpdateAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest& request, ::google::cloud::kms::v1::AutokeyConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AutokeyConfig>> AsyncUpdateAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AutokeyConfig>>(AsyncUpdateAutokeyConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AutokeyConfig>> PrepareAsyncUpdateAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AutokeyConfig>>(PrepareAsyncUpdateAutokeyConfigRaw(context, request, cq));
    }
    // Returns the [AutokeyConfig][google.cloud.kms.v1.AutokeyConfig] for a
    // folder.
    virtual ::grpc::Status GetAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest& request, ::google::cloud::kms::v1::AutokeyConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AutokeyConfig>> AsyncGetAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AutokeyConfig>>(AsyncGetAutokeyConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AutokeyConfig>> PrepareAsyncGetAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AutokeyConfig>>(PrepareAsyncGetAutokeyConfigRaw(context, request, cq));
    }
    // Returns the effective Cloud KMS Autokey configuration for a given project.
    virtual ::grpc::Status ShowEffectiveAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest& request, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>> AsyncShowEffectiveAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>>(AsyncShowEffectiveAutokeyConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>> PrepareAsyncShowEffectiveAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>>(PrepareAsyncShowEffectiveAutokeyConfigRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Updates the [AutokeyConfig][google.cloud.kms.v1.AutokeyConfig] for a
      // folder. The caller must have both `cloudkms.autokeyConfigs.update`
      // permission on the parent folder and `cloudkms.cryptoKeys.setIamPolicy`
      // permission on the provided key project. A
      // [KeyHandle][google.cloud.kms.v1.KeyHandle] creation in the folder's
      // descendant projects will use this configuration to determine where to
      // create the resulting [CryptoKey][google.cloud.kms.v1.CryptoKey].
      virtual void UpdateAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* request, ::google::cloud::kms::v1::AutokeyConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* request, ::google::cloud::kms::v1::AutokeyConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the [AutokeyConfig][google.cloud.kms.v1.AutokeyConfig] for a
      // folder.
      virtual void GetAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest* request, ::google::cloud::kms::v1::AutokeyConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest* request, ::google::cloud::kms::v1::AutokeyConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the effective Cloud KMS Autokey configuration for a given project.
      virtual void ShowEffectiveAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* request, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ShowEffectiveAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* request, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AutokeyConfig>* AsyncUpdateAutokeyConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AutokeyConfig>* PrepareAsyncUpdateAutokeyConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AutokeyConfig>* AsyncGetAutokeyConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::AutokeyConfig>* PrepareAsyncGetAutokeyConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>* AsyncShowEffectiveAutokeyConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>* PrepareAsyncShowEffectiveAutokeyConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status UpdateAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest& request, ::google::cloud::kms::v1::AutokeyConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AutokeyConfig>> AsyncUpdateAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AutokeyConfig>>(AsyncUpdateAutokeyConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AutokeyConfig>> PrepareAsyncUpdateAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AutokeyConfig>>(PrepareAsyncUpdateAutokeyConfigRaw(context, request, cq));
    }
    ::grpc::Status GetAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest& request, ::google::cloud::kms::v1::AutokeyConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AutokeyConfig>> AsyncGetAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AutokeyConfig>>(AsyncGetAutokeyConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AutokeyConfig>> PrepareAsyncGetAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AutokeyConfig>>(PrepareAsyncGetAutokeyConfigRaw(context, request, cq));
    }
    ::grpc::Status ShowEffectiveAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest& request, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>> AsyncShowEffectiveAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>>(AsyncShowEffectiveAutokeyConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>> PrepareAsyncShowEffectiveAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>>(PrepareAsyncShowEffectiveAutokeyConfigRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void UpdateAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* request, ::google::cloud::kms::v1::AutokeyConfig* response, std::function<void(::grpc::Status)>) override;
      void UpdateAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* request, ::google::cloud::kms::v1::AutokeyConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest* request, ::google::cloud::kms::v1::AutokeyConfig* response, std::function<void(::grpc::Status)>) override;
      void GetAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest* request, ::google::cloud::kms::v1::AutokeyConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ShowEffectiveAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* request, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* response, std::function<void(::grpc::Status)>) override;
      void ShowEffectiveAutokeyConfig(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* request, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AutokeyConfig>* AsyncUpdateAutokeyConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AutokeyConfig>* PrepareAsyncUpdateAutokeyConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AutokeyConfig>* AsyncGetAutokeyConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::AutokeyConfig>* PrepareAsyncGetAutokeyConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>* AsyncShowEffectiveAutokeyConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>* PrepareAsyncShowEffectiveAutokeyConfigRaw(::grpc::ClientContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAutokeyConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAutokeyConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_ShowEffectiveAutokeyConfig_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Updates the [AutokeyConfig][google.cloud.kms.v1.AutokeyConfig] for a
    // folder. The caller must have both `cloudkms.autokeyConfigs.update`
    // permission on the parent folder and `cloudkms.cryptoKeys.setIamPolicy`
    // permission on the provided key project. A
    // [KeyHandle][google.cloud.kms.v1.KeyHandle] creation in the folder's
    // descendant projects will use this configuration to determine where to
    // create the resulting [CryptoKey][google.cloud.kms.v1.CryptoKey].
    virtual ::grpc::Status UpdateAutokeyConfig(::grpc::ServerContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* request, ::google::cloud::kms::v1::AutokeyConfig* response);
    // Returns the [AutokeyConfig][google.cloud.kms.v1.AutokeyConfig] for a
    // folder.
    virtual ::grpc::Status GetAutokeyConfig(::grpc::ServerContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest* request, ::google::cloud::kms::v1::AutokeyConfig* response);
    // Returns the effective Cloud KMS Autokey configuration for a given project.
    virtual ::grpc::Status ShowEffectiveAutokeyConfig(::grpc::ServerContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* request, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAutokeyConfig() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_UpdateAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAutokeyConfig(::grpc::ServerContext* context, ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::AutokeyConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAutokeyConfig() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAutokeyConfig(::grpc::ServerContext* context, ::google::cloud::kms::v1::GetAutokeyConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::AutokeyConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ShowEffectiveAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ShowEffectiveAutokeyConfig() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ShowEffectiveAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowEffectiveAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestShowEffectiveAutokeyConfig(::grpc::ServerContext* context, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_UpdateAutokeyConfig<WithAsyncMethod_GetAutokeyConfig<WithAsyncMethod_ShowEffectiveAutokeyConfig<Service > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_UpdateAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAutokeyConfig() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::UpdateAutokeyConfigRequest, ::google::cloud::kms::v1::AutokeyConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* request, ::google::cloud::kms::v1::AutokeyConfig* response) { return this->UpdateAutokeyConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAutokeyConfig(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::UpdateAutokeyConfigRequest, ::google::cloud::kms::v1::AutokeyConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::UpdateAutokeyConfigRequest, ::google::cloud::kms::v1::AutokeyConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAutokeyConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAutokeyConfig() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetAutokeyConfigRequest, ::google::cloud::kms::v1::AutokeyConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::GetAutokeyConfigRequest* request, ::google::cloud::kms::v1::AutokeyConfig* response) { return this->GetAutokeyConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetAutokeyConfig(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::GetAutokeyConfigRequest, ::google::cloud::kms::v1::AutokeyConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::GetAutokeyConfigRequest, ::google::cloud::kms::v1::AutokeyConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAutokeyConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::GetAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ShowEffectiveAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ShowEffectiveAutokeyConfig() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* request, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* response) { return this->ShowEffectiveAutokeyConfig(context, request, response); }));}
    void SetMessageAllocatorFor_ShowEffectiveAutokeyConfig(
        ::grpc::MessageAllocator< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ShowEffectiveAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowEffectiveAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ShowEffectiveAutokeyConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_UpdateAutokeyConfig<WithCallbackMethod_GetAutokeyConfig<WithCallbackMethod_ShowEffectiveAutokeyConfig<Service > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_UpdateAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAutokeyConfig() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_UpdateAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAutokeyConfig() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ShowEffectiveAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ShowEffectiveAutokeyConfig() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ShowEffectiveAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowEffectiveAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAutokeyConfig() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_UpdateAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAutokeyConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAutokeyConfig() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAutokeyConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ShowEffectiveAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ShowEffectiveAutokeyConfig() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ShowEffectiveAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowEffectiveAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestShowEffectiveAutokeyConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAutokeyConfig() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAutokeyConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAutokeyConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAutokeyConfig() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAutokeyConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAutokeyConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ShowEffectiveAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ShowEffectiveAutokeyConfig() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ShowEffectiveAutokeyConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_ShowEffectiveAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowEffectiveAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ShowEffectiveAutokeyConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAutokeyConfig() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::UpdateAutokeyConfigRequest, ::google::cloud::kms::v1::AutokeyConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::UpdateAutokeyConfigRequest, ::google::cloud::kms::v1::AutokeyConfig>* streamer) {
                       return this->StreamedUpdateAutokeyConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::UpdateAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAutokeyConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::UpdateAutokeyConfigRequest,::google::cloud::kms::v1::AutokeyConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAutokeyConfig() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::GetAutokeyConfigRequest, ::google::cloud::kms::v1::AutokeyConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::GetAutokeyConfigRequest, ::google::cloud::kms::v1::AutokeyConfig>* streamer) {
                       return this->StreamedGetAutokeyConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::GetAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::AutokeyConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAutokeyConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::GetAutokeyConfigRequest,::google::cloud::kms::v1::AutokeyConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ShowEffectiveAutokeyConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ShowEffectiveAutokeyConfig() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>* streamer) {
                       return this->StreamedShowEffectiveAutokeyConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ShowEffectiveAutokeyConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ShowEffectiveAutokeyConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest* /*request*/, ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedShowEffectiveAutokeyConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::kms::v1::ShowEffectiveAutokeyConfigRequest,::google::cloud::kms::v1::ShowEffectiveAutokeyConfigResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_UpdateAutokeyConfig<WithStreamedUnaryMethod_GetAutokeyConfig<WithStreamedUnaryMethod_ShowEffectiveAutokeyConfig<Service > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_UpdateAutokeyConfig<WithStreamedUnaryMethod_GetAutokeyConfig<WithStreamedUnaryMethod_ShowEffectiveAutokeyConfig<Service > > > StreamedService;
};

}  // namespace v1
}  // namespace kms
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fkms_2fv1_2fautokey_5fadmin_2eproto__INCLUDED
