// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/metastore/v1/metastore_federation.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_METASTORE_V1_MOCKS_MOCK_DATAPROC_METASTORE_FEDERATION_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_METASTORE_V1_MOCKS_MOCK_DATAPROC_METASTORE_FEDERATION_CONNECTION_H

#include "google/cloud/metastore/v1/dataproc_metastore_federation_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace metastore_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `DataprocMetastoreFederationConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `DataprocMetastoreFederationClient`.
 * To do so, construct an object of type `DataprocMetastoreFederationClient`
 * with an instance of this class. Then use the Google Test framework functions
 * to program the behavior of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockDataprocMetastoreFederationConnection
    : public metastore_v1::DataprocMetastoreFederationConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD((StreamRange<google::cloud::metastore::v1::Federation>),
              ListFederations,
              (google::cloud::metastore::v1::ListFederationsRequest request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::metastore::v1::Federation>, GetFederation,
      (google::cloud::metastore::v1::GetFederationRequest const& request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateFederation)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateFederation(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::metastore::v1::Federation>>,
      CreateFederation,
      (google::cloud::metastore::v1::CreateFederationRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, CreateFederation,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::metastore::v1::CreateFederationRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::metastore::v1::Federation>>,
              CreateFederation,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateFederation)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateFederation(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::metastore::v1::Federation>>,
      UpdateFederation,
      (google::cloud::metastore::v1::UpdateFederationRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, UpdateFederation,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::metastore::v1::UpdateFederationRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::metastore::v1::Federation>>,
              UpdateFederation,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteFederation)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteFederation(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::metastore::v1::OperationMetadata>>,
      DeleteFederation,
      (google::cloud::metastore::v1::DeleteFederationRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, DeleteFederation,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::metastore::v1::DeleteFederationRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::metastore::v1::OperationMetadata>>,
              DeleteFederation,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace metastore_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_METASTORE_V1_MOCKS_MOCK_DATAPROC_METASTORE_FEDERATION_CONNECTION_H
