// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/migrationcenter/v1/migrationcenter.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_MIGRATIONCENTER_V1_MOCKS_MOCK_MIGRATION_CENTER_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_MIGRATIONCENTER_V1_MOCKS_MOCK_MIGRATION_CENTER_CONNECTION_H

#include "google/cloud/migrationcenter/v1/migration_center_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace migrationcenter_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `MigrationCenterConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `MigrationCenterClient`. To do so,
 * construct an object of type `MigrationCenterClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockMigrationCenterConnection
    : public migrationcenter_v1::MigrationCenterConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD((StreamRange<google::cloud::migrationcenter::v1::Asset>),
              ListAssets,
              (google::cloud::migrationcenter::v1::ListAssetsRequest request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::migrationcenter::v1::Asset>, GetAsset,
      (google::cloud::migrationcenter::v1::GetAssetRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::migrationcenter::v1::Asset>, UpdateAsset,
      (google::cloud::migrationcenter::v1::UpdateAssetRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::migrationcenter::v1::BatchUpdateAssetsResponse>,
      BatchUpdateAssets,
      (google::cloud::migrationcenter::v1::BatchUpdateAssetsRequest const&
           request),
      (override));

  MOCK_METHOD(
      Status, DeleteAsset,
      (google::cloud::migrationcenter::v1::DeleteAssetRequest const& request),
      (override));

  MOCK_METHOD(
      Status, BatchDeleteAssets,
      (google::cloud::migrationcenter::v1::BatchDeleteAssetsRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::migrationcenter::v1::ReportAssetFramesResponse>,
      ReportAssetFrames,
      (google::cloud::migrationcenter::v1::ReportAssetFramesRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<
          google::cloud::migrationcenter::v1::AggregateAssetsValuesResponse>,
      AggregateAssetsValues,
      (google::cloud::migrationcenter::v1::AggregateAssetsValuesRequest const&
           request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateImportJob)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateImportJob(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::migrationcenter::v1::ImportJob>>,
              CreateImportJob,
              (google::cloud::migrationcenter::v1::CreateImportJobRequest const&
                   request),
              (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, CreateImportJob,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::migrationcenter::v1::CreateImportJobRequest const&
                   request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::migrationcenter::v1::ImportJob>>,
              CreateImportJob,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::migrationcenter::v1::ImportJob>),
      ListImportJobs,
      (google::cloud::migrationcenter::v1::ListImportJobsRequest request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::migrationcenter::v1::ImportJob>, GetImportJob,
      (google::cloud::migrationcenter::v1::GetImportJobRequest const& request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteImportJob)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteImportJob(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeleteImportJob,
      (google::cloud::migrationcenter::v1::DeleteImportJobRequest const&
           request),
      (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, DeleteImportJob,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::migrationcenter::v1::DeleteImportJobRequest const&
                   request),
              (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeleteImportJob,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateImportJob)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateImportJob(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::migrationcenter::v1::ImportJob>>,
              UpdateImportJob,
              (google::cloud::migrationcenter::v1::UpdateImportJobRequest const&
                   request),
              (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, UpdateImportJob,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::migrationcenter::v1::UpdateImportJobRequest const&
                   request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::migrationcenter::v1::ImportJob>>,
              UpdateImportJob,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, ValidateImportJob)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, ValidateImportJob(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      ValidateImportJob,
      (google::cloud::migrationcenter::v1::ValidateImportJobRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, ValidateImportJob,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::ValidateImportJobRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      ValidateImportJob,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, RunImportJob)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, RunImportJob(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      RunImportJob,
      (google::cloud::migrationcenter::v1::RunImportJobRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, RunImportJob,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::RunImportJobRequest const& request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      RunImportJob,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::migrationcenter::v1::ImportDataFile>,
      GetImportDataFile,
      (google::cloud::migrationcenter::v1::GetImportDataFileRequest const&
           request),
      (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::migrationcenter::v1::ImportDataFile>),
      ListImportDataFiles,
      (google::cloud::migrationcenter::v1::ListImportDataFilesRequest request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateImportDataFile)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateImportDataFile(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::ImportDataFile>>,
      CreateImportDataFile,
      (google::cloud::migrationcenter::v1::CreateImportDataFileRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, CreateImportDataFile,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::CreateImportDataFileRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::ImportDataFile>>,
      CreateImportDataFile,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteImportDataFile)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteImportDataFile(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeleteImportDataFile,
      (google::cloud::migrationcenter::v1::DeleteImportDataFileRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, DeleteImportDataFile,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::DeleteImportDataFileRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeleteImportDataFile,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  MOCK_METHOD((StreamRange<google::cloud::migrationcenter::v1::Group>),
              ListGroups,
              (google::cloud::migrationcenter::v1::ListGroupsRequest request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::migrationcenter::v1::Group>, GetGroup,
      (google::cloud::migrationcenter::v1::GetGroupRequest const& request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateGroup)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateGroup(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::Group>>, CreateGroup,
      (google::cloud::migrationcenter::v1::CreateGroupRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, CreateGroup,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::CreateGroupRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::migrationcenter::v1::Group>>,
              CreateGroup,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateGroup)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateGroup(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::Group>>, UpdateGroup,
      (google::cloud::migrationcenter::v1::UpdateGroupRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, UpdateGroup,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::UpdateGroupRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::migrationcenter::v1::Group>>,
              UpdateGroup,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteGroup)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteGroup(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeleteGroup,
      (google::cloud::migrationcenter::v1::DeleteGroupRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, DeleteGroup,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::DeleteGroupRequest const& request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeleteGroup,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, AddAssetsToGroup)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, AddAssetsToGroup(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::Group>>,
      AddAssetsToGroup,
      (google::cloud::migrationcenter::v1::AddAssetsToGroupRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, AddAssetsToGroup,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::AddAssetsToGroupRequest const&
           request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::migrationcenter::v1::Group>>,
              AddAssetsToGroup,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, RemoveAssetsFromGroup)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, RemoveAssetsFromGroup(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::Group>>,
      RemoveAssetsFromGroup,
      (google::cloud::migrationcenter::v1::RemoveAssetsFromGroupRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, RemoveAssetsFromGroup,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::RemoveAssetsFromGroupRequest const&
           request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::migrationcenter::v1::Group>>,
              RemoveAssetsFromGroup,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::migrationcenter::v1::ErrorFrame>),
      ListErrorFrames,
      (google::cloud::migrationcenter::v1::ListErrorFramesRequest request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::migrationcenter::v1::ErrorFrame>, GetErrorFrame,
      (google::cloud::migrationcenter::v1::GetErrorFrameRequest const& request),
      (override));

  MOCK_METHOD((StreamRange<google::cloud::migrationcenter::v1::Source>),
              ListSources,
              (google::cloud::migrationcenter::v1::ListSourcesRequest request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::migrationcenter::v1::Source>, GetSource,
      (google::cloud::migrationcenter::v1::GetSourceRequest const& request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateSource)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateSource(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::Source>>,
      CreateSource,
      (google::cloud::migrationcenter::v1::CreateSourceRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, CreateSource,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::CreateSourceRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::migrationcenter::v1::Source>>,
              CreateSource,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateSource)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateSource(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::Source>>,
      UpdateSource,
      (google::cloud::migrationcenter::v1::UpdateSourceRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, UpdateSource,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::UpdateSourceRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::migrationcenter::v1::Source>>,
              UpdateSource,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteSource)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteSource(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeleteSource,
      (google::cloud::migrationcenter::v1::DeleteSourceRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, DeleteSource,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::DeleteSourceRequest const& request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeleteSource,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::migrationcenter::v1::PreferenceSet>),
      ListPreferenceSets,
      (google::cloud::migrationcenter::v1::ListPreferenceSetsRequest request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::migrationcenter::v1::PreferenceSet>,
      GetPreferenceSet,
      (google::cloud::migrationcenter::v1::GetPreferenceSetRequest const&
           request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreatePreferenceSet)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreatePreferenceSet(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::PreferenceSet>>,
      CreatePreferenceSet,
      (google::cloud::migrationcenter::v1::CreatePreferenceSetRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, CreatePreferenceSet,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::CreatePreferenceSetRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::PreferenceSet>>,
      CreatePreferenceSet,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdatePreferenceSet)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdatePreferenceSet(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::PreferenceSet>>,
      UpdatePreferenceSet,
      (google::cloud::migrationcenter::v1::UpdatePreferenceSetRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, UpdatePreferenceSet,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::UpdatePreferenceSetRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::PreferenceSet>>,
      UpdatePreferenceSet,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeletePreferenceSet)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeletePreferenceSet(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeletePreferenceSet,
      (google::cloud::migrationcenter::v1::DeletePreferenceSetRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, DeletePreferenceSet,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::DeletePreferenceSetRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeletePreferenceSet,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::migrationcenter::v1::Settings>, GetSettings,
      (google::cloud::migrationcenter::v1::GetSettingsRequest const& request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateSettings)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateSettings(::testing::_))` instead.
  MOCK_METHOD(future<StatusOr<google::cloud::migrationcenter::v1::Settings>>,
              UpdateSettings,
              (google::cloud::migrationcenter::v1::UpdateSettingsRequest const&
                   request),
              (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, UpdateSettings,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::migrationcenter::v1::UpdateSettingsRequest const&
                   request),
              (override));

  MOCK_METHOD(future<StatusOr<google::cloud::migrationcenter::v1::Settings>>,
              UpdateSettings,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateReportConfig)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateReportConfig(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::ReportConfig>>,
      CreateReportConfig,
      (google::cloud::migrationcenter::v1::CreateReportConfigRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, CreateReportConfig,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::CreateReportConfigRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::ReportConfig>>,
      CreateReportConfig,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  MOCK_METHOD(StatusOr<google::cloud::migrationcenter::v1::ReportConfig>,
              GetReportConfig,
              (google::cloud::migrationcenter::v1::GetReportConfigRequest const&
                   request),
              (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::migrationcenter::v1::ReportConfig>),
      ListReportConfigs,
      (google::cloud::migrationcenter::v1::ListReportConfigsRequest request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteReportConfig)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteReportConfig(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeleteReportConfig,
      (google::cloud::migrationcenter::v1::DeleteReportConfigRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, DeleteReportConfig,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::DeleteReportConfigRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeleteReportConfig,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateReport)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateReport(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::Report>>,
      CreateReport,
      (google::cloud::migrationcenter::v1::CreateReportRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, CreateReport,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::CreateReportRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::migrationcenter::v1::Report>>,
              CreateReport,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::migrationcenter::v1::Report>, GetReport,
      (google::cloud::migrationcenter::v1::GetReportRequest const& request),
      (override));

  MOCK_METHOD((StreamRange<google::cloud::migrationcenter::v1::Report>),
              ListReports,
              (google::cloud::migrationcenter::v1::ListReportsRequest request),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteReport)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteReport(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeleteReport,
      (google::cloud::migrationcenter::v1::DeleteReportRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, DeleteReport,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::migrationcenter::v1::DeleteReportRequest const& request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::migrationcenter::v1::OperationMetadata>>,
      DeleteReport,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace migrationcenter_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_MIGRATIONCENTER_V1_MOCKS_MOCK_MIGRATION_CENTER_CONNECTION_H
