// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/monitoring/v3/query_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_MONITORING_V3_INTERNAL_QUERY_STUB_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_MONITORING_V3_INTERNAL_QUERY_STUB_H

#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/monitoring/v3/query_service.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace monitoring_v3_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class QueryServiceStub {
 public:
  virtual ~QueryServiceStub() = 0;

  virtual StatusOr<google::monitoring::v3::QueryTimeSeriesResponse>
  QueryTimeSeries(
      grpc::ClientContext& context, Options const& options,
      google::monitoring::v3::QueryTimeSeriesRequest const& request) = 0;
};

class DefaultQueryServiceStub : public QueryServiceStub {
 public:
  explicit DefaultQueryServiceStub(
      std::unique_ptr<google::monitoring::v3::QueryService::StubInterface>
          grpc_stub)
      : grpc_stub_(std::move(grpc_stub)) {}

  StatusOr<google::monitoring::v3::QueryTimeSeriesResponse> QueryTimeSeries(
      grpc::ClientContext& context, Options const& options,
      google::monitoring::v3::QueryTimeSeriesRequest const& request) override;

 private:
  std::unique_ptr<google::monitoring::v3::QueryService::StubInterface>
      grpc_stub_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace monitoring_v3_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_MONITORING_V3_INTERNAL_QUERY_STUB_H
