// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/networkconnectivity/v1/policy_based_routing.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_NETWORKCONNECTIVITY_V1_MOCKS_MOCK_POLICY_BASED_ROUTING_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_NETWORKCONNECTIVITY_V1_MOCKS_MOCK_POLICY_BASED_ROUTING_CONNECTION_H

#include "google/cloud/networkconnectivity/v1/policy_based_routing_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace networkconnectivity_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `PolicyBasedRoutingServiceConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `PolicyBasedRoutingServiceClient`.
 * To do so, construct an object of type `PolicyBasedRoutingServiceClient` with
 * an instance of this class. Then use the Google Test framework functions to
 * program the behavior of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockPolicyBasedRoutingServiceConnection
    : public networkconnectivity_v1::PolicyBasedRoutingServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::networkconnectivity::v1::PolicyBasedRoute>),
      ListPolicyBasedRoutes,
      (google::cloud::networkconnectivity::v1::ListPolicyBasedRoutesRequest
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::networkconnectivity::v1::PolicyBasedRoute>,
      GetPolicyBasedRoute,
      (google::cloud::networkconnectivity::v1::GetPolicyBasedRouteRequest const&
           request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreatePolicyBasedRoute)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreatePolicyBasedRoute(::testing::_))` instead.
  MOCK_METHOD(
      future<
          StatusOr<google::cloud::networkconnectivity::v1::PolicyBasedRoute>>,
      CreatePolicyBasedRoute,
      (google::cloud::networkconnectivity::v1::
           CreatePolicyBasedRouteRequest const& request),
      (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, CreatePolicyBasedRoute,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::networkconnectivity::v1::
                   CreatePolicyBasedRouteRequest const& request),
              (override));

  MOCK_METHOD(
      future<
          StatusOr<google::cloud::networkconnectivity::v1::PolicyBasedRoute>>,
      CreatePolicyBasedRoute,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeletePolicyBasedRoute)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeletePolicyBasedRoute(::testing::_))` instead.
  MOCK_METHOD(
      future<
          StatusOr<google::cloud::networkconnectivity::v1::OperationMetadata>>,
      DeletePolicyBasedRoute,
      (google::cloud::networkconnectivity::v1::
           DeletePolicyBasedRouteRequest const& request),
      (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>, DeletePolicyBasedRoute,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::networkconnectivity::v1::
                   DeletePolicyBasedRouteRequest const& request),
              (override));

  MOCK_METHOD(
      future<
          StatusOr<google::cloud::networkconnectivity::v1::OperationMetadata>>,
      DeletePolicyBasedRoute,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace networkconnectivity_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_NETWORKCONNECTIVITY_V1_MOCKS_MOCK_POLICY_BASED_ROUTING_CONNECTION_H
