// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/networkservices/v1/dep.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_NETWORKSERVICES_V1_MOCKS_MOCK_DEP_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_NETWORKSERVICES_V1_MOCKS_MOCK_DEP_CONNECTION_H

#include "google/cloud/networkservices/v1/dep_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace networkservices_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `DepServiceConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `DepServiceClient`. To do so,
 * construct an object of type `DepServiceClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockDepServiceConnection
    : public networkservices_v1::DepServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::networkservices::v1::LbTrafficExtension>),
      ListLbTrafficExtensions,
      (google::cloud::networkservices::v1::ListLbTrafficExtensionsRequest
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::networkservices::v1::LbTrafficExtension>,
      GetLbTrafficExtension,
      (google::cloud::networkservices::v1::GetLbTrafficExtensionRequest const&
           request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateLbTrafficExtension)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateLbTrafficExtension(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::networkservices::v1::LbTrafficExtension>>,
      CreateLbTrafficExtension,
      (google::cloud::networkservices::v1::
           CreateLbTrafficExtensionRequest const& request),
      (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>,
              CreateLbTrafficExtension,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::networkservices::v1::
                   CreateLbTrafficExtensionRequest const& request),
              (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::networkservices::v1::LbTrafficExtension>>,
      CreateLbTrafficExtension,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateLbTrafficExtension)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateLbTrafficExtension(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::networkservices::v1::LbTrafficExtension>>,
      UpdateLbTrafficExtension,
      (google::cloud::networkservices::v1::
           UpdateLbTrafficExtensionRequest const& request),
      (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>,
              UpdateLbTrafficExtension,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::networkservices::v1::
                   UpdateLbTrafficExtensionRequest const& request),
              (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::networkservices::v1::LbTrafficExtension>>,
      UpdateLbTrafficExtension,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteLbTrafficExtension)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteLbTrafficExtension(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>,
      DeleteLbTrafficExtension,
      (google::cloud::networkservices::v1::
           DeleteLbTrafficExtensionRequest const& request),
      (override));

  MOCK_METHOD(StatusOr<google::longrunning::Operation>,
              DeleteLbTrafficExtension,
              (ExperimentalTag, NoAwaitTag,
               google::cloud::networkservices::v1::
                   DeleteLbTrafficExtensionRequest const& request),
              (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>,
      DeleteLbTrafficExtension,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::networkservices::v1::LbRouteExtension>),
      ListLbRouteExtensions,
      (google::cloud::networkservices::v1::ListLbRouteExtensionsRequest
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::networkservices::v1::LbRouteExtension>,
      GetLbRouteExtension,
      (google::cloud::networkservices::v1::GetLbRouteExtensionRequest const&
           request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateLbRouteExtension)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateLbRouteExtension(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::networkservices::v1::LbRouteExtension>>,
      CreateLbRouteExtension,
      (google::cloud::networkservices::v1::CreateLbRouteExtensionRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, CreateLbRouteExtension,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::networkservices::v1::CreateLbRouteExtensionRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::networkservices::v1::LbRouteExtension>>,
      CreateLbRouteExtension,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateLbRouteExtension)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateLbRouteExtension(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::networkservices::v1::LbRouteExtension>>,
      UpdateLbRouteExtension,
      (google::cloud::networkservices::v1::UpdateLbRouteExtensionRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, UpdateLbRouteExtension,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::networkservices::v1::UpdateLbRouteExtensionRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::networkservices::v1::LbRouteExtension>>,
      UpdateLbRouteExtension,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteLbRouteExtension)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteLbRouteExtension(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>,
      DeleteLbRouteExtension,
      (google::cloud::networkservices::v1::DeleteLbRouteExtensionRequest const&
           request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, DeleteLbRouteExtension,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::networkservices::v1::DeleteLbRouteExtensionRequest const&
           request),
      (override));

  MOCK_METHOD(
      future<StatusOr<google::cloud::networkservices::v1::OperationMetadata>>,
      DeleteLbRouteExtension,
      (ExperimentalTag, google::longrunning::Operation const& operation),
      (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace networkservices_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_NETWORKSERVICES_V1_MOCKS_MOCK_DEP_CONNECTION_H
