// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/rapidmigrationassessment/v1/rapidmigrationassessment.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RAPIDMIGRATIONASSESSMENT_V1_RAPID_MIGRATION_ASSESSMENT_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RAPIDMIGRATIONASSESSMENT_V1_RAPID_MIGRATION_ASSESSMENT_CONNECTION_H

#include "google/cloud/rapidmigrationassessment/v1/internal/rapid_migration_assessment_retry_traits.h"
#include "google/cloud/rapidmigrationassessment/v1/rapid_migration_assessment_connection_idempotency_policy.h"
#include "google/cloud/backoff_policy.h"
#include "google/cloud/experimental_tag.h"
#include "google/cloud/future.h"
#include "google/cloud/internal/retry_policy_impl.h"
#include "google/cloud/no_await_tag.h"
#include "google/cloud/options.h"
#include "google/cloud/polling_policy.h"
#include "google/cloud/status_or.h"
#include "google/cloud/stream_range.h"
#include "google/cloud/version.h"
#include <google/cloud/rapidmigrationassessment/v1/rapidmigrationassessment.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace rapidmigrationassessment_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/// The retry policy for `RapidMigrationAssessmentConnection`.
class RapidMigrationAssessmentRetryPolicy
    : public ::google::cloud::RetryPolicy {
 public:
  /// Creates a new instance of the policy, reset to the initial state.
  virtual std::unique_ptr<RapidMigrationAssessmentRetryPolicy> clone()
      const = 0;
};

/**
 * A retry policy for `RapidMigrationAssessmentConnection` based on counting
 * errors.
 *
 * This policy stops retrying if:
 * - An RPC returns a non-transient error.
 * - More than a prescribed number of transient failures is detected.
 *
 * In this class the following status codes are treated as transient errors:
 * - [`kUnavailable`](@ref google::cloud::StatusCode)
 */
class RapidMigrationAssessmentLimitedErrorCountRetryPolicy
    : public RapidMigrationAssessmentRetryPolicy {
 public:
  /**
   * Create an instance that tolerates up to @p maximum_failures transient
   * errors.
   *
   * @note Disable the retry loop by providing an instance of this policy with
   *     @p maximum_failures == 0.
   */
  explicit RapidMigrationAssessmentLimitedErrorCountRetryPolicy(
      int maximum_failures)
      : impl_(maximum_failures) {}

  RapidMigrationAssessmentLimitedErrorCountRetryPolicy(
      RapidMigrationAssessmentLimitedErrorCountRetryPolicy&& rhs) noexcept
      : RapidMigrationAssessmentLimitedErrorCountRetryPolicy(
            rhs.maximum_failures()) {}
  RapidMigrationAssessmentLimitedErrorCountRetryPolicy(
      RapidMigrationAssessmentLimitedErrorCountRetryPolicy const& rhs) noexcept
      : RapidMigrationAssessmentLimitedErrorCountRetryPolicy(
            rhs.maximum_failures()) {}

  int maximum_failures() const { return impl_.maximum_failures(); }

  bool OnFailure(Status const& status) override {
    return impl_.OnFailure(status);
  }
  bool IsExhausted() const override { return impl_.IsExhausted(); }
  bool IsPermanentFailure(Status const& status) const override {
    return impl_.IsPermanentFailure(status);
  }
  std::unique_ptr<RapidMigrationAssessmentRetryPolicy> clone() const override {
    return std::make_unique<
        RapidMigrationAssessmentLimitedErrorCountRetryPolicy>(
        maximum_failures());
  }

  // This is provided only for backwards compatibility.
  using BaseType = RapidMigrationAssessmentRetryPolicy;

 private:
  google::cloud::internal::LimitedErrorCountRetryPolicy<
      rapidmigrationassessment_v1_internal::RapidMigrationAssessmentRetryTraits>
      impl_;
};

/**
 * A retry policy for `RapidMigrationAssessmentConnection` based on elapsed
 * time.
 *
 * This policy stops retrying if:
 * - An RPC returns a non-transient error.
 * - The elapsed time in the retry loop exceeds a prescribed duration.
 *
 * In this class the following status codes are treated as transient errors:
 * - [`kUnavailable`](@ref google::cloud::StatusCode)
 */
class RapidMigrationAssessmentLimitedTimeRetryPolicy
    : public RapidMigrationAssessmentRetryPolicy {
 public:
  /**
   * Constructor given a `std::chrono::duration<>` object.
   *
   * @tparam DurationRep a placeholder to match the `Rep` tparam for @p
   *     duration's type. The semantics of this template parameter are
   *     documented in `std::chrono::duration<>`. In brief, the underlying
   *     arithmetic type used to store the number of ticks. For our purposes it
   *     is simply a formal parameter.
   * @tparam DurationPeriod a placeholder to match the `Period` tparam for @p
   *     duration's type. The semantics of this template parameter are
   *     documented in `std::chrono::duration<>`. In brief, the length of the
   *     tick in seconds, expressed as a `std::ratio<>`. For our purposes it is
   *     simply a formal parameter.
   * @param maximum_duration the maximum time allowed before the policy expires.
   *     While the application can express this time in any units they desire,
   *     the class truncates to milliseconds.
   *
   * @see https://en.cppreference.com/w/cpp/chrono/duration for more information
   *     about `std::chrono::duration`.
   */
  template <typename DurationRep, typename DurationPeriod>
  explicit RapidMigrationAssessmentLimitedTimeRetryPolicy(
      std::chrono::duration<DurationRep, DurationPeriod> maximum_duration)
      : impl_(maximum_duration) {}

  RapidMigrationAssessmentLimitedTimeRetryPolicy(
      RapidMigrationAssessmentLimitedTimeRetryPolicy&& rhs) noexcept
      : RapidMigrationAssessmentLimitedTimeRetryPolicy(rhs.maximum_duration()) {
  }
  RapidMigrationAssessmentLimitedTimeRetryPolicy(
      RapidMigrationAssessmentLimitedTimeRetryPolicy const& rhs) noexcept
      : RapidMigrationAssessmentLimitedTimeRetryPolicy(rhs.maximum_duration()) {
  }

  std::chrono::milliseconds maximum_duration() const {
    return impl_.maximum_duration();
  }

  bool OnFailure(Status const& status) override {
    return impl_.OnFailure(status);
  }
  bool IsExhausted() const override { return impl_.IsExhausted(); }
  bool IsPermanentFailure(Status const& status) const override {
    return impl_.IsPermanentFailure(status);
  }
  std::unique_ptr<RapidMigrationAssessmentRetryPolicy> clone() const override {
    return std::make_unique<RapidMigrationAssessmentLimitedTimeRetryPolicy>(
        maximum_duration());
  }

  // This is provided only for backwards compatibility.
  using BaseType = RapidMigrationAssessmentRetryPolicy;

 private:
  google::cloud::internal::LimitedTimeRetryPolicy<
      rapidmigrationassessment_v1_internal::RapidMigrationAssessmentRetryTraits>
      impl_;
};

/**
 * The `RapidMigrationAssessmentConnection` object for
 * `RapidMigrationAssessmentClient`.
 *
 * This interface defines virtual methods for each of the user-facing overload
 * sets in `RapidMigrationAssessmentClient`. This allows users to inject custom
 * behavior (e.g., with a Google Mock object) when writing tests that use
 * objects of type `RapidMigrationAssessmentClient`.
 *
 * To create a concrete instance, see
 * `MakeRapidMigrationAssessmentConnection()`.
 *
 * For mocking, see
 * `rapidmigrationassessment_v1_mocks::MockRapidMigrationAssessmentConnection`.
 */
class RapidMigrationAssessmentConnection {
 public:
  virtual ~RapidMigrationAssessmentConnection() = 0;

  virtual Options options() { return Options{}; }

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Collector>>
  CreateCollector(
      google::cloud::rapidmigrationassessment::v1::CreateCollectorRequest const&
          request);

  virtual StatusOr<google::longrunning::Operation> CreateCollector(
      ExperimentalTag, NoAwaitTag,
      google::cloud::rapidmigrationassessment::v1::CreateCollectorRequest const&
          request);

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Collector>>
  CreateCollector(ExperimentalTag,
                  google::longrunning::Operation const& operation);

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Annotation>>
  CreateAnnotation(google::cloud::rapidmigrationassessment::v1::
                       CreateAnnotationRequest const& request);

  virtual StatusOr<google::longrunning::Operation> CreateAnnotation(
      ExperimentalTag, NoAwaitTag,
      google::cloud::rapidmigrationassessment::v1::
          CreateAnnotationRequest const& request);

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Annotation>>
  CreateAnnotation(ExperimentalTag,
                   google::longrunning::Operation const& operation);

  virtual StatusOr<google::cloud::rapidmigrationassessment::v1::Annotation>
  GetAnnotation(
      google::cloud::rapidmigrationassessment::v1::GetAnnotationRequest const&
          request);

  virtual StreamRange<google::cloud::rapidmigrationassessment::v1::Collector>
  ListCollectors(
      google::cloud::rapidmigrationassessment::v1::ListCollectorsRequest
          request);

  virtual StatusOr<google::cloud::rapidmigrationassessment::v1::Collector>
  GetCollector(
      google::cloud::rapidmigrationassessment::v1::GetCollectorRequest const&
          request);

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Collector>>
  UpdateCollector(
      google::cloud::rapidmigrationassessment::v1::UpdateCollectorRequest const&
          request);

  virtual StatusOr<google::longrunning::Operation> UpdateCollector(
      ExperimentalTag, NoAwaitTag,
      google::cloud::rapidmigrationassessment::v1::UpdateCollectorRequest const&
          request);

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Collector>>
  UpdateCollector(ExperimentalTag,
                  google::longrunning::Operation const& operation);

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Collector>>
  DeleteCollector(
      google::cloud::rapidmigrationassessment::v1::DeleteCollectorRequest const&
          request);

  virtual StatusOr<google::longrunning::Operation> DeleteCollector(
      ExperimentalTag, NoAwaitTag,
      google::cloud::rapidmigrationassessment::v1::DeleteCollectorRequest const&
          request);

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Collector>>
  DeleteCollector(ExperimentalTag,
                  google::longrunning::Operation const& operation);

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Collector>>
  ResumeCollector(
      google::cloud::rapidmigrationassessment::v1::ResumeCollectorRequest const&
          request);

  virtual StatusOr<google::longrunning::Operation> ResumeCollector(
      ExperimentalTag, NoAwaitTag,
      google::cloud::rapidmigrationassessment::v1::ResumeCollectorRequest const&
          request);

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Collector>>
  ResumeCollector(ExperimentalTag,
                  google::longrunning::Operation const& operation);

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Collector>>
  RegisterCollector(google::cloud::rapidmigrationassessment::v1::
                        RegisterCollectorRequest const& request);

  virtual StatusOr<google::longrunning::Operation> RegisterCollector(
      ExperimentalTag, NoAwaitTag,
      google::cloud::rapidmigrationassessment::v1::
          RegisterCollectorRequest const& request);

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Collector>>
  RegisterCollector(ExperimentalTag,
                    google::longrunning::Operation const& operation);

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Collector>>
  PauseCollector(
      google::cloud::rapidmigrationassessment::v1::PauseCollectorRequest const&
          request);

  virtual StatusOr<google::longrunning::Operation> PauseCollector(
      ExperimentalTag, NoAwaitTag,
      google::cloud::rapidmigrationassessment::v1::PauseCollectorRequest const&
          request);

  virtual future<
      StatusOr<google::cloud::rapidmigrationassessment::v1::Collector>>
  PauseCollector(ExperimentalTag,
                 google::longrunning::Operation const& operation);
};

/**
 * A factory function to construct an object of type
 * `RapidMigrationAssessmentConnection`.
 *
 * The returned connection object should not be used directly; instead it
 * should be passed as an argument to the constructor of
 * RapidMigrationAssessmentClient.
 *
 * The optional @p options argument may be used to configure aspects of the
 * returned `RapidMigrationAssessmentConnection`. Expected options are any of
 * the types in the following option lists:
 *
 * - `google::cloud::CommonOptionList`
 * - `google::cloud::GrpcOptionList`
 * - `google::cloud::UnifiedCredentialsOptionList`
 * -
 * `google::cloud::rapidmigrationassessment_v1::RapidMigrationAssessmentPolicyOptionList`
 *
 * @note Unexpected options will be ignored. To log unexpected options instead,
 *     set `GOOGLE_CLOUD_CPP_ENABLE_CLOG=yes` in the environment.
 *
 * @param options (optional) Configure the `RapidMigrationAssessmentConnection`
 * created by this function.
 */
std::shared_ptr<RapidMigrationAssessmentConnection>
MakeRapidMigrationAssessmentConnection(Options options = {});

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace rapidmigrationassessment_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RAPIDMIGRATIONASSESSMENT_V1_RAPID_MIGRATION_ASSESSMENT_CONNECTION_H
