// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/resourcemanager/v3/tag_keys.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RESOURCEMANAGER_V3_MOCKS_MOCK_TAG_KEYS_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RESOURCEMANAGER_V3_MOCKS_MOCK_TAG_KEYS_CONNECTION_H

#include "google/cloud/resourcemanager/v3/tag_keys_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace resourcemanager_v3_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `TagKeysConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `TagKeysClient`. To do so,
 * construct an object of type `TagKeysClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockTagKeysConnection : public resourcemanager_v3::TagKeysConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD((StreamRange<google::cloud::resourcemanager::v3::TagKey>),
              ListTagKeys,
              (google::cloud::resourcemanager::v3::ListTagKeysRequest request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::resourcemanager::v3::TagKey>, GetTagKey,
      (google::cloud::resourcemanager::v3::GetTagKeyRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::cloud::resourcemanager::v3::TagKey>, GetNamespacedTagKey,
      (google::cloud::resourcemanager::v3::GetNamespacedTagKeyRequest const&
           request),
      (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, CreateTagKey)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, CreateTagKey(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::resourcemanager::v3::TagKey>>,
      CreateTagKey,
      (google::cloud::resourcemanager::v3::CreateTagKeyRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, CreateTagKey,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::resourcemanager::v3::CreateTagKeyRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::resourcemanager::v3::TagKey>>,
              CreateTagKey,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, UpdateTagKey)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, UpdateTagKey(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::resourcemanager::v3::TagKey>>,
      UpdateTagKey,
      (google::cloud::resourcemanager::v3::UpdateTagKeyRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, UpdateTagKey,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::resourcemanager::v3::UpdateTagKeyRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::resourcemanager::v3::TagKey>>,
              UpdateTagKey,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  /// Due to additional overloads for this method
  /// `EXPECT_CALL(*mock, DeleteTagKey)` is now ambiguous. Use
  /// `EXPECT_CALL(*mock, DeleteTagKey(::testing::_))` instead.
  MOCK_METHOD(
      future<StatusOr<google::cloud::resourcemanager::v3::TagKey>>,
      DeleteTagKey,
      (google::cloud::resourcemanager::v3::DeleteTagKeyRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::longrunning::Operation>, DeleteTagKey,
      (ExperimentalTag, NoAwaitTag,
       google::cloud::resourcemanager::v3::DeleteTagKeyRequest const& request),
      (override));

  MOCK_METHOD(future<StatusOr<google::cloud::resourcemanager::v3::TagKey>>,
              DeleteTagKey,
              (ExperimentalTag,
               google::longrunning::Operation const& operation),
              (override));

  MOCK_METHOD(StatusOr<google::iam::v1::Policy>, GetIamPolicy,
              (google::iam::v1::GetIamPolicyRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::iam::v1::Policy>, SetIamPolicy,
              (google::iam::v1::SetIamPolicyRequest const& request),
              (override));

  MOCK_METHOD(StatusOr<google::iam::v1::TestIamPermissionsResponse>,
              TestIamPermissions,
              (google::iam::v1::TestIamPermissionsRequest const& request),
              (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace resourcemanager_v3_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RESOURCEMANAGER_V3_MOCKS_MOCK_TAG_KEYS_CONNECTION_H
