// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/run/v2/job.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RUN_V2_INTERNAL_JOBS_TRACING_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RUN_V2_INTERNAL_JOBS_TRACING_CONNECTION_H

#include "google/cloud/run/v2/jobs_connection.h"
#include "google/cloud/version.h"
#include <memory>

namespace google {
namespace cloud {
namespace run_v2_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

#ifdef GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

class JobsTracingConnection : public run_v2::JobsConnection {
 public:
  ~JobsTracingConnection() override = default;

  explicit JobsTracingConnection(std::shared_ptr<run_v2::JobsConnection> child);

  Options options() override { return child_->options(); }

  future<StatusOr<google::cloud::run::v2::Job>> CreateJob(
      google::cloud::run::v2::CreateJobRequest const& request) override;

  StatusOr<google::longrunning::Operation> CreateJob(
      ExperimentalTag, NoAwaitTag,
      google::cloud::run::v2::CreateJobRequest const& request) override;

  future<StatusOr<google::cloud::run::v2::Job>> CreateJob(
      ExperimentalTag,
      google::longrunning::Operation const& operation) override;

  StatusOr<google::cloud::run::v2::Job> GetJob(
      google::cloud::run::v2::GetJobRequest const& request) override;

  StreamRange<google::cloud::run::v2::Job> ListJobs(
      google::cloud::run::v2::ListJobsRequest request) override;

  future<StatusOr<google::cloud::run::v2::Job>> UpdateJob(
      google::cloud::run::v2::UpdateJobRequest const& request) override;

  StatusOr<google::longrunning::Operation> UpdateJob(
      ExperimentalTag, NoAwaitTag,
      google::cloud::run::v2::UpdateJobRequest const& request) override;

  future<StatusOr<google::cloud::run::v2::Job>> UpdateJob(
      ExperimentalTag,
      google::longrunning::Operation const& operation) override;

  future<StatusOr<google::cloud::run::v2::Job>> DeleteJob(
      google::cloud::run::v2::DeleteJobRequest const& request) override;

  StatusOr<google::longrunning::Operation> DeleteJob(
      ExperimentalTag, NoAwaitTag,
      google::cloud::run::v2::DeleteJobRequest const& request) override;

  future<StatusOr<google::cloud::run::v2::Job>> DeleteJob(
      ExperimentalTag,
      google::longrunning::Operation const& operation) override;

  future<StatusOr<google::cloud::run::v2::Execution>> RunJob(
      google::cloud::run::v2::RunJobRequest const& request) override;

  StatusOr<google::longrunning::Operation> RunJob(
      ExperimentalTag, NoAwaitTag,
      google::cloud::run::v2::RunJobRequest const& request) override;

  future<StatusOr<google::cloud::run::v2::Execution>> RunJob(
      ExperimentalTag,
      google::longrunning::Operation const& operation) override;

  StatusOr<google::iam::v1::Policy> GetIamPolicy(
      google::iam::v1::GetIamPolicyRequest const& request) override;

  StatusOr<google::iam::v1::Policy> SetIamPolicy(
      google::iam::v1::SetIamPolicyRequest const& request) override;

  StatusOr<google::iam::v1::TestIamPermissionsResponse> TestIamPermissions(
      google::iam::v1::TestIamPermissionsRequest const& request) override;

 private:
  std::shared_ptr<run_v2::JobsConnection> child_;
};

#endif  // GOOGLE_CLOUD_CPP_HAVE_OPENTELEMETRY

/**
 * Conditionally applies the tracing decorator to the given connection.
 *
 * The connection is only decorated if tracing is enabled (as determined by the
 * connection's options).
 */
std::shared_ptr<run_v2::JobsConnection> MakeJobsTracingConnection(
    std::shared_ptr<run_v2::JobsConnection> conn);

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace run_v2_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RUN_V2_INTERNAL_JOBS_TRACING_CONNECTION_H
