// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/appengine/v1/appengine.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fappengine_2fv1_2fappengine_2eproto__INCLUDED
#define GRPC_google_2fappengine_2fv1_2fappengine_2eproto__INCLUDED

#include "google/appengine/v1/appengine.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace appengine {
namespace v1 {

// Manages App Engine applications.
class Applications final {
 public:
  static constexpr char const* service_full_name() {
    return "google.appengine.v1.Applications";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Gets information about an application.
    virtual ::grpc::Status GetApplication(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest& request, ::google::appengine::v1::Application* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Application>> AsyncGetApplication(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Application>>(AsyncGetApplicationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Application>> PrepareAsyncGetApplication(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Application>>(PrepareAsyncGetApplicationRaw(context, request, cq));
    }
    // Creates an App Engine application for a Google Cloud Platform project.
    // Required fields:
    //
    // * `id` - The ID of the target Cloud Platform project.
    // * *location* - The [region](https://cloud.google.com/appengine/docs/locations) where you want the App Engine application located.
    //
    // For more information about App Engine applications, see [Managing Projects, Applications, and Billing](https://cloud.google.com/appengine/docs/standard/python/console/).
    virtual ::grpc::Status CreateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateApplicationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateApplicationRaw(context, request, cq));
    }
    // Updates the specified Application resource.
    // You can update the following fields:
    //
    // * `auth_domain` - Google authentication domain for controlling user access to the application.
    // * `default_cookie_expiration` - Cookie expiration policy for the application.
    // * `iap` - Identity-Aware Proxy properties for the application.
    virtual ::grpc::Status UpdateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateApplicationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateApplicationRaw(context, request, cq));
    }
    // Recreates the required App Engine features for the specified App Engine
    // application, for example a Cloud Storage bucket or App Engine service
    // account.
    // Use this method if you receive an error message about a missing feature,
    // for example, *Error retrieving the App Engine service account*.
    // If you have deleted your App Engine service account, this will
    // not be able to recreate it. Instead, you should attempt to use the
    // IAM undelete API if possible at https://cloud.google.com/iam/reference/rest/v1/projects.serviceAccounts/undelete?apix_params=%7B"name"%3A"projects%2F-%2FserviceAccounts%2Funique_id"%2C"resource"%3A%7B%7D%7D .
    // If the deletion was recent, the numeric ID can be found in the Cloud
    // Console Activity Log.
    virtual ::grpc::Status RepairApplication(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRepairApplication(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRepairApplicationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRepairApplication(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRepairApplicationRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Gets information about an application.
      virtual void GetApplication(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest* request, ::google::appengine::v1::Application* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetApplication(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest* request, ::google::appengine::v1::Application* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an App Engine application for a Google Cloud Platform project.
      // Required fields:
      //
      // * `id` - The ID of the target Cloud Platform project.
      // * *location* - The [region](https://cloud.google.com/appengine/docs/locations) where you want the App Engine application located.
      //
      // For more information about App Engine applications, see [Managing Projects, Applications, and Billing](https://cloud.google.com/appengine/docs/standard/python/console/).
      virtual void CreateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified Application resource.
      // You can update the following fields:
      //
      // * `auth_domain` - Google authentication domain for controlling user access to the application.
      // * `default_cookie_expiration` - Cookie expiration policy for the application.
      // * `iap` - Identity-Aware Proxy properties for the application.
      virtual void UpdateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Recreates the required App Engine features for the specified App Engine
      // application, for example a Cloud Storage bucket or App Engine service
      // account.
      // Use this method if you receive an error message about a missing feature,
      // for example, *Error retrieving the App Engine service account*.
      // If you have deleted your App Engine service account, this will
      // not be able to recreate it. Instead, you should attempt to use the
      // IAM undelete API if possible at https://cloud.google.com/iam/reference/rest/v1/projects.serviceAccounts/undelete?apix_params=%7B"name"%3A"projects%2F-%2FserviceAccounts%2Funique_id"%2C"resource"%3A%7B%7D%7D .
      // If the deletion was recent, the numeric ID can be found in the Cloud
      // Console Activity Log.
      virtual void RepairApplication(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RepairApplication(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Application>* AsyncGetApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Application>* PrepareAsyncGetApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRepairApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRepairApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status GetApplication(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest& request, ::google::appengine::v1::Application* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Application>> AsyncGetApplication(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Application>>(AsyncGetApplicationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Application>> PrepareAsyncGetApplication(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Application>>(PrepareAsyncGetApplicationRaw(context, request, cq));
    }
    ::grpc::Status CreateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateApplicationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateApplicationRaw(context, request, cq));
    }
    ::grpc::Status UpdateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateApplicationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateApplicationRaw(context, request, cq));
    }
    ::grpc::Status RepairApplication(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRepairApplication(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRepairApplicationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRepairApplication(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRepairApplicationRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void GetApplication(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest* request, ::google::appengine::v1::Application* response, std::function<void(::grpc::Status)>) override;
      void GetApplication(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest* request, ::google::appengine::v1::Application* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateApplication(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RepairApplication(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RepairApplication(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Application>* AsyncGetApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Application>* PrepareAsyncGetApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetApplicationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateApplicationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateApplicationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRepairApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRepairApplicationRaw(::grpc::ClientContext* context, const ::google::appengine::v1::RepairApplicationRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetApplication_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateApplication_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateApplication_;
    const ::grpc::internal::RpcMethod rpcmethod_RepairApplication_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Gets information about an application.
    virtual ::grpc::Status GetApplication(::grpc::ServerContext* context, const ::google::appengine::v1::GetApplicationRequest* request, ::google::appengine::v1::Application* response);
    // Creates an App Engine application for a Google Cloud Platform project.
    // Required fields:
    //
    // * `id` - The ID of the target Cloud Platform project.
    // * *location* - The [region](https://cloud.google.com/appengine/docs/locations) where you want the App Engine application located.
    //
    // For more information about App Engine applications, see [Managing Projects, Applications, and Billing](https://cloud.google.com/appengine/docs/standard/python/console/).
    virtual ::grpc::Status CreateApplication(::grpc::ServerContext* context, const ::google::appengine::v1::CreateApplicationRequest* request, ::google::longrunning::Operation* response);
    // Updates the specified Application resource.
    // You can update the following fields:
    //
    // * `auth_domain` - Google authentication domain for controlling user access to the application.
    // * `default_cookie_expiration` - Cookie expiration policy for the application.
    // * `iap` - Identity-Aware Proxy properties for the application.
    virtual ::grpc::Status UpdateApplication(::grpc::ServerContext* context, const ::google::appengine::v1::UpdateApplicationRequest* request, ::google::longrunning::Operation* response);
    // Recreates the required App Engine features for the specified App Engine
    // application, for example a Cloud Storage bucket or App Engine service
    // account.
    // Use this method if you receive an error message about a missing feature,
    // for example, *Error retrieving the App Engine service account*.
    // If you have deleted your App Engine service account, this will
    // not be able to recreate it. Instead, you should attempt to use the
    // IAM undelete API if possible at https://cloud.google.com/iam/reference/rest/v1/projects.serviceAccounts/undelete?apix_params=%7B"name"%3A"projects%2F-%2FserviceAccounts%2Funique_id"%2C"resource"%3A%7B%7D%7D .
    // If the deletion was recent, the numeric ID can be found in the Cloud
    // Console Activity Log.
    virtual ::grpc::Status RepairApplication(::grpc::ServerContext* context, const ::google::appengine::v1::RepairApplicationRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetApplication() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetApplicationRequest* /*request*/, ::google::appengine::v1::Application* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetApplication(::grpc::ServerContext* context, ::google::appengine::v1::GetApplicationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::Application>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateApplication() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_CreateApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateApplication(::grpc::ServerContext* context, ::google::appengine::v1::CreateApplicationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateApplication() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_UpdateApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateApplication(::grpc::ServerContext* context, ::google::appengine::v1::UpdateApplicationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RepairApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RepairApplication() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_RepairApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RepairApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::RepairApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRepairApplication(::grpc::ServerContext* context, ::google::appengine::v1::RepairApplicationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetApplication<WithAsyncMethod_CreateApplication<WithAsyncMethod_UpdateApplication<WithAsyncMethod_RepairApplication<Service > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_GetApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetApplication() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetApplicationRequest, ::google::appengine::v1::Application>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::GetApplicationRequest* request, ::google::appengine::v1::Application* response) { return this->GetApplication(context, request, response); }));}
    void SetMessageAllocatorFor_GetApplication(
        ::grpc::MessageAllocator< ::google::appengine::v1::GetApplicationRequest, ::google::appengine::v1::Application>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetApplicationRequest, ::google::appengine::v1::Application>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetApplicationRequest* /*request*/, ::google::appengine::v1::Application* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetApplication(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::GetApplicationRequest* /*request*/, ::google::appengine::v1::Application* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateApplication() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::CreateApplicationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::CreateApplicationRequest* request, ::google::longrunning::Operation* response) { return this->CreateApplication(context, request, response); }));}
    void SetMessageAllocatorFor_CreateApplication(
        ::grpc::MessageAllocator< ::google::appengine::v1::CreateApplicationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::CreateApplicationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateApplication(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::CreateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateApplication() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::UpdateApplicationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::UpdateApplicationRequest* request, ::google::longrunning::Operation* response) { return this->UpdateApplication(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateApplication(
        ::grpc::MessageAllocator< ::google::appengine::v1::UpdateApplicationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::UpdateApplicationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateApplication(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::UpdateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RepairApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RepairApplication() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::RepairApplicationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::RepairApplicationRequest* request, ::google::longrunning::Operation* response) { return this->RepairApplication(context, request, response); }));}
    void SetMessageAllocatorFor_RepairApplication(
        ::grpc::MessageAllocator< ::google::appengine::v1::RepairApplicationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::RepairApplicationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RepairApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RepairApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::RepairApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RepairApplication(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::RepairApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_GetApplication<WithCallbackMethod_CreateApplication<WithCallbackMethod_UpdateApplication<WithCallbackMethod_RepairApplication<Service > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetApplication() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetApplicationRequest* /*request*/, ::google::appengine::v1::Application* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateApplication() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_CreateApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateApplication() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_UpdateApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RepairApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RepairApplication() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_RepairApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RepairApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::RepairApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetApplication() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetApplicationRequest* /*request*/, ::google::appengine::v1::Application* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetApplication(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateApplication() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_CreateApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateApplication(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateApplication() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_UpdateApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateApplication(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RepairApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RepairApplication() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_RepairApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RepairApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::RepairApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRepairApplication(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetApplication() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetApplication(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetApplicationRequest* /*request*/, ::google::appengine::v1::Application* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetApplication(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateApplication() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateApplication(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateApplication(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateApplication() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateApplication(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateApplication(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RepairApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RepairApplication() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RepairApplication(context, request, response); }));
    }
    ~WithRawCallbackMethod_RepairApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RepairApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::RepairApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RepairApplication(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetApplication() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::GetApplicationRequest, ::google::appengine::v1::Application>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::GetApplicationRequest, ::google::appengine::v1::Application>* streamer) {
                       return this->StreamedGetApplication(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetApplicationRequest* /*request*/, ::google::appengine::v1::Application* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetApplication(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::GetApplicationRequest,::google::appengine::v1::Application>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateApplication() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::CreateApplicationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::CreateApplicationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateApplication(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateApplication(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::CreateApplicationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateApplication() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::UpdateApplicationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::UpdateApplicationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateApplication(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateApplication(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::UpdateApplicationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RepairApplication : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RepairApplication() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::RepairApplicationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::RepairApplicationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRepairApplication(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RepairApplication() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RepairApplication(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::RepairApplicationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRepairApplication(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::RepairApplicationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetApplication<WithStreamedUnaryMethod_CreateApplication<WithStreamedUnaryMethod_UpdateApplication<WithStreamedUnaryMethod_RepairApplication<Service > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetApplication<WithStreamedUnaryMethod_CreateApplication<WithStreamedUnaryMethod_UpdateApplication<WithStreamedUnaryMethod_RepairApplication<Service > > > > StreamedService;
};

// Manages services of an application.
class Services final {
 public:
  static constexpr char const* service_full_name() {
    return "google.appengine.v1.Services";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists all the services in the application.
    virtual ::grpc::Status ListServices(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest& request, ::google::appengine::v1::ListServicesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListServicesResponse>> AsyncListServices(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListServicesResponse>>(AsyncListServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListServicesResponse>> PrepareAsyncListServices(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListServicesResponse>>(PrepareAsyncListServicesRaw(context, request, cq));
    }
    // Gets the current configuration of the specified service.
    virtual ::grpc::Status GetService(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest& request, ::google::appengine::v1::Service* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Service>> AsyncGetService(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Service>>(AsyncGetServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Service>> PrepareAsyncGetService(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Service>>(PrepareAsyncGetServiceRaw(context, request, cq));
    }
    // Updates the configuration of the specified service.
    virtual ::grpc::Status UpdateService(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateService(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateService(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateServiceRaw(context, request, cq));
    }
    // Deletes the specified service and all enclosed versions.
    virtual ::grpc::Status DeleteService(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteService(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteService(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteServiceRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists all the services in the application.
      virtual void ListServices(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest* request, ::google::appengine::v1::ListServicesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListServices(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest* request, ::google::appengine::v1::ListServicesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the current configuration of the specified service.
      virtual void GetService(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest* request, ::google::appengine::v1::Service* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetService(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest* request, ::google::appengine::v1::Service* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the configuration of the specified service.
      virtual void UpdateService(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateService(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified service and all enclosed versions.
      virtual void DeleteService(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteService(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListServicesResponse>* AsyncListServicesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListServicesResponse>* PrepareAsyncListServicesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Service>* AsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Service>* PrepareAsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateServiceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateServiceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteServiceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteServiceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListServices(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest& request, ::google::appengine::v1::ListServicesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListServicesResponse>> AsyncListServices(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListServicesResponse>>(AsyncListServicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListServicesResponse>> PrepareAsyncListServices(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListServicesResponse>>(PrepareAsyncListServicesRaw(context, request, cq));
    }
    ::grpc::Status GetService(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest& request, ::google::appengine::v1::Service* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Service>> AsyncGetService(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Service>>(AsyncGetServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Service>> PrepareAsyncGetService(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Service>>(PrepareAsyncGetServiceRaw(context, request, cq));
    }
    ::grpc::Status UpdateService(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateService(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateService(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateServiceRaw(context, request, cq));
    }
    ::grpc::Status DeleteService(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteService(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteServiceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteService(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteServiceRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListServices(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest* request, ::google::appengine::v1::ListServicesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListServices(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest* request, ::google::appengine::v1::ListServicesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetService(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest* request, ::google::appengine::v1::Service* response, std::function<void(::grpc::Status)>) override;
      void GetService(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest* request, ::google::appengine::v1::Service* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateService(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateService(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteService(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteService(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListServicesResponse>* AsyncListServicesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListServicesResponse>* PrepareAsyncListServicesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListServicesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Service>* AsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Service>* PrepareAsyncGetServiceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateServiceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateServiceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteServiceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteServiceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteServiceRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListServices_;
    const ::grpc::internal::RpcMethod rpcmethod_GetService_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateService_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteService_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists all the services in the application.
    virtual ::grpc::Status ListServices(::grpc::ServerContext* context, const ::google::appengine::v1::ListServicesRequest* request, ::google::appengine::v1::ListServicesResponse* response);
    // Gets the current configuration of the specified service.
    virtual ::grpc::Status GetService(::grpc::ServerContext* context, const ::google::appengine::v1::GetServiceRequest* request, ::google::appengine::v1::Service* response);
    // Updates the configuration of the specified service.
    virtual ::grpc::Status UpdateService(::grpc::ServerContext* context, const ::google::appengine::v1::UpdateServiceRequest* request, ::google::longrunning::Operation* response);
    // Deletes the specified service and all enclosed versions.
    virtual ::grpc::Status DeleteService(::grpc::ServerContext* context, const ::google::appengine::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListServices() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListServicesRequest* /*request*/, ::google::appengine::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServices(::grpc::ServerContext* context, ::google::appengine::v1::ListServicesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::ListServicesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetService() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetServiceRequest* /*request*/, ::google::appengine::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetService(::grpc::ServerContext* context, ::google::appengine::v1::GetServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::Service>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateService() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_UpdateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateService(::grpc::ServerContext* context, ::google::appengine::v1::UpdateServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteService() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteService(::grpc::ServerContext* context, ::google::appengine::v1::DeleteServiceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListServices<WithAsyncMethod_GetService<WithAsyncMethod_UpdateService<WithAsyncMethod_DeleteService<Service > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListServices() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListServicesRequest, ::google::appengine::v1::ListServicesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::ListServicesRequest* request, ::google::appengine::v1::ListServicesResponse* response) { return this->ListServices(context, request, response); }));}
    void SetMessageAllocatorFor_ListServices(
        ::grpc::MessageAllocator< ::google::appengine::v1::ListServicesRequest, ::google::appengine::v1::ListServicesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListServicesRequest, ::google::appengine::v1::ListServicesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListServicesRequest* /*request*/, ::google::appengine::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServices(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::ListServicesRequest* /*request*/, ::google::appengine::v1::ListServicesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetService() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetServiceRequest, ::google::appengine::v1::Service>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::GetServiceRequest* request, ::google::appengine::v1::Service* response) { return this->GetService(context, request, response); }));}
    void SetMessageAllocatorFor_GetService(
        ::grpc::MessageAllocator< ::google::appengine::v1::GetServiceRequest, ::google::appengine::v1::Service>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetServiceRequest, ::google::appengine::v1::Service>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetServiceRequest* /*request*/, ::google::appengine::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::GetServiceRequest* /*request*/, ::google::appengine::v1::Service* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateService() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::UpdateServiceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::UpdateServiceRequest* request, ::google::longrunning::Operation* response) { return this->UpdateService(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateService(
        ::grpc::MessageAllocator< ::google::appengine::v1::UpdateServiceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::UpdateServiceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteService() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DeleteServiceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::DeleteServiceRequest* request, ::google::longrunning::Operation* response) { return this->DeleteService(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteService(
        ::grpc::MessageAllocator< ::google::appengine::v1::DeleteServiceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DeleteServiceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteService(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListServices<WithCallbackMethod_GetService<WithCallbackMethod_UpdateService<WithCallbackMethod_DeleteService<Service > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListServices() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListServicesRequest* /*request*/, ::google::appengine::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetService() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetServiceRequest* /*request*/, ::google::appengine::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateService() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_UpdateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteService() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListServices() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListServicesRequest* /*request*/, ::google::appengine::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListServices(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetService() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetServiceRequest* /*request*/, ::google::appengine::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateService() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_UpdateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteService() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteService(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListServices() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListServices(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListServicesRequest* /*request*/, ::google::appengine::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListServices(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetService() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetService(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetServiceRequest* /*request*/, ::google::appengine::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateService() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateService(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteService() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteService(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteService(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListServices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListServices() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::ListServicesRequest, ::google::appengine::v1::ListServicesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::ListServicesRequest, ::google::appengine::v1::ListServicesResponse>* streamer) {
                       return this->StreamedListServices(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListServices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListServices(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListServicesRequest* /*request*/, ::google::appengine::v1::ListServicesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListServices(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::ListServicesRequest,::google::appengine::v1::ListServicesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetService() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::GetServiceRequest, ::google::appengine::v1::Service>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::GetServiceRequest, ::google::appengine::v1::Service>* streamer) {
                       return this->StreamedGetService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetServiceRequest* /*request*/, ::google::appengine::v1::Service* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::GetServiceRequest,::google::appengine::v1::Service>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateService() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::UpdateServiceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::UpdateServiceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::UpdateServiceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteService : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteService() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::DeleteServiceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::DeleteServiceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteService(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteService() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteService(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteServiceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteService(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::DeleteServiceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListServices<WithStreamedUnaryMethod_GetService<WithStreamedUnaryMethod_UpdateService<WithStreamedUnaryMethod_DeleteService<Service > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListServices<WithStreamedUnaryMethod_GetService<WithStreamedUnaryMethod_UpdateService<WithStreamedUnaryMethod_DeleteService<Service > > > > StreamedService;
};

// Manages versions of a service.
class Versions final {
 public:
  static constexpr char const* service_full_name() {
    return "google.appengine.v1.Versions";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists the versions of a service.
    virtual ::grpc::Status ListVersions(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest& request, ::google::appengine::v1::ListVersionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListVersionsResponse>> AsyncListVersions(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListVersionsResponse>>(AsyncListVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListVersionsResponse>> PrepareAsyncListVersions(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListVersionsResponse>>(PrepareAsyncListVersionsRaw(context, request, cq));
    }
    // Gets the specified Version resource.
    // By default, only a `BASIC_VIEW` will be returned.
    // Specify the `FULL_VIEW` parameter to get the full resource.
    virtual ::grpc::Status GetVersion(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest& request, ::google::appengine::v1::Version* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Version>> AsyncGetVersion(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Version>>(AsyncGetVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Version>> PrepareAsyncGetVersion(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Version>>(PrepareAsyncGetVersionRaw(context, request, cq));
    }
    // Deploys code and resource files to a new version.
    virtual ::grpc::Status CreateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateVersionRaw(context, request, cq));
    }
    // Updates the specified Version resource.
    // You can specify the following fields depending on the App Engine
    // environment and type of scaling that the version resource uses:
    //
    // **Standard environment**
    //
    // * [`instance_class`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.instance_class)
    //
    // *automatic scaling* in the standard environment:
    //
    // * [`automatic_scaling.min_idle_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
    // * [`automatic_scaling.max_idle_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
    // * [`automaticScaling.standard_scheduler_settings.max_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#StandardSchedulerSettings)
    // * [`automaticScaling.standard_scheduler_settings.min_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#StandardSchedulerSettings)
    // * [`automaticScaling.standard_scheduler_settings.target_cpu_utilization`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#StandardSchedulerSettings)
    // * [`automaticScaling.standard_scheduler_settings.target_throughput_utilization`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#StandardSchedulerSettings)
    //
    // *basic scaling* or *manual scaling* in the standard environment:
    //
    // * [`serving_status`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.serving_status)
    // * [`manual_scaling.instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#manualscaling)
    //
    // **Flexible environment**
    //
    // * [`serving_status`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.serving_status)
    //
    // *automatic scaling* in the flexible environment:
    //
    // * [`automatic_scaling.min_total_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
    // * [`automatic_scaling.max_total_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
    // * [`automatic_scaling.cool_down_period_sec`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
    // * [`automatic_scaling.cpu_utilization.target_utilization`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
    //
    // *manual scaling* in the flexible environment:
    //
    // * [`manual_scaling.instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#manualscaling)
    virtual ::grpc::Status UpdateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateVersionRaw(context, request, cq));
    }
    // Deletes an existing Version resource.
    virtual ::grpc::Status DeleteVersion(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteVersion(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteVersion(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteVersionRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists the versions of a service.
      virtual void ListVersions(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest* request, ::google::appengine::v1::ListVersionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListVersions(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest* request, ::google::appengine::v1::ListVersionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the specified Version resource.
      // By default, only a `BASIC_VIEW` will be returned.
      // Specify the `FULL_VIEW` parameter to get the full resource.
      virtual void GetVersion(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest* request, ::google::appengine::v1::Version* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetVersion(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest* request, ::google::appengine::v1::Version* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deploys code and resource files to a new version.
      virtual void CreateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified Version resource.
      // You can specify the following fields depending on the App Engine
      // environment and type of scaling that the version resource uses:
      //
      // **Standard environment**
      //
      // * [`instance_class`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.instance_class)
      //
      // *automatic scaling* in the standard environment:
      //
      // * [`automatic_scaling.min_idle_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
      // * [`automatic_scaling.max_idle_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
      // * [`automaticScaling.standard_scheduler_settings.max_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#StandardSchedulerSettings)
      // * [`automaticScaling.standard_scheduler_settings.min_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#StandardSchedulerSettings)
      // * [`automaticScaling.standard_scheduler_settings.target_cpu_utilization`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#StandardSchedulerSettings)
      // * [`automaticScaling.standard_scheduler_settings.target_throughput_utilization`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#StandardSchedulerSettings)
      //
      // *basic scaling* or *manual scaling* in the standard environment:
      //
      // * [`serving_status`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.serving_status)
      // * [`manual_scaling.instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#manualscaling)
      //
      // **Flexible environment**
      //
      // * [`serving_status`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.serving_status)
      //
      // *automatic scaling* in the flexible environment:
      //
      // * [`automatic_scaling.min_total_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
      // * [`automatic_scaling.max_total_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
      // * [`automatic_scaling.cool_down_period_sec`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
      // * [`automatic_scaling.cpu_utilization.target_utilization`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
      //
      // *manual scaling* in the flexible environment:
      //
      // * [`manual_scaling.instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#manualscaling)
      virtual void UpdateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an existing Version resource.
      virtual void DeleteVersion(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteVersion(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListVersionsResponse>* AsyncListVersionsRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListVersionsResponse>* PrepareAsyncListVersionsRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Version>* AsyncGetVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Version>* PrepareAsyncGetVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListVersions(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest& request, ::google::appengine::v1::ListVersionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListVersionsResponse>> AsyncListVersions(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListVersionsResponse>>(AsyncListVersionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListVersionsResponse>> PrepareAsyncListVersions(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListVersionsResponse>>(PrepareAsyncListVersionsRaw(context, request, cq));
    }
    ::grpc::Status GetVersion(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest& request, ::google::appengine::v1::Version* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Version>> AsyncGetVersion(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Version>>(AsyncGetVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Version>> PrepareAsyncGetVersion(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Version>>(PrepareAsyncGetVersionRaw(context, request, cq));
    }
    ::grpc::Status CreateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateVersionRaw(context, request, cq));
    }
    ::grpc::Status UpdateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateVersionRaw(context, request, cq));
    }
    ::grpc::Status DeleteVersion(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteVersion(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteVersionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteVersion(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteVersionRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListVersions(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest* request, ::google::appengine::v1::ListVersionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListVersions(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest* request, ::google::appengine::v1::ListVersionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetVersion(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest* request, ::google::appengine::v1::Version* response, std::function<void(::grpc::Status)>) override;
      void GetVersion(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest* request, ::google::appengine::v1::Version* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateVersion(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteVersion(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteVersion(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListVersionsResponse>* AsyncListVersionsRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListVersionsResponse>* PrepareAsyncListVersionsRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListVersionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Version>* AsyncGetVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Version>* PrepareAsyncGetVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteVersionRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteVersionRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListVersions_;
    const ::grpc::internal::RpcMethod rpcmethod_GetVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateVersion_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteVersion_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists the versions of a service.
    virtual ::grpc::Status ListVersions(::grpc::ServerContext* context, const ::google::appengine::v1::ListVersionsRequest* request, ::google::appengine::v1::ListVersionsResponse* response);
    // Gets the specified Version resource.
    // By default, only a `BASIC_VIEW` will be returned.
    // Specify the `FULL_VIEW` parameter to get the full resource.
    virtual ::grpc::Status GetVersion(::grpc::ServerContext* context, const ::google::appengine::v1::GetVersionRequest* request, ::google::appengine::v1::Version* response);
    // Deploys code and resource files to a new version.
    virtual ::grpc::Status CreateVersion(::grpc::ServerContext* context, const ::google::appengine::v1::CreateVersionRequest* request, ::google::longrunning::Operation* response);
    // Updates the specified Version resource.
    // You can specify the following fields depending on the App Engine
    // environment and type of scaling that the version resource uses:
    //
    // **Standard environment**
    //
    // * [`instance_class`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.instance_class)
    //
    // *automatic scaling* in the standard environment:
    //
    // * [`automatic_scaling.min_idle_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
    // * [`automatic_scaling.max_idle_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
    // * [`automaticScaling.standard_scheduler_settings.max_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#StandardSchedulerSettings)
    // * [`automaticScaling.standard_scheduler_settings.min_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#StandardSchedulerSettings)
    // * [`automaticScaling.standard_scheduler_settings.target_cpu_utilization`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#StandardSchedulerSettings)
    // * [`automaticScaling.standard_scheduler_settings.target_throughput_utilization`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#StandardSchedulerSettings)
    //
    // *basic scaling* or *manual scaling* in the standard environment:
    //
    // * [`serving_status`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.serving_status)
    // * [`manual_scaling.instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#manualscaling)
    //
    // **Flexible environment**
    //
    // * [`serving_status`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.serving_status)
    //
    // *automatic scaling* in the flexible environment:
    //
    // * [`automatic_scaling.min_total_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
    // * [`automatic_scaling.max_total_instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
    // * [`automatic_scaling.cool_down_period_sec`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
    // * [`automatic_scaling.cpu_utilization.target_utilization`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#Version.FIELDS.automatic_scaling)
    //
    // *manual scaling* in the flexible environment:
    //
    // * [`manual_scaling.instances`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions#manualscaling)
    virtual ::grpc::Status UpdateVersion(::grpc::ServerContext* context, const ::google::appengine::v1::UpdateVersionRequest* request, ::google::longrunning::Operation* response);
    // Deletes an existing Version resource.
    virtual ::grpc::Status DeleteVersion(::grpc::ServerContext* context, const ::google::appengine::v1::DeleteVersionRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListVersions() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVersions(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListVersionsRequest* /*request*/, ::google::appengine::v1::ListVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVersions(::grpc::ServerContext* context, ::google::appengine::v1::ListVersionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::ListVersionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetVersion() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetVersionRequest* /*request*/, ::google::appengine::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVersion(::grpc::ServerContext* context, ::google::appengine::v1::GetVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::Version>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateVersion() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateVersion(::grpc::ServerContext* context, ::google::appengine::v1::CreateVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateVersion() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateVersion(::grpc::ServerContext* context, ::google::appengine::v1::UpdateVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteVersion() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteVersion(::grpc::ServerContext* context, ::google::appengine::v1::DeleteVersionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListVersions<WithAsyncMethod_GetVersion<WithAsyncMethod_CreateVersion<WithAsyncMethod_UpdateVersion<WithAsyncMethod_DeleteVersion<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListVersions() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListVersionsRequest, ::google::appengine::v1::ListVersionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::ListVersionsRequest* request, ::google::appengine::v1::ListVersionsResponse* response) { return this->ListVersions(context, request, response); }));}
    void SetMessageAllocatorFor_ListVersions(
        ::grpc::MessageAllocator< ::google::appengine::v1::ListVersionsRequest, ::google::appengine::v1::ListVersionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListVersionsRequest, ::google::appengine::v1::ListVersionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVersions(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListVersionsRequest* /*request*/, ::google::appengine::v1::ListVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::ListVersionsRequest* /*request*/, ::google::appengine::v1::ListVersionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetVersion() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetVersionRequest, ::google::appengine::v1::Version>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::GetVersionRequest* request, ::google::appengine::v1::Version* response) { return this->GetVersion(context, request, response); }));}
    void SetMessageAllocatorFor_GetVersion(
        ::grpc::MessageAllocator< ::google::appengine::v1::GetVersionRequest, ::google::appengine::v1::Version>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetVersionRequest, ::google::appengine::v1::Version>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetVersionRequest* /*request*/, ::google::appengine::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::GetVersionRequest* /*request*/, ::google::appengine::v1::Version* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateVersion() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::CreateVersionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::CreateVersionRequest* request, ::google::longrunning::Operation* response) { return this->CreateVersion(context, request, response); }));}
    void SetMessageAllocatorFor_CreateVersion(
        ::grpc::MessageAllocator< ::google::appengine::v1::CreateVersionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::CreateVersionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::CreateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateVersion() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::UpdateVersionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::UpdateVersionRequest* request, ::google::longrunning::Operation* response) { return this->UpdateVersion(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateVersion(
        ::grpc::MessageAllocator< ::google::appengine::v1::UpdateVersionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::UpdateVersionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::UpdateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteVersion() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DeleteVersionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::DeleteVersionRequest* request, ::google::longrunning::Operation* response) { return this->DeleteVersion(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteVersion(
        ::grpc::MessageAllocator< ::google::appengine::v1::DeleteVersionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DeleteVersionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListVersions<WithCallbackMethod_GetVersion<WithCallbackMethod_CreateVersion<WithCallbackMethod_UpdateVersion<WithCallbackMethod_DeleteVersion<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListVersions() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVersions(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListVersionsRequest* /*request*/, ::google::appengine::v1::ListVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetVersion() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetVersionRequest* /*request*/, ::google::appengine::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateVersion() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateVersion() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteVersion() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListVersions() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVersions(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListVersionsRequest* /*request*/, ::google::appengine::v1::ListVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVersions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetVersion() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetVersionRequest* /*request*/, ::google::appengine::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateVersion() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateVersion() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteVersion() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteVersion(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListVersions() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListVersions(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVersions(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListVersionsRequest* /*request*/, ::google::appengine::v1::ListVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVersions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetVersion() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetVersionRequest* /*request*/, ::google::appengine::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateVersion() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateVersion() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteVersion() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteVersion(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteVersion(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListVersions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListVersions() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::ListVersionsRequest, ::google::appengine::v1::ListVersionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::ListVersionsRequest, ::google::appengine::v1::ListVersionsResponse>* streamer) {
                       return this->StreamedListVersions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListVersions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListVersions(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListVersionsRequest* /*request*/, ::google::appengine::v1::ListVersionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListVersions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::ListVersionsRequest,::google::appengine::v1::ListVersionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetVersion() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::GetVersionRequest, ::google::appengine::v1::Version>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::GetVersionRequest, ::google::appengine::v1::Version>* streamer) {
                       return this->StreamedGetVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetVersionRequest* /*request*/, ::google::appengine::v1::Version* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::GetVersionRequest,::google::appengine::v1::Version>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateVersion() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::CreateVersionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::CreateVersionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::CreateVersionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateVersion() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::UpdateVersionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::UpdateVersionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::UpdateVersionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteVersion : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteVersion() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::DeleteVersionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::DeleteVersionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteVersion(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteVersion() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteVersion(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteVersionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteVersion(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::DeleteVersionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListVersions<WithStreamedUnaryMethod_GetVersion<WithStreamedUnaryMethod_CreateVersion<WithStreamedUnaryMethod_UpdateVersion<WithStreamedUnaryMethod_DeleteVersion<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListVersions<WithStreamedUnaryMethod_GetVersion<WithStreamedUnaryMethod_CreateVersion<WithStreamedUnaryMethod_UpdateVersion<WithStreamedUnaryMethod_DeleteVersion<Service > > > > > StreamedService;
};

// Manages instances of a version.
class Instances final {
 public:
  static constexpr char const* service_full_name() {
    return "google.appengine.v1.Instances";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists the instances of a version.
    //
    // Tip: To aggregate details about instances over time, see the
    // [Stackdriver Monitoring API](https://cloud.google.com/monitoring/api/ref_v3/rest/v3/projects.timeSeries/list).
    virtual ::grpc::Status ListInstances(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest& request, ::google::appengine::v1::ListInstancesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListInstancesResponse>> AsyncListInstances(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListInstancesResponse>>(AsyncListInstancesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListInstancesResponse>> PrepareAsyncListInstances(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListInstancesResponse>>(PrepareAsyncListInstancesRaw(context, request, cq));
    }
    // Gets instance information.
    virtual ::grpc::Status GetInstance(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest& request, ::google::appengine::v1::Instance* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Instance>> AsyncGetInstance(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Instance>>(AsyncGetInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Instance>> PrepareAsyncGetInstance(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Instance>>(PrepareAsyncGetInstanceRaw(context, request, cq));
    }
    // Stops a running instance.
    //
    // The instance might be automatically recreated based on the scaling settings
    // of the version. For more information, see "How Instances are Managed"
    // ([standard environment](https://cloud.google.com/appengine/docs/standard/python/how-instances-are-managed) |
    // [flexible environment](https://cloud.google.com/appengine/docs/flexible/python/how-instances-are-managed)).
    //
    // To ensure that instances are not re-created and avoid getting billed, you
    // can stop all instances within the target version by changing the serving
    // status of the version to `STOPPED` with the
    // [`apps.services.versions.patch`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions/patch)
    // method.
    virtual ::grpc::Status DeleteInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteInstanceRaw(context, request, cq));
    }
    // Enables debugging on a VM instance. This allows you to use the SSH
    // command to connect to the virtual machine where the instance lives.
    // While in "debug mode", the instance continues to serve live traffic.
    // You should delete the instance when you are done debugging and then
    // allow the system to take over and determine if another instance
    // should be started.
    //
    // Only applicable for instances in App Engine flexible environment.
    virtual ::grpc::Status DebugInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDebugInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDebugInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDebugInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDebugInstanceRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists the instances of a version.
      //
      // Tip: To aggregate details about instances over time, see the
      // [Stackdriver Monitoring API](https://cloud.google.com/monitoring/api/ref_v3/rest/v3/projects.timeSeries/list).
      virtual void ListInstances(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest* request, ::google::appengine::v1::ListInstancesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInstances(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest* request, ::google::appengine::v1::ListInstancesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets instance information.
      virtual void GetInstance(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest* request, ::google::appengine::v1::Instance* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInstance(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest* request, ::google::appengine::v1::Instance* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Stops a running instance.
      //
      // The instance might be automatically recreated based on the scaling settings
      // of the version. For more information, see "How Instances are Managed"
      // ([standard environment](https://cloud.google.com/appengine/docs/standard/python/how-instances-are-managed) |
      // [flexible environment](https://cloud.google.com/appengine/docs/flexible/python/how-instances-are-managed)).
      //
      // To ensure that instances are not re-created and avoid getting billed, you
      // can stop all instances within the target version by changing the serving
      // status of the version to `STOPPED` with the
      // [`apps.services.versions.patch`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions/patch)
      // method.
      virtual void DeleteInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Enables debugging on a VM instance. This allows you to use the SSH
      // command to connect to the virtual machine where the instance lives.
      // While in "debug mode", the instance continues to serve live traffic.
      // You should delete the instance when you are done debugging and then
      // allow the system to take over and determine if another instance
      // should be started.
      //
      // Only applicable for instances in App Engine flexible environment.
      virtual void DebugInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DebugInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListInstancesResponse>* AsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListInstancesResponse>* PrepareAsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Instance>* AsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::Instance>* PrepareAsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDebugInstanceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDebugInstanceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListInstances(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest& request, ::google::appengine::v1::ListInstancesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListInstancesResponse>> AsyncListInstances(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListInstancesResponse>>(AsyncListInstancesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListInstancesResponse>> PrepareAsyncListInstances(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListInstancesResponse>>(PrepareAsyncListInstancesRaw(context, request, cq));
    }
    ::grpc::Status GetInstance(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest& request, ::google::appengine::v1::Instance* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Instance>> AsyncGetInstance(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Instance>>(AsyncGetInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Instance>> PrepareAsyncGetInstance(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Instance>>(PrepareAsyncGetInstanceRaw(context, request, cq));
    }
    ::grpc::Status DeleteInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteInstanceRaw(context, request, cq));
    }
    ::grpc::Status DebugInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDebugInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDebugInstanceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDebugInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDebugInstanceRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListInstances(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest* request, ::google::appengine::v1::ListInstancesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInstances(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest* request, ::google::appengine::v1::ListInstancesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInstance(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest* request, ::google::appengine::v1::Instance* response, std::function<void(::grpc::Status)>) override;
      void GetInstance(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest* request, ::google::appengine::v1::Instance* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DebugInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DebugInstance(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListInstancesResponse>* AsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListInstancesResponse>* PrepareAsyncListInstancesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListInstancesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Instance>* AsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::Instance>* PrepareAsyncGetInstanceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteInstanceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDebugInstanceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDebugInstanceRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DebugInstanceRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListInstances_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteInstance_;
    const ::grpc::internal::RpcMethod rpcmethod_DebugInstance_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists the instances of a version.
    //
    // Tip: To aggregate details about instances over time, see the
    // [Stackdriver Monitoring API](https://cloud.google.com/monitoring/api/ref_v3/rest/v3/projects.timeSeries/list).
    virtual ::grpc::Status ListInstances(::grpc::ServerContext* context, const ::google::appengine::v1::ListInstancesRequest* request, ::google::appengine::v1::ListInstancesResponse* response);
    // Gets instance information.
    virtual ::grpc::Status GetInstance(::grpc::ServerContext* context, const ::google::appengine::v1::GetInstanceRequest* request, ::google::appengine::v1::Instance* response);
    // Stops a running instance.
    //
    // The instance might be automatically recreated based on the scaling settings
    // of the version. For more information, see "How Instances are Managed"
    // ([standard environment](https://cloud.google.com/appengine/docs/standard/python/how-instances-are-managed) |
    // [flexible environment](https://cloud.google.com/appengine/docs/flexible/python/how-instances-are-managed)).
    //
    // To ensure that instances are not re-created and avoid getting billed, you
    // can stop all instances within the target version by changing the serving
    // status of the version to `STOPPED` with the
    // [`apps.services.versions.patch`](https://cloud.google.com/appengine/docs/admin-api/reference/rest/v1/apps.services.versions/patch)
    // method.
    virtual ::grpc::Status DeleteInstance(::grpc::ServerContext* context, const ::google::appengine::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response);
    // Enables debugging on a VM instance. This allows you to use the SSH
    // command to connect to the virtual machine where the instance lives.
    // While in "debug mode", the instance continues to serve live traffic.
    // You should delete the instance when you are done debugging and then
    // allow the system to take over and determine if another instance
    // should be started.
    //
    // Only applicable for instances in App Engine flexible environment.
    virtual ::grpc::Status DebugInstance(::grpc::ServerContext* context, const ::google::appengine::v1::DebugInstanceRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInstances() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListInstancesRequest* /*request*/, ::google::appengine::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstances(::grpc::ServerContext* context, ::google::appengine::v1::ListInstancesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::ListInstancesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInstance() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetInstanceRequest* /*request*/, ::google::appengine::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstance(::grpc::ServerContext* context, ::google::appengine::v1::GetInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::Instance>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstance(::grpc::ServerContext* context, ::google::appengine::v1::DeleteInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DebugInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DebugInstance() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DebugInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DebugInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DebugInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDebugInstance(::grpc::ServerContext* context, ::google::appengine::v1::DebugInstanceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListInstances<WithAsyncMethod_GetInstance<WithAsyncMethod_DeleteInstance<WithAsyncMethod_DebugInstance<Service > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInstances() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListInstancesRequest, ::google::appengine::v1::ListInstancesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::ListInstancesRequest* request, ::google::appengine::v1::ListInstancesResponse* response) { return this->ListInstances(context, request, response); }));}
    void SetMessageAllocatorFor_ListInstances(
        ::grpc::MessageAllocator< ::google::appengine::v1::ListInstancesRequest, ::google::appengine::v1::ListInstancesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListInstancesRequest, ::google::appengine::v1::ListInstancesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListInstancesRequest* /*request*/, ::google::appengine::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstances(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::ListInstancesRequest* /*request*/, ::google::appengine::v1::ListInstancesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInstance() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetInstanceRequest, ::google::appengine::v1::Instance>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::GetInstanceRequest* request, ::google::appengine::v1::Instance* response) { return this->GetInstance(context, request, response); }));}
    void SetMessageAllocatorFor_GetInstance(
        ::grpc::MessageAllocator< ::google::appengine::v1::GetInstanceRequest, ::google::appengine::v1::Instance>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetInstanceRequest, ::google::appengine::v1::Instance>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetInstanceRequest* /*request*/, ::google::appengine::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::GetInstanceRequest* /*request*/, ::google::appengine::v1::Instance* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DeleteInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::DeleteInstanceRequest* request, ::google::longrunning::Operation* response) { return this->DeleteInstance(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteInstance(
        ::grpc::MessageAllocator< ::google::appengine::v1::DeleteInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DeleteInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DebugInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DebugInstance() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DebugInstanceRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::DebugInstanceRequest* request, ::google::longrunning::Operation* response) { return this->DebugInstance(context, request, response); }));}
    void SetMessageAllocatorFor_DebugInstance(
        ::grpc::MessageAllocator< ::google::appengine::v1::DebugInstanceRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DebugInstanceRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DebugInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DebugInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DebugInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DebugInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::DebugInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListInstances<WithCallbackMethod_GetInstance<WithCallbackMethod_DeleteInstance<WithCallbackMethod_DebugInstance<Service > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInstances() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListInstancesRequest* /*request*/, ::google::appengine::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInstance() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetInstanceRequest* /*request*/, ::google::appengine::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DebugInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DebugInstance() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DebugInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DebugInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DebugInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInstances() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListInstancesRequest* /*request*/, ::google::appengine::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInstances(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInstance() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetInstanceRequest* /*request*/, ::google::appengine::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DebugInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DebugInstance() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DebugInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DebugInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DebugInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDebugInstance(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInstances() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInstances(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListInstancesRequest* /*request*/, ::google::appengine::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInstances(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInstance() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetInstanceRequest* /*request*/, ::google::appengine::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DebugInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DebugInstance() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DebugInstance(context, request, response); }));
    }
    ~WithRawCallbackMethod_DebugInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DebugInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DebugInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DebugInstance(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInstances : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInstances() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::ListInstancesRequest, ::google::appengine::v1::ListInstancesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::ListInstancesRequest, ::google::appengine::v1::ListInstancesResponse>* streamer) {
                       return this->StreamedListInstances(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInstances() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInstances(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListInstancesRequest* /*request*/, ::google::appengine::v1::ListInstancesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInstances(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::ListInstancesRequest,::google::appengine::v1::ListInstancesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInstance() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::GetInstanceRequest, ::google::appengine::v1::Instance>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::GetInstanceRequest, ::google::appengine::v1::Instance>* streamer) {
                       return this->StreamedGetInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetInstanceRequest* /*request*/, ::google::appengine::v1::Instance* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::GetInstanceRequest,::google::appengine::v1::Instance>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteInstance() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::DeleteInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::DeleteInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::DeleteInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DebugInstance : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DebugInstance() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::DebugInstanceRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::DebugInstanceRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDebugInstance(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DebugInstance() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DebugInstance(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DebugInstanceRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDebugInstance(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::DebugInstanceRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListInstances<WithStreamedUnaryMethod_GetInstance<WithStreamedUnaryMethod_DeleteInstance<WithStreamedUnaryMethod_DebugInstance<Service > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListInstances<WithStreamedUnaryMethod_GetInstance<WithStreamedUnaryMethod_DeleteInstance<WithStreamedUnaryMethod_DebugInstance<Service > > > > StreamedService;
};

// Firewall resources are used to define a collection of access control rules
// for an Application. Each rule is defined with a position which specifies
// the rule's order in the sequence of rules, an IP range to be matched against
// requests, and an action to take upon matching requests.
//
// Every request is evaluated against the Firewall rules in priority order.
// Processesing stops at the first rule which matches the request's IP address.
// A final rule always specifies an action that applies to all remaining
// IP addresses. The default final rule for a newly-created application will be
// set to "allow" if not otherwise specified by the user.
class Firewall final {
 public:
  static constexpr char const* service_full_name() {
    return "google.appengine.v1.Firewall";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists the firewall rules of an application.
    virtual ::grpc::Status ListIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest& request, ::google::appengine::v1::ListIngressRulesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListIngressRulesResponse>> AsyncListIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListIngressRulesResponse>>(AsyncListIngressRulesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListIngressRulesResponse>> PrepareAsyncListIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListIngressRulesResponse>>(PrepareAsyncListIngressRulesRaw(context, request, cq));
    }
    // Replaces the entire firewall ruleset in one bulk operation. This overrides
    // and replaces the rules of an existing firewall with the new rules.
    //
    // If the final rule does not match traffic with the '*' wildcard IP range,
    // then an "allow all" rule is explicitly added to the end of the list.
    virtual ::grpc::Status BatchUpdateIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest& request, ::google::appengine::v1::BatchUpdateIngressRulesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::BatchUpdateIngressRulesResponse>> AsyncBatchUpdateIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::BatchUpdateIngressRulesResponse>>(AsyncBatchUpdateIngressRulesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::BatchUpdateIngressRulesResponse>> PrepareAsyncBatchUpdateIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::BatchUpdateIngressRulesResponse>>(PrepareAsyncBatchUpdateIngressRulesRaw(context, request, cq));
    }
    // Creates a firewall rule for the application.
    virtual ::grpc::Status CreateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest& request, ::google::appengine::v1::FirewallRule* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>> AsyncCreateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>>(AsyncCreateIngressRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>> PrepareAsyncCreateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>>(PrepareAsyncCreateIngressRuleRaw(context, request, cq));
    }
    // Gets the specified firewall rule.
    virtual ::grpc::Status GetIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest& request, ::google::appengine::v1::FirewallRule* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>> AsyncGetIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>>(AsyncGetIngressRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>> PrepareAsyncGetIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>>(PrepareAsyncGetIngressRuleRaw(context, request, cq));
    }
    // Updates the specified firewall rule.
    virtual ::grpc::Status UpdateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest& request, ::google::appengine::v1::FirewallRule* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>> AsyncUpdateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>>(AsyncUpdateIngressRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>> PrepareAsyncUpdateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>>(PrepareAsyncUpdateIngressRuleRaw(context, request, cq));
    }
    // Deletes the specified firewall rule.
    virtual ::grpc::Status DeleteIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteIngressRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteIngressRuleRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists the firewall rules of an application.
      virtual void ListIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest* request, ::google::appengine::v1::ListIngressRulesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest* request, ::google::appengine::v1::ListIngressRulesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Replaces the entire firewall ruleset in one bulk operation. This overrides
      // and replaces the rules of an existing firewall with the new rules.
      //
      // If the final rule does not match traffic with the '*' wildcard IP range,
      // then an "allow all" rule is explicitly added to the end of the list.
      virtual void BatchUpdateIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest* request, ::google::appengine::v1::BatchUpdateIngressRulesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchUpdateIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest* request, ::google::appengine::v1::BatchUpdateIngressRulesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a firewall rule for the application.
      virtual void CreateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the specified firewall rule.
      virtual void GetIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified firewall rule.
      virtual void UpdateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified firewall rule.
      virtual void DeleteIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListIngressRulesResponse>* AsyncListIngressRulesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListIngressRulesResponse>* PrepareAsyncListIngressRulesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::BatchUpdateIngressRulesResponse>* AsyncBatchUpdateIngressRulesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::BatchUpdateIngressRulesResponse>* PrepareAsyncBatchUpdateIngressRulesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>* AsyncCreateIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>* PrepareAsyncCreateIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>* AsyncGetIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>* PrepareAsyncGetIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>* AsyncUpdateIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::FirewallRule>* PrepareAsyncUpdateIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest& request, ::google::appengine::v1::ListIngressRulesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListIngressRulesResponse>> AsyncListIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListIngressRulesResponse>>(AsyncListIngressRulesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListIngressRulesResponse>> PrepareAsyncListIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListIngressRulesResponse>>(PrepareAsyncListIngressRulesRaw(context, request, cq));
    }
    ::grpc::Status BatchUpdateIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest& request, ::google::appengine::v1::BatchUpdateIngressRulesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::BatchUpdateIngressRulesResponse>> AsyncBatchUpdateIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::BatchUpdateIngressRulesResponse>>(AsyncBatchUpdateIngressRulesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::BatchUpdateIngressRulesResponse>> PrepareAsyncBatchUpdateIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::BatchUpdateIngressRulesResponse>>(PrepareAsyncBatchUpdateIngressRulesRaw(context, request, cq));
    }
    ::grpc::Status CreateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest& request, ::google::appengine::v1::FirewallRule* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>> AsyncCreateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>>(AsyncCreateIngressRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>> PrepareAsyncCreateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>>(PrepareAsyncCreateIngressRuleRaw(context, request, cq));
    }
    ::grpc::Status GetIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest& request, ::google::appengine::v1::FirewallRule* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>> AsyncGetIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>>(AsyncGetIngressRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>> PrepareAsyncGetIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>>(PrepareAsyncGetIngressRuleRaw(context, request, cq));
    }
    ::grpc::Status UpdateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest& request, ::google::appengine::v1::FirewallRule* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>> AsyncUpdateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>>(AsyncUpdateIngressRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>> PrepareAsyncUpdateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>>(PrepareAsyncUpdateIngressRuleRaw(context, request, cq));
    }
    ::grpc::Status DeleteIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteIngressRuleRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteIngressRuleRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest* request, ::google::appengine::v1::ListIngressRulesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest* request, ::google::appengine::v1::ListIngressRulesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchUpdateIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest* request, ::google::appengine::v1::BatchUpdateIngressRulesResponse* response, std::function<void(::grpc::Status)>) override;
      void BatchUpdateIngressRules(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest* request, ::google::appengine::v1::BatchUpdateIngressRulesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response, std::function<void(::grpc::Status)>) override;
      void CreateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response, std::function<void(::grpc::Status)>) override;
      void GetIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response, std::function<void(::grpc::Status)>) override;
      void UpdateIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteIngressRule(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListIngressRulesResponse>* AsyncListIngressRulesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListIngressRulesResponse>* PrepareAsyncListIngressRulesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListIngressRulesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::BatchUpdateIngressRulesResponse>* AsyncBatchUpdateIngressRulesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::BatchUpdateIngressRulesResponse>* PrepareAsyncBatchUpdateIngressRulesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>* AsyncCreateIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>* PrepareAsyncCreateIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>* AsyncGetIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>* PrepareAsyncGetIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetIngressRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>* AsyncUpdateIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::FirewallRule>* PrepareAsyncUpdateIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteIngressRuleRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListIngressRules_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchUpdateIngressRules_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateIngressRule_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIngressRule_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateIngressRule_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteIngressRule_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists the firewall rules of an application.
    virtual ::grpc::Status ListIngressRules(::grpc::ServerContext* context, const ::google::appengine::v1::ListIngressRulesRequest* request, ::google::appengine::v1::ListIngressRulesResponse* response);
    // Replaces the entire firewall ruleset in one bulk operation. This overrides
    // and replaces the rules of an existing firewall with the new rules.
    //
    // If the final rule does not match traffic with the '*' wildcard IP range,
    // then an "allow all" rule is explicitly added to the end of the list.
    virtual ::grpc::Status BatchUpdateIngressRules(::grpc::ServerContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest* request, ::google::appengine::v1::BatchUpdateIngressRulesResponse* response);
    // Creates a firewall rule for the application.
    virtual ::grpc::Status CreateIngressRule(::grpc::ServerContext* context, const ::google::appengine::v1::CreateIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response);
    // Gets the specified firewall rule.
    virtual ::grpc::Status GetIngressRule(::grpc::ServerContext* context, const ::google::appengine::v1::GetIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response);
    // Updates the specified firewall rule.
    virtual ::grpc::Status UpdateIngressRule(::grpc::ServerContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response);
    // Deletes the specified firewall rule.
    virtual ::grpc::Status DeleteIngressRule(::grpc::ServerContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest* request, ::google::protobuf::Empty* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListIngressRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListIngressRules() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListIngressRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIngressRules(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListIngressRulesRequest* /*request*/, ::google::appengine::v1::ListIngressRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListIngressRules(::grpc::ServerContext* context, ::google::appengine::v1::ListIngressRulesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::ListIngressRulesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchUpdateIngressRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchUpdateIngressRules() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_BatchUpdateIngressRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateIngressRules(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::BatchUpdateIngressRulesRequest* /*request*/, ::google::appengine::v1::BatchUpdateIngressRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateIngressRules(::grpc::ServerContext* context, ::google::appengine::v1::BatchUpdateIngressRulesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::BatchUpdateIngressRulesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateIngressRule() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateIngressRule(::grpc::ServerContext* context, ::google::appengine::v1::CreateIngressRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::FirewallRule>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIngressRule() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIngressRule(::grpc::ServerContext* context, ::google::appengine::v1::GetIngressRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::FirewallRule>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateIngressRule() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateIngressRule(::grpc::ServerContext* context, ::google::appengine::v1::UpdateIngressRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::FirewallRule>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteIngressRule() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_DeleteIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteIngressRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteIngressRule(::grpc::ServerContext* context, ::google::appengine::v1::DeleteIngressRuleRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListIngressRules<WithAsyncMethod_BatchUpdateIngressRules<WithAsyncMethod_CreateIngressRule<WithAsyncMethod_GetIngressRule<WithAsyncMethod_UpdateIngressRule<WithAsyncMethod_DeleteIngressRule<Service > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListIngressRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListIngressRules() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListIngressRulesRequest, ::google::appengine::v1::ListIngressRulesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::ListIngressRulesRequest* request, ::google::appengine::v1::ListIngressRulesResponse* response) { return this->ListIngressRules(context, request, response); }));}
    void SetMessageAllocatorFor_ListIngressRules(
        ::grpc::MessageAllocator< ::google::appengine::v1::ListIngressRulesRequest, ::google::appengine::v1::ListIngressRulesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListIngressRulesRequest, ::google::appengine::v1::ListIngressRulesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListIngressRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIngressRules(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListIngressRulesRequest* /*request*/, ::google::appengine::v1::ListIngressRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListIngressRules(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::ListIngressRulesRequest* /*request*/, ::google::appengine::v1::ListIngressRulesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchUpdateIngressRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchUpdateIngressRules() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::BatchUpdateIngressRulesRequest, ::google::appengine::v1::BatchUpdateIngressRulesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::BatchUpdateIngressRulesRequest* request, ::google::appengine::v1::BatchUpdateIngressRulesResponse* response) { return this->BatchUpdateIngressRules(context, request, response); }));}
    void SetMessageAllocatorFor_BatchUpdateIngressRules(
        ::grpc::MessageAllocator< ::google::appengine::v1::BatchUpdateIngressRulesRequest, ::google::appengine::v1::BatchUpdateIngressRulesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::BatchUpdateIngressRulesRequest, ::google::appengine::v1::BatchUpdateIngressRulesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchUpdateIngressRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateIngressRules(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::BatchUpdateIngressRulesRequest* /*request*/, ::google::appengine::v1::BatchUpdateIngressRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchUpdateIngressRules(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::BatchUpdateIngressRulesRequest* /*request*/, ::google::appengine::v1::BatchUpdateIngressRulesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateIngressRule() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::CreateIngressRuleRequest, ::google::appengine::v1::FirewallRule>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::CreateIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response) { return this->CreateIngressRule(context, request, response); }));}
    void SetMessageAllocatorFor_CreateIngressRule(
        ::grpc::MessageAllocator< ::google::appengine::v1::CreateIngressRuleRequest, ::google::appengine::v1::FirewallRule>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::CreateIngressRuleRequest, ::google::appengine::v1::FirewallRule>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateIngressRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::CreateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetIngressRule() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetIngressRuleRequest, ::google::appengine::v1::FirewallRule>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::GetIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response) { return this->GetIngressRule(context, request, response); }));}
    void SetMessageAllocatorFor_GetIngressRule(
        ::grpc::MessageAllocator< ::google::appengine::v1::GetIngressRuleRequest, ::google::appengine::v1::FirewallRule>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetIngressRuleRequest, ::google::appengine::v1::FirewallRule>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIngressRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::GetIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateIngressRule() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::UpdateIngressRuleRequest, ::google::appengine::v1::FirewallRule>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::UpdateIngressRuleRequest* request, ::google::appengine::v1::FirewallRule* response) { return this->UpdateIngressRule(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateIngressRule(
        ::grpc::MessageAllocator< ::google::appengine::v1::UpdateIngressRuleRequest, ::google::appengine::v1::FirewallRule>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::UpdateIngressRuleRequest, ::google::appengine::v1::FirewallRule>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateIngressRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::UpdateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteIngressRule() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DeleteIngressRuleRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::DeleteIngressRuleRequest* request, ::google::protobuf::Empty* response) { return this->DeleteIngressRule(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteIngressRule(
        ::grpc::MessageAllocator< ::google::appengine::v1::DeleteIngressRuleRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DeleteIngressRuleRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteIngressRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteIngressRule(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::DeleteIngressRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListIngressRules<WithCallbackMethod_BatchUpdateIngressRules<WithCallbackMethod_CreateIngressRule<WithCallbackMethod_GetIngressRule<WithCallbackMethod_UpdateIngressRule<WithCallbackMethod_DeleteIngressRule<Service > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListIngressRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListIngressRules() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListIngressRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIngressRules(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListIngressRulesRequest* /*request*/, ::google::appengine::v1::ListIngressRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchUpdateIngressRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchUpdateIngressRules() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_BatchUpdateIngressRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateIngressRules(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::BatchUpdateIngressRulesRequest* /*request*/, ::google::appengine::v1::BatchUpdateIngressRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateIngressRule() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIngressRule() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateIngressRule() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteIngressRule() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_DeleteIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteIngressRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListIngressRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListIngressRules() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListIngressRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIngressRules(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListIngressRulesRequest* /*request*/, ::google::appengine::v1::ListIngressRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListIngressRules(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchUpdateIngressRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchUpdateIngressRules() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_BatchUpdateIngressRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateIngressRules(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::BatchUpdateIngressRulesRequest* /*request*/, ::google::appengine::v1::BatchUpdateIngressRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateIngressRules(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateIngressRule() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateIngressRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIngressRule() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIngressRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateIngressRule() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateIngressRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteIngressRule() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_DeleteIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteIngressRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteIngressRule(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListIngressRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListIngressRules() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListIngressRules(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListIngressRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIngressRules(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListIngressRulesRequest* /*request*/, ::google::appengine::v1::ListIngressRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListIngressRules(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchUpdateIngressRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchUpdateIngressRules() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchUpdateIngressRules(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchUpdateIngressRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateIngressRules(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::BatchUpdateIngressRulesRequest* /*request*/, ::google::appengine::v1::BatchUpdateIngressRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchUpdateIngressRules(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateIngressRule() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateIngressRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateIngressRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetIngressRule() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetIngressRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIngressRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateIngressRule() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateIngressRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateIngressRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteIngressRule() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteIngressRule(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteIngressRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteIngressRule(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListIngressRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListIngressRules() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::ListIngressRulesRequest, ::google::appengine::v1::ListIngressRulesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::ListIngressRulesRequest, ::google::appengine::v1::ListIngressRulesResponse>* streamer) {
                       return this->StreamedListIngressRules(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListIngressRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListIngressRules(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListIngressRulesRequest* /*request*/, ::google::appengine::v1::ListIngressRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListIngressRules(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::ListIngressRulesRequest,::google::appengine::v1::ListIngressRulesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchUpdateIngressRules : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchUpdateIngressRules() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::BatchUpdateIngressRulesRequest, ::google::appengine::v1::BatchUpdateIngressRulesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::BatchUpdateIngressRulesRequest, ::google::appengine::v1::BatchUpdateIngressRulesResponse>* streamer) {
                       return this->StreamedBatchUpdateIngressRules(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchUpdateIngressRules() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchUpdateIngressRules(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::BatchUpdateIngressRulesRequest* /*request*/, ::google::appengine::v1::BatchUpdateIngressRulesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchUpdateIngressRules(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::BatchUpdateIngressRulesRequest,::google::appengine::v1::BatchUpdateIngressRulesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateIngressRule() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::CreateIngressRuleRequest, ::google::appengine::v1::FirewallRule>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::CreateIngressRuleRequest, ::google::appengine::v1::FirewallRule>* streamer) {
                       return this->StreamedCreateIngressRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateIngressRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::CreateIngressRuleRequest,::google::appengine::v1::FirewallRule>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIngressRule() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::GetIngressRuleRequest, ::google::appengine::v1::FirewallRule>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::GetIngressRuleRequest, ::google::appengine::v1::FirewallRule>* streamer) {
                       return this->StreamedGetIngressRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIngressRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::GetIngressRuleRequest,::google::appengine::v1::FirewallRule>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateIngressRule() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::UpdateIngressRuleRequest, ::google::appengine::v1::FirewallRule>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::UpdateIngressRuleRequest, ::google::appengine::v1::FirewallRule>* streamer) {
                       return this->StreamedUpdateIngressRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateIngressRuleRequest* /*request*/, ::google::appengine::v1::FirewallRule* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateIngressRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::UpdateIngressRuleRequest,::google::appengine::v1::FirewallRule>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteIngressRule : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteIngressRule() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::DeleteIngressRuleRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::DeleteIngressRuleRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteIngressRule(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteIngressRule() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteIngressRule(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteIngressRuleRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteIngressRule(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::DeleteIngressRuleRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListIngressRules<WithStreamedUnaryMethod_BatchUpdateIngressRules<WithStreamedUnaryMethod_CreateIngressRule<WithStreamedUnaryMethod_GetIngressRule<WithStreamedUnaryMethod_UpdateIngressRule<WithStreamedUnaryMethod_DeleteIngressRule<Service > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListIngressRules<WithStreamedUnaryMethod_BatchUpdateIngressRules<WithStreamedUnaryMethod_CreateIngressRule<WithStreamedUnaryMethod_GetIngressRule<WithStreamedUnaryMethod_UpdateIngressRule<WithStreamedUnaryMethod_DeleteIngressRule<Service > > > > > > StreamedService;
};

// Manages domains a user is authorized to administer. To authorize use of a
// domain, verify ownership via
// [Webmaster Central](https://www.google.com/webmasters/verification/home).
class AuthorizedDomains final {
 public:
  static constexpr char const* service_full_name() {
    return "google.appengine.v1.AuthorizedDomains";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists all domains the user is authorized to administer.
    virtual ::grpc::Status ListAuthorizedDomains(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest& request, ::google::appengine::v1::ListAuthorizedDomainsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListAuthorizedDomainsResponse>> AsyncListAuthorizedDomains(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListAuthorizedDomainsResponse>>(AsyncListAuthorizedDomainsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListAuthorizedDomainsResponse>> PrepareAsyncListAuthorizedDomains(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListAuthorizedDomainsResponse>>(PrepareAsyncListAuthorizedDomainsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists all domains the user is authorized to administer.
      virtual void ListAuthorizedDomains(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest* request, ::google::appengine::v1::ListAuthorizedDomainsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAuthorizedDomains(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest* request, ::google::appengine::v1::ListAuthorizedDomainsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListAuthorizedDomainsResponse>* AsyncListAuthorizedDomainsRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListAuthorizedDomainsResponse>* PrepareAsyncListAuthorizedDomainsRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListAuthorizedDomains(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest& request, ::google::appengine::v1::ListAuthorizedDomainsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListAuthorizedDomainsResponse>> AsyncListAuthorizedDomains(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListAuthorizedDomainsResponse>>(AsyncListAuthorizedDomainsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListAuthorizedDomainsResponse>> PrepareAsyncListAuthorizedDomains(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListAuthorizedDomainsResponse>>(PrepareAsyncListAuthorizedDomainsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListAuthorizedDomains(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest* request, ::google::appengine::v1::ListAuthorizedDomainsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAuthorizedDomains(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest* request, ::google::appengine::v1::ListAuthorizedDomainsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListAuthorizedDomainsResponse>* AsyncListAuthorizedDomainsRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListAuthorizedDomainsResponse>* PrepareAsyncListAuthorizedDomainsRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListAuthorizedDomains_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists all domains the user is authorized to administer.
    virtual ::grpc::Status ListAuthorizedDomains(::grpc::ServerContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest* request, ::google::appengine::v1::ListAuthorizedDomainsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAuthorizedDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAuthorizedDomains() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListAuthorizedDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizedDomains(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedDomainsRequest* /*request*/, ::google::appengine::v1::ListAuthorizedDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAuthorizedDomains(::grpc::ServerContext* context, ::google::appengine::v1::ListAuthorizedDomainsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::ListAuthorizedDomainsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListAuthorizedDomains<Service > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListAuthorizedDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAuthorizedDomains() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListAuthorizedDomainsRequest, ::google::appengine::v1::ListAuthorizedDomainsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::ListAuthorizedDomainsRequest* request, ::google::appengine::v1::ListAuthorizedDomainsResponse* response) { return this->ListAuthorizedDomains(context, request, response); }));}
    void SetMessageAllocatorFor_ListAuthorizedDomains(
        ::grpc::MessageAllocator< ::google::appengine::v1::ListAuthorizedDomainsRequest, ::google::appengine::v1::ListAuthorizedDomainsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListAuthorizedDomainsRequest, ::google::appengine::v1::ListAuthorizedDomainsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAuthorizedDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizedDomains(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedDomainsRequest* /*request*/, ::google::appengine::v1::ListAuthorizedDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAuthorizedDomains(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedDomainsRequest* /*request*/, ::google::appengine::v1::ListAuthorizedDomainsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListAuthorizedDomains<Service > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListAuthorizedDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAuthorizedDomains() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListAuthorizedDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizedDomains(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedDomainsRequest* /*request*/, ::google::appengine::v1::ListAuthorizedDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAuthorizedDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAuthorizedDomains() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListAuthorizedDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizedDomains(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedDomainsRequest* /*request*/, ::google::appengine::v1::ListAuthorizedDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAuthorizedDomains(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAuthorizedDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAuthorizedDomains() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAuthorizedDomains(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAuthorizedDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizedDomains(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedDomainsRequest* /*request*/, ::google::appengine::v1::ListAuthorizedDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAuthorizedDomains(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAuthorizedDomains : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAuthorizedDomains() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::ListAuthorizedDomainsRequest, ::google::appengine::v1::ListAuthorizedDomainsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::ListAuthorizedDomainsRequest, ::google::appengine::v1::ListAuthorizedDomainsResponse>* streamer) {
                       return this->StreamedListAuthorizedDomains(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAuthorizedDomains() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAuthorizedDomains(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedDomainsRequest* /*request*/, ::google::appengine::v1::ListAuthorizedDomainsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAuthorizedDomains(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::ListAuthorizedDomainsRequest,::google::appengine::v1::ListAuthorizedDomainsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListAuthorizedDomains<Service > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListAuthorizedDomains<Service > StreamedService;
};

// Manages SSL certificates a user is authorized to administer. A user can
// administer any SSL certificates applicable to their authorized domains.
class AuthorizedCertificates final {
 public:
  static constexpr char const* service_full_name() {
    return "google.appengine.v1.AuthorizedCertificates";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists all SSL certificates the user is authorized to administer.
    virtual ::grpc::Status ListAuthorizedCertificates(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest& request, ::google::appengine::v1::ListAuthorizedCertificatesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListAuthorizedCertificatesResponse>> AsyncListAuthorizedCertificates(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListAuthorizedCertificatesResponse>>(AsyncListAuthorizedCertificatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListAuthorizedCertificatesResponse>> PrepareAsyncListAuthorizedCertificates(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListAuthorizedCertificatesResponse>>(PrepareAsyncListAuthorizedCertificatesRaw(context, request, cq));
    }
    // Gets the specified SSL certificate.
    virtual ::grpc::Status GetAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest& request, ::google::appengine::v1::AuthorizedCertificate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>> AsyncGetAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>>(AsyncGetAuthorizedCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>> PrepareAsyncGetAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>>(PrepareAsyncGetAuthorizedCertificateRaw(context, request, cq));
    }
    // Uploads the specified SSL certificate.
    virtual ::grpc::Status CreateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest& request, ::google::appengine::v1::AuthorizedCertificate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>> AsyncCreateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>>(AsyncCreateAuthorizedCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>> PrepareAsyncCreateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>>(PrepareAsyncCreateAuthorizedCertificateRaw(context, request, cq));
    }
    // Updates the specified SSL certificate. To renew a certificate and maintain
    // its existing domain mappings, update `certificate_data` with a new
    // certificate. The new certificate must be applicable to the same domains as
    // the original certificate. The certificate `display_name` may also be
    // updated.
    virtual ::grpc::Status UpdateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest& request, ::google::appengine::v1::AuthorizedCertificate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>> AsyncUpdateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>>(AsyncUpdateAuthorizedCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>> PrepareAsyncUpdateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>>(PrepareAsyncUpdateAuthorizedCertificateRaw(context, request, cq));
    }
    // Deletes the specified SSL certificate.
    virtual ::grpc::Status DeleteAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteAuthorizedCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteAuthorizedCertificateRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists all SSL certificates the user is authorized to administer.
      virtual void ListAuthorizedCertificates(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest* request, ::google::appengine::v1::ListAuthorizedCertificatesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAuthorizedCertificates(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest* request, ::google::appengine::v1::ListAuthorizedCertificatesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the specified SSL certificate.
      virtual void GetAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Uploads the specified SSL certificate.
      virtual void CreateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified SSL certificate. To renew a certificate and maintain
      // its existing domain mappings, update `certificate_data` with a new
      // certificate. The new certificate must be applicable to the same domains as
      // the original certificate. The certificate `display_name` may also be
      // updated.
      virtual void UpdateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified SSL certificate.
      virtual void DeleteAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListAuthorizedCertificatesResponse>* AsyncListAuthorizedCertificatesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListAuthorizedCertificatesResponse>* PrepareAsyncListAuthorizedCertificatesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>* AsyncGetAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>* PrepareAsyncGetAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>* AsyncCreateAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>* PrepareAsyncCreateAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>* AsyncUpdateAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::AuthorizedCertificate>* PrepareAsyncUpdateAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListAuthorizedCertificates(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest& request, ::google::appengine::v1::ListAuthorizedCertificatesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListAuthorizedCertificatesResponse>> AsyncListAuthorizedCertificates(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListAuthorizedCertificatesResponse>>(AsyncListAuthorizedCertificatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListAuthorizedCertificatesResponse>> PrepareAsyncListAuthorizedCertificates(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListAuthorizedCertificatesResponse>>(PrepareAsyncListAuthorizedCertificatesRaw(context, request, cq));
    }
    ::grpc::Status GetAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest& request, ::google::appengine::v1::AuthorizedCertificate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>> AsyncGetAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>>(AsyncGetAuthorizedCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>> PrepareAsyncGetAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>>(PrepareAsyncGetAuthorizedCertificateRaw(context, request, cq));
    }
    ::grpc::Status CreateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest& request, ::google::appengine::v1::AuthorizedCertificate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>> AsyncCreateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>>(AsyncCreateAuthorizedCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>> PrepareAsyncCreateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>>(PrepareAsyncCreateAuthorizedCertificateRaw(context, request, cq));
    }
    ::grpc::Status UpdateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest& request, ::google::appengine::v1::AuthorizedCertificate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>> AsyncUpdateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>>(AsyncUpdateAuthorizedCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>> PrepareAsyncUpdateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>>(PrepareAsyncUpdateAuthorizedCertificateRaw(context, request, cq));
    }
    ::grpc::Status DeleteAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteAuthorizedCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteAuthorizedCertificateRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListAuthorizedCertificates(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest* request, ::google::appengine::v1::ListAuthorizedCertificatesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAuthorizedCertificates(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest* request, ::google::appengine::v1::ListAuthorizedCertificatesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response, std::function<void(::grpc::Status)>) override;
      void GetAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response, std::function<void(::grpc::Status)>) override;
      void CreateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response, std::function<void(::grpc::Status)>) override;
      void UpdateAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteAuthorizedCertificate(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListAuthorizedCertificatesResponse>* AsyncListAuthorizedCertificatesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListAuthorizedCertificatesResponse>* PrepareAsyncListAuthorizedCertificatesRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>* AsyncGetAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>* PrepareAsyncGetAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>* AsyncCreateAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>* PrepareAsyncCreateAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>* AsyncUpdateAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::AuthorizedCertificate>* PrepareAsyncUpdateAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteAuthorizedCertificateRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListAuthorizedCertificates_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAuthorizedCertificate_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAuthorizedCertificate_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAuthorizedCertificate_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAuthorizedCertificate_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists all SSL certificates the user is authorized to administer.
    virtual ::grpc::Status ListAuthorizedCertificates(::grpc::ServerContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest* request, ::google::appengine::v1::ListAuthorizedCertificatesResponse* response);
    // Gets the specified SSL certificate.
    virtual ::grpc::Status GetAuthorizedCertificate(::grpc::ServerContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response);
    // Uploads the specified SSL certificate.
    virtual ::grpc::Status CreateAuthorizedCertificate(::grpc::ServerContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response);
    // Updates the specified SSL certificate. To renew a certificate and maintain
    // its existing domain mappings, update `certificate_data` with a new
    // certificate. The new certificate must be applicable to the same domains as
    // the original certificate. The certificate `display_name` may also be
    // updated.
    virtual ::grpc::Status UpdateAuthorizedCertificate(::grpc::ServerContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response);
    // Deletes the specified SSL certificate.
    virtual ::grpc::Status DeleteAuthorizedCertificate(::grpc::ServerContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest* request, ::google::protobuf::Empty* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAuthorizedCertificates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAuthorizedCertificates() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListAuthorizedCertificates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizedCertificates(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedCertificatesRequest* /*request*/, ::google::appengine::v1::ListAuthorizedCertificatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAuthorizedCertificates(::grpc::ServerContext* context, ::google::appengine::v1::ListAuthorizedCertificatesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::ListAuthorizedCertificatesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAuthorizedCertificate() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAuthorizedCertificate(::grpc::ServerContext* context, ::google::appengine::v1::GetAuthorizedCertificateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::AuthorizedCertificate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAuthorizedCertificate() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAuthorizedCertificate(::grpc::ServerContext* context, ::google::appengine::v1::CreateAuthorizedCertificateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::AuthorizedCertificate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAuthorizedCertificate() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAuthorizedCertificate(::grpc::ServerContext* context, ::google::appengine::v1::UpdateAuthorizedCertificateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::AuthorizedCertificate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAuthorizedCertificate() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAuthorizedCertificate(::grpc::ServerContext* context, ::google::appengine::v1::DeleteAuthorizedCertificateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListAuthorizedCertificates<WithAsyncMethod_GetAuthorizedCertificate<WithAsyncMethod_CreateAuthorizedCertificate<WithAsyncMethod_UpdateAuthorizedCertificate<WithAsyncMethod_DeleteAuthorizedCertificate<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListAuthorizedCertificates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAuthorizedCertificates() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListAuthorizedCertificatesRequest, ::google::appengine::v1::ListAuthorizedCertificatesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::ListAuthorizedCertificatesRequest* request, ::google::appengine::v1::ListAuthorizedCertificatesResponse* response) { return this->ListAuthorizedCertificates(context, request, response); }));}
    void SetMessageAllocatorFor_ListAuthorizedCertificates(
        ::grpc::MessageAllocator< ::google::appengine::v1::ListAuthorizedCertificatesRequest, ::google::appengine::v1::ListAuthorizedCertificatesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListAuthorizedCertificatesRequest, ::google::appengine::v1::ListAuthorizedCertificatesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAuthorizedCertificates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizedCertificates(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedCertificatesRequest* /*request*/, ::google::appengine::v1::ListAuthorizedCertificatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAuthorizedCertificates(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedCertificatesRequest* /*request*/, ::google::appengine::v1::ListAuthorizedCertificatesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAuthorizedCertificate() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::GetAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response) { return this->GetAuthorizedCertificate(context, request, response); }));}
    void SetMessageAllocatorFor_GetAuthorizedCertificate(
        ::grpc::MessageAllocator< ::google::appengine::v1::GetAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAuthorizedCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::GetAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAuthorizedCertificate() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::CreateAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::CreateAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response) { return this->CreateAuthorizedCertificate(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAuthorizedCertificate(
        ::grpc::MessageAllocator< ::google::appengine::v1::CreateAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::CreateAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAuthorizedCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::CreateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAuthorizedCertificate() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::UpdateAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest* request, ::google::appengine::v1::AuthorizedCertificate* response) { return this->UpdateAuthorizedCertificate(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAuthorizedCertificate(
        ::grpc::MessageAllocator< ::google::appengine::v1::UpdateAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::UpdateAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAuthorizedCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAuthorizedCertificate() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DeleteAuthorizedCertificateRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest* request, ::google::protobuf::Empty* response) { return this->DeleteAuthorizedCertificate(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAuthorizedCertificate(
        ::grpc::MessageAllocator< ::google::appengine::v1::DeleteAuthorizedCertificateRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DeleteAuthorizedCertificateRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAuthorizedCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListAuthorizedCertificates<WithCallbackMethod_GetAuthorizedCertificate<WithCallbackMethod_CreateAuthorizedCertificate<WithCallbackMethod_UpdateAuthorizedCertificate<WithCallbackMethod_DeleteAuthorizedCertificate<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListAuthorizedCertificates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAuthorizedCertificates() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListAuthorizedCertificates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizedCertificates(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedCertificatesRequest* /*request*/, ::google::appengine::v1::ListAuthorizedCertificatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAuthorizedCertificate() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAuthorizedCertificate() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAuthorizedCertificate() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAuthorizedCertificate() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAuthorizedCertificates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAuthorizedCertificates() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListAuthorizedCertificates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizedCertificates(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedCertificatesRequest* /*request*/, ::google::appengine::v1::ListAuthorizedCertificatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAuthorizedCertificates(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAuthorizedCertificate() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAuthorizedCertificate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAuthorizedCertificate() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAuthorizedCertificate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAuthorizedCertificate() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAuthorizedCertificate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAuthorizedCertificate() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAuthorizedCertificate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAuthorizedCertificates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAuthorizedCertificates() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAuthorizedCertificates(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAuthorizedCertificates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAuthorizedCertificates(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedCertificatesRequest* /*request*/, ::google::appengine::v1::ListAuthorizedCertificatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAuthorizedCertificates(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAuthorizedCertificate() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAuthorizedCertificate(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAuthorizedCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAuthorizedCertificate() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAuthorizedCertificate(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAuthorizedCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAuthorizedCertificate() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAuthorizedCertificate(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAuthorizedCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAuthorizedCertificate() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAuthorizedCertificate(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAuthorizedCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAuthorizedCertificates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAuthorizedCertificates() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::ListAuthorizedCertificatesRequest, ::google::appengine::v1::ListAuthorizedCertificatesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::ListAuthorizedCertificatesRequest, ::google::appengine::v1::ListAuthorizedCertificatesResponse>* streamer) {
                       return this->StreamedListAuthorizedCertificates(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAuthorizedCertificates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAuthorizedCertificates(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListAuthorizedCertificatesRequest* /*request*/, ::google::appengine::v1::ListAuthorizedCertificatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAuthorizedCertificates(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::ListAuthorizedCertificatesRequest,::google::appengine::v1::ListAuthorizedCertificatesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAuthorizedCertificate() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::GetAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::GetAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>* streamer) {
                       return this->StreamedGetAuthorizedCertificate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAuthorizedCertificate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::GetAuthorizedCertificateRequest,::google::appengine::v1::AuthorizedCertificate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAuthorizedCertificate() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::CreateAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::CreateAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>* streamer) {
                       return this->StreamedCreateAuthorizedCertificate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAuthorizedCertificate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::CreateAuthorizedCertificateRequest,::google::appengine::v1::AuthorizedCertificate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAuthorizedCertificate() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::UpdateAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::UpdateAuthorizedCertificateRequest, ::google::appengine::v1::AuthorizedCertificate>* streamer) {
                       return this->StreamedUpdateAuthorizedCertificate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateAuthorizedCertificateRequest* /*request*/, ::google::appengine::v1::AuthorizedCertificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAuthorizedCertificate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::UpdateAuthorizedCertificateRequest,::google::appengine::v1::AuthorizedCertificate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAuthorizedCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAuthorizedCertificate() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::DeleteAuthorizedCertificateRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::DeleteAuthorizedCertificateRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteAuthorizedCertificate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAuthorizedCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAuthorizedCertificate(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteAuthorizedCertificateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAuthorizedCertificate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::DeleteAuthorizedCertificateRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListAuthorizedCertificates<WithStreamedUnaryMethod_GetAuthorizedCertificate<WithStreamedUnaryMethod_CreateAuthorizedCertificate<WithStreamedUnaryMethod_UpdateAuthorizedCertificate<WithStreamedUnaryMethod_DeleteAuthorizedCertificate<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListAuthorizedCertificates<WithStreamedUnaryMethod_GetAuthorizedCertificate<WithStreamedUnaryMethod_CreateAuthorizedCertificate<WithStreamedUnaryMethod_UpdateAuthorizedCertificate<WithStreamedUnaryMethod_DeleteAuthorizedCertificate<Service > > > > > StreamedService;
};

// Manages domains serving an application.
class DomainMappings final {
 public:
  static constexpr char const* service_full_name() {
    return "google.appengine.v1.DomainMappings";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists the domain mappings on an application.
    virtual ::grpc::Status ListDomainMappings(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest& request, ::google::appengine::v1::ListDomainMappingsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListDomainMappingsResponse>> AsyncListDomainMappings(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListDomainMappingsResponse>>(AsyncListDomainMappingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListDomainMappingsResponse>> PrepareAsyncListDomainMappings(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListDomainMappingsResponse>>(PrepareAsyncListDomainMappingsRaw(context, request, cq));
    }
    // Gets the specified domain mapping.
    virtual ::grpc::Status GetDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest& request, ::google::appengine::v1::DomainMapping* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::DomainMapping>> AsyncGetDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::DomainMapping>>(AsyncGetDomainMappingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::DomainMapping>> PrepareAsyncGetDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::DomainMapping>>(PrepareAsyncGetDomainMappingRaw(context, request, cq));
    }
    // Maps a domain to an application. A user must be authorized to administer a
    // domain in order to map it to an application. For a list of available
    // authorized domains, see [`AuthorizedDomains.ListAuthorizedDomains`]().
    virtual ::grpc::Status CreateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateDomainMappingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateDomainMappingRaw(context, request, cq));
    }
    // Updates the specified domain mapping. To map an SSL certificate to a
    // domain mapping, update `certificate_id` to point to an `AuthorizedCertificate`
    // resource. A user must be authorized to administer the associated domain
    // in order to update a `DomainMapping` resource.
    virtual ::grpc::Status UpdateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateDomainMappingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateDomainMappingRaw(context, request, cq));
    }
    // Deletes the specified domain mapping. A user must be authorized to
    // administer the associated domain in order to delete a `DomainMapping`
    // resource.
    virtual ::grpc::Status DeleteDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteDomainMappingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteDomainMappingRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists the domain mappings on an application.
      virtual void ListDomainMappings(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest* request, ::google::appengine::v1::ListDomainMappingsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDomainMappings(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest* request, ::google::appengine::v1::ListDomainMappingsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the specified domain mapping.
      virtual void GetDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest* request, ::google::appengine::v1::DomainMapping* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest* request, ::google::appengine::v1::DomainMapping* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Maps a domain to an application. A user must be authorized to administer a
      // domain in order to map it to an application. For a list of available
      // authorized domains, see [`AuthorizedDomains.ListAuthorizedDomains`]().
      virtual void CreateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified domain mapping. To map an SSL certificate to a
      // domain mapping, update `certificate_id` to point to an `AuthorizedCertificate`
      // resource. A user must be authorized to administer the associated domain
      // in order to update a `DomainMapping` resource.
      virtual void UpdateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified domain mapping. A user must be authorized to
      // administer the associated domain in order to delete a `DomainMapping`
      // resource.
      virtual void DeleteDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListDomainMappingsResponse>* AsyncListDomainMappingsRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::ListDomainMappingsResponse>* PrepareAsyncListDomainMappingsRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::DomainMapping>* AsyncGetDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::appengine::v1::DomainMapping>* PrepareAsyncGetDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListDomainMappings(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest& request, ::google::appengine::v1::ListDomainMappingsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListDomainMappingsResponse>> AsyncListDomainMappings(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListDomainMappingsResponse>>(AsyncListDomainMappingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListDomainMappingsResponse>> PrepareAsyncListDomainMappings(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListDomainMappingsResponse>>(PrepareAsyncListDomainMappingsRaw(context, request, cq));
    }
    ::grpc::Status GetDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest& request, ::google::appengine::v1::DomainMapping* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::DomainMapping>> AsyncGetDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::DomainMapping>>(AsyncGetDomainMappingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::DomainMapping>> PrepareAsyncGetDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::DomainMapping>>(PrepareAsyncGetDomainMappingRaw(context, request, cq));
    }
    ::grpc::Status CreateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateDomainMappingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateDomainMappingRaw(context, request, cq));
    }
    ::grpc::Status UpdateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateDomainMappingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateDomainMappingRaw(context, request, cq));
    }
    ::grpc::Status DeleteDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteDomainMappingRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteDomainMappingRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListDomainMappings(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest* request, ::google::appengine::v1::ListDomainMappingsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDomainMappings(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest* request, ::google::appengine::v1::ListDomainMappingsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest* request, ::google::appengine::v1::DomainMapping* response, std::function<void(::grpc::Status)>) override;
      void GetDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest* request, ::google::appengine::v1::DomainMapping* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteDomainMapping(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListDomainMappingsResponse>* AsyncListDomainMappingsRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::ListDomainMappingsResponse>* PrepareAsyncListDomainMappingsRaw(::grpc::ClientContext* context, const ::google::appengine::v1::ListDomainMappingsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::DomainMapping>* AsyncGetDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::appengine::v1::DomainMapping>* PrepareAsyncGetDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::GetDomainMappingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::CreateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteDomainMappingRaw(::grpc::ClientContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListDomainMappings_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDomainMapping_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateDomainMapping_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateDomainMapping_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteDomainMapping_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists the domain mappings on an application.
    virtual ::grpc::Status ListDomainMappings(::grpc::ServerContext* context, const ::google::appengine::v1::ListDomainMappingsRequest* request, ::google::appengine::v1::ListDomainMappingsResponse* response);
    // Gets the specified domain mapping.
    virtual ::grpc::Status GetDomainMapping(::grpc::ServerContext* context, const ::google::appengine::v1::GetDomainMappingRequest* request, ::google::appengine::v1::DomainMapping* response);
    // Maps a domain to an application. A user must be authorized to administer a
    // domain in order to map it to an application. For a list of available
    // authorized domains, see [`AuthorizedDomains.ListAuthorizedDomains`]().
    virtual ::grpc::Status CreateDomainMapping(::grpc::ServerContext* context, const ::google::appengine::v1::CreateDomainMappingRequest* request, ::google::longrunning::Operation* response);
    // Updates the specified domain mapping. To map an SSL certificate to a
    // domain mapping, update `certificate_id` to point to an `AuthorizedCertificate`
    // resource. A user must be authorized to administer the associated domain
    // in order to update a `DomainMapping` resource.
    virtual ::grpc::Status UpdateDomainMapping(::grpc::ServerContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest* request, ::google::longrunning::Operation* response);
    // Deletes the specified domain mapping. A user must be authorized to
    // administer the associated domain in order to delete a `DomainMapping`
    // resource.
    virtual ::grpc::Status DeleteDomainMapping(::grpc::ServerContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDomainMappings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDomainMappings() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListDomainMappings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDomainMappings(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListDomainMappingsRequest* /*request*/, ::google::appengine::v1::ListDomainMappingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDomainMappings(::grpc::ServerContext* context, ::google::appengine::v1::ListDomainMappingsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::ListDomainMappingsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDomainMapping() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetDomainMappingRequest* /*request*/, ::google::appengine::v1::DomainMapping* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDomainMapping(::grpc::ServerContext* context, ::google::appengine::v1::GetDomainMappingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::appengine::v1::DomainMapping>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateDomainMapping() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDomainMapping(::grpc::ServerContext* context, ::google::appengine::v1::CreateDomainMappingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateDomainMapping() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDomainMapping(::grpc::ServerContext* context, ::google::appengine::v1::UpdateDomainMappingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteDomainMapping() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDomainMapping(::grpc::ServerContext* context, ::google::appengine::v1::DeleteDomainMappingRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListDomainMappings<WithAsyncMethod_GetDomainMapping<WithAsyncMethod_CreateDomainMapping<WithAsyncMethod_UpdateDomainMapping<WithAsyncMethod_DeleteDomainMapping<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListDomainMappings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDomainMappings() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListDomainMappingsRequest, ::google::appengine::v1::ListDomainMappingsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::ListDomainMappingsRequest* request, ::google::appengine::v1::ListDomainMappingsResponse* response) { return this->ListDomainMappings(context, request, response); }));}
    void SetMessageAllocatorFor_ListDomainMappings(
        ::grpc::MessageAllocator< ::google::appengine::v1::ListDomainMappingsRequest, ::google::appengine::v1::ListDomainMappingsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::ListDomainMappingsRequest, ::google::appengine::v1::ListDomainMappingsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDomainMappings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDomainMappings(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListDomainMappingsRequest* /*request*/, ::google::appengine::v1::ListDomainMappingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDomainMappings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::ListDomainMappingsRequest* /*request*/, ::google::appengine::v1::ListDomainMappingsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDomainMapping() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetDomainMappingRequest, ::google::appengine::v1::DomainMapping>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::GetDomainMappingRequest* request, ::google::appengine::v1::DomainMapping* response) { return this->GetDomainMapping(context, request, response); }));}
    void SetMessageAllocatorFor_GetDomainMapping(
        ::grpc::MessageAllocator< ::google::appengine::v1::GetDomainMappingRequest, ::google::appengine::v1::DomainMapping>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::GetDomainMappingRequest, ::google::appengine::v1::DomainMapping>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetDomainMappingRequest* /*request*/, ::google::appengine::v1::DomainMapping* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDomainMapping(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::GetDomainMappingRequest* /*request*/, ::google::appengine::v1::DomainMapping* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateDomainMapping() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::CreateDomainMappingRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::CreateDomainMappingRequest* request, ::google::longrunning::Operation* response) { return this->CreateDomainMapping(context, request, response); }));}
    void SetMessageAllocatorFor_CreateDomainMapping(
        ::grpc::MessageAllocator< ::google::appengine::v1::CreateDomainMappingRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::CreateDomainMappingRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDomainMapping(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::CreateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateDomainMapping() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::UpdateDomainMappingRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::UpdateDomainMappingRequest* request, ::google::longrunning::Operation* response) { return this->UpdateDomainMapping(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateDomainMapping(
        ::grpc::MessageAllocator< ::google::appengine::v1::UpdateDomainMappingRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::UpdateDomainMappingRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDomainMapping(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::UpdateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteDomainMapping() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DeleteDomainMappingRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::appengine::v1::DeleteDomainMappingRequest* request, ::google::longrunning::Operation* response) { return this->DeleteDomainMapping(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteDomainMapping(
        ::grpc::MessageAllocator< ::google::appengine::v1::DeleteDomainMappingRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::appengine::v1::DeleteDomainMappingRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDomainMapping(
      ::grpc::CallbackServerContext* /*context*/, const ::google::appengine::v1::DeleteDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListDomainMappings<WithCallbackMethod_GetDomainMapping<WithCallbackMethod_CreateDomainMapping<WithCallbackMethod_UpdateDomainMapping<WithCallbackMethod_DeleteDomainMapping<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListDomainMappings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDomainMappings() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListDomainMappings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDomainMappings(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListDomainMappingsRequest* /*request*/, ::google::appengine::v1::ListDomainMappingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDomainMapping() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetDomainMappingRequest* /*request*/, ::google::appengine::v1::DomainMapping* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateDomainMapping() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateDomainMapping() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteDomainMapping() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDomainMappings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDomainMappings() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListDomainMappings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDomainMappings(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListDomainMappingsRequest* /*request*/, ::google::appengine::v1::ListDomainMappingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDomainMappings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDomainMapping() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetDomainMappingRequest* /*request*/, ::google::appengine::v1::DomainMapping* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDomainMapping(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateDomainMapping() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDomainMapping(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateDomainMapping() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDomainMapping(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteDomainMapping() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDomainMapping(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDomainMappings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDomainMappings() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDomainMappings(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDomainMappings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDomainMappings(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListDomainMappingsRequest* /*request*/, ::google::appengine::v1::ListDomainMappingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDomainMappings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDomainMapping() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDomainMapping(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetDomainMappingRequest* /*request*/, ::google::appengine::v1::DomainMapping* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDomainMapping(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateDomainMapping() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateDomainMapping(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDomainMapping(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateDomainMapping() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateDomainMapping(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDomainMapping(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteDomainMapping() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteDomainMapping(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDomainMapping(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDomainMappings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDomainMappings() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::ListDomainMappingsRequest, ::google::appengine::v1::ListDomainMappingsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::ListDomainMappingsRequest, ::google::appengine::v1::ListDomainMappingsResponse>* streamer) {
                       return this->StreamedListDomainMappings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDomainMappings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDomainMappings(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::ListDomainMappingsRequest* /*request*/, ::google::appengine::v1::ListDomainMappingsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDomainMappings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::ListDomainMappingsRequest,::google::appengine::v1::ListDomainMappingsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDomainMapping() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::GetDomainMappingRequest, ::google::appengine::v1::DomainMapping>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::GetDomainMappingRequest, ::google::appengine::v1::DomainMapping>* streamer) {
                       return this->StreamedGetDomainMapping(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::GetDomainMappingRequest* /*request*/, ::google::appengine::v1::DomainMapping* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDomainMapping(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::GetDomainMappingRequest,::google::appengine::v1::DomainMapping>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateDomainMapping() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::CreateDomainMappingRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::CreateDomainMappingRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateDomainMapping(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::CreateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateDomainMapping(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::CreateDomainMappingRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateDomainMapping() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::UpdateDomainMappingRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::UpdateDomainMappingRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateDomainMapping(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::UpdateDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateDomainMapping(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::UpdateDomainMappingRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteDomainMapping : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteDomainMapping() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::appengine::v1::DeleteDomainMappingRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::appengine::v1::DeleteDomainMappingRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteDomainMapping(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteDomainMapping() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteDomainMapping(::grpc::ServerContext* /*context*/, const ::google::appengine::v1::DeleteDomainMappingRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteDomainMapping(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::appengine::v1::DeleteDomainMappingRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListDomainMappings<WithStreamedUnaryMethod_GetDomainMapping<WithStreamedUnaryMethod_CreateDomainMapping<WithStreamedUnaryMethod_UpdateDomainMapping<WithStreamedUnaryMethod_DeleteDomainMapping<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListDomainMappings<WithStreamedUnaryMethod_GetDomainMapping<WithStreamedUnaryMethod_CreateDomainMapping<WithStreamedUnaryMethod_UpdateDomainMapping<WithStreamedUnaryMethod_DeleteDomainMapping<Service > > > > > StreamedService;
};

}  // namespace v1
}  // namespace appengine
}  // namespace google


#endif  // GRPC_google_2fappengine_2fv1_2fappengine_2eproto__INCLUDED
