// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/certificatemanager/v1/certificate_manager.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fcertificatemanager_2fv1_2fcertificate_5fmanager_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fcertificatemanager_2fv1_2fcertificate_5fmanager_2eproto__INCLUDED

#include "google/cloud/certificatemanager/v1/certificate_manager.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace certificatemanager {
namespace v1 {

// API Overview
//
// Certificates Manager API allows customers to see and manage all their TLS
// certificates.
//
// Certificates Manager API service provides methods to manage certificates,
// group them into collections, and create serving configuration that can be
// easily applied to other Cloud resources e.g. Target Proxies.
//
// Data Model
//
// The Certificates Manager service exposes the following resources:
//
// * `Certificate` that describes a single TLS certificate.
// * `CertificateMap` that describes a collection of certificates that can be
// attached to a target resource.
// * `CertificateMapEntry` that describes a single configuration entry that
// consists of a SNI and a group of certificates. It's a subresource of
// CertificateMap.
//
// Certificate, CertificateMap and CertificateMapEntry IDs
// have to fully match the regexp `[a-z0-9-]{1,63}`. In other words,
// - only lower case letters, digits, and hyphen are allowed
// - length of the resource ID has to be in [1,63] range.
//
// Provides methods to manage Cloud Certificate Manager entities.
class CertificateManager final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.certificatemanager.v1.CertificateManager";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists Certificates in a given project and location.
    virtual ::grpc::Status ListCertificates(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest& request, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificatesResponse>> AsyncListCertificates(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificatesResponse>>(AsyncListCertificatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificatesResponse>> PrepareAsyncListCertificates(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificatesResponse>>(PrepareAsyncListCertificatesRaw(context, request, cq));
    }
    // Gets details of a single Certificate.
    virtual ::grpc::Status GetCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest& request, ::google::cloud::certificatemanager::v1::Certificate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::Certificate>> AsyncGetCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::Certificate>>(AsyncGetCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::Certificate>> PrepareAsyncGetCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::Certificate>>(PrepareAsyncGetCertificateRaw(context, request, cq));
    }
    // Creates a new Certificate in a given project and location.
    virtual ::grpc::Status CreateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateCertificateRaw(context, request, cq));
    }
    // Updates a Certificate.
    virtual ::grpc::Status UpdateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateCertificateRaw(context, request, cq));
    }
    // Deletes a single Certificate.
    virtual ::grpc::Status DeleteCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteCertificateRaw(context, request, cq));
    }
    // Lists CertificateMaps in a given project and location.
    virtual ::grpc::Status ListCertificateMaps(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest& request, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>> AsyncListCertificateMaps(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>>(AsyncListCertificateMapsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>> PrepareAsyncListCertificateMaps(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>>(PrepareAsyncListCertificateMapsRaw(context, request, cq));
    }
    // Gets details of a single CertificateMap.
    virtual ::grpc::Status GetCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest& request, ::google::cloud::certificatemanager::v1::CertificateMap* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateMap>> AsyncGetCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateMap>>(AsyncGetCertificateMapRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateMap>> PrepareAsyncGetCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateMap>>(PrepareAsyncGetCertificateMapRaw(context, request, cq));
    }
    // Creates a new CertificateMap in a given project and location.
    virtual ::grpc::Status CreateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateCertificateMapRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateCertificateMapRaw(context, request, cq));
    }
    // Updates a CertificateMap.
    virtual ::grpc::Status UpdateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateCertificateMapRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateCertificateMapRaw(context, request, cq));
    }
    // Deletes a single CertificateMap. A Certificate Map can't be deleted
    // if it contains Certificate Map Entries. Remove all the entries from
    // the map before calling this method.
    virtual ::grpc::Status DeleteCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteCertificateMapRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteCertificateMapRaw(context, request, cq));
    }
    // Lists CertificateMapEntries in a given project and location.
    virtual ::grpc::Status ListCertificateMapEntries(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest& request, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>> AsyncListCertificateMapEntries(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>>(AsyncListCertificateMapEntriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>> PrepareAsyncListCertificateMapEntries(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>>(PrepareAsyncListCertificateMapEntriesRaw(context, request, cq));
    }
    // Gets details of a single CertificateMapEntry.
    virtual ::grpc::Status GetCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest& request, ::google::cloud::certificatemanager::v1::CertificateMapEntry* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateMapEntry>> AsyncGetCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateMapEntry>>(AsyncGetCertificateMapEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateMapEntry>> PrepareAsyncGetCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateMapEntry>>(PrepareAsyncGetCertificateMapEntryRaw(context, request, cq));
    }
    // Creates a new CertificateMapEntry in a given project and location.
    virtual ::grpc::Status CreateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateCertificateMapEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateCertificateMapEntryRaw(context, request, cq));
    }
    // Updates a CertificateMapEntry.
    virtual ::grpc::Status UpdateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateCertificateMapEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateCertificateMapEntryRaw(context, request, cq));
    }
    // Deletes a single CertificateMapEntry.
    virtual ::grpc::Status DeleteCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteCertificateMapEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteCertificateMapEntryRaw(context, request, cq));
    }
    // Lists DnsAuthorizations in a given project and location.
    virtual ::grpc::Status ListDnsAuthorizations(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest& request, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>> AsyncListDnsAuthorizations(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>>(AsyncListDnsAuthorizationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>> PrepareAsyncListDnsAuthorizations(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>>(PrepareAsyncListDnsAuthorizationsRaw(context, request, cq));
    }
    // Gets details of a single DnsAuthorization.
    virtual ::grpc::Status GetDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest& request, ::google::cloud::certificatemanager::v1::DnsAuthorization* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::DnsAuthorization>> AsyncGetDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::DnsAuthorization>>(AsyncGetDnsAuthorizationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::DnsAuthorization>> PrepareAsyncGetDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::DnsAuthorization>>(PrepareAsyncGetDnsAuthorizationRaw(context, request, cq));
    }
    // Creates a new DnsAuthorization in a given project and location.
    virtual ::grpc::Status CreateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateDnsAuthorizationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateDnsAuthorizationRaw(context, request, cq));
    }
    // Updates a DnsAuthorization.
    virtual ::grpc::Status UpdateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateDnsAuthorizationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateDnsAuthorizationRaw(context, request, cq));
    }
    // Deletes a single DnsAuthorization.
    virtual ::grpc::Status DeleteDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteDnsAuthorizationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteDnsAuthorizationRaw(context, request, cq));
    }
    // Lists CertificateIssuanceConfigs in a given project and location.
    virtual ::grpc::Status ListCertificateIssuanceConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest& request, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>> AsyncListCertificateIssuanceConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>>(AsyncListCertificateIssuanceConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>> PrepareAsyncListCertificateIssuanceConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>>(PrepareAsyncListCertificateIssuanceConfigsRaw(context, request, cq));
    }
    // Gets details of a single CertificateIssuanceConfig.
    virtual ::grpc::Status GetCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest& request, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>> AsyncGetCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>>(AsyncGetCertificateIssuanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>> PrepareAsyncGetCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>>(PrepareAsyncGetCertificateIssuanceConfigRaw(context, request, cq));
    }
    // Creates a new CertificateIssuanceConfig in a given project and location.
    virtual ::grpc::Status CreateCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateCertificateIssuanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateCertificateIssuanceConfigRaw(context, request, cq));
    }
    // Deletes a single CertificateIssuanceConfig.
    virtual ::grpc::Status DeleteCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteCertificateIssuanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteCertificateIssuanceConfigRaw(context, request, cq));
    }
    // Lists TrustConfigs in a given project and location.
    virtual ::grpc::Status ListTrustConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest& request, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>> AsyncListTrustConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>>(AsyncListTrustConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>> PrepareAsyncListTrustConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>>(PrepareAsyncListTrustConfigsRaw(context, request, cq));
    }
    // Gets details of a single TrustConfig.
    virtual ::grpc::Status GetTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest& request, ::google::cloud::certificatemanager::v1::TrustConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::TrustConfig>> AsyncGetTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::TrustConfig>>(AsyncGetTrustConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::TrustConfig>> PrepareAsyncGetTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::TrustConfig>>(PrepareAsyncGetTrustConfigRaw(context, request, cq));
    }
    // Creates a new TrustConfig in a given project and location.
    virtual ::grpc::Status CreateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateTrustConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateTrustConfigRaw(context, request, cq));
    }
    // Updates a TrustConfig.
    virtual ::grpc::Status UpdateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateTrustConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateTrustConfigRaw(context, request, cq));
    }
    // Deletes a single TrustConfig.
    virtual ::grpc::Status DeleteTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteTrustConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteTrustConfigRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists Certificates in a given project and location.
      virtual void ListCertificates(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest* request, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCertificates(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest* request, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Certificate.
      virtual void GetCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest* request, ::google::cloud::certificatemanager::v1::Certificate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest* request, ::google::cloud::certificatemanager::v1::Certificate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Certificate in a given project and location.
      virtual void CreateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a Certificate.
      virtual void UpdateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single Certificate.
      virtual void DeleteCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists CertificateMaps in a given project and location.
      virtual void ListCertificateMaps(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCertificateMaps(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single CertificateMap.
      virtual void GetCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* request, ::google::cloud::certificatemanager::v1::CertificateMap* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* request, ::google::cloud::certificatemanager::v1::CertificateMap* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new CertificateMap in a given project and location.
      virtual void CreateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a CertificateMap.
      virtual void UpdateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single CertificateMap. A Certificate Map can't be deleted
      // if it contains Certificate Map Entries. Remove all the entries from
      // the map before calling this method.
      virtual void DeleteCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists CertificateMapEntries in a given project and location.
      virtual void ListCertificateMapEntries(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCertificateMapEntries(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single CertificateMapEntry.
      virtual void GetCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* request, ::google::cloud::certificatemanager::v1::CertificateMapEntry* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* request, ::google::cloud::certificatemanager::v1::CertificateMapEntry* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new CertificateMapEntry in a given project and location.
      virtual void CreateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a CertificateMapEntry.
      virtual void UpdateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single CertificateMapEntry.
      virtual void DeleteCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists DnsAuthorizations in a given project and location.
      virtual void ListDnsAuthorizations(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* request, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListDnsAuthorizations(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* request, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single DnsAuthorization.
      virtual void GetDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* request, ::google::cloud::certificatemanager::v1::DnsAuthorization* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* request, ::google::cloud::certificatemanager::v1::DnsAuthorization* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new DnsAuthorization in a given project and location.
      virtual void CreateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a DnsAuthorization.
      virtual void UpdateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single DnsAuthorization.
      virtual void DeleteDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists CertificateIssuanceConfigs in a given project and location.
      virtual void ListCertificateIssuanceConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCertificateIssuanceConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single CertificateIssuanceConfig.
      virtual void GetCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* request, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* request, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new CertificateIssuanceConfig in a given project and location.
      virtual void CreateCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single CertificateIssuanceConfig.
      virtual void DeleteCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists TrustConfigs in a given project and location.
      virtual void ListTrustConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* request, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTrustConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* request, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single TrustConfig.
      virtual void GetTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* request, ::google::cloud::certificatemanager::v1::TrustConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* request, ::google::cloud::certificatemanager::v1::TrustConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new TrustConfig in a given project and location.
      virtual void CreateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a TrustConfig.
      virtual void UpdateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single TrustConfig.
      virtual void DeleteTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificatesResponse>* AsyncListCertificatesRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificatesResponse>* PrepareAsyncListCertificatesRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::Certificate>* AsyncGetCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::Certificate>* PrepareAsyncGetCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>* AsyncListCertificateMapsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>* PrepareAsyncListCertificateMapsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateMap>* AsyncGetCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateMap>* PrepareAsyncGetCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>* AsyncListCertificateMapEntriesRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>* PrepareAsyncListCertificateMapEntriesRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateMapEntry>* AsyncGetCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateMapEntry>* PrepareAsyncGetCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>* AsyncListDnsAuthorizationsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>* PrepareAsyncListDnsAuthorizationsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::DnsAuthorization>* AsyncGetDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::DnsAuthorization>* PrepareAsyncGetDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>* AsyncListCertificateIssuanceConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>* PrepareAsyncListCertificateIssuanceConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>* AsyncGetCertificateIssuanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>* PrepareAsyncGetCertificateIssuanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateCertificateIssuanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateCertificateIssuanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteCertificateIssuanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteCertificateIssuanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>* AsyncListTrustConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>* PrepareAsyncListTrustConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::TrustConfig>* AsyncGetTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::certificatemanager::v1::TrustConfig>* PrepareAsyncGetTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListCertificates(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest& request, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificatesResponse>> AsyncListCertificates(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificatesResponse>>(AsyncListCertificatesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificatesResponse>> PrepareAsyncListCertificates(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificatesResponse>>(PrepareAsyncListCertificatesRaw(context, request, cq));
    }
    ::grpc::Status GetCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest& request, ::google::cloud::certificatemanager::v1::Certificate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::Certificate>> AsyncGetCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::Certificate>>(AsyncGetCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::Certificate>> PrepareAsyncGetCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::Certificate>>(PrepareAsyncGetCertificateRaw(context, request, cq));
    }
    ::grpc::Status CreateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateCertificateRaw(context, request, cq));
    }
    ::grpc::Status UpdateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateCertificateRaw(context, request, cq));
    }
    ::grpc::Status DeleteCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteCertificateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteCertificateRaw(context, request, cq));
    }
    ::grpc::Status ListCertificateMaps(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest& request, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>> AsyncListCertificateMaps(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>>(AsyncListCertificateMapsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>> PrepareAsyncListCertificateMaps(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>>(PrepareAsyncListCertificateMapsRaw(context, request, cq));
    }
    ::grpc::Status GetCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest& request, ::google::cloud::certificatemanager::v1::CertificateMap* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateMap>> AsyncGetCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateMap>>(AsyncGetCertificateMapRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateMap>> PrepareAsyncGetCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateMap>>(PrepareAsyncGetCertificateMapRaw(context, request, cq));
    }
    ::grpc::Status CreateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateCertificateMapRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateCertificateMapRaw(context, request, cq));
    }
    ::grpc::Status UpdateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateCertificateMapRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateCertificateMapRaw(context, request, cq));
    }
    ::grpc::Status DeleteCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteCertificateMapRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteCertificateMapRaw(context, request, cq));
    }
    ::grpc::Status ListCertificateMapEntries(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest& request, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>> AsyncListCertificateMapEntries(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>>(AsyncListCertificateMapEntriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>> PrepareAsyncListCertificateMapEntries(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>>(PrepareAsyncListCertificateMapEntriesRaw(context, request, cq));
    }
    ::grpc::Status GetCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest& request, ::google::cloud::certificatemanager::v1::CertificateMapEntry* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateMapEntry>> AsyncGetCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateMapEntry>>(AsyncGetCertificateMapEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateMapEntry>> PrepareAsyncGetCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateMapEntry>>(PrepareAsyncGetCertificateMapEntryRaw(context, request, cq));
    }
    ::grpc::Status CreateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateCertificateMapEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateCertificateMapEntryRaw(context, request, cq));
    }
    ::grpc::Status UpdateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateCertificateMapEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateCertificateMapEntryRaw(context, request, cq));
    }
    ::grpc::Status DeleteCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteCertificateMapEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteCertificateMapEntryRaw(context, request, cq));
    }
    ::grpc::Status ListDnsAuthorizations(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest& request, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>> AsyncListDnsAuthorizations(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>>(AsyncListDnsAuthorizationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>> PrepareAsyncListDnsAuthorizations(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>>(PrepareAsyncListDnsAuthorizationsRaw(context, request, cq));
    }
    ::grpc::Status GetDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest& request, ::google::cloud::certificatemanager::v1::DnsAuthorization* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::DnsAuthorization>> AsyncGetDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::DnsAuthorization>>(AsyncGetDnsAuthorizationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::DnsAuthorization>> PrepareAsyncGetDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::DnsAuthorization>>(PrepareAsyncGetDnsAuthorizationRaw(context, request, cq));
    }
    ::grpc::Status CreateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateDnsAuthorizationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateDnsAuthorizationRaw(context, request, cq));
    }
    ::grpc::Status UpdateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateDnsAuthorizationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateDnsAuthorizationRaw(context, request, cq));
    }
    ::grpc::Status DeleteDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteDnsAuthorizationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteDnsAuthorizationRaw(context, request, cq));
    }
    ::grpc::Status ListCertificateIssuanceConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest& request, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>> AsyncListCertificateIssuanceConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>>(AsyncListCertificateIssuanceConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>> PrepareAsyncListCertificateIssuanceConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>>(PrepareAsyncListCertificateIssuanceConfigsRaw(context, request, cq));
    }
    ::grpc::Status GetCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest& request, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>> AsyncGetCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>>(AsyncGetCertificateIssuanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>> PrepareAsyncGetCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>>(PrepareAsyncGetCertificateIssuanceConfigRaw(context, request, cq));
    }
    ::grpc::Status CreateCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateCertificateIssuanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateCertificateIssuanceConfigRaw(context, request, cq));
    }
    ::grpc::Status DeleteCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteCertificateIssuanceConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteCertificateIssuanceConfigRaw(context, request, cq));
    }
    ::grpc::Status ListTrustConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest& request, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>> AsyncListTrustConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>>(AsyncListTrustConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>> PrepareAsyncListTrustConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>>(PrepareAsyncListTrustConfigsRaw(context, request, cq));
    }
    ::grpc::Status GetTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest& request, ::google::cloud::certificatemanager::v1::TrustConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::TrustConfig>> AsyncGetTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::TrustConfig>>(AsyncGetTrustConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::TrustConfig>> PrepareAsyncGetTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::TrustConfig>>(PrepareAsyncGetTrustConfigRaw(context, request, cq));
    }
    ::grpc::Status CreateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateTrustConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateTrustConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateTrustConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateTrustConfigRaw(context, request, cq));
    }
    ::grpc::Status DeleteTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteTrustConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteTrustConfigRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListCertificates(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest* request, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCertificates(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest* request, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest* request, ::google::cloud::certificatemanager::v1::Certificate* response, std::function<void(::grpc::Status)>) override;
      void GetCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest* request, ::google::cloud::certificatemanager::v1::Certificate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteCertificate(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListCertificateMaps(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCertificateMaps(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* request, ::google::cloud::certificatemanager::v1::CertificateMap* response, std::function<void(::grpc::Status)>) override;
      void GetCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* request, ::google::cloud::certificatemanager::v1::CertificateMap* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteCertificateMap(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListCertificateMapEntries(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCertificateMapEntries(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* request, ::google::cloud::certificatemanager::v1::CertificateMapEntry* response, std::function<void(::grpc::Status)>) override;
      void GetCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* request, ::google::cloud::certificatemanager::v1::CertificateMapEntry* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteCertificateMapEntry(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListDnsAuthorizations(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* request, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListDnsAuthorizations(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* request, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* request, ::google::cloud::certificatemanager::v1::DnsAuthorization* response, std::function<void(::grpc::Status)>) override;
      void GetDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* request, ::google::cloud::certificatemanager::v1::DnsAuthorization* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteDnsAuthorization(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListCertificateIssuanceConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCertificateIssuanceConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* request, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* response, std::function<void(::grpc::Status)>) override;
      void GetCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* request, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteCertificateIssuanceConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTrustConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* request, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTrustConfigs(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* request, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* request, ::google::cloud::certificatemanager::v1::TrustConfig* response, std::function<void(::grpc::Status)>) override;
      void GetTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* request, ::google::cloud::certificatemanager::v1::TrustConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteTrustConfig(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificatesResponse>* AsyncListCertificatesRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificatesResponse>* PrepareAsyncListCertificatesRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::Certificate>* AsyncGetCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::Certificate>* PrepareAsyncGetCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteCertificateRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>* AsyncListCertificateMapsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>* PrepareAsyncListCertificateMapsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateMap>* AsyncGetCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateMap>* PrepareAsyncGetCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteCertificateMapRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>* AsyncListCertificateMapEntriesRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>* PrepareAsyncListCertificateMapEntriesRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateMapEntry>* AsyncGetCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateMapEntry>* PrepareAsyncGetCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteCertificateMapEntryRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>* AsyncListDnsAuthorizationsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>* PrepareAsyncListDnsAuthorizationsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::DnsAuthorization>* AsyncGetDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::DnsAuthorization>* PrepareAsyncGetDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteDnsAuthorizationRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>* AsyncListCertificateIssuanceConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>* PrepareAsyncListCertificateIssuanceConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>* AsyncGetCertificateIssuanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>* PrepareAsyncGetCertificateIssuanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateCertificateIssuanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateCertificateIssuanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteCertificateIssuanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteCertificateIssuanceConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>* AsyncListTrustConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>* PrepareAsyncListTrustConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::TrustConfig>* AsyncGetTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::certificatemanager::v1::TrustConfig>* PrepareAsyncGetTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteTrustConfigRaw(::grpc::ClientContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListCertificates_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCertificate_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCertificate_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCertificate_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCertificate_;
    const ::grpc::internal::RpcMethod rpcmethod_ListCertificateMaps_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCertificateMap_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCertificateMap_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCertificateMap_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCertificateMap_;
    const ::grpc::internal::RpcMethod rpcmethod_ListCertificateMapEntries_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCertificateMapEntry_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCertificateMapEntry_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCertificateMapEntry_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCertificateMapEntry_;
    const ::grpc::internal::RpcMethod rpcmethod_ListDnsAuthorizations_;
    const ::grpc::internal::RpcMethod rpcmethod_GetDnsAuthorization_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateDnsAuthorization_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateDnsAuthorization_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteDnsAuthorization_;
    const ::grpc::internal::RpcMethod rpcmethod_ListCertificateIssuanceConfigs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCertificateIssuanceConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCertificateIssuanceConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCertificateIssuanceConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTrustConfigs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTrustConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTrustConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateTrustConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTrustConfig_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists Certificates in a given project and location.
    virtual ::grpc::Status ListCertificates(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest* request, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* response);
    // Gets details of a single Certificate.
    virtual ::grpc::Status GetCertificate(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest* request, ::google::cloud::certificatemanager::v1::Certificate* response);
    // Creates a new Certificate in a given project and location.
    virtual ::grpc::Status CreateCertificate(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest* request, ::google::longrunning::Operation* response);
    // Updates a Certificate.
    virtual ::grpc::Status UpdateCertificate(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single Certificate.
    virtual ::grpc::Status DeleteCertificate(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* request, ::google::longrunning::Operation* response);
    // Lists CertificateMaps in a given project and location.
    virtual ::grpc::Status ListCertificateMaps(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* response);
    // Gets details of a single CertificateMap.
    virtual ::grpc::Status GetCertificateMap(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* request, ::google::cloud::certificatemanager::v1::CertificateMap* response);
    // Creates a new CertificateMap in a given project and location.
    virtual ::grpc::Status CreateCertificateMap(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* request, ::google::longrunning::Operation* response);
    // Updates a CertificateMap.
    virtual ::grpc::Status UpdateCertificateMap(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single CertificateMap. A Certificate Map can't be deleted
    // if it contains Certificate Map Entries. Remove all the entries from
    // the map before calling this method.
    virtual ::grpc::Status DeleteCertificateMap(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* request, ::google::longrunning::Operation* response);
    // Lists CertificateMapEntries in a given project and location.
    virtual ::grpc::Status ListCertificateMapEntries(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* response);
    // Gets details of a single CertificateMapEntry.
    virtual ::grpc::Status GetCertificateMapEntry(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* request, ::google::cloud::certificatemanager::v1::CertificateMapEntry* response);
    // Creates a new CertificateMapEntry in a given project and location.
    virtual ::grpc::Status CreateCertificateMapEntry(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* request, ::google::longrunning::Operation* response);
    // Updates a CertificateMapEntry.
    virtual ::grpc::Status UpdateCertificateMapEntry(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single CertificateMapEntry.
    virtual ::grpc::Status DeleteCertificateMapEntry(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* request, ::google::longrunning::Operation* response);
    // Lists DnsAuthorizations in a given project and location.
    virtual ::grpc::Status ListDnsAuthorizations(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* request, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* response);
    // Gets details of a single DnsAuthorization.
    virtual ::grpc::Status GetDnsAuthorization(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* request, ::google::cloud::certificatemanager::v1::DnsAuthorization* response);
    // Creates a new DnsAuthorization in a given project and location.
    virtual ::grpc::Status CreateDnsAuthorization(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* request, ::google::longrunning::Operation* response);
    // Updates a DnsAuthorization.
    virtual ::grpc::Status UpdateDnsAuthorization(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single DnsAuthorization.
    virtual ::grpc::Status DeleteDnsAuthorization(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* request, ::google::longrunning::Operation* response);
    // Lists CertificateIssuanceConfigs in a given project and location.
    virtual ::grpc::Status ListCertificateIssuanceConfigs(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* response);
    // Gets details of a single CertificateIssuanceConfig.
    virtual ::grpc::Status GetCertificateIssuanceConfig(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* request, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* response);
    // Creates a new CertificateIssuanceConfig in a given project and location.
    virtual ::grpc::Status CreateCertificateIssuanceConfig(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single CertificateIssuanceConfig.
    virtual ::grpc::Status DeleteCertificateIssuanceConfig(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* request, ::google::longrunning::Operation* response);
    // Lists TrustConfigs in a given project and location.
    virtual ::grpc::Status ListTrustConfigs(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* request, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* response);
    // Gets details of a single TrustConfig.
    virtual ::grpc::Status GetTrustConfig(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* request, ::google::cloud::certificatemanager::v1::TrustConfig* response);
    // Creates a new TrustConfig in a given project and location.
    virtual ::grpc::Status CreateTrustConfig(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* request, ::google::longrunning::Operation* response);
    // Updates a TrustConfig.
    virtual ::grpc::Status UpdateTrustConfig(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single TrustConfig.
    virtual ::grpc::Status DeleteTrustConfig(::grpc::ServerContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCertificates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCertificates() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListCertificates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificates(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCertificates(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::ListCertificatesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::certificatemanager::v1::ListCertificatesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCertificate() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateRequest* /*request*/, ::google::cloud::certificatemanager::v1::Certificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCertificate(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::GetCertificateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::certificatemanager::v1::Certificate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCertificate() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCertificate(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::CreateCertificateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCertificate() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCertificate(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCertificate() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCertificate(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCertificateMaps : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCertificateMaps() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListCertificateMaps() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateMaps(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCertificateMaps(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCertificateMap() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMap* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCertificateMap(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::certificatemanager::v1::CertificateMap>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCertificateMap() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_CreateCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCertificateMap(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCertificateMap() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_UpdateCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCertificateMap(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCertificateMap() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_DeleteCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCertificateMap(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCertificateMapEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCertificateMapEntries() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_ListCertificateMapEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateMapEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCertificateMapEntries(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCertificateMapEntry() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_GetCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMapEntry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCertificateMapEntry(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::certificatemanager::v1::CertificateMapEntry>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCertificateMapEntry() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_CreateCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCertificateMapEntry(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCertificateMapEntry() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_UpdateCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCertificateMapEntry(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCertificateMapEntry() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_DeleteCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCertificateMapEntry(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListDnsAuthorizations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListDnsAuthorizations() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_ListDnsAuthorizations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDnsAuthorizations(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDnsAuthorizations(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetDnsAuthorization() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_GetDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* /*request*/, ::google::cloud::certificatemanager::v1::DnsAuthorization* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDnsAuthorization(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::certificatemanager::v1::DnsAuthorization>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateDnsAuthorization() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_CreateDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDnsAuthorization(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateDnsAuthorization() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_UpdateDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDnsAuthorization(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteDnsAuthorization() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_DeleteDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDnsAuthorization(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCertificateIssuanceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCertificateIssuanceConfigs() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_ListCertificateIssuanceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateIssuanceConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCertificateIssuanceConfigs(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_GetCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCertificateIssuanceConfig(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_CreateCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCertificateIssuanceConfig(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_DeleteCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCertificateIssuanceConfig(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTrustConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTrustConfigs() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_ListTrustConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrustConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTrustConfigs(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTrustConfig() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_GetTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::TrustConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTrustConfig(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::certificatemanager::v1::TrustConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTrustConfig() {
      ::grpc::Service::MarkMethodAsync(26);
    }
    ~WithAsyncMethod_CreateTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTrustConfig(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateTrustConfig() {
      ::grpc::Service::MarkMethodAsync(27);
    }
    ~WithAsyncMethod_UpdateTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTrustConfig(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTrustConfig() {
      ::grpc::Service::MarkMethodAsync(28);
    }
    ~WithAsyncMethod_DeleteTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTrustConfig(::grpc::ServerContext* context, ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListCertificates<WithAsyncMethod_GetCertificate<WithAsyncMethod_CreateCertificate<WithAsyncMethod_UpdateCertificate<WithAsyncMethod_DeleteCertificate<WithAsyncMethod_ListCertificateMaps<WithAsyncMethod_GetCertificateMap<WithAsyncMethod_CreateCertificateMap<WithAsyncMethod_UpdateCertificateMap<WithAsyncMethod_DeleteCertificateMap<WithAsyncMethod_ListCertificateMapEntries<WithAsyncMethod_GetCertificateMapEntry<WithAsyncMethod_CreateCertificateMapEntry<WithAsyncMethod_UpdateCertificateMapEntry<WithAsyncMethod_DeleteCertificateMapEntry<WithAsyncMethod_ListDnsAuthorizations<WithAsyncMethod_GetDnsAuthorization<WithAsyncMethod_CreateDnsAuthorization<WithAsyncMethod_UpdateDnsAuthorization<WithAsyncMethod_DeleteDnsAuthorization<WithAsyncMethod_ListCertificateIssuanceConfigs<WithAsyncMethod_GetCertificateIssuanceConfig<WithAsyncMethod_CreateCertificateIssuanceConfig<WithAsyncMethod_DeleteCertificateIssuanceConfig<WithAsyncMethod_ListTrustConfigs<WithAsyncMethod_GetTrustConfig<WithAsyncMethod_CreateTrustConfig<WithAsyncMethod_UpdateTrustConfig<WithAsyncMethod_DeleteTrustConfig<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListCertificates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCertificates() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::ListCertificatesRequest, ::google::cloud::certificatemanager::v1::ListCertificatesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest* request, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* response) { return this->ListCertificates(context, request, response); }));}
    void SetMessageAllocatorFor_ListCertificates(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::ListCertificatesRequest, ::google::cloud::certificatemanager::v1::ListCertificatesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::ListCertificatesRequest, ::google::cloud::certificatemanager::v1::ListCertificatesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCertificates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificates(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCertificates(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCertificate() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::GetCertificateRequest, ::google::cloud::certificatemanager::v1::Certificate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateRequest* request, ::google::cloud::certificatemanager::v1::Certificate* response) { return this->GetCertificate(context, request, response); }));}
    void SetMessageAllocatorFor_GetCertificate(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::GetCertificateRequest, ::google::cloud::certificatemanager::v1::Certificate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::GetCertificateRequest, ::google::cloud::certificatemanager::v1::Certificate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateRequest* /*request*/, ::google::cloud::certificatemanager::v1::Certificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateRequest* /*request*/, ::google::cloud::certificatemanager::v1::Certificate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCertificate() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::CreateCertificateRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest* request, ::google::longrunning::Operation* response) { return this->CreateCertificate(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCertificate(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::CreateCertificateRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::CreateCertificateRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCertificate() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::UpdateCertificateRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* request, ::google::longrunning::Operation* response) { return this->UpdateCertificate(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCertificate(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::UpdateCertificateRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::UpdateCertificateRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCertificate() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::DeleteCertificateRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* request, ::google::longrunning::Operation* response) { return this->DeleteCertificate(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCertificate(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::DeleteCertificateRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::DeleteCertificateRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListCertificateMaps : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCertificateMaps() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* response) { return this->ListCertificateMaps(context, request, response); }));}
    void SetMessageAllocatorFor_ListCertificateMaps(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCertificateMaps() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateMaps(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCertificateMaps(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCertificateMap() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::GetCertificateMapRequest, ::google::cloud::certificatemanager::v1::CertificateMap>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* request, ::google::cloud::certificatemanager::v1::CertificateMap* response) { return this->GetCertificateMap(context, request, response); }));}
    void SetMessageAllocatorFor_GetCertificateMap(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::GetCertificateMapRequest, ::google::cloud::certificatemanager::v1::CertificateMap>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::GetCertificateMapRequest, ::google::cloud::certificatemanager::v1::CertificateMap>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMap* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCertificateMap(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMap* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCertificateMap() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* request, ::google::longrunning::Operation* response) { return this->CreateCertificateMap(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCertificateMap(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCertificateMap(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCertificateMap() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* request, ::google::longrunning::Operation* response) { return this->UpdateCertificateMap(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCertificateMap(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCertificateMap(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCertificateMap() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* request, ::google::longrunning::Operation* response) { return this->DeleteCertificateMap(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCertificateMap(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCertificateMap(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListCertificateMapEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCertificateMapEntries() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* response) { return this->ListCertificateMapEntries(context, request, response); }));}
    void SetMessageAllocatorFor_ListCertificateMapEntries(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCertificateMapEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateMapEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCertificateMapEntries(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCertificateMapEntry() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest, ::google::cloud::certificatemanager::v1::CertificateMapEntry>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* request, ::google::cloud::certificatemanager::v1::CertificateMapEntry* response) { return this->GetCertificateMapEntry(context, request, response); }));}
    void SetMessageAllocatorFor_GetCertificateMapEntry(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest, ::google::cloud::certificatemanager::v1::CertificateMapEntry>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest, ::google::cloud::certificatemanager::v1::CertificateMapEntry>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMapEntry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCertificateMapEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMapEntry* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCertificateMapEntry() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* request, ::google::longrunning::Operation* response) { return this->CreateCertificateMapEntry(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCertificateMapEntry(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCertificateMapEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCertificateMapEntry() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* request, ::google::longrunning::Operation* response) { return this->UpdateCertificateMapEntry(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCertificateMapEntry(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCertificateMapEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCertificateMapEntry() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* request, ::google::longrunning::Operation* response) { return this->DeleteCertificateMapEntry(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCertificateMapEntry(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCertificateMapEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListDnsAuthorizations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListDnsAuthorizations() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* request, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* response) { return this->ListDnsAuthorizations(context, request, response); }));}
    void SetMessageAllocatorFor_ListDnsAuthorizations(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListDnsAuthorizations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDnsAuthorizations(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDnsAuthorizations(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetDnsAuthorization() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest, ::google::cloud::certificatemanager::v1::DnsAuthorization>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* request, ::google::cloud::certificatemanager::v1::DnsAuthorization* response) { return this->GetDnsAuthorization(context, request, response); }));}
    void SetMessageAllocatorFor_GetDnsAuthorization(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest, ::google::cloud::certificatemanager::v1::DnsAuthorization>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest, ::google::cloud::certificatemanager::v1::DnsAuthorization>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* /*request*/, ::google::cloud::certificatemanager::v1::DnsAuthorization* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDnsAuthorization(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* /*request*/, ::google::cloud::certificatemanager::v1::DnsAuthorization* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateDnsAuthorization() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* request, ::google::longrunning::Operation* response) { return this->CreateDnsAuthorization(context, request, response); }));}
    void SetMessageAllocatorFor_CreateDnsAuthorization(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDnsAuthorization(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateDnsAuthorization() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* request, ::google::longrunning::Operation* response) { return this->UpdateDnsAuthorization(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateDnsAuthorization(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDnsAuthorization(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteDnsAuthorization() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* request, ::google::longrunning::Operation* response) { return this->DeleteDnsAuthorization(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteDnsAuthorization(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDnsAuthorization(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListCertificateIssuanceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCertificateIssuanceConfigs() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* request, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* response) { return this->ListCertificateIssuanceConfigs(context, request, response); }));}
    void SetMessageAllocatorFor_ListCertificateIssuanceConfigs(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCertificateIssuanceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateIssuanceConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCertificateIssuanceConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* request, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* response) { return this->GetCertificateIssuanceConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetCertificateIssuanceConfig(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCertificateIssuanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* request, ::google::longrunning::Operation* response) { return this->CreateCertificateIssuanceConfig(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCertificateIssuanceConfig(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCertificateIssuanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* request, ::google::longrunning::Operation* response) { return this->DeleteCertificateIssuanceConfig(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCertificateIssuanceConfig(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCertificateIssuanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTrustConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTrustConfigs() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* request, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* response) { return this->ListTrustConfigs(context, request, response); }));}
    void SetMessageAllocatorFor_ListTrustConfigs(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTrustConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrustConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTrustConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTrustConfig() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::GetTrustConfigRequest, ::google::cloud::certificatemanager::v1::TrustConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* request, ::google::cloud::certificatemanager::v1::TrustConfig* response) { return this->GetTrustConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetTrustConfig(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::GetTrustConfigRequest, ::google::cloud::certificatemanager::v1::TrustConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::GetTrustConfigRequest, ::google::cloud::certificatemanager::v1::TrustConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::TrustConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTrustConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::TrustConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTrustConfig() {
      ::grpc::Service::MarkMethodCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* request, ::google::longrunning::Operation* response) { return this->CreateTrustConfig(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTrustConfig(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(26);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTrustConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateTrustConfig() {
      ::grpc::Service::MarkMethodCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* request, ::google::longrunning::Operation* response) { return this->UpdateTrustConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateTrustConfig(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(27);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTrustConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTrustConfig() {
      ::grpc::Service::MarkMethodCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* request, ::google::longrunning::Operation* response) { return this->DeleteTrustConfig(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTrustConfig(
        ::grpc::MessageAllocator< ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(28);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTrustConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListCertificates<WithCallbackMethod_GetCertificate<WithCallbackMethod_CreateCertificate<WithCallbackMethod_UpdateCertificate<WithCallbackMethod_DeleteCertificate<WithCallbackMethod_ListCertificateMaps<WithCallbackMethod_GetCertificateMap<WithCallbackMethod_CreateCertificateMap<WithCallbackMethod_UpdateCertificateMap<WithCallbackMethod_DeleteCertificateMap<WithCallbackMethod_ListCertificateMapEntries<WithCallbackMethod_GetCertificateMapEntry<WithCallbackMethod_CreateCertificateMapEntry<WithCallbackMethod_UpdateCertificateMapEntry<WithCallbackMethod_DeleteCertificateMapEntry<WithCallbackMethod_ListDnsAuthorizations<WithCallbackMethod_GetDnsAuthorization<WithCallbackMethod_CreateDnsAuthorization<WithCallbackMethod_UpdateDnsAuthorization<WithCallbackMethod_DeleteDnsAuthorization<WithCallbackMethod_ListCertificateIssuanceConfigs<WithCallbackMethod_GetCertificateIssuanceConfig<WithCallbackMethod_CreateCertificateIssuanceConfig<WithCallbackMethod_DeleteCertificateIssuanceConfig<WithCallbackMethod_ListTrustConfigs<WithCallbackMethod_GetTrustConfig<WithCallbackMethod_CreateTrustConfig<WithCallbackMethod_UpdateTrustConfig<WithCallbackMethod_DeleteTrustConfig<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListCertificates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCertificates() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListCertificates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificates(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCertificate() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateRequest* /*request*/, ::google::cloud::certificatemanager::v1::Certificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCertificate() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCertificate() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCertificate() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListCertificateMaps : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCertificateMaps() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListCertificateMaps() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateMaps(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCertificateMap() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMap* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCertificateMap() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_CreateCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCertificateMap() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_UpdateCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCertificateMap() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_DeleteCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListCertificateMapEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCertificateMapEntries() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_ListCertificateMapEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateMapEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCertificateMapEntry() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_GetCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMapEntry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCertificateMapEntry() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_CreateCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCertificateMapEntry() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_UpdateCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCertificateMapEntry() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_DeleteCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListDnsAuthorizations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListDnsAuthorizations() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_ListDnsAuthorizations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDnsAuthorizations(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetDnsAuthorization() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_GetDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* /*request*/, ::google::cloud::certificatemanager::v1::DnsAuthorization* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateDnsAuthorization() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_CreateDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateDnsAuthorization() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_UpdateDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteDnsAuthorization() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_DeleteDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListCertificateIssuanceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCertificateIssuanceConfigs() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_ListCertificateIssuanceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateIssuanceConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_GetCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_CreateCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_DeleteCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTrustConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTrustConfigs() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_ListTrustConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrustConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTrustConfig() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_GetTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::TrustConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTrustConfig() {
      ::grpc::Service::MarkMethodGeneric(26);
    }
    ~WithGenericMethod_CreateTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateTrustConfig() {
      ::grpc::Service::MarkMethodGeneric(27);
    }
    ~WithGenericMethod_UpdateTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTrustConfig() {
      ::grpc::Service::MarkMethodGeneric(28);
    }
    ~WithGenericMethod_DeleteTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCertificates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCertificates() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListCertificates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificates(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCertificates(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCertificate() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateRequest* /*request*/, ::google::cloud::certificatemanager::v1::Certificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCertificate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCertificate() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCertificate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCertificate() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCertificate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCertificate() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCertificate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCertificateMaps : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCertificateMaps() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListCertificateMaps() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateMaps(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCertificateMaps(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCertificateMap() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMap* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCertificateMap(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCertificateMap() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_CreateCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCertificateMap(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCertificateMap() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_UpdateCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCertificateMap(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCertificateMap() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_DeleteCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCertificateMap(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCertificateMapEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCertificateMapEntries() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_ListCertificateMapEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateMapEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCertificateMapEntries(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCertificateMapEntry() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_GetCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMapEntry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCertificateMapEntry(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCertificateMapEntry() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_CreateCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCertificateMapEntry(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCertificateMapEntry() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_UpdateCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCertificateMapEntry(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCertificateMapEntry() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_DeleteCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCertificateMapEntry(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListDnsAuthorizations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListDnsAuthorizations() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_ListDnsAuthorizations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDnsAuthorizations(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListDnsAuthorizations(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetDnsAuthorization() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_GetDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* /*request*/, ::google::cloud::certificatemanager::v1::DnsAuthorization* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetDnsAuthorization(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateDnsAuthorization() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_CreateDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateDnsAuthorization(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateDnsAuthorization() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_UpdateDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateDnsAuthorization(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteDnsAuthorization() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_DeleteDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteDnsAuthorization(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCertificateIssuanceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCertificateIssuanceConfigs() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_ListCertificateIssuanceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateIssuanceConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCertificateIssuanceConfigs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_GetCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCertificateIssuanceConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_CreateCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCertificateIssuanceConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_DeleteCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCertificateIssuanceConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTrustConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTrustConfigs() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_ListTrustConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrustConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTrustConfigs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTrustConfig() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_GetTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::TrustConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTrustConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTrustConfig() {
      ::grpc::Service::MarkMethodRaw(26);
    }
    ~WithRawMethod_CreateTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTrustConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateTrustConfig() {
      ::grpc::Service::MarkMethodRaw(27);
    }
    ~WithRawMethod_UpdateTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTrustConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTrustConfig() {
      ::grpc::Service::MarkMethodRaw(28);
    }
    ~WithRawMethod_DeleteTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTrustConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCertificates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCertificates() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCertificates(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCertificates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificates(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCertificates(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCertificate() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCertificate(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateRequest* /*request*/, ::google::cloud::certificatemanager::v1::Certificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCertificate() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCertificate(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCertificate() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCertificate(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCertificate() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCertificate(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCertificate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCertificateMaps : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCertificateMaps() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCertificateMaps(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCertificateMaps() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateMaps(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCertificateMaps(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCertificateMap() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCertificateMap(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMap* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCertificateMap(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCertificateMap() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCertificateMap(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCertificateMap(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCertificateMap() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCertificateMap(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCertificateMap(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCertificateMap() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCertificateMap(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCertificateMap(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCertificateMapEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCertificateMapEntries() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCertificateMapEntries(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCertificateMapEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateMapEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCertificateMapEntries(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCertificateMapEntry() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCertificateMapEntry(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMapEntry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCertificateMapEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCertificateMapEntry() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCertificateMapEntry(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCertificateMapEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCertificateMapEntry() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCertificateMapEntry(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCertificateMapEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCertificateMapEntry() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCertificateMapEntry(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCertificateMapEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListDnsAuthorizations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListDnsAuthorizations() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListDnsAuthorizations(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListDnsAuthorizations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListDnsAuthorizations(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListDnsAuthorizations(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetDnsAuthorization() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetDnsAuthorization(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* /*request*/, ::google::cloud::certificatemanager::v1::DnsAuthorization* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetDnsAuthorization(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateDnsAuthorization() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateDnsAuthorization(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateDnsAuthorization(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateDnsAuthorization() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateDnsAuthorization(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateDnsAuthorization(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteDnsAuthorization() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteDnsAuthorization(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteDnsAuthorization(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCertificateIssuanceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCertificateIssuanceConfigs() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCertificateIssuanceConfigs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCertificateIssuanceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCertificateIssuanceConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCertificateIssuanceConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCertificateIssuanceConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCertificateIssuanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCertificateIssuanceConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCertificateIssuanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCertificateIssuanceConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCertificateIssuanceConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTrustConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTrustConfigs() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTrustConfigs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTrustConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrustConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTrustConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTrustConfig() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTrustConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::TrustConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTrustConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTrustConfig() {
      ::grpc::Service::MarkMethodRawCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTrustConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTrustConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateTrustConfig() {
      ::grpc::Service::MarkMethodRawCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateTrustConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTrustConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTrustConfig() {
      ::grpc::Service::MarkMethodRawCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTrustConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTrustConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCertificates : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCertificates() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::ListCertificatesRequest, ::google::cloud::certificatemanager::v1::ListCertificatesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::ListCertificatesRequest, ::google::cloud::certificatemanager::v1::ListCertificatesResponse>* streamer) {
                       return this->StreamedListCertificates(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCertificates() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCertificates(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificatesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificatesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCertificates(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::ListCertificatesRequest,::google::cloud::certificatemanager::v1::ListCertificatesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCertificate() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::GetCertificateRequest, ::google::cloud::certificatemanager::v1::Certificate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::GetCertificateRequest, ::google::cloud::certificatemanager::v1::Certificate>* streamer) {
                       return this->StreamedGetCertificate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateRequest* /*request*/, ::google::cloud::certificatemanager::v1::Certificate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCertificate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::GetCertificateRequest,::google::cloud::certificatemanager::v1::Certificate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCertificate() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::CreateCertificateRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::CreateCertificateRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateCertificate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCertificate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::CreateCertificateRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCertificate() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::UpdateCertificateRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::UpdateCertificateRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateCertificate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCertificate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::UpdateCertificateRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCertificate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCertificate() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::DeleteCertificateRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::DeleteCertificateRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteCertificate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCertificate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCertificate(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCertificate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::DeleteCertificateRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCertificateMaps : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCertificateMaps() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>* streamer) {
                       return this->StreamedListCertificateMaps(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCertificateMaps() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCertificateMaps(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCertificateMaps(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::ListCertificateMapsRequest,::google::cloud::certificatemanager::v1::ListCertificateMapsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCertificateMap() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::GetCertificateMapRequest, ::google::cloud::certificatemanager::v1::CertificateMap>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::GetCertificateMapRequest, ::google::cloud::certificatemanager::v1::CertificateMap>* streamer) {
                       return this->StreamedGetCertificateMap(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMap* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCertificateMap(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::GetCertificateMapRequest,::google::cloud::certificatemanager::v1::CertificateMap>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCertificateMap() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateCertificateMap(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCertificateMap(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::CreateCertificateMapRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCertificateMap() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateCertificateMap(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCertificateMap(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::UpdateCertificateMapRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCertificateMap : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCertificateMap() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteCertificateMap(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCertificateMap() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCertificateMap(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCertificateMap(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::DeleteCertificateMapRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCertificateMapEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCertificateMapEntries() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>* streamer) {
                       return this->StreamedListCertificateMapEntries(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCertificateMapEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCertificateMapEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCertificateMapEntries(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::ListCertificateMapEntriesRequest,::google::cloud::certificatemanager::v1::ListCertificateMapEntriesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCertificateMapEntry() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest, ::google::cloud::certificatemanager::v1::CertificateMapEntry>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest, ::google::cloud::certificatemanager::v1::CertificateMapEntry>* streamer) {
                       return this->StreamedGetCertificateMapEntry(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateMapEntry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCertificateMapEntry(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::GetCertificateMapEntryRequest,::google::cloud::certificatemanager::v1::CertificateMapEntry>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCertificateMapEntry() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateCertificateMapEntry(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCertificateMapEntry(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::CreateCertificateMapEntryRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCertificateMapEntry() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateCertificateMapEntry(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCertificateMapEntry(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::UpdateCertificateMapEntryRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCertificateMapEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCertificateMapEntry() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteCertificateMapEntry(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCertificateMapEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCertificateMapEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCertificateMapEntry(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::DeleteCertificateMapEntryRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListDnsAuthorizations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListDnsAuthorizations() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>* streamer) {
                       return this->StreamedListDnsAuthorizations(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListDnsAuthorizations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListDnsAuthorizations(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListDnsAuthorizations(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::ListDnsAuthorizationsRequest,::google::cloud::certificatemanager::v1::ListDnsAuthorizationsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetDnsAuthorization() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest, ::google::cloud::certificatemanager::v1::DnsAuthorization>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest, ::google::cloud::certificatemanager::v1::DnsAuthorization>* streamer) {
                       return this->StreamedGetDnsAuthorization(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest* /*request*/, ::google::cloud::certificatemanager::v1::DnsAuthorization* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetDnsAuthorization(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::GetDnsAuthorizationRequest,::google::cloud::certificatemanager::v1::DnsAuthorization>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateDnsAuthorization() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateDnsAuthorization(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateDnsAuthorization(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::CreateDnsAuthorizationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateDnsAuthorization() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateDnsAuthorization(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateDnsAuthorization(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::UpdateDnsAuthorizationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteDnsAuthorization : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteDnsAuthorization() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteDnsAuthorization(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteDnsAuthorization() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteDnsAuthorization(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteDnsAuthorization(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::DeleteDnsAuthorizationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCertificateIssuanceConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCertificateIssuanceConfigs() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>* streamer) {
                       return this->StreamedListCertificateIssuanceConfigs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCertificateIssuanceConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCertificateIssuanceConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCertificateIssuanceConfigs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsRequest,::google::cloud::certificatemanager::v1::ListCertificateIssuanceConfigsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>* streamer) {
                       return this->StreamedGetCertificateIssuanceConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::CertificateIssuanceConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCertificateIssuanceConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::GetCertificateIssuanceConfigRequest,::google::cloud::certificatemanager::v1::CertificateIssuanceConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateCertificateIssuanceConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCertificateIssuanceConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::CreateCertificateIssuanceConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCertificateIssuanceConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCertificateIssuanceConfig() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteCertificateIssuanceConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCertificateIssuanceConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCertificateIssuanceConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCertificateIssuanceConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::DeleteCertificateIssuanceConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTrustConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTrustConfigs() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>* streamer) {
                       return this->StreamedListTrustConfigs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTrustConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTrustConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest* /*request*/, ::google::cloud::certificatemanager::v1::ListTrustConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTrustConfigs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::ListTrustConfigsRequest,::google::cloud::certificatemanager::v1::ListTrustConfigsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTrustConfig() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::GetTrustConfigRequest, ::google::cloud::certificatemanager::v1::TrustConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::GetTrustConfigRequest, ::google::cloud::certificatemanager::v1::TrustConfig>* streamer) {
                       return this->StreamedGetTrustConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::GetTrustConfigRequest* /*request*/, ::google::cloud::certificatemanager::v1::TrustConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTrustConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::GetTrustConfigRequest,::google::cloud::certificatemanager::v1::TrustConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTrustConfig() {
      ::grpc::Service::MarkMethodStreamed(26,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateTrustConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTrustConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::CreateTrustConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateTrustConfig() {
      ::grpc::Service::MarkMethodStreamed(27,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateTrustConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateTrustConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::UpdateTrustConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTrustConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTrustConfig() {
      ::grpc::Service::MarkMethodStreamed(28,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteTrustConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTrustConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTrustConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTrustConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::certificatemanager::v1::DeleteTrustConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListCertificates<WithStreamedUnaryMethod_GetCertificate<WithStreamedUnaryMethod_CreateCertificate<WithStreamedUnaryMethod_UpdateCertificate<WithStreamedUnaryMethod_DeleteCertificate<WithStreamedUnaryMethod_ListCertificateMaps<WithStreamedUnaryMethod_GetCertificateMap<WithStreamedUnaryMethod_CreateCertificateMap<WithStreamedUnaryMethod_UpdateCertificateMap<WithStreamedUnaryMethod_DeleteCertificateMap<WithStreamedUnaryMethod_ListCertificateMapEntries<WithStreamedUnaryMethod_GetCertificateMapEntry<WithStreamedUnaryMethod_CreateCertificateMapEntry<WithStreamedUnaryMethod_UpdateCertificateMapEntry<WithStreamedUnaryMethod_DeleteCertificateMapEntry<WithStreamedUnaryMethod_ListDnsAuthorizations<WithStreamedUnaryMethod_GetDnsAuthorization<WithStreamedUnaryMethod_CreateDnsAuthorization<WithStreamedUnaryMethod_UpdateDnsAuthorization<WithStreamedUnaryMethod_DeleteDnsAuthorization<WithStreamedUnaryMethod_ListCertificateIssuanceConfigs<WithStreamedUnaryMethod_GetCertificateIssuanceConfig<WithStreamedUnaryMethod_CreateCertificateIssuanceConfig<WithStreamedUnaryMethod_DeleteCertificateIssuanceConfig<WithStreamedUnaryMethod_ListTrustConfigs<WithStreamedUnaryMethod_GetTrustConfig<WithStreamedUnaryMethod_CreateTrustConfig<WithStreamedUnaryMethod_UpdateTrustConfig<WithStreamedUnaryMethod_DeleteTrustConfig<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListCertificates<WithStreamedUnaryMethod_GetCertificate<WithStreamedUnaryMethod_CreateCertificate<WithStreamedUnaryMethod_UpdateCertificate<WithStreamedUnaryMethod_DeleteCertificate<WithStreamedUnaryMethod_ListCertificateMaps<WithStreamedUnaryMethod_GetCertificateMap<WithStreamedUnaryMethod_CreateCertificateMap<WithStreamedUnaryMethod_UpdateCertificateMap<WithStreamedUnaryMethod_DeleteCertificateMap<WithStreamedUnaryMethod_ListCertificateMapEntries<WithStreamedUnaryMethod_GetCertificateMapEntry<WithStreamedUnaryMethod_CreateCertificateMapEntry<WithStreamedUnaryMethod_UpdateCertificateMapEntry<WithStreamedUnaryMethod_DeleteCertificateMapEntry<WithStreamedUnaryMethod_ListDnsAuthorizations<WithStreamedUnaryMethod_GetDnsAuthorization<WithStreamedUnaryMethod_CreateDnsAuthorization<WithStreamedUnaryMethod_UpdateDnsAuthorization<WithStreamedUnaryMethod_DeleteDnsAuthorization<WithStreamedUnaryMethod_ListCertificateIssuanceConfigs<WithStreamedUnaryMethod_GetCertificateIssuanceConfig<WithStreamedUnaryMethod_CreateCertificateIssuanceConfig<WithStreamedUnaryMethod_DeleteCertificateIssuanceConfig<WithStreamedUnaryMethod_ListTrustConfigs<WithStreamedUnaryMethod_GetTrustConfig<WithStreamedUnaryMethod_CreateTrustConfig<WithStreamedUnaryMethod_UpdateTrustConfig<WithStreamedUnaryMethod_DeleteTrustConfig<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace certificatemanager
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fcertificatemanager_2fv1_2fcertificate_5fmanager_2eproto__INCLUDED
