// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/gkemulticloud/v1/azure_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fgkemulticloud_2fv1_2fazure_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fgkemulticloud_2fv1_2fazure_5fservice_2eproto__INCLUDED

#include "google/cloud/gkemulticloud/v1/azure_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace gkemulticloud {
namespace v1 {

// The AzureClusters API provides a single centrally managed service
// to create and manage Anthos clusters that run on Azure infrastructure.
class AzureClusters final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.gkemulticloud.v1.AzureClusters";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a new [AzureClient][google.cloud.gkemulticloud.v1.AzureClient]
    // resource on a given Google Cloud project and region.
    //
    // `AzureClient` resources hold client authentication
    // information needed by the Anthos Multicloud API to manage Azure resources
    // on your Azure subscription on your behalf.
    //
    // If successful, the response contains a newly created
    // [Operation][google.longrunning.Operation] resource that can be
    // described to track the status of the operation.
    virtual ::grpc::Status CreateAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateAzureClientRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateAzureClientRaw(context, request, cq));
    }
    // Describes a specific
    // [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] resource.
    virtual ::grpc::Status GetAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest& request, ::google::cloud::gkemulticloud::v1::AzureClient* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureClient>> AsyncGetAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureClient>>(AsyncGetAzureClientRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureClient>> PrepareAsyncGetAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureClient>>(PrepareAsyncGetAzureClientRaw(context, request, cq));
    }
    // Lists all [AzureClient][google.cloud.gkemulticloud.v1.AzureClient]
    // resources on a given Google Cloud project and region.
    virtual ::grpc::Status ListAzureClients(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest& request, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>> AsyncListAzureClients(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>>(AsyncListAzureClientsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>> PrepareAsyncListAzureClients(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>>(PrepareAsyncListAzureClientsRaw(context, request, cq));
    }
    // Deletes a specific [AzureClient][google.cloud.gkemulticloud.v1.AzureClient]
    // resource.
    //
    // If the client is used by one or more clusters, deletion will
    // fail and a `FAILED_PRECONDITION` error will be returned.
    //
    // If successful, the response contains a newly created
    // [Operation][google.longrunning.Operation] resource that can be
    // described to track the status of the operation.
    virtual ::grpc::Status DeleteAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteAzureClientRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteAzureClientRaw(context, request, cq));
    }
    // Creates a new [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster]
    // resource on a given Google Cloud Platform project and region.
    //
    // If successful, the response contains a newly created
    // [Operation][google.longrunning.Operation] resource that can be
    // described to track the status of the operation.
    virtual ::grpc::Status CreateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateAzureClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateAzureClusterRaw(context, request, cq));
    }
    // Updates an [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster].
    virtual ::grpc::Status UpdateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateAzureClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateAzureClusterRaw(context, request, cq));
    }
    // Describes a specific
    // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster] resource.
    virtual ::grpc::Status GetAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest& request, ::google::cloud::gkemulticloud::v1::AzureCluster* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureCluster>> AsyncGetAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureCluster>>(AsyncGetAzureClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureCluster>> PrepareAsyncGetAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureCluster>>(PrepareAsyncGetAzureClusterRaw(context, request, cq));
    }
    // Lists all [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster]
    // resources on a given Google Cloud project and region.
    virtual ::grpc::Status ListAzureClusters(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest& request, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>> AsyncListAzureClusters(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>>(AsyncListAzureClustersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>> PrepareAsyncListAzureClusters(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>>(PrepareAsyncListAzureClustersRaw(context, request, cq));
    }
    // Deletes a specific
    // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster] resource.
    //
    // Fails if the cluster has one or more associated
    // [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool] resources.
    //
    // If successful, the response contains a newly created
    // [Operation][google.longrunning.Operation] resource that can be
    // described to track the status of the operation.
    virtual ::grpc::Status DeleteAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteAzureClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteAzureClusterRaw(context, request, cq));
    }
    // Generates an access token for a cluster agent.
    virtual ::grpc::Status GenerateAzureClusterAgentToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest& request, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>> AsyncGenerateAzureClusterAgentToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>>(AsyncGenerateAzureClusterAgentTokenRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>> PrepareAsyncGenerateAzureClusterAgentToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>>(PrepareAsyncGenerateAzureClusterAgentTokenRaw(context, request, cq));
    }
    // Generates a short-lived access token to authenticate to a given
    // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster] resource.
    virtual ::grpc::Status GenerateAzureAccessToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest& request, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>> AsyncGenerateAzureAccessToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>>(AsyncGenerateAzureAccessTokenRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>> PrepareAsyncGenerateAzureAccessToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>>(PrepareAsyncGenerateAzureAccessTokenRaw(context, request, cq));
    }
    // Creates a new [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool],
    // attached to a given
    // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster].
    //
    // If successful, the response contains a newly created
    // [Operation][google.longrunning.Operation] resource that can be
    // described to track the status of the operation.
    virtual ::grpc::Status CreateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateAzureNodePoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateAzureNodePoolRaw(context, request, cq));
    }
    // Updates an [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool].
    virtual ::grpc::Status UpdateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateAzureNodePoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateAzureNodePoolRaw(context, request, cq));
    }
    // Describes a specific
    // [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool] resource.
    virtual ::grpc::Status GetAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest& request, ::google::cloud::gkemulticloud::v1::AzureNodePool* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureNodePool>> AsyncGetAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureNodePool>>(AsyncGetAzureNodePoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureNodePool>> PrepareAsyncGetAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureNodePool>>(PrepareAsyncGetAzureNodePoolRaw(context, request, cq));
    }
    // Lists all [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool]
    // resources on a given
    // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster].
    virtual ::grpc::Status ListAzureNodePools(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest& request, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>> AsyncListAzureNodePools(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>>(AsyncListAzureNodePoolsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>> PrepareAsyncListAzureNodePools(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>>(PrepareAsyncListAzureNodePoolsRaw(context, request, cq));
    }
    // Deletes a specific
    // [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool] resource.
    //
    // If successful, the response contains a newly created
    // [Operation][google.longrunning.Operation] resource that can be
    // described to track the status of the operation.
    virtual ::grpc::Status DeleteAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteAzureNodePoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteAzureNodePoolRaw(context, request, cq));
    }
    // Gets the OIDC discovery document for the cluster.
    // See the
    // [OpenID Connect Discovery 1.0
    // specification](https://openid.net/specs/openid-connect-discovery-1_0.html)
    // for details.
    virtual ::grpc::Status GetAzureOpenIdConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest& request, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>> AsyncGetAzureOpenIdConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>>(AsyncGetAzureOpenIdConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>> PrepareAsyncGetAzureOpenIdConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>>(PrepareAsyncGetAzureOpenIdConfigRaw(context, request, cq));
    }
    // Gets the public component of the cluster signing keys in
    // JSON Web Key format.
    virtual ::grpc::Status GetAzureJsonWebKeys(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest& request, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>> AsyncGetAzureJsonWebKeys(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>>(AsyncGetAzureJsonWebKeysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>> PrepareAsyncGetAzureJsonWebKeys(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>>(PrepareAsyncGetAzureJsonWebKeysRaw(context, request, cq));
    }
    // Returns information, such as supported Azure regions and Kubernetes
    // versions, on a given Google Cloud location.
    virtual ::grpc::Status GetAzureServerConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest& request, ::google::cloud::gkemulticloud::v1::AzureServerConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureServerConfig>> AsyncGetAzureServerConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureServerConfig>>(AsyncGetAzureServerConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureServerConfig>> PrepareAsyncGetAzureServerConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureServerConfig>>(PrepareAsyncGetAzureServerConfigRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a new [AzureClient][google.cloud.gkemulticloud.v1.AzureClient]
      // resource on a given Google Cloud project and region.
      //
      // `AzureClient` resources hold client authentication
      // information needed by the Anthos Multicloud API to manage Azure resources
      // on your Azure subscription on your behalf.
      //
      // If successful, the response contains a newly created
      // [Operation][google.longrunning.Operation] resource that can be
      // described to track the status of the operation.
      virtual void CreateAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Describes a specific
      // [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] resource.
      virtual void GetAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* request, ::google::cloud::gkemulticloud::v1::AzureClient* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* request, ::google::cloud::gkemulticloud::v1::AzureClient* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all [AzureClient][google.cloud.gkemulticloud.v1.AzureClient]
      // resources on a given Google Cloud project and region.
      virtual void ListAzureClients(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAzureClients(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a specific [AzureClient][google.cloud.gkemulticloud.v1.AzureClient]
      // resource.
      //
      // If the client is used by one or more clusters, deletion will
      // fail and a `FAILED_PRECONDITION` error will be returned.
      //
      // If successful, the response contains a newly created
      // [Operation][google.longrunning.Operation] resource that can be
      // described to track the status of the operation.
      virtual void DeleteAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster]
      // resource on a given Google Cloud Platform project and region.
      //
      // If successful, the response contains a newly created
      // [Operation][google.longrunning.Operation] resource that can be
      // described to track the status of the operation.
      virtual void CreateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster].
      virtual void UpdateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Describes a specific
      // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster] resource.
      virtual void GetAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* request, ::google::cloud::gkemulticloud::v1::AzureCluster* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* request, ::google::cloud::gkemulticloud::v1::AzureCluster* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster]
      // resources on a given Google Cloud project and region.
      virtual void ListAzureClusters(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAzureClusters(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a specific
      // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster] resource.
      //
      // Fails if the cluster has one or more associated
      // [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool] resources.
      //
      // If successful, the response contains a newly created
      // [Operation][google.longrunning.Operation] resource that can be
      // described to track the status of the operation.
      virtual void DeleteAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Generates an access token for a cluster agent.
      virtual void GenerateAzureClusterAgentToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* request, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GenerateAzureClusterAgentToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* request, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Generates a short-lived access token to authenticate to a given
      // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster] resource.
      virtual void GenerateAzureAccessToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* request, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GenerateAzureAccessToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* request, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool],
      // attached to a given
      // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster].
      //
      // If successful, the response contains a newly created
      // [Operation][google.longrunning.Operation] resource that can be
      // described to track the status of the operation.
      virtual void CreateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool].
      virtual void UpdateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Describes a specific
      // [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool] resource.
      virtual void GetAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* request, ::google::cloud::gkemulticloud::v1::AzureNodePool* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* request, ::google::cloud::gkemulticloud::v1::AzureNodePool* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool]
      // resources on a given
      // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster].
      virtual void ListAzureNodePools(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAzureNodePools(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a specific
      // [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool] resource.
      //
      // If successful, the response contains a newly created
      // [Operation][google.longrunning.Operation] resource that can be
      // described to track the status of the operation.
      virtual void DeleteAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the OIDC discovery document for the cluster.
      // See the
      // [OpenID Connect Discovery 1.0
      // specification](https://openid.net/specs/openid-connect-discovery-1_0.html)
      // for details.
      virtual void GetAzureOpenIdConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* request, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAzureOpenIdConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* request, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the public component of the cluster signing keys in
      // JSON Web Key format.
      virtual void GetAzureJsonWebKeys(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* request, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAzureJsonWebKeys(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* request, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns information, such as supported Azure regions and Kubernetes
      // versions, on a given Google Cloud location.
      virtual void GetAzureServerConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* request, ::google::cloud::gkemulticloud::v1::AzureServerConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAzureServerConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* request, ::google::cloud::gkemulticloud::v1::AzureServerConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateAzureClientRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateAzureClientRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureClient>* AsyncGetAzureClientRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureClient>* PrepareAsyncGetAzureClientRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>* AsyncListAzureClientsRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>* PrepareAsyncListAzureClientsRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteAzureClientRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteAzureClientRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureCluster>* AsyncGetAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureCluster>* PrepareAsyncGetAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>* AsyncListAzureClustersRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>* PrepareAsyncListAzureClustersRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>* AsyncGenerateAzureClusterAgentTokenRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>* PrepareAsyncGenerateAzureClusterAgentTokenRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>* AsyncGenerateAzureAccessTokenRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>* PrepareAsyncGenerateAzureAccessTokenRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureNodePool>* AsyncGetAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureNodePool>* PrepareAsyncGetAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>* AsyncListAzureNodePoolsRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>* PrepareAsyncListAzureNodePoolsRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>* AsyncGetAzureOpenIdConfigRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>* PrepareAsyncGetAzureOpenIdConfigRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>* AsyncGetAzureJsonWebKeysRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>* PrepareAsyncGetAzureJsonWebKeysRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureServerConfig>* AsyncGetAzureServerConfigRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkemulticloud::v1::AzureServerConfig>* PrepareAsyncGetAzureServerConfigRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateAzureClientRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateAzureClientRaw(context, request, cq));
    }
    ::grpc::Status GetAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest& request, ::google::cloud::gkemulticloud::v1::AzureClient* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureClient>> AsyncGetAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureClient>>(AsyncGetAzureClientRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureClient>> PrepareAsyncGetAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureClient>>(PrepareAsyncGetAzureClientRaw(context, request, cq));
    }
    ::grpc::Status ListAzureClients(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest& request, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>> AsyncListAzureClients(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>>(AsyncListAzureClientsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>> PrepareAsyncListAzureClients(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>>(PrepareAsyncListAzureClientsRaw(context, request, cq));
    }
    ::grpc::Status DeleteAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteAzureClientRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteAzureClientRaw(context, request, cq));
    }
    ::grpc::Status CreateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateAzureClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateAzureClusterRaw(context, request, cq));
    }
    ::grpc::Status UpdateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateAzureClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateAzureClusterRaw(context, request, cq));
    }
    ::grpc::Status GetAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest& request, ::google::cloud::gkemulticloud::v1::AzureCluster* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureCluster>> AsyncGetAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureCluster>>(AsyncGetAzureClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureCluster>> PrepareAsyncGetAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureCluster>>(PrepareAsyncGetAzureClusterRaw(context, request, cq));
    }
    ::grpc::Status ListAzureClusters(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest& request, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>> AsyncListAzureClusters(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>>(AsyncListAzureClustersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>> PrepareAsyncListAzureClusters(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>>(PrepareAsyncListAzureClustersRaw(context, request, cq));
    }
    ::grpc::Status DeleteAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteAzureClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteAzureClusterRaw(context, request, cq));
    }
    ::grpc::Status GenerateAzureClusterAgentToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest& request, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>> AsyncGenerateAzureClusterAgentToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>>(AsyncGenerateAzureClusterAgentTokenRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>> PrepareAsyncGenerateAzureClusterAgentToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>>(PrepareAsyncGenerateAzureClusterAgentTokenRaw(context, request, cq));
    }
    ::grpc::Status GenerateAzureAccessToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest& request, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>> AsyncGenerateAzureAccessToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>>(AsyncGenerateAzureAccessTokenRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>> PrepareAsyncGenerateAzureAccessToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>>(PrepareAsyncGenerateAzureAccessTokenRaw(context, request, cq));
    }
    ::grpc::Status CreateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateAzureNodePoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateAzureNodePoolRaw(context, request, cq));
    }
    ::grpc::Status UpdateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateAzureNodePoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateAzureNodePoolRaw(context, request, cq));
    }
    ::grpc::Status GetAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest& request, ::google::cloud::gkemulticloud::v1::AzureNodePool* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureNodePool>> AsyncGetAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureNodePool>>(AsyncGetAzureNodePoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureNodePool>> PrepareAsyncGetAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureNodePool>>(PrepareAsyncGetAzureNodePoolRaw(context, request, cq));
    }
    ::grpc::Status ListAzureNodePools(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest& request, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>> AsyncListAzureNodePools(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>>(AsyncListAzureNodePoolsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>> PrepareAsyncListAzureNodePools(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>>(PrepareAsyncListAzureNodePoolsRaw(context, request, cq));
    }
    ::grpc::Status DeleteAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteAzureNodePoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteAzureNodePoolRaw(context, request, cq));
    }
    ::grpc::Status GetAzureOpenIdConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest& request, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>> AsyncGetAzureOpenIdConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>>(AsyncGetAzureOpenIdConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>> PrepareAsyncGetAzureOpenIdConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>>(PrepareAsyncGetAzureOpenIdConfigRaw(context, request, cq));
    }
    ::grpc::Status GetAzureJsonWebKeys(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest& request, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>> AsyncGetAzureJsonWebKeys(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>>(AsyncGetAzureJsonWebKeysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>> PrepareAsyncGetAzureJsonWebKeys(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>>(PrepareAsyncGetAzureJsonWebKeysRaw(context, request, cq));
    }
    ::grpc::Status GetAzureServerConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest& request, ::google::cloud::gkemulticloud::v1::AzureServerConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureServerConfig>> AsyncGetAzureServerConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureServerConfig>>(AsyncGetAzureServerConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureServerConfig>> PrepareAsyncGetAzureServerConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureServerConfig>>(PrepareAsyncGetAzureServerConfigRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* request, ::google::cloud::gkemulticloud::v1::AzureClient* response, std::function<void(::grpc::Status)>) override;
      void GetAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* request, ::google::cloud::gkemulticloud::v1::AzureClient* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAzureClients(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAzureClients(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteAzureClient(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* request, ::google::cloud::gkemulticloud::v1::AzureCluster* response, std::function<void(::grpc::Status)>) override;
      void GetAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* request, ::google::cloud::gkemulticloud::v1::AzureCluster* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAzureClusters(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAzureClusters(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteAzureCluster(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GenerateAzureClusterAgentToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* request, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* response, std::function<void(::grpc::Status)>) override;
      void GenerateAzureClusterAgentToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* request, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GenerateAzureAccessToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* request, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* response, std::function<void(::grpc::Status)>) override;
      void GenerateAzureAccessToken(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* request, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* request, ::google::cloud::gkemulticloud::v1::AzureNodePool* response, std::function<void(::grpc::Status)>) override;
      void GetAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* request, ::google::cloud::gkemulticloud::v1::AzureNodePool* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAzureNodePools(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAzureNodePools(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteAzureNodePool(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAzureOpenIdConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* request, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* response, std::function<void(::grpc::Status)>) override;
      void GetAzureOpenIdConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* request, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAzureJsonWebKeys(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* request, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* response, std::function<void(::grpc::Status)>) override;
      void GetAzureJsonWebKeys(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* request, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAzureServerConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* request, ::google::cloud::gkemulticloud::v1::AzureServerConfig* response, std::function<void(::grpc::Status)>) override;
      void GetAzureServerConfig(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* request, ::google::cloud::gkemulticloud::v1::AzureServerConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateAzureClientRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateAzureClientRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureClient>* AsyncGetAzureClientRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureClient>* PrepareAsyncGetAzureClientRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>* AsyncListAzureClientsRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>* PrepareAsyncListAzureClientsRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteAzureClientRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteAzureClientRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureCluster>* AsyncGetAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureCluster>* PrepareAsyncGetAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>* AsyncListAzureClustersRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>* PrepareAsyncListAzureClustersRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteAzureClusterRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>* AsyncGenerateAzureClusterAgentTokenRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>* PrepareAsyncGenerateAzureClusterAgentTokenRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>* AsyncGenerateAzureAccessTokenRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>* PrepareAsyncGenerateAzureAccessTokenRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureNodePool>* AsyncGetAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureNodePool>* PrepareAsyncGetAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>* AsyncListAzureNodePoolsRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>* PrepareAsyncListAzureNodePoolsRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteAzureNodePoolRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>* AsyncGetAzureOpenIdConfigRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>* PrepareAsyncGetAzureOpenIdConfigRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>* AsyncGetAzureJsonWebKeysRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>* PrepareAsyncGetAzureJsonWebKeysRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureServerConfig>* AsyncGetAzureServerConfigRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkemulticloud::v1::AzureServerConfig>* PrepareAsyncGetAzureServerConfigRaw(::grpc::ClientContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAzureClient_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAzureClient_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAzureClients_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAzureClient_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAzureCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAzureCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAzureCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAzureClusters_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAzureCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_GenerateAzureClusterAgentToken_;
    const ::grpc::internal::RpcMethod rpcmethod_GenerateAzureAccessToken_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAzureNodePool_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAzureNodePool_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAzureNodePool_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAzureNodePools_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAzureNodePool_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAzureOpenIdConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAzureJsonWebKeys_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAzureServerConfig_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a new [AzureClient][google.cloud.gkemulticloud.v1.AzureClient]
    // resource on a given Google Cloud project and region.
    //
    // `AzureClient` resources hold client authentication
    // information needed by the Anthos Multicloud API to manage Azure resources
    // on your Azure subscription on your behalf.
    //
    // If successful, the response contains a newly created
    // [Operation][google.longrunning.Operation] resource that can be
    // described to track the status of the operation.
    virtual ::grpc::Status CreateAzureClient(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* request, ::google::longrunning::Operation* response);
    // Describes a specific
    // [AzureClient][google.cloud.gkemulticloud.v1.AzureClient] resource.
    virtual ::grpc::Status GetAzureClient(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* request, ::google::cloud::gkemulticloud::v1::AzureClient* response);
    // Lists all [AzureClient][google.cloud.gkemulticloud.v1.AzureClient]
    // resources on a given Google Cloud project and region.
    virtual ::grpc::Status ListAzureClients(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* response);
    // Deletes a specific [AzureClient][google.cloud.gkemulticloud.v1.AzureClient]
    // resource.
    //
    // If the client is used by one or more clusters, deletion will
    // fail and a `FAILED_PRECONDITION` error will be returned.
    //
    // If successful, the response contains a newly created
    // [Operation][google.longrunning.Operation] resource that can be
    // described to track the status of the operation.
    virtual ::grpc::Status DeleteAzureClient(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* request, ::google::longrunning::Operation* response);
    // Creates a new [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster]
    // resource on a given Google Cloud Platform project and region.
    //
    // If successful, the response contains a newly created
    // [Operation][google.longrunning.Operation] resource that can be
    // described to track the status of the operation.
    virtual ::grpc::Status CreateAzureCluster(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* request, ::google::longrunning::Operation* response);
    // Updates an [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster].
    virtual ::grpc::Status UpdateAzureCluster(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* request, ::google::longrunning::Operation* response);
    // Describes a specific
    // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster] resource.
    virtual ::grpc::Status GetAzureCluster(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* request, ::google::cloud::gkemulticloud::v1::AzureCluster* response);
    // Lists all [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster]
    // resources on a given Google Cloud project and region.
    virtual ::grpc::Status ListAzureClusters(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* response);
    // Deletes a specific
    // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster] resource.
    //
    // Fails if the cluster has one or more associated
    // [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool] resources.
    //
    // If successful, the response contains a newly created
    // [Operation][google.longrunning.Operation] resource that can be
    // described to track the status of the operation.
    virtual ::grpc::Status DeleteAzureCluster(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* request, ::google::longrunning::Operation* response);
    // Generates an access token for a cluster agent.
    virtual ::grpc::Status GenerateAzureClusterAgentToken(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* request, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* response);
    // Generates a short-lived access token to authenticate to a given
    // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster] resource.
    virtual ::grpc::Status GenerateAzureAccessToken(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* request, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* response);
    // Creates a new [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool],
    // attached to a given
    // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster].
    //
    // If successful, the response contains a newly created
    // [Operation][google.longrunning.Operation] resource that can be
    // described to track the status of the operation.
    virtual ::grpc::Status CreateAzureNodePool(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* request, ::google::longrunning::Operation* response);
    // Updates an [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool].
    virtual ::grpc::Status UpdateAzureNodePool(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* request, ::google::longrunning::Operation* response);
    // Describes a specific
    // [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool] resource.
    virtual ::grpc::Status GetAzureNodePool(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* request, ::google::cloud::gkemulticloud::v1::AzureNodePool* response);
    // Lists all [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool]
    // resources on a given
    // [AzureCluster][google.cloud.gkemulticloud.v1.AzureCluster].
    virtual ::grpc::Status ListAzureNodePools(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* response);
    // Deletes a specific
    // [AzureNodePool][google.cloud.gkemulticloud.v1.AzureNodePool] resource.
    //
    // If successful, the response contains a newly created
    // [Operation][google.longrunning.Operation] resource that can be
    // described to track the status of the operation.
    virtual ::grpc::Status DeleteAzureNodePool(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* request, ::google::longrunning::Operation* response);
    // Gets the OIDC discovery document for the cluster.
    // See the
    // [OpenID Connect Discovery 1.0
    // specification](https://openid.net/specs/openid-connect-discovery-1_0.html)
    // for details.
    virtual ::grpc::Status GetAzureOpenIdConfig(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* request, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* response);
    // Gets the public component of the cluster signing keys in
    // JSON Web Key format.
    virtual ::grpc::Status GetAzureJsonWebKeys(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* request, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* response);
    // Returns information, such as supported Azure regions and Kubernetes
    // versions, on a given Google Cloud location.
    virtual ::grpc::Status GetAzureServerConfig(::grpc::ServerContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* request, ::google::cloud::gkemulticloud::v1::AzureServerConfig* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAzureClient() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAzureClient(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAzureClient() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAzureClient(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkemulticloud::v1::AzureClient>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAzureClients : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAzureClients() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListAzureClients() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureClients(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAzureClients(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAzureClient() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAzureClient(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAzureCluster() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_CreateAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAzureCluster(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAzureCluster() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_UpdateAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAzureCluster(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAzureCluster() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureCluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAzureCluster(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkemulticloud::v1::AzureCluster>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAzureClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAzureClusters() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ListAzureClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAzureClusters(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAzureCluster() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_DeleteAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAzureCluster(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GenerateAzureClusterAgentToken : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GenerateAzureClusterAgentToken() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_GenerateAzureClusterAgentToken() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateAzureClusterAgentToken(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateAzureClusterAgentToken(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GenerateAzureAccessToken : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GenerateAzureAccessToken() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_GenerateAzureAccessToken() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateAzureAccessToken(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateAzureAccessToken(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAzureNodePool() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_CreateAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAzureNodePool(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAzureNodePool() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_UpdateAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAzureNodePool(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAzureNodePool() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_GetAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureNodePool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAzureNodePool(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkemulticloud::v1::AzureNodePool>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAzureNodePools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAzureNodePools() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_ListAzureNodePools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureNodePools(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAzureNodePools(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAzureNodePool() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_DeleteAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAzureNodePool(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAzureOpenIdConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAzureOpenIdConfig() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_GetAzureOpenIdConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureOpenIdConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAzureOpenIdConfig(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAzureJsonWebKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAzureJsonWebKeys() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_GetAzureJsonWebKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureJsonWebKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAzureJsonWebKeys(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAzureServerConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAzureServerConfig() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_GetAzureServerConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureServerConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureServerConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAzureServerConfig(::grpc::ServerContext* context, ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkemulticloud::v1::AzureServerConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateAzureClient<WithAsyncMethod_GetAzureClient<WithAsyncMethod_ListAzureClients<WithAsyncMethod_DeleteAzureClient<WithAsyncMethod_CreateAzureCluster<WithAsyncMethod_UpdateAzureCluster<WithAsyncMethod_GetAzureCluster<WithAsyncMethod_ListAzureClusters<WithAsyncMethod_DeleteAzureCluster<WithAsyncMethod_GenerateAzureClusterAgentToken<WithAsyncMethod_GenerateAzureAccessToken<WithAsyncMethod_CreateAzureNodePool<WithAsyncMethod_UpdateAzureNodePool<WithAsyncMethod_GetAzureNodePool<WithAsyncMethod_ListAzureNodePools<WithAsyncMethod_DeleteAzureNodePool<WithAsyncMethod_GetAzureOpenIdConfig<WithAsyncMethod_GetAzureJsonWebKeys<WithAsyncMethod_GetAzureServerConfig<Service > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAzureClient() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* request, ::google::longrunning::Operation* response) { return this->CreateAzureClient(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAzureClient(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAzureClient(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAzureClient() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GetAzureClientRequest, ::google::cloud::gkemulticloud::v1::AzureClient>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* request, ::google::cloud::gkemulticloud::v1::AzureClient* response) { return this->GetAzureClient(context, request, response); }));}
    void SetMessageAllocatorFor_GetAzureClient(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::GetAzureClientRequest, ::google::cloud::gkemulticloud::v1::AzureClient>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GetAzureClientRequest, ::google::cloud::gkemulticloud::v1::AzureClient>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAzureClient(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureClient* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAzureClients : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAzureClients() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* response) { return this->ListAzureClients(context, request, response); }));}
    void SetMessageAllocatorFor_ListAzureClients(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAzureClients() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureClients(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAzureClients(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAzureClient() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* request, ::google::longrunning::Operation* response) { return this->DeleteAzureClient(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAzureClient(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAzureClient(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAzureCluster() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* request, ::google::longrunning::Operation* response) { return this->CreateAzureCluster(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAzureCluster(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAzureCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAzureCluster() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* request, ::google::longrunning::Operation* response) { return this->UpdateAzureCluster(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAzureCluster(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAzureCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAzureCluster() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest, ::google::cloud::gkemulticloud::v1::AzureCluster>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* request, ::google::cloud::gkemulticloud::v1::AzureCluster* response) { return this->GetAzureCluster(context, request, response); }));}
    void SetMessageAllocatorFor_GetAzureCluster(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest, ::google::cloud::gkemulticloud::v1::AzureCluster>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest, ::google::cloud::gkemulticloud::v1::AzureCluster>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureCluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAzureCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureCluster* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAzureClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAzureClusters() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* response) { return this->ListAzureClusters(context, request, response); }));}
    void SetMessageAllocatorFor_ListAzureClusters(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAzureClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAzureClusters(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAzureCluster() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* request, ::google::longrunning::Operation* response) { return this->DeleteAzureCluster(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAzureCluster(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAzureCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GenerateAzureClusterAgentToken : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GenerateAzureClusterAgentToken() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* request, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* response) { return this->GenerateAzureClusterAgentToken(context, request, response); }));}
    void SetMessageAllocatorFor_GenerateAzureClusterAgentToken(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GenerateAzureClusterAgentToken() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateAzureClusterAgentToken(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateAzureClusterAgentToken(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GenerateAzureAccessToken : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GenerateAzureAccessToken() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* request, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* response) { return this->GenerateAzureAccessToken(context, request, response); }));}
    void SetMessageAllocatorFor_GenerateAzureAccessToken(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GenerateAzureAccessToken() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateAzureAccessToken(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateAzureAccessToken(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAzureNodePool() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* request, ::google::longrunning::Operation* response) { return this->CreateAzureNodePool(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAzureNodePool(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAzureNodePool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAzureNodePool() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* request, ::google::longrunning::Operation* response) { return this->UpdateAzureNodePool(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAzureNodePool(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAzureNodePool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAzureNodePool() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest, ::google::cloud::gkemulticloud::v1::AzureNodePool>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* request, ::google::cloud::gkemulticloud::v1::AzureNodePool* response) { return this->GetAzureNodePool(context, request, response); }));}
    void SetMessageAllocatorFor_GetAzureNodePool(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest, ::google::cloud::gkemulticloud::v1::AzureNodePool>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest, ::google::cloud::gkemulticloud::v1::AzureNodePool>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureNodePool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAzureNodePool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureNodePool* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAzureNodePools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAzureNodePools() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* request, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* response) { return this->ListAzureNodePools(context, request, response); }));}
    void SetMessageAllocatorFor_ListAzureNodePools(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAzureNodePools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureNodePools(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAzureNodePools(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAzureNodePool() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* request, ::google::longrunning::Operation* response) { return this->DeleteAzureNodePool(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAzureNodePool(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAzureNodePool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAzureOpenIdConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAzureOpenIdConfig() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* request, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* response) { return this->GetAzureOpenIdConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetAzureOpenIdConfig(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAzureOpenIdConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureOpenIdConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAzureOpenIdConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAzureJsonWebKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAzureJsonWebKeys() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* request, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* response) { return this->GetAzureJsonWebKeys(context, request, response); }));}
    void SetMessageAllocatorFor_GetAzureJsonWebKeys(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAzureJsonWebKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureJsonWebKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAzureJsonWebKeys(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAzureServerConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAzureServerConfig() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest, ::google::cloud::gkemulticloud::v1::AzureServerConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* request, ::google::cloud::gkemulticloud::v1::AzureServerConfig* response) { return this->GetAzureServerConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetAzureServerConfig(
        ::grpc::MessageAllocator< ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest, ::google::cloud::gkemulticloud::v1::AzureServerConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest, ::google::cloud::gkemulticloud::v1::AzureServerConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAzureServerConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureServerConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureServerConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAzureServerConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureServerConfig* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateAzureClient<WithCallbackMethod_GetAzureClient<WithCallbackMethod_ListAzureClients<WithCallbackMethod_DeleteAzureClient<WithCallbackMethod_CreateAzureCluster<WithCallbackMethod_UpdateAzureCluster<WithCallbackMethod_GetAzureCluster<WithCallbackMethod_ListAzureClusters<WithCallbackMethod_DeleteAzureCluster<WithCallbackMethod_GenerateAzureClusterAgentToken<WithCallbackMethod_GenerateAzureAccessToken<WithCallbackMethod_CreateAzureNodePool<WithCallbackMethod_UpdateAzureNodePool<WithCallbackMethod_GetAzureNodePool<WithCallbackMethod_ListAzureNodePools<WithCallbackMethod_DeleteAzureNodePool<WithCallbackMethod_GetAzureOpenIdConfig<WithCallbackMethod_GetAzureJsonWebKeys<WithCallbackMethod_GetAzureServerConfig<Service > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAzureClient() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAzureClient() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAzureClients : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAzureClients() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListAzureClients() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureClients(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAzureClient() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAzureCluster() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_CreateAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAzureCluster() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_UpdateAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAzureCluster() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureCluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAzureClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAzureClusters() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ListAzureClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAzureCluster() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_DeleteAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GenerateAzureClusterAgentToken : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GenerateAzureClusterAgentToken() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_GenerateAzureClusterAgentToken() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateAzureClusterAgentToken(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GenerateAzureAccessToken : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GenerateAzureAccessToken() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_GenerateAzureAccessToken() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateAzureAccessToken(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAzureNodePool() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_CreateAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAzureNodePool() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_UpdateAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAzureNodePool() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_GetAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureNodePool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAzureNodePools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAzureNodePools() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_ListAzureNodePools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureNodePools(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAzureNodePool() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_DeleteAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAzureOpenIdConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAzureOpenIdConfig() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_GetAzureOpenIdConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureOpenIdConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAzureJsonWebKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAzureJsonWebKeys() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_GetAzureJsonWebKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureJsonWebKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAzureServerConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAzureServerConfig() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_GetAzureServerConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureServerConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureServerConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAzureClient() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAzureClient(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAzureClient() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAzureClient(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAzureClients : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAzureClients() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListAzureClients() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureClients(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAzureClients(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAzureClient() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAzureClient(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAzureCluster() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_CreateAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAzureCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAzureCluster() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_UpdateAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAzureCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAzureCluster() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureCluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAzureCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAzureClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAzureClusters() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ListAzureClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAzureClusters(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAzureCluster() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_DeleteAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAzureCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GenerateAzureClusterAgentToken : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GenerateAzureClusterAgentToken() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_GenerateAzureClusterAgentToken() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateAzureClusterAgentToken(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateAzureClusterAgentToken(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GenerateAzureAccessToken : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GenerateAzureAccessToken() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_GenerateAzureAccessToken() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateAzureAccessToken(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateAzureAccessToken(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAzureNodePool() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_CreateAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAzureNodePool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAzureNodePool() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_UpdateAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAzureNodePool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAzureNodePool() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_GetAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureNodePool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAzureNodePool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAzureNodePools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAzureNodePools() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_ListAzureNodePools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureNodePools(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAzureNodePools(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAzureNodePool() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_DeleteAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAzureNodePool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAzureOpenIdConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAzureOpenIdConfig() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_GetAzureOpenIdConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureOpenIdConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAzureOpenIdConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAzureJsonWebKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAzureJsonWebKeys() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_GetAzureJsonWebKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureJsonWebKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAzureJsonWebKeys(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAzureServerConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAzureServerConfig() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_GetAzureServerConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureServerConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureServerConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAzureServerConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAzureClient() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAzureClient(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAzureClient(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAzureClient() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAzureClient(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAzureClient(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAzureClients : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAzureClients() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAzureClients(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAzureClients() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureClients(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAzureClients(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAzureClient() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAzureClient(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAzureClient(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAzureCluster() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAzureCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAzureCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAzureCluster() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAzureCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAzureCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAzureCluster() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAzureCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureCluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAzureCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAzureClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAzureClusters() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAzureClusters(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAzureClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAzureClusters(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAzureCluster() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAzureCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAzureCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GenerateAzureClusterAgentToken : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GenerateAzureClusterAgentToken() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GenerateAzureClusterAgentToken(context, request, response); }));
    }
    ~WithRawCallbackMethod_GenerateAzureClusterAgentToken() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateAzureClusterAgentToken(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateAzureClusterAgentToken(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GenerateAzureAccessToken : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GenerateAzureAccessToken() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GenerateAzureAccessToken(context, request, response); }));
    }
    ~WithRawCallbackMethod_GenerateAzureAccessToken() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateAzureAccessToken(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateAzureAccessToken(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAzureNodePool() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAzureNodePool(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAzureNodePool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAzureNodePool() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAzureNodePool(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAzureNodePool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAzureNodePool() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAzureNodePool(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureNodePool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAzureNodePool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAzureNodePools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAzureNodePools() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAzureNodePools(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAzureNodePools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAzureNodePools(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAzureNodePools(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAzureNodePool() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAzureNodePool(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAzureNodePool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAzureOpenIdConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAzureOpenIdConfig() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAzureOpenIdConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAzureOpenIdConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureOpenIdConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAzureOpenIdConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAzureJsonWebKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAzureJsonWebKeys() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAzureJsonWebKeys(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAzureJsonWebKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureJsonWebKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAzureJsonWebKeys(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAzureServerConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAzureServerConfig() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAzureServerConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAzureServerConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAzureServerConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureServerConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAzureServerConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAzureClient() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateAzureClient(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAzureClient(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::CreateAzureClientRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAzureClient() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::GetAzureClientRequest, ::google::cloud::gkemulticloud::v1::AzureClient>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::GetAzureClientRequest, ::google::cloud::gkemulticloud::v1::AzureClient>* streamer) {
                       return this->StreamedGetAzureClient(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClientRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureClient* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAzureClient(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::GetAzureClientRequest,::google::cloud::gkemulticloud::v1::AzureClient>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAzureClients : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAzureClients() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>* streamer) {
                       return this->StreamedListAzureClients(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAzureClients() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAzureClients(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClientsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAzureClients(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::ListAzureClientsRequest,::google::cloud::gkemulticloud::v1::ListAzureClientsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAzureClient : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAzureClient() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteAzureClient(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAzureClient() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAzureClient(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAzureClient(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::DeleteAzureClientRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAzureCluster() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateAzureCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAzureCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::CreateAzureClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAzureCluster() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateAzureCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAzureCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::UpdateAzureClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAzureCluster() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest, ::google::cloud::gkemulticloud::v1::AzureCluster>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest, ::google::cloud::gkemulticloud::v1::AzureCluster>* streamer) {
                       return this->StreamedGetAzureCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureCluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAzureCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::GetAzureClusterRequest,::google::cloud::gkemulticloud::v1::AzureCluster>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAzureClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAzureClusters() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>* streamer) {
                       return this->StreamedListAzureClusters(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAzureClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAzureClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAzureClusters(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::ListAzureClustersRequest,::google::cloud::gkemulticloud::v1::ListAzureClustersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAzureCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAzureCluster() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteAzureCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAzureCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAzureCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAzureCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::DeleteAzureClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GenerateAzureClusterAgentToken : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GenerateAzureClusterAgentToken() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>* streamer) {
                       return this->StreamedGenerateAzureClusterAgentToken(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GenerateAzureClusterAgentToken() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GenerateAzureClusterAgentToken(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGenerateAzureClusterAgentToken(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenRequest,::google::cloud::gkemulticloud::v1::GenerateAzureClusterAgentTokenResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GenerateAzureAccessToken : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GenerateAzureAccessToken() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>* streamer) {
                       return this->StreamedGenerateAzureAccessToken(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GenerateAzureAccessToken() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GenerateAzureAccessToken(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest* /*request*/, ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGenerateAzureAccessToken(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenRequest,::google::cloud::gkemulticloud::v1::GenerateAzureAccessTokenResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAzureNodePool() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateAzureNodePool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAzureNodePool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::CreateAzureNodePoolRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAzureNodePool() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateAzureNodePool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAzureNodePool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::UpdateAzureNodePoolRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAzureNodePool() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest, ::google::cloud::gkemulticloud::v1::AzureNodePool>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest, ::google::cloud::gkemulticloud::v1::AzureNodePool>* streamer) {
                       return this->StreamedGetAzureNodePool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureNodePool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAzureNodePool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::GetAzureNodePoolRequest,::google::cloud::gkemulticloud::v1::AzureNodePool>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAzureNodePools : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAzureNodePools() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>* streamer) {
                       return this->StreamedListAzureNodePools(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAzureNodePools() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAzureNodePools(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest* /*request*/, ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAzureNodePools(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::ListAzureNodePoolsRequest,::google::cloud::gkemulticloud::v1::ListAzureNodePoolsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAzureNodePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAzureNodePool() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteAzureNodePool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAzureNodePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAzureNodePool(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAzureNodePool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::DeleteAzureNodePoolRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAzureOpenIdConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAzureOpenIdConfig() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>* streamer) {
                       return this->StreamedGetAzureOpenIdConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAzureOpenIdConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAzureOpenIdConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureOpenIdConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAzureOpenIdConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::GetAzureOpenIdConfigRequest,::google::cloud::gkemulticloud::v1::AzureOpenIdConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAzureJsonWebKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAzureJsonWebKeys() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>* streamer) {
                       return this->StreamedGetAzureJsonWebKeys(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAzureJsonWebKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAzureJsonWebKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureJsonWebKeys* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAzureJsonWebKeys(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::GetAzureJsonWebKeysRequest,::google::cloud::gkemulticloud::v1::AzureJsonWebKeys>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAzureServerConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAzureServerConfig() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest, ::google::cloud::gkemulticloud::v1::AzureServerConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest, ::google::cloud::gkemulticloud::v1::AzureServerConfig>* streamer) {
                       return this->StreamedGetAzureServerConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAzureServerConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAzureServerConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest* /*request*/, ::google::cloud::gkemulticloud::v1::AzureServerConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAzureServerConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkemulticloud::v1::GetAzureServerConfigRequest,::google::cloud::gkemulticloud::v1::AzureServerConfig>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateAzureClient<WithStreamedUnaryMethod_GetAzureClient<WithStreamedUnaryMethod_ListAzureClients<WithStreamedUnaryMethod_DeleteAzureClient<WithStreamedUnaryMethod_CreateAzureCluster<WithStreamedUnaryMethod_UpdateAzureCluster<WithStreamedUnaryMethod_GetAzureCluster<WithStreamedUnaryMethod_ListAzureClusters<WithStreamedUnaryMethod_DeleteAzureCluster<WithStreamedUnaryMethod_GenerateAzureClusterAgentToken<WithStreamedUnaryMethod_GenerateAzureAccessToken<WithStreamedUnaryMethod_CreateAzureNodePool<WithStreamedUnaryMethod_UpdateAzureNodePool<WithStreamedUnaryMethod_GetAzureNodePool<WithStreamedUnaryMethod_ListAzureNodePools<WithStreamedUnaryMethod_DeleteAzureNodePool<WithStreamedUnaryMethod_GetAzureOpenIdConfig<WithStreamedUnaryMethod_GetAzureJsonWebKeys<WithStreamedUnaryMethod_GetAzureServerConfig<Service > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateAzureClient<WithStreamedUnaryMethod_GetAzureClient<WithStreamedUnaryMethod_ListAzureClients<WithStreamedUnaryMethod_DeleteAzureClient<WithStreamedUnaryMethod_CreateAzureCluster<WithStreamedUnaryMethod_UpdateAzureCluster<WithStreamedUnaryMethod_GetAzureCluster<WithStreamedUnaryMethod_ListAzureClusters<WithStreamedUnaryMethod_DeleteAzureCluster<WithStreamedUnaryMethod_GenerateAzureClusterAgentToken<WithStreamedUnaryMethod_GenerateAzureAccessToken<WithStreamedUnaryMethod_CreateAzureNodePool<WithStreamedUnaryMethod_UpdateAzureNodePool<WithStreamedUnaryMethod_GetAzureNodePool<WithStreamedUnaryMethod_ListAzureNodePools<WithStreamedUnaryMethod_DeleteAzureNodePool<WithStreamedUnaryMethod_GetAzureOpenIdConfig<WithStreamedUnaryMethod_GetAzureJsonWebKeys<WithStreamedUnaryMethod_GetAzureServerConfig<Service > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace gkemulticloud
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fgkemulticloud_2fv1_2fazure_5fservice_2eproto__INCLUDED
