// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/networkconnectivity/v1/hub.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fnetworkconnectivity_2fv1_2fhub_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fnetworkconnectivity_2fv1_2fhub_2eproto__INCLUDED

#include "google/cloud/networkconnectivity/v1/hub.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace networkconnectivity {
namespace v1 {

// Network Connectivity Center is a hub-and-spoke abstraction for network
// connectivity management in Google Cloud. It reduces operational complexity
// through a simple, centralized connectivity management model.
class HubService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.networkconnectivity.v1.HubService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists the Network Connectivity Center hubs associated with a given project.
    virtual ::grpc::Status ListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubsResponse>> AsyncListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubsResponse>>(AsyncListHubsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubsResponse>> PrepareAsyncListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubsResponse>>(PrepareAsyncListHubsRaw(context, request, cq));
    }
    // Gets details about a Network Connectivity Center hub.
    virtual ::grpc::Status GetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::google::cloud::networkconnectivity::v1::Hub* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Hub>> AsyncGetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Hub>>(AsyncGetHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Hub>> PrepareAsyncGetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Hub>>(PrepareAsyncGetHubRaw(context, request, cq));
    }
    // Creates a new Network Connectivity Center hub in the specified project.
    virtual ::grpc::Status CreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateHubRaw(context, request, cq));
    }
    // Updates the description and/or labels of a Network Connectivity Center
    // hub.
    virtual ::grpc::Status UpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateHubRaw(context, request, cq));
    }
    // Deletes a Network Connectivity Center hub.
    virtual ::grpc::Status DeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteHubRaw(context, request, cq));
    }
    // Lists the Network Connectivity Center spokes associated with a
    // specified hub and location. The list includes both spokes that are attached
    // to the hub and spokes that have been proposed but not yet accepted.
    virtual ::grpc::Status ListHubSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest& request, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>> AsyncListHubSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>>(AsyncListHubSpokesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>> PrepareAsyncListHubSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>>(PrepareAsyncListHubSpokesRaw(context, request, cq));
    }
    // Lists the Network Connectivity Center spokes in a specified project and
    // location.
    virtual ::grpc::Status ListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>> AsyncListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>>(AsyncListSpokesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>> PrepareAsyncListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>>(PrepareAsyncListSpokesRaw(context, request, cq));
    }
    // Gets details about a Network Connectivity Center spoke.
    virtual ::grpc::Status GetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::google::cloud::networkconnectivity::v1::Spoke* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Spoke>> AsyncGetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Spoke>>(AsyncGetSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Spoke>> PrepareAsyncGetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Spoke>>(PrepareAsyncGetSpokeRaw(context, request, cq));
    }
    // Creates a Network Connectivity Center spoke.
    virtual ::grpc::Status CreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateSpokeRaw(context, request, cq));
    }
    // Updates the parameters of a Network Connectivity Center spoke.
    virtual ::grpc::Status UpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateSpokeRaw(context, request, cq));
    }
    // Rejects a Network Connectivity Center spoke from being attached to a hub.
    // If the spoke was previously in the `ACTIVE` state, it
    // transitions to the `INACTIVE` state and is no longer able to
    // connect to other spokes that are attached to the hub.
    virtual ::grpc::Status RejectHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRejectHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRejectHubSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRejectHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRejectHubSpokeRaw(context, request, cq));
    }
    // Accepts a proposal to attach a Network Connectivity Center spoke
    // to a hub.
    virtual ::grpc::Status AcceptHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncAcceptHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncAcceptHubSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncAcceptHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncAcceptHubSpokeRaw(context, request, cq));
    }
    // Deletes a Network Connectivity Center spoke.
    virtual ::grpc::Status DeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteSpokeRaw(context, request, cq));
    }
    // Gets details about a Network Connectivity Center route table.
    virtual ::grpc::Status GetRouteTable(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest& request, ::google::cloud::networkconnectivity::v1::RouteTable* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::RouteTable>> AsyncGetRouteTable(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::RouteTable>>(AsyncGetRouteTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::RouteTable>> PrepareAsyncGetRouteTable(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::RouteTable>>(PrepareAsyncGetRouteTableRaw(context, request, cq));
    }
    // Gets details about the specified route.
    virtual ::grpc::Status GetRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest& request, ::google::cloud::networkconnectivity::v1::Route* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Route>> AsyncGetRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Route>>(AsyncGetRouteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Route>> PrepareAsyncGetRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Route>>(PrepareAsyncGetRouteRaw(context, request, cq));
    }
    // Lists routes in a given project.
    virtual ::grpc::Status ListRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest& request, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListRoutesResponse>> AsyncListRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListRoutesResponse>>(AsyncListRoutesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListRoutesResponse>> PrepareAsyncListRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListRoutesResponse>>(PrepareAsyncListRoutesRaw(context, request, cq));
    }
    // Lists route tables in a given project.
    virtual ::grpc::Status ListRouteTables(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest& request, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>> AsyncListRouteTables(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>>(AsyncListRouteTablesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>> PrepareAsyncListRouteTables(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>>(PrepareAsyncListRouteTablesRaw(context, request, cq));
    }
    // Gets details about a Network Connectivity Center group.
    virtual ::grpc::Status GetGroup(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest& request, ::google::cloud::networkconnectivity::v1::Group* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Group>> AsyncGetGroup(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Group>>(AsyncGetGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Group>> PrepareAsyncGetGroup(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Group>>(PrepareAsyncGetGroupRaw(context, request, cq));
    }
    // Lists groups in a given hub.
    virtual ::grpc::Status ListGroups(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest& request, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListGroupsResponse>> AsyncListGroups(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListGroupsResponse>>(AsyncListGroupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListGroupsResponse>> PrepareAsyncListGroups(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListGroupsResponse>>(PrepareAsyncListGroupsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists the Network Connectivity Center hubs associated with a given project.
      virtual void ListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details about a Network Connectivity Center hub.
      virtual void GetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::google::cloud::networkconnectivity::v1::Hub* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::google::cloud::networkconnectivity::v1::Hub* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Network Connectivity Center hub in the specified project.
      virtual void CreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the description and/or labels of a Network Connectivity Center
      // hub.
      virtual void UpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a Network Connectivity Center hub.
      virtual void DeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the Network Connectivity Center spokes associated with a
      // specified hub and location. The list includes both spokes that are attached
      // to the hub and spokes that have been proposed but not yet accepted.
      virtual void ListHubSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListHubSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the Network Connectivity Center spokes in a specified project and
      // location.
      virtual void ListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details about a Network Connectivity Center spoke.
      virtual void GetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::google::cloud::networkconnectivity::v1::Spoke* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::google::cloud::networkconnectivity::v1::Spoke* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a Network Connectivity Center spoke.
      virtual void CreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a Network Connectivity Center spoke.
      virtual void UpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Rejects a Network Connectivity Center spoke from being attached to a hub.
      // If the spoke was previously in the `ACTIVE` state, it
      // transitions to the `INACTIVE` state and is no longer able to
      // connect to other spokes that are attached to the hub.
      virtual void RejectHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RejectHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Accepts a proposal to attach a Network Connectivity Center spoke
      // to a hub.
      virtual void AcceptHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AcceptHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a Network Connectivity Center spoke.
      virtual void DeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details about a Network Connectivity Center route table.
      virtual void GetRouteTable(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* request, ::google::cloud::networkconnectivity::v1::RouteTable* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRouteTable(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* request, ::google::cloud::networkconnectivity::v1::RouteTable* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details about the specified route.
      virtual void GetRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest* request, ::google::cloud::networkconnectivity::v1::Route* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest* request, ::google::cloud::networkconnectivity::v1::Route* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists routes in a given project.
      virtual void ListRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest* request, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest* request, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists route tables in a given project.
      virtual void ListRouteTables(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* request, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListRouteTables(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* request, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details about a Network Connectivity Center group.
      virtual void GetGroup(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest* request, ::google::cloud::networkconnectivity::v1::Group* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetGroup(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest* request, ::google::cloud::networkconnectivity::v1::Group* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists groups in a given hub.
      virtual void ListGroups(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest* request, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListGroups(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest* request, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubsResponse>* AsyncListHubsRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubsResponse>* PrepareAsyncListHubsRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Hub>* AsyncGetHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Hub>* PrepareAsyncGetHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>* AsyncListHubSpokesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>* PrepareAsyncListHubSpokesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* AsyncListSpokesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* PrepareAsyncListSpokesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Spoke>* AsyncGetSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Spoke>* PrepareAsyncGetSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRejectHubSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRejectHubSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncAcceptHubSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncAcceptHubSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::RouteTable>* AsyncGetRouteTableRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::RouteTable>* PrepareAsyncGetRouteTableRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Route>* AsyncGetRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Route>* PrepareAsyncGetRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListRoutesResponse>* AsyncListRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListRoutesResponse>* PrepareAsyncListRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>* AsyncListRouteTablesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>* PrepareAsyncListRouteTablesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Group>* AsyncGetGroupRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::Group>* PrepareAsyncGetGroupRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListGroupsResponse>* AsyncListGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkconnectivity::v1::ListGroupsResponse>* PrepareAsyncListGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubsResponse>> AsyncListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubsResponse>>(AsyncListHubsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubsResponse>> PrepareAsyncListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubsResponse>>(PrepareAsyncListHubsRaw(context, request, cq));
    }
    ::grpc::Status GetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::google::cloud::networkconnectivity::v1::Hub* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Hub>> AsyncGetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Hub>>(AsyncGetHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Hub>> PrepareAsyncGetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Hub>>(PrepareAsyncGetHubRaw(context, request, cq));
    }
    ::grpc::Status CreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateHubRaw(context, request, cq));
    }
    ::grpc::Status UpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateHubRaw(context, request, cq));
    }
    ::grpc::Status DeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteHubRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteHubRaw(context, request, cq));
    }
    ::grpc::Status ListHubSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest& request, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>> AsyncListHubSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>>(AsyncListHubSpokesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>> PrepareAsyncListHubSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>>(PrepareAsyncListHubSpokesRaw(context, request, cq));
    }
    ::grpc::Status ListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>> AsyncListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>>(AsyncListSpokesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>> PrepareAsyncListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>>(PrepareAsyncListSpokesRaw(context, request, cq));
    }
    ::grpc::Status GetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::google::cloud::networkconnectivity::v1::Spoke* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Spoke>> AsyncGetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Spoke>>(AsyncGetSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Spoke>> PrepareAsyncGetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Spoke>>(PrepareAsyncGetSpokeRaw(context, request, cq));
    }
    ::grpc::Status CreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateSpokeRaw(context, request, cq));
    }
    ::grpc::Status UpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateSpokeRaw(context, request, cq));
    }
    ::grpc::Status RejectHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRejectHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRejectHubSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRejectHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRejectHubSpokeRaw(context, request, cq));
    }
    ::grpc::Status AcceptHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncAcceptHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncAcceptHubSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncAcceptHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncAcceptHubSpokeRaw(context, request, cq));
    }
    ::grpc::Status DeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteSpokeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteSpokeRaw(context, request, cq));
    }
    ::grpc::Status GetRouteTable(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest& request, ::google::cloud::networkconnectivity::v1::RouteTable* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::RouteTable>> AsyncGetRouteTable(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::RouteTable>>(AsyncGetRouteTableRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::RouteTable>> PrepareAsyncGetRouteTable(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::RouteTable>>(PrepareAsyncGetRouteTableRaw(context, request, cq));
    }
    ::grpc::Status GetRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest& request, ::google::cloud::networkconnectivity::v1::Route* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Route>> AsyncGetRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Route>>(AsyncGetRouteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Route>> PrepareAsyncGetRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Route>>(PrepareAsyncGetRouteRaw(context, request, cq));
    }
    ::grpc::Status ListRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest& request, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListRoutesResponse>> AsyncListRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListRoutesResponse>>(AsyncListRoutesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListRoutesResponse>> PrepareAsyncListRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListRoutesResponse>>(PrepareAsyncListRoutesRaw(context, request, cq));
    }
    ::grpc::Status ListRouteTables(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest& request, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>> AsyncListRouteTables(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>>(AsyncListRouteTablesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>> PrepareAsyncListRouteTables(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>>(PrepareAsyncListRouteTablesRaw(context, request, cq));
    }
    ::grpc::Status GetGroup(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest& request, ::google::cloud::networkconnectivity::v1::Group* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Group>> AsyncGetGroup(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Group>>(AsyncGetGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Group>> PrepareAsyncGetGroup(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Group>>(PrepareAsyncGetGroupRaw(context, request, cq));
    }
    ::grpc::Status ListGroups(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest& request, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListGroupsResponse>> AsyncListGroups(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListGroupsResponse>>(AsyncListGroupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListGroupsResponse>> PrepareAsyncListGroups(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListGroupsResponse>>(PrepareAsyncListGroupsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListHubs(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::google::cloud::networkconnectivity::v1::Hub* response, std::function<void(::grpc::Status)>) override;
      void GetHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::google::cloud::networkconnectivity::v1::Hub* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteHub(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListHubSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListHubSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSpokes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::google::cloud::networkconnectivity::v1::Spoke* response, std::function<void(::grpc::Status)>) override;
      void GetSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::google::cloud::networkconnectivity::v1::Spoke* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RejectHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RejectHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AcceptHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void AcceptHubSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteSpoke(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRouteTable(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* request, ::google::cloud::networkconnectivity::v1::RouteTable* response, std::function<void(::grpc::Status)>) override;
      void GetRouteTable(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* request, ::google::cloud::networkconnectivity::v1::RouteTable* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest* request, ::google::cloud::networkconnectivity::v1::Route* response, std::function<void(::grpc::Status)>) override;
      void GetRoute(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest* request, ::google::cloud::networkconnectivity::v1::Route* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest* request, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListRoutes(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest* request, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListRouteTables(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* request, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListRouteTables(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* request, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetGroup(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest* request, ::google::cloud::networkconnectivity::v1::Group* response, std::function<void(::grpc::Status)>) override;
      void GetGroup(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest* request, ::google::cloud::networkconnectivity::v1::Group* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListGroups(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest* request, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListGroups(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest* request, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubsResponse>* AsyncListHubsRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubsResponse>* PrepareAsyncListHubsRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Hub>* AsyncGetHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Hub>* PrepareAsyncGetHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteHubRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>* AsyncListHubSpokesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>* PrepareAsyncListHubSpokesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* AsyncListSpokesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* PrepareAsyncListSpokesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Spoke>* AsyncGetSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Spoke>* PrepareAsyncGetSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRejectHubSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRejectHubSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncAcceptHubSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncAcceptHubSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteSpokeRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::RouteTable>* AsyncGetRouteTableRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::RouteTable>* PrepareAsyncGetRouteTableRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Route>* AsyncGetRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Route>* PrepareAsyncGetRouteRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListRoutesResponse>* AsyncListRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListRoutesResponse>* PrepareAsyncListRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>* AsyncListRouteTablesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>* PrepareAsyncListRouteTablesRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Group>* AsyncGetGroupRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::Group>* PrepareAsyncGetGroupRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListGroupsResponse>* AsyncListGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkconnectivity::v1::ListGroupsResponse>* PrepareAsyncListGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListHubs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetHub_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateHub_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateHub_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteHub_;
    const ::grpc::internal::RpcMethod rpcmethod_ListHubSpokes_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSpokes_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSpoke_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateSpoke_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateSpoke_;
    const ::grpc::internal::RpcMethod rpcmethod_RejectHubSpoke_;
    const ::grpc::internal::RpcMethod rpcmethod_AcceptHubSpoke_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteSpoke_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRouteTable_;
    const ::grpc::internal::RpcMethod rpcmethod_GetRoute_;
    const ::grpc::internal::RpcMethod rpcmethod_ListRoutes_;
    const ::grpc::internal::RpcMethod rpcmethod_ListRouteTables_;
    const ::grpc::internal::RpcMethod rpcmethod_GetGroup_;
    const ::grpc::internal::RpcMethod rpcmethod_ListGroups_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists the Network Connectivity Center hubs associated with a given project.
    virtual ::grpc::Status ListHubs(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response);
    // Gets details about a Network Connectivity Center hub.
    virtual ::grpc::Status GetHub(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::google::cloud::networkconnectivity::v1::Hub* response);
    // Creates a new Network Connectivity Center hub in the specified project.
    virtual ::grpc::Status CreateHub(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::google::longrunning::Operation* response);
    // Updates the description and/or labels of a Network Connectivity Center
    // hub.
    virtual ::grpc::Status UpdateHub(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::google::longrunning::Operation* response);
    // Deletes a Network Connectivity Center hub.
    virtual ::grpc::Status DeleteHub(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::google::longrunning::Operation* response);
    // Lists the Network Connectivity Center spokes associated with a
    // specified hub and location. The list includes both spokes that are attached
    // to the hub and spokes that have been proposed but not yet accepted.
    virtual ::grpc::Status ListHubSpokes(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* response);
    // Lists the Network Connectivity Center spokes in a specified project and
    // location.
    virtual ::grpc::Status ListSpokes(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response);
    // Gets details about a Network Connectivity Center spoke.
    virtual ::grpc::Status GetSpoke(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::google::cloud::networkconnectivity::v1::Spoke* response);
    // Creates a Network Connectivity Center spoke.
    virtual ::grpc::Status CreateSpoke(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::google::longrunning::Operation* response);
    // Updates the parameters of a Network Connectivity Center spoke.
    virtual ::grpc::Status UpdateSpoke(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::google::longrunning::Operation* response);
    // Rejects a Network Connectivity Center spoke from being attached to a hub.
    // If the spoke was previously in the `ACTIVE` state, it
    // transitions to the `INACTIVE` state and is no longer able to
    // connect to other spokes that are attached to the hub.
    virtual ::grpc::Status RejectHubSpoke(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* request, ::google::longrunning::Operation* response);
    // Accepts a proposal to attach a Network Connectivity Center spoke
    // to a hub.
    virtual ::grpc::Status AcceptHubSpoke(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* request, ::google::longrunning::Operation* response);
    // Deletes a Network Connectivity Center spoke.
    virtual ::grpc::Status DeleteSpoke(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::google::longrunning::Operation* response);
    // Gets details about a Network Connectivity Center route table.
    virtual ::grpc::Status GetRouteTable(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* request, ::google::cloud::networkconnectivity::v1::RouteTable* response);
    // Gets details about the specified route.
    virtual ::grpc::Status GetRoute(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest* request, ::google::cloud::networkconnectivity::v1::Route* response);
    // Lists routes in a given project.
    virtual ::grpc::Status ListRoutes(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest* request, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* response);
    // Lists route tables in a given project.
    virtual ::grpc::Status ListRouteTables(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* request, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* response);
    // Gets details about a Network Connectivity Center group.
    virtual ::grpc::Status GetGroup(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest* request, ::google::cloud::networkconnectivity::v1::Group* response);
    // Lists groups in a given hub.
    virtual ::grpc::Status ListGroups(::grpc::ServerContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest* request, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListHubs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListHubs() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListHubs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListHubs(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::ListHubsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetHub() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetHub(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::Hub>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateHub() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateHub(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateHub() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateHub(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteHub() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteHub(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListHubSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListHubSpokes() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListHubSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListHubSpokes(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSpokes() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ListSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSpokes(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSpoke() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSpoke(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::Spoke>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateSpoke() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_CreateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSpoke(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateSpoke() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_UpdateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSpoke(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RejectHubSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RejectHubSpoke() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_RejectHubSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejectHubSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRejectHubSpoke(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AcceptHubSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AcceptHubSpoke() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_AcceptHubSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcceptHubSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAcceptHubSpoke(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteSpoke() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_DeleteSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSpoke(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRouteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRouteTable() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_GetRouteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRouteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* /*request*/, ::google::cloud::networkconnectivity::v1::RouteTable* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRouteTable(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::RouteTable>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetRoute() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_GetRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Route* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRoute(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::GetRouteRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::Route>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListRoutes() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_ListRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRoutes(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::ListRoutesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::ListRoutesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListRouteTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListRouteTables() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_ListRouteTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRouteTables(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRouteTables(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetGroup() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_GetGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetGroupRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Group* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetGroup(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::GetGroupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::Group>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListGroups() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_ListGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListGroups(::grpc::ServerContext* context, ::google::cloud::networkconnectivity::v1::ListGroupsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkconnectivity::v1::ListGroupsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListHubs<WithAsyncMethod_GetHub<WithAsyncMethod_CreateHub<WithAsyncMethod_UpdateHub<WithAsyncMethod_DeleteHub<WithAsyncMethod_ListHubSpokes<WithAsyncMethod_ListSpokes<WithAsyncMethod_GetSpoke<WithAsyncMethod_CreateSpoke<WithAsyncMethod_UpdateSpoke<WithAsyncMethod_RejectHubSpoke<WithAsyncMethod_AcceptHubSpoke<WithAsyncMethod_DeleteSpoke<WithAsyncMethod_GetRouteTable<WithAsyncMethod_GetRoute<WithAsyncMethod_ListRoutes<WithAsyncMethod_ListRouteTables<WithAsyncMethod_GetGroup<WithAsyncMethod_ListGroups<Service > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListHubs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListHubs() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListHubsRequest, ::google::cloud::networkconnectivity::v1::ListHubsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* request, ::google::cloud::networkconnectivity::v1::ListHubsResponse* response) { return this->ListHubs(context, request, response); }));}
    void SetMessageAllocatorFor_ListHubs(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::ListHubsRequest, ::google::cloud::networkconnectivity::v1::ListHubsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListHubsRequest, ::google::cloud::networkconnectivity::v1::ListHubsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListHubs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListHubs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetHub() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetHubRequest, ::google::cloud::networkconnectivity::v1::Hub>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::GetHubRequest* request, ::google::cloud::networkconnectivity::v1::Hub* response) { return this->GetHub(context, request, response); }));}
    void SetMessageAllocatorFor_GetHub(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::GetHubRequest, ::google::cloud::networkconnectivity::v1::Hub>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetHubRequest, ::google::cloud::networkconnectivity::v1::Hub>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetHub(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateHub() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::CreateHubRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* request, ::google::longrunning::Operation* response) { return this->CreateHub(context, request, response); }));}
    void SetMessageAllocatorFor_CreateHub(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::CreateHubRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::CreateHubRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateHub(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateHub() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::UpdateHubRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* request, ::google::longrunning::Operation* response) { return this->UpdateHub(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateHub(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::UpdateHubRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::UpdateHubRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateHub(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteHub() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::DeleteHubRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* request, ::google::longrunning::Operation* response) { return this->DeleteHub(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteHub(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::DeleteHubRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::DeleteHubRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteHub(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListHubSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListHubSpokes() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* response) { return this->ListHubSpokes(context, request, response); }));}
    void SetMessageAllocatorFor_ListHubSpokes(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListHubSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListHubSpokes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSpokes() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListSpokesRequest, ::google::cloud::networkconnectivity::v1::ListSpokesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* request, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* response) { return this->ListSpokes(context, request, response); }));}
    void SetMessageAllocatorFor_ListSpokes(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::ListSpokesRequest, ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListSpokesRequest, ::google::cloud::networkconnectivity::v1::ListSpokesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSpokes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSpoke() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetSpokeRequest, ::google::cloud::networkconnectivity::v1::Spoke>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* request, ::google::cloud::networkconnectivity::v1::Spoke* response) { return this->GetSpoke(context, request, response); }));}
    void SetMessageAllocatorFor_GetSpoke(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::GetSpokeRequest, ::google::cloud::networkconnectivity::v1::Spoke>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetSpokeRequest, ::google::cloud::networkconnectivity::v1::Spoke>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateSpoke() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::CreateSpokeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* request, ::google::longrunning::Operation* response) { return this->CreateSpoke(context, request, response); }));}
    void SetMessageAllocatorFor_CreateSpoke(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::CreateSpokeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::CreateSpokeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateSpoke() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* request, ::google::longrunning::Operation* response) { return this->UpdateSpoke(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateSpoke(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RejectHubSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RejectHubSpoke() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* request, ::google::longrunning::Operation* response) { return this->RejectHubSpoke(context, request, response); }));}
    void SetMessageAllocatorFor_RejectHubSpoke(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RejectHubSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejectHubSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RejectHubSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AcceptHubSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AcceptHubSpoke() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* request, ::google::longrunning::Operation* response) { return this->AcceptHubSpoke(context, request, response); }));}
    void SetMessageAllocatorFor_AcceptHubSpoke(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AcceptHubSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcceptHubSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AcceptHubSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteSpoke() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* request, ::google::longrunning::Operation* response) { return this->DeleteSpoke(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteSpoke(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRouteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRouteTable() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetRouteTableRequest, ::google::cloud::networkconnectivity::v1::RouteTable>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* request, ::google::cloud::networkconnectivity::v1::RouteTable* response) { return this->GetRouteTable(context, request, response); }));}
    void SetMessageAllocatorFor_GetRouteTable(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::GetRouteTableRequest, ::google::cloud::networkconnectivity::v1::RouteTable>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetRouteTableRequest, ::google::cloud::networkconnectivity::v1::RouteTable>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRouteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRouteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* /*request*/, ::google::cloud::networkconnectivity::v1::RouteTable* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRouteTable(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* /*request*/, ::google::cloud::networkconnectivity::v1::RouteTable* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetRoute() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetRouteRequest, ::google::cloud::networkconnectivity::v1::Route>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::GetRouteRequest* request, ::google::cloud::networkconnectivity::v1::Route* response) { return this->GetRoute(context, request, response); }));}
    void SetMessageAllocatorFor_GetRoute(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::GetRouteRequest, ::google::cloud::networkconnectivity::v1::Route>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetRouteRequest, ::google::cloud::networkconnectivity::v1::Route>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Route* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRoute(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Route* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListRoutes() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListRoutesRequest, ::google::cloud::networkconnectivity::v1::ListRoutesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest* request, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* response) { return this->ListRoutes(context, request, response); }));}
    void SetMessageAllocatorFor_ListRoutes(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::ListRoutesRequest, ::google::cloud::networkconnectivity::v1::ListRoutesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListRoutesRequest, ::google::cloud::networkconnectivity::v1::ListRoutesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRoutes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListRouteTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListRouteTables() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* request, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* response) { return this->ListRouteTables(context, request, response); }));}
    void SetMessageAllocatorFor_ListRouteTables(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListRouteTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRouteTables(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRouteTables(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetGroup() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetGroupRequest, ::google::cloud::networkconnectivity::v1::Group>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::GetGroupRequest* request, ::google::cloud::networkconnectivity::v1::Group* response) { return this->GetGroup(context, request, response); }));}
    void SetMessageAllocatorFor_GetGroup(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::GetGroupRequest, ::google::cloud::networkconnectivity::v1::Group>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::GetGroupRequest, ::google::cloud::networkconnectivity::v1::Group>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetGroupRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Group* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetGroupRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Group* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListGroups() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListGroupsRequest, ::google::cloud::networkconnectivity::v1::ListGroupsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest* request, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* response) { return this->ListGroups(context, request, response); }));}
    void SetMessageAllocatorFor_ListGroups(
        ::grpc::MessageAllocator< ::google::cloud::networkconnectivity::v1::ListGroupsRequest, ::google::cloud::networkconnectivity::v1::ListGroupsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkconnectivity::v1::ListGroupsRequest, ::google::cloud::networkconnectivity::v1::ListGroupsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListGroups(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListHubs<WithCallbackMethod_GetHub<WithCallbackMethod_CreateHub<WithCallbackMethod_UpdateHub<WithCallbackMethod_DeleteHub<WithCallbackMethod_ListHubSpokes<WithCallbackMethod_ListSpokes<WithCallbackMethod_GetSpoke<WithCallbackMethod_CreateSpoke<WithCallbackMethod_UpdateSpoke<WithCallbackMethod_RejectHubSpoke<WithCallbackMethod_AcceptHubSpoke<WithCallbackMethod_DeleteSpoke<WithCallbackMethod_GetRouteTable<WithCallbackMethod_GetRoute<WithCallbackMethod_ListRoutes<WithCallbackMethod_ListRouteTables<WithCallbackMethod_GetGroup<WithCallbackMethod_ListGroups<Service > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListHubs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListHubs() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListHubs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetHub() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateHub() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateHub() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteHub() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListHubSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListHubSpokes() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListHubSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSpokes() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ListSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSpoke() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateSpoke() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_CreateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateSpoke() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_UpdateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RejectHubSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RejectHubSpoke() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_RejectHubSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejectHubSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AcceptHubSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AcceptHubSpoke() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_AcceptHubSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcceptHubSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteSpoke() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_DeleteSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRouteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRouteTable() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_GetRouteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRouteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* /*request*/, ::google::cloud::networkconnectivity::v1::RouteTable* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetRoute() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_GetRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Route* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListRoutes() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_ListRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListRouteTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListRouteTables() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_ListRouteTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRouteTables(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetGroup() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_GetGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetGroupRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Group* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListGroups() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_ListGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListHubs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListHubs() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListHubs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListHubs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetHub() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetHub(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateHub() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateHub(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateHub() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateHub(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteHub() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteHub(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListHubSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListHubSpokes() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListHubSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListHubSpokes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSpokes() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ListSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSpokes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSpoke() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSpoke(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateSpoke() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_CreateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSpoke(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateSpoke() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_UpdateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSpoke(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RejectHubSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RejectHubSpoke() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_RejectHubSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejectHubSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRejectHubSpoke(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AcceptHubSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AcceptHubSpoke() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_AcceptHubSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcceptHubSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAcceptHubSpoke(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteSpoke() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_DeleteSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSpoke(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRouteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRouteTable() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_GetRouteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRouteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* /*request*/, ::google::cloud::networkconnectivity::v1::RouteTable* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRouteTable(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetRoute() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_GetRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Route* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetRoute(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListRoutes() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_ListRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRoutes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListRouteTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListRouteTables() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_ListRouteTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRouteTables(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListRouteTables(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetGroup() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_GetGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetGroupRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Group* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetGroup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListGroups() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_ListGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListGroups(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListHubs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListHubs() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListHubs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListHubs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListHubs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetHub() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetHub(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetHub(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateHub() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateHub(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateHub(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateHub() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateHub(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateHub(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteHub() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteHub(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteHub(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListHubSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListHubSpokes() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListHubSpokes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListHubSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHubSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListHubSpokes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSpokes() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSpokes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSpokes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSpoke() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSpoke(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateSpoke() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateSpoke(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateSpoke() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateSpoke(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RejectHubSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RejectHubSpoke() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RejectHubSpoke(context, request, response); }));
    }
    ~WithRawCallbackMethod_RejectHubSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejectHubSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RejectHubSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AcceptHubSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AcceptHubSpoke() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AcceptHubSpoke(context, request, response); }));
    }
    ~WithRawCallbackMethod_AcceptHubSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AcceptHubSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AcceptHubSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteSpoke() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteSpoke(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSpoke(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRouteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRouteTable() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRouteTable(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRouteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRouteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* /*request*/, ::google::cloud::networkconnectivity::v1::RouteTable* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRouteTable(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetRoute() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetRoute(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Route* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetRoute(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListRoutes() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListRoutes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRoutes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListRouteTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListRouteTables() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListRouteTables(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListRouteTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListRouteTables(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListRouteTables(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetGroup() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetGroup(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetGroupRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Group* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListGroups() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListGroups(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListGroups(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListHubs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListHubs() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::ListHubsRequest, ::google::cloud::networkconnectivity::v1::ListHubsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::ListHubsRequest, ::google::cloud::networkconnectivity::v1::ListHubsResponse>* streamer) {
                       return this->StreamedListHubs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListHubs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListHubs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListHubs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::ListHubsRequest,::google::cloud::networkconnectivity::v1::ListHubsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetHub() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::GetHubRequest, ::google::cloud::networkconnectivity::v1::Hub>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::GetHubRequest, ::google::cloud::networkconnectivity::v1::Hub>* streamer) {
                       return this->StreamedGetHub(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetHubRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Hub* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetHub(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::GetHubRequest,::google::cloud::networkconnectivity::v1::Hub>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateHub() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::CreateHubRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::CreateHubRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateHub(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateHub(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::CreateHubRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateHub() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::UpdateHubRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::UpdateHubRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateHub(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateHub(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::UpdateHubRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteHub : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteHub() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::DeleteHubRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::DeleteHubRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteHub(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteHub() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteHub(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteHubRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteHub(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::DeleteHubRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListHubSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListHubSpokes() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>* streamer) {
                       return this->StreamedListHubSpokes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListHubSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListHubSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListHubSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListHubSpokes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::ListHubSpokesRequest,::google::cloud::networkconnectivity::v1::ListHubSpokesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSpokes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSpokes() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::ListSpokesRequest, ::google::cloud::networkconnectivity::v1::ListSpokesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::ListSpokesRequest, ::google::cloud::networkconnectivity::v1::ListSpokesResponse>* streamer) {
                       return this->StreamedListSpokes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSpokes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSpokes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListSpokesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListSpokesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSpokes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::ListSpokesRequest,::google::cloud::networkconnectivity::v1::ListSpokesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSpoke() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::GetSpokeRequest, ::google::cloud::networkconnectivity::v1::Spoke>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::GetSpokeRequest, ::google::cloud::networkconnectivity::v1::Spoke>* streamer) {
                       return this->StreamedGetSpoke(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetSpokeRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Spoke* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSpoke(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::GetSpokeRequest,::google::cloud::networkconnectivity::v1::Spoke>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateSpoke() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::CreateSpokeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::CreateSpokeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateSpoke(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::CreateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateSpoke(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::CreateSpokeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateSpoke() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateSpoke(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateSpoke(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::UpdateSpokeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RejectHubSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RejectHubSpoke() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRejectHubSpoke(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RejectHubSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RejectHubSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRejectHubSpoke(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::RejectHubSpokeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AcceptHubSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AcceptHubSpoke() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedAcceptHubSpoke(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AcceptHubSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AcceptHubSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAcceptHubSpoke(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::AcceptHubSpokeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteSpoke : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteSpoke() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteSpoke(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteSpoke() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteSpoke(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteSpoke(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::DeleteSpokeRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRouteTable : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRouteTable() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::GetRouteTableRequest, ::google::cloud::networkconnectivity::v1::RouteTable>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::GetRouteTableRequest, ::google::cloud::networkconnectivity::v1::RouteTable>* streamer) {
                       return this->StreamedGetRouteTable(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRouteTable() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRouteTable(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteTableRequest* /*request*/, ::google::cloud::networkconnectivity::v1::RouteTable* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRouteTable(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::GetRouteTableRequest,::google::cloud::networkconnectivity::v1::RouteTable>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetRoute : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetRoute() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::GetRouteRequest, ::google::cloud::networkconnectivity::v1::Route>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::GetRouteRequest, ::google::cloud::networkconnectivity::v1::Route>* streamer) {
                       return this->StreamedGetRoute(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetRoute() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetRoute(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetRouteRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Route* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetRoute(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::GetRouteRequest,::google::cloud::networkconnectivity::v1::Route>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListRoutes() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::ListRoutesRequest, ::google::cloud::networkconnectivity::v1::ListRoutesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::ListRoutesRequest, ::google::cloud::networkconnectivity::v1::ListRoutesResponse>* streamer) {
                       return this->StreamedListRoutes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRoutesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListRoutes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::ListRoutesRequest,::google::cloud::networkconnectivity::v1::ListRoutesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListRouteTables : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListRouteTables() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>* streamer) {
                       return this->StreamedListRouteTables(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListRouteTables() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListRouteTables(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListRouteTablesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListRouteTables(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::ListRouteTablesRequest,::google::cloud::networkconnectivity::v1::ListRouteTablesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetGroup() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::GetGroupRequest, ::google::cloud::networkconnectivity::v1::Group>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::GetGroupRequest, ::google::cloud::networkconnectivity::v1::Group>* streamer) {
                       return this->StreamedGetGroup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::GetGroupRequest* /*request*/, ::google::cloud::networkconnectivity::v1::Group* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetGroup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::GetGroupRequest,::google::cloud::networkconnectivity::v1::Group>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListGroups() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkconnectivity::v1::ListGroupsRequest, ::google::cloud::networkconnectivity::v1::ListGroupsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkconnectivity::v1::ListGroupsRequest, ::google::cloud::networkconnectivity::v1::ListGroupsResponse>* streamer) {
                       return this->StreamedListGroups(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::networkconnectivity::v1::ListGroupsRequest* /*request*/, ::google::cloud::networkconnectivity::v1::ListGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListGroups(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkconnectivity::v1::ListGroupsRequest,::google::cloud::networkconnectivity::v1::ListGroupsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListHubs<WithStreamedUnaryMethod_GetHub<WithStreamedUnaryMethod_CreateHub<WithStreamedUnaryMethod_UpdateHub<WithStreamedUnaryMethod_DeleteHub<WithStreamedUnaryMethod_ListHubSpokes<WithStreamedUnaryMethod_ListSpokes<WithStreamedUnaryMethod_GetSpoke<WithStreamedUnaryMethod_CreateSpoke<WithStreamedUnaryMethod_UpdateSpoke<WithStreamedUnaryMethod_RejectHubSpoke<WithStreamedUnaryMethod_AcceptHubSpoke<WithStreamedUnaryMethod_DeleteSpoke<WithStreamedUnaryMethod_GetRouteTable<WithStreamedUnaryMethod_GetRoute<WithStreamedUnaryMethod_ListRoutes<WithStreamedUnaryMethod_ListRouteTables<WithStreamedUnaryMethod_GetGroup<WithStreamedUnaryMethod_ListGroups<Service > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListHubs<WithStreamedUnaryMethod_GetHub<WithStreamedUnaryMethod_CreateHub<WithStreamedUnaryMethod_UpdateHub<WithStreamedUnaryMethod_DeleteHub<WithStreamedUnaryMethod_ListHubSpokes<WithStreamedUnaryMethod_ListSpokes<WithStreamedUnaryMethod_GetSpoke<WithStreamedUnaryMethod_CreateSpoke<WithStreamedUnaryMethod_UpdateSpoke<WithStreamedUnaryMethod_RejectHubSpoke<WithStreamedUnaryMethod_AcceptHubSpoke<WithStreamedUnaryMethod_DeleteSpoke<WithStreamedUnaryMethod_GetRouteTable<WithStreamedUnaryMethod_GetRoute<WithStreamedUnaryMethod_ListRoutes<WithStreamedUnaryMethod_ListRouteTables<WithStreamedUnaryMethod_GetGroup<WithStreamedUnaryMethod_ListGroups<Service > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace networkconnectivity
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fnetworkconnectivity_2fv1_2fhub_2eproto__INCLUDED
